/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

// TODO : Temporary File  : Has to change the file for EPMTree Specific needs. -- IMPORTANT
(function(){
    dojo.provide("com.ibm.epm.web.core.client.internal.EPMTreeClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
	dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
	
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
    
    var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var EPMServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
	
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    
    com.ibm.epm.web.core.client.internal.EPMTreeClient = {
        // The base URIs for each element.
        //	_PROJECT_URI : "epm/resources/bu/Tara/project",
        //	_TASK_URI: "epm/resources/bu/Tara/task",
        //	_SUMMARY_TASK_URI: "epm/resources/bu/Tara/summarytask",
        //	_MILESTONE_URI: "epm/resources/bu/Tara/milestone",
        //	_DEFECT_URI: "epm/resources/bu/Tara/defect",
        //	_CHANGEREQUEST_URI: "epm/resources/bu/Tara/changerequest",
        //	_ISSUE_URI: "epm/resources/bu/Tara/issue",
        
        _BASE_URI: "epm/resources/",
        _SCHEDULE_URI: "/schedule",
		_BASE_SERVICES_URI: "epm/services",
		_WORK_URI: "/work/getAllRootElementsForWBSTree",
        _IWEB_UI_SERVICE_REST_NAME: "com.ibm.epm.work.component.service.IWebUIService",
        
        getAllResources: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        getURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
		getProposedFromCalendar: function(responseHandler,args) {
			var SERVICE_URI = this._IWEB_UI_SERVICE_REST_NAME;
			var method = "getProposedFromCalendar";
			var serviceRequest = new ServiceRequest(SERVICE_URI, method, args);
			TeamServerClient.invokeService(serviceRequest, responseHandler);
		},

		// method to invoke the delete URI
		deleteURI: function(responseHandler, uri){
            var serviceRequest = new EPMServiceRequest(this._BASE_URI + uri, "delete");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
		
		postURI: function(responseHandler, uri, params){
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
		
		getAllRootElementsForWBS: function(responseHandler){
			var serviceRequest = new ServiceRequest(this._BASE_SERVICES_URI + this._WORK_URI, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
		}	
    };
})();
