/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient");
    
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");	
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
    
    var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;	
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	
	var _GET_LEAF_LEVEL_WI		= "getLeafLevelWorkItems";
	var	_GET_ADMIN_PA			= "getAdminProjectArea";
	var	_INITIALIZE_DB			= "postInitializeDB";	
	var	GET_WI_CONFIG			= "getWorkItemsConfigurations";
	var	_EPM_WEB_SERVICE_URI	= "com.ibm.epm.work.component.service.IWebUIService";
	var _EPM_WI_STATES = "getWorkItemEditableProperties";
	
	function _invokeEPMWebUIService (responseHandler, method, appArgs){	
		var serviceRequest = null;		
		// appArgs is optional, so test whether or not it was sent
		if (!appArgs) {
			serviceRequest =
					new ServiceRequest(_EPM_WEB_SERVICE_URI, method);
		} else {
			serviceRequest=
					new ServiceRequest(_EPM_WEB_SERVICE_URI, method, appArgs);
		}
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
    
    com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient = {
		
		getLeafLevelWorkItems: function(responseHandler) {			
			var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
            var paName = getCurrentProjectArea().name;
			var appArgs = {
				projectAreaName: paName
			}
			_invokeEPMWebUIService(responseHandler, _GET_LEAF_LEVEL_WI, appArgs);			
		},
		
		getWorkItemsConfigs: function(responseHandler, paName) {			
			var appArgs = {
				projectAreaName: paName
			}
			_invokeEPMWebUIService(responseHandler, GET_WI_CONFIG, appArgs);			
		},
		
		getAdminProjectArea: function(responseHandler) {			
			_invokeEPMWebUIService(responseHandler, _GET_ADMIN_PA, null);
		},
		
		postInitializeDB: function(responseHandler) {			
			_invokeEPMWebUIService(responseHandler, _INITIALIZE_DB, null);
		},
		getStates: function(responseHandler,projectAreaItemID){
			_invokeEPMWebUIService(responseHandler, _EPM_WI_STATES, {projectAreaName: projectAreaItemID});
		}
		        
    };
})();
