/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.web.client.internal.ProfilesClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    com.ibm.epm.resource.web.client.internal.ProfilesClient = {
    
        _PROJECT_PROFILE_URI: "epm/resources/profile",
        _BASE_URI: "epm/resources/",
        
        getAllProfiles: function(responseHandler){
            this._invokeWorkService(responseHandler, "get", null);
        },
        
        getAllProjectsWithPagination: function(responseHandler, args){
            this._invokeWorkService(responseHandler, "get", args);
        },
        getURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        getLinksURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        postCreateProfile: function(responseHandler, args){
            this._invokeWorkService(responseHandler, "post", args);
        },
        
        /**
         * Invokes the requested method on the work REST service.
         */
        _invokeWorkService: function(responseHandler, method, args){
            if (arguments.length == 2) {
                var serviceRequest = new ServiceRequest(this._PROJECT_PROFILE_URI, method);
            }
            else {
                serviceRequest = new ServiceRequest(this._PROJECT_PROFILE_URI, method, args);
            }
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
    };
})();
