/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.web.client.internal.StaticPoolClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    var _SERVICE_URI = "com.ibm.team.dashboard.viewlets.service.internal.teams.ITeamsService";
    
    com.ibm.epm.resource.web.client.internal.StaticPoolClient = {
    
        _BASE_URI: "epm/resources",
        
        /*
         * gets the specified relative uri details from service
         * Incoming : responseHandler
         * 			  relativeUri uri of the get resource
         * Outgoing : None
         */
        getURI: function(responseHandler, relativeURI){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + relativeURI, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        /*
         * Unlinks the user from static pool
         * Incoming : response Handler
         * 			  uri - selected static pool uri
         * 			  userHref -userHref to be removed from pool
         * Outgoing : None
         */
        unassignUser: function(responseHandler, uri, userHref){
            var args = {
                User: userHref + ":del"
            };
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + uri, "post", args);
            
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
            
        },
        /*
         * Links the user to the static pool
         * Incoming : responseHandler
         * 			  uri - selected static pool uri
         * 			  userHref - user href to be unlined from pool
         */
        assignUser: function(responseHandler, uri, userHref){
            var args = {
                User: userHref + ":add"
            };
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + uri, "post", args);
            
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
        
    };
})();
