/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.client.internal.skills.SkillsClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    com.ibm.epm.admin.web.client.internal.skills.SkillsClient = {
        _BASE_URI: "epm/resources",
        _SKILL_URI: "epm/resources/skill",
        
        getSkills: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        saveSkill: function(responseHandler, uri, params){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        getAllSkills: function(responseHandler){
            var serviceRequest = new ServiceRequest(this._SKILL_URI, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        postSkill: function(responseHandler, args){
            var serviceRequest = new ServiceRequest(this._SKILL_URI, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        deleteSkill: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + uri, "delete", null);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        updateSkill: function(responseHandler, id, args){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + id, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
    };
})();
