/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/


(function() {
dojo.provide("com.ibm.epm.admin.web.client.internal.timecodes.TimecodesClient");

dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");

var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;

com.ibm.epm.admin.web.client.internal.timecodes.TimecodesClient = {
	_BASE_URI: "epm/resources",
	_TIMECODE_URI: "epm/resources/timecode",

    getTimecodes: function(responseHandler, uri){
    	var serviceRequest = new ServiceRequest(
					this._BASE_URI+uri,
					"get");
		EpmServerClient.operateOnResource(serviceRequest, responseHandler);
    },
    
    saveTimecode: function(responseHandler, uri, params){
    	var serviceRequest = new ServiceRequest(
					this._BASE_URI+uri,
					"post", params);
		EpmServerClient.operateOnResource(serviceRequest, responseHandler);
    },
    
    getAllTimecodes: function(responseHandler){
    	var serviceRequest = new ServiceRequest(this._TIMECODE_URI, "get");
		EpmServerClient.operateOnResource(serviceRequest, responseHandler);
    },
    
    postTimecode: function(responseHandler, args) {
		var serviceRequest = new ServiceRequest(
					this._TIMECODE_URI,
					"post",
					args);
		EpmServerClient.operateOnResource(serviceRequest, responseHandler);
	},
	
	updateTimecode: function(responseHandler, id, args) {
		var serviceRequest = new ServiceRequest(
					this._BASE_URI + "/" + id,
					"post",
					args);
		EpmServerClient.operateOnResource(serviceRequest, responseHandler);
	}	 	
 };
})();
 