/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){

    dojo.provide("com.ibm.epm.admin.web.client.internal.user.EPMUserClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    var AllUsers = "epm/resources/user";
    var BASE_URI = "epm/resources/";
	var CALENDAR_URI = "epm/resources/calendars";
    
    com.ibm.epm.admin.web.client.internal.user.EPMUserClient = {
    
        /*
         * Get the list of all the users
         */
        getAllUsers: function(responseHandler, method){
        
            var serviceRequest = new ServiceRequest(this.AllUsers, method);
            
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        /*
         * Get the list of all the users
         */
        getUserDetail: function(responseHandler, href, method){
        
            var serviceRequest = new ServiceRequest(BASE_URI + href, method);
            
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        saveUserDetail: function(responseHandler, userURI, dataToSave, method){
        
            var serviceRequest = new ServiceRequest(BASE_URI + userURI, method, dataToSave);
            
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
            
        },
		
		/**
         * Performs GET operation on given URI
         */
        getURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
		/*
		 * 
		 */
		saveUserCalendar: function(responseHandler, params){
			var serviceRequest = new ServiceRequest(CALENDAR_URI, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
		},
		
		/*
		 * 
		 */
		deleteUserCalendar: function(responseHandler, uri){
			var serviceRequest = new ServiceRequest(CALENDAR_URI, "delete");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
		}
    };
})();
