/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/**
 * @author suryakant
 */
(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.EPMProjectProfileGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.GridModelClient");
    dojo.require("com.ibm.epm.web.core.util.internal.Constants");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    
    var EPMGridController = com.ibm.epm.web.core.grid.controller.EPMGridController;
    var gridModelClient = com.ibm.epm.web.core.grid.controller.GridModelClient;
    var Constants = com.ibm.epm.web.core.util.internal.Constants;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    
    dojo.declare("com.ibm.epm.web.core.grid.controller.EPMProjectProfileGridController", EPMGridController, {
        initializeController: function(allElementsURI, viewer, model, linksToBeLoaded){
            // Calling super function
            this.inherited("initializeController", arguments);
        },
        
        postCreate: function(){
            this.inherited(arguments);
        },
        
        buildGridModel: function(){
            this._get_n_updateModel();
        },
        
        //TODO: High Priority - The Call to the sever will change and query will be used to populate the data
        // Work around for the time being
        // Query Json Expression : {"attributeExpressions": [{"attributeId": "profileType", "operator": "matches", "values": ["systemProfile"
        // ], "variables": []}]}
        // URI : epm/query/?type=profile&execute=true&jsonExpression=%7B%22
        // attributeExpressions%22%3A%20%5B%7B%22attributeId%22%3A%20%22profileType
        // %22%2C%20%22operator%22%3A%20%22matches%22%2C%20%22values%22%3A%20%5B%22
        // systemProfile%22%5D%2C%20%22variables%22%3A%20%5B%5D%7D%5D%2C%7D
        
        // Work item : 4288
        _get_n_updateModel: function(){
            var self = this;
            
            var getAllElementsHandlers = {
                _updateAllElements: function(collectionElements){
                    if (collectionElements) {
                        if (!dojo.isArray(collectionElements)) { // for single elements it will not be a array.
                            collectionElements = [collectionElements];
                        }
                        // If the Reuslt doesnt contain any information then create blank grid
                        if (collectionElements.length == 0) {
                            self._createBlankRow();
                        }
                        else {
                            var massagedLinks = this.massageLinks(collectionElements);
                            self.updateModel(false, massagedLinks);
                        }
                    }
                    else {
                        self._createBlankRow();
                    }
                },
                _getAllElementsFailure: function(errorMsg){
                    self._createBlankRow();
                    
                },
                massageLinks: function(collectionElementsLinks){
                    if (!collectionElementsLinks || collectionElementsLinks.length == 0) {
                        return null;
                    }
                    var massagedLinks = new Array(1);
                    for (var i in collectionElementsLinks) {
                        massagedLinks.push(collectionElementsLinks[i]);
                    }
                    return massagedLinks;
                }
                
            };
            var srh = new ServiceResponseHandler(getAllElementsHandlers, "_updateAllElements", "_getAllElementsFailure");
            
            //Fetch the data from the server
            // Display blank grid if the data is not available
            if (this._allElementsURI != null && this._allElementsURI != "" && this._allElementsURI.indexOf(this.newElementPrefix) == -1) {
            
                var uri = this._allElementsURI;
                if (this._allElementsURI.indexOf("projectId=") != -1) {
                    var param = this._allElementsURI.substring(this._allElementsURI.indexOf("projectId=") + "projectId=".length);
                    uri = this._allElementsURI.substring(0, this._allElementsURI.indexOf("?") - 1);
                }
                
                
                gridModelClient.getURIWithQueryArgs(srh, uri, param);
            }
            else {
            
                self._createBlankRow();
                
            }
        }
        
    });
})();
