/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.EPMRiskGridController");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMGridController");
    
    var abstractEPMGridController = com.ibm.epm.web.core.grid.controller.EPMGridController;
    
    dojo.declare("com.ibm.epm.web.core.grid.controller.EPMRiskGridController", abstractEPMGridController, {
        /* 
         * initializeController calling the super function
         */
        initializeController: function(allElementsURI, viewer, model, linksToBeLoaded){
            // Calling super function			
            this.inherited(arguments);
            this.EPMCollection = allElementsURI;
        },
        
        
        /* 
         * postCreate calling the super function
         */
        postCreate: function(){
            this.inherited(arguments);
        },
        
        /* 
         * buildGridModel - This function creates the grid model
         */
        buildGridModel: function(){
            this._get_n_updateModel();
        },
        
        
        /* 
         * massageCodeLinks - This function will wrap the links into an array.
         */
        massageCodeLinks: function(massagedLinks, collectionElementsLinks){
            massagedLinks.push(collectionElementsLinks);
        },
        
        _get_n_updateModel: function(){
            var self = this;
            var massagedLinks = new Array(1);
            self.massageCodeLinks(massagedLinks, self.EPMCollection);
            self.updateModel(false, massagedLinks);
            
            
        }
    });
})();
