/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.web.core.grid.controller.PubSub");

(function(){

    com.ibm.epm.web.core.grid.controller.PubSub = {
        /**
         * the object publish:
         * publishObj = {
         oldRowID	: The tempory ID of the row.
         newObject	: The new row object that will be inserted
         rowIndex	: the index of the row not the ID
         uniqueIdentifier	: the unique identifier of the grid like treeID.
         }
         */
        REPLACE_NODE: "com.ibm.epm.web.core.grid.controller.replaceNode",
        
        /**
         * the Object that is published
         * publishObj = {
         controllerID		: the ID of the controller.
         uniqueIdentifier	: the unique identifier of the grid like treeID.
         row					: The row object that is modified.
         fieldName			: The name of the field that is modified.
         oldValue			: The oldValue of the field that is modified.
         newValue			: The newValue of the field that is modified.
         }
         */
        FIELD_CHANGED: "com.ibm.epm.web.core.grid.controller.fieldChanged",
		
		/**
         * the Object that is published
         * publishObj = {
         controllerID		: the ID of the controller.
         uniqueIdentifier	: the unique identifier of the grid like treeID.
         rowid				: The row object that is modified.         
         }
         */
        ROW_DELETED: "com.ibm.epm.web.core.grid.controller.rowDeleted",
		
		
		/**
		 * the Object that is published
		 * publishObj = {
			  SelectedWBSTreeNode	: The selected WBS tree node data.
			  newTitle : Modified title in summary input from WI editor.  
		  }
		 */
		RENAME_NODE: "com.ibm.epm.web.core.grid.controller.renameNode",
		
		/**
		 * the Object that is published
		 * publishObj = {
			  SelectedWBSTreeNode	: The selected WBS tree node data.
		  }
		 */
		REFRESH_ROW_DATA: "com.ibm.epm.web.core.grid.controller.refreshData",
		
		/**
		 * published object:
		 * controllerID: the id of the controller.
		 * uniqueIdentifier	: the unique identifier of the grid like treeID.
		 */
		LOADING_COMPLETED: "com.ibm.epm.web.core.grid.controller.loadingCompleted"
    };
    
    
})();
