/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.tree.TreeUtil");
    
    function getTreeStore(treeID, paramRootNodeName, iconClass){
    
        var rootNodeName = paramRootNodeName || "Root";
        var item = [{
            name: rootNodeName,
            identifier: "Root"
        }];

		if (iconClass) {
			item[0].iconClass = iconClass;

		}

        this._treeData = {
            identifier: 'identifier',
            label: 'name',
            items: item
        };

        var itemFileWriteStore = new dojo.data.ItemFileWriteStore({
            data: this._treeData
        });
        
        this._treeStore = new dijit.tree.ForestStoreModel({
            store: itemFileWriteStore,
            rootLabel: "Root"
        });
        
        if (this._treeStore) {
        
            var props = {
                model: this._treeStore,
                persist: false,
                showRoot: false,
                id: treeID
            };
        }
        
        return props;
        
        
    }
    
    function destroyTreeStore(){
    
        if (this._treeStore) {
            delete this._treeStore;
        }
        
        if (this._treeData) {
            delete this._treeData;
        }
        
    }
    
    com.ibm.epm.web.core.tree.TreeUtil.getTreeStore = getTreeStore;
    com.ibm.epm.web.core.tree.TreeUtil.destroyTreeStore = destroyTreeStore;
    
})();
