/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.financial.web.ui.internal.AssociateProjectCodesGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.web.core.ui.internal.FinancialConstants");
    
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var FinancialConstants = com.ibm.epm.web.core.ui.internal.FinancialConstants;
    
    dojo.declare("com.ibm.epm.financial.web.ui.internal.AssociateProjectCodesGridModel", abstractGridModel, {
        newElementPrefix: "_unsaved",
        codeType: "",
        load: function(codeUri){
            this.codeType = codeUri;
        },
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID){
            var row = {
                "id": rowID,
                "href": rowID,
                "name": "",
                "resourcetype": "",
                "description": "",
                "code": "",
				"action": "",
                
                "loadedelement": null
            };
            if (this.codeType == FinancialConstants.CHARGE_CODE_TYPE) {
                row.billable = true;
                row.state = "ACTIVE";
            }
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.name = loadedElement.name;
                row.description = loadedElement.description;
                row.code = loadedElement.code;
                row.loadedelement = [loadedElement];
                if (this.codeType == FinancialConstants.CHARGE_CODE_TYPE) {
                    row.billable = loadedElement.billable;
                    row.state = loadedElement.state;
                }
            }
        },
        
        prepareSaveParams: function(row){
            var saveParams = {};
            return saveParams;
        },
        
        _getNewElementURI: function(row){
            return this.codeType;
        }
    });
})();

