/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.BaselineSave");
    
    // Widgets
   dojo.require("com.ibm.epm.web.core.grid.controller.GridModelClient");
   dojo.require("dojo.date.stamp");

 	//Constants
	 dojo.require("com.ibm.epm.work.web.ui.internal.WBSConstants");

	//ServiceResponseHandler
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
	 
	 //EPMErrorHandler
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");

    dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");
	
	var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler; 
    var WBSConstants = com.ibm.epm.work.web.ui.internal.WBSConstants;
    var WorkMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
    var GridModelClient = com.ibm.epm.web.core.grid.controller.GridModelClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler; 	
    
    dojo.declare("com.ibm.epm.work.web.ui.internal.BaselineSave", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.epm.work.web", "ui/internal/templates/BaselineSave.html"),
        
        /**
         * load: Called from the parent widgets to get the controller, dialog and grid row data
         * @param {Object} project
         * @param {Object} dialog
         * @param {Object} gridController
         * @param {Object} rowIndex
         */
		constructor: function()
		{
		    this._startUp();
		},
		
		/**
		 * Initialize the html text
		 */
		_startUp: function(){
		   
		   this.baselineLabelInfo = WorkMessages.BASELINE_INFO_LABEL;
		   this.baselineName = WorkMessages.BASLINE_NAME_LABEL;
		   this.baselineSave = WorkMessages.SAVE;
		   this.baselineCancel = WorkMessages.CANCEL;
		},
		
		/**
		 * Load the dialog and initialize 
		 * @param {Object} dlg
		 * @param {Object} identifier
		 * @param {Object} name
		 */
        load: function(dlg,identifier,name){
		  this.dialog = dlg;
		  this.baseUri = identifier;
          var date = new Date();
		  dojo.byId("baselineNameInputId").value = date.toDateString();
		  dojo.byId("baselineNameInputId").focus();
		  
        },
        
       /**
        * Called when save is hit
        */
        _saveTheBaseline: function(){
			
			this.baselineName = dojo.byId("baselineNameInputId").value;
			this._postTheBaseline();
		    this._destroy();
			
		},
		/**
		 * Cancel of the Dialog 
		 */
		_cancelThebaseline: function(){
			this._destroy();
			
		},
		
		/**
		 * Close and Destroy the dialog
		 */
		_destroy :function(){
			if(this.dialog)
			{
				this.dialog.close();
				this.dialog.destroy();
			}
		},
		
		/**
		 *  Make a post call to the baseline service
		 *  Do nothing on success , show msg on failure
		 */
		_postTheBaseline: function(){
			 var self = this;
             var serviceObj = {
                success: function(data){
                },
                failure: function(errorObj){
					// display and clear the error message
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
					
                }
            };
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            
            var inputparams = {"name":this.baselineName};
           
			GridModelClient.postURI(srh, this.baseUri + WBSConstants.SLASH + WBSConstants.BASELINE , inputparams);	
					
								
        },
		/*
         * Display and clear the error message 
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage, errorCode) {
            var self = this;
			EPMErrorHandler.setError(errorMessage, errorCode);
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                EPMErrorHandler.clearError();
                clearInterval(intervalID);
            }, 5000);  
        }
        
              
        
    });
})();
