/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/


if (!dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMCalendarDialog"]) {
    dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMCalendarDialog"] = true;
    dojo.provide("com.ibm.epm.web.core.ui.internal.EPMCalendarDialog");
    
    dojo.require("dijit.Dialog");
    dojo.require("dijit.form.Button");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    
    
    dojo.declare("com.ibm.epm.web.core.ui.internal.EPMCalendarDialog", [dijit._Widget, dijit._Templated], {
    
        dialog: null,
        
        _show: function(){
            this.dialog.show();
			this.dialog._savedFocus = this._savedFocus;
			this._disconnectAllEvents();
			this._connectAllEvents();
		},
		
        show: function(){
            this.dialog.show();
			this._savedFocus = this.dialog._savedFocus;
			this._disconnectAllEvents();
			this._connectAllEvents();
        },
        
        widgetsInTemplate: true,
        
        templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/templates/EPMCalendarDialog.html"),
        
        postCreate: function(){
			this._pconnects = [];
            com.ibm.epm.web.core.ui.internal.EPMCalendarDialog.superclass.postCreate.apply(this);
            this.addbuttons(this.buttonlist);
            this.addCalendarNode(this.calendar);
        },
        
        addCalendarNode: function(calendar){
            if (this.calendar) {
                this.calendarContent.appendChild(this.calendar.domNode);
            }
        },
        
        addbuttons: function(buttonlist){
            if (buttonlist) {
                for (var i = 0; i < buttonlist.length; i++) {
                    var button = new dijit.form.Button({
                        label: buttonlist[i].label
                    });
                    if (buttonlist[i].action) {
                        dojo.connect(button, "onClick", buttonlist[i].action);
                    }
                    else {
                        dojo.connect(button, "onClick", this, "hide");
                    }
                    this.buttons.appendChild(button.domNode);
                }
            }
        },
		
		_onKeyDown: function(e) {
            var keys = dojo.keys;
			if(e.keyCode == keys.ESCAPE) {
				this._closeCalendarDialog();
			}
		},
		
		_disconnectAllEvents: function() {
            dojo.forEach(this._pconnects, dojo.disconnect);
            this._pconnects = [];
		},
		
		_connectAllEvents: function() {
            this._pconnects.push(dojo.connect(this.dialog.closeButtonNode, "onclick", this, this._closeCalendarDialog));
			this._pconnects.push(dojo.connect(this.dialog.domNode, "onkeydown", this, this._onKeyDown));
		},
        
		/*
		 * Private function _hide : Only to be used in this file
		 */
		_hide: function(){
			this._disconnectAllEvents();
			if (this.dialog && this.dialog.domNode != null) {
				this.dialog.hide();
			}
        },

        hide: function(){
			this.dialog.refocus = false;
			this._hide();
        },
		
		unhide: function() {
			this.dialog.refocus = true;
			this._show();
		},
		
		_closeCalendarDialog: function() {
			this._hide();
			if(this.calendar){
				this.calendar.destroy();
			}
		},
		
        destroy: function(){
            this._disconnectAllEvents();
			
			this.inherited(arguments);
            this._hide();
			if(this.calendar){
				this.calendar.destroy();
			}
            this.dialog.destroy();
        }
        
    });
}
