/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/


if (!dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMConfirmDialog"]) {
    dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMConfirmDialog"] = true;
    dojo.provide("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");
    
    dojo.require("dijit.Dialog");
    dojo.require("dijit.form.Button");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants");
    
    var EPMDomNodeConstants = com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants;
    
    dojo.declare("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog", [dijit._Widget, dijit._Templated], {
    
        dialog: null,
		title:"",
		width:"450px",
		onClose: null,
        show: function(){
//            this.dialog.show();
        },
        widgetsInTemplate: true,
        templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/templates/EPMConfirmDialog.html"),
        
        postCreate: function(){
            com.ibm.epm.web.core.ui.internal.EPMConfirmDialog.superclass.postCreate.apply(this);
            this.addbuttons(this.buttonlist);
            this.addLabels(this.labelList);
			if (this.dialog == null) {
				this.dialog = new jazz.ui.Dialog({
					contentNode: this.containerNode,
					primaryTitle: this.title,
					closeOnEsc: true,
					width: this.width,
					onClose: this.onClose
				});
			}
        },
        addLabels: function(labelList){
            if (labelList) {
                for (var i = 0; i < labelList.length; i++) {
                
                    var div = document.createElement("div");
                    div.innerHTML = labelList[i].label;
                    this.content.appendChild(div);
                }
            }
        },
        
        addbuttons: function(buttonlist){
            if (buttonlist) {
                for (var i = 0; i < buttonlist.length; i++) {
					button = document.createElement(EPMDomNodeConstants.BUTTON);
            		button.innerHTML = buttonlist[i].label;
            		button.title = buttonlist[i].label;
            
                    if (buttonlist[i].action) {
						dojo.connect(button, EPMDomNodeConstants.ON_CLICK, buttonlist[i].action);
                    }
                    else {
                        dojo.connect(button, EPMDomNodeConstants.ON_CLICK, this, "destroy");
                    }
                    this.buttons.appendChild(button);
                }
            }
        },
        
        destroy: function(){
			this.onClose = null;
			if (this.dialog) {
				this.dialog.close();
				this.dialog = null;
			}
        },
        
        hide: function(){
//            this.dialog.hide();
        }
        
    });
}
