/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.web.core.ui.internal.EPMFinancialTree");

dojo.require("com.ibm.epm.web.core.ui.internal.EPMTree");
dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
dojo.require("com.ibm.epm.web.core.util.internal.Constants");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");
// Localization
dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages");

var EPMFinancialTreeMessages = dojo.i18n.getLocalization("com.ibm.epm.web.core.ui", "Messages");
var EPMTreeEvents = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
var CoreConstants = com.ibm.epm.web.core.util.internal.Constants;

var EPMTree = com.ibm.epm.web.core.ui.internal.EPMTree;
var EPMTreeClient = com.ibm.epm.web.core.client.internal.EPMTreeClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

(function(){

    dojo.declare("com.ibm.epm.web.core.ui.internal.EPMFinancialTree", EPMTree, {
    
        initialize: function(topLevelURI, linkType, ID, nodes, menuImage, projectID){
            // store other information
            this._topLevelURI = topLevelURI;
            this._projectID = projectID;
            this.inherited(arguments);
        },
        
        //TODO : IMP - Have to remove this funtion to get data for the tree to seperate class so that
        // diffent data fecthing mechanishms can be implemented
        
        // Get all the Root level tree nodes for the Tree
        getRootNodes: function(){
        
            var self = this;
            if (!self._projectID) {
                this.inherited(arguments);
            }
            else {
                var serviceObj = {
                    success: function(data){
                        var len = 0;
                        var codeLinks = null;
                        if (data) {
                            var temp = "";
                            if (self._topLevelURI === "timecodes") {
                                temp = CoreConstants.TIMECODE;
                            }
                            else {
                                temp = CoreConstants.CHARGECODE;
                            }
                            
                            codeLinks = getLink(data, temp);
                            if (codeLinks) {
                                len = codeLinks.length;
                            }
                        }
                        if ((!data) || (len == 0)) {
                            // No data
                        }
                        else {
                            for (var j in codeLinks) {
                                //self._setvalues(codeLinks[i].relativeHref, codeLinks[i].title);
                                //self._setvalues(data.links[i].relativeHref, data.links[i].title);
                                // add all the required information to the variable
                                var chargecodeItem = null;
                                
                                var ccresourcetype = "epm" + self._getResourceType(codeLinks[j].relativeHref);
                                var ccresourceIconClass = self._getResourceType(codeLinks[j].relativeHref) + "Icon";
                                
                                chargecodeItem = {
                                
                                    "href": codeLinks[j].relativeHref,
                                    "name": codeLinks[j].title,
                                    "identifier": codeLinks[j].relativeHref, // using relativeHref itself as Identifier
                                    "parentIdentifier": null,
                                    "detailLevel": false,
                                    "resourcetype": ccresourcetype,
                                    "iconClass": ccresourceIconClass
                                
                                };
                                // TODO : Refactor to reduce the condition cheking - Important task
                                
                                // Chk if the data is already present in the store
                                // If yes - then just update the values.
                                // add the node to the tree
                                
                                if (self._treeStore && self.getItemNodeByIdentity(chargecodeItem.identifier)) {
                                    self._updateNode(chargecodeItem);
                                }
                                else {
                                    self._addNode(null, chargecodeItem, j);
                                    self._addTempChildNode(chargecodeItem);
                                }
                                
                                // For restoring the earlier state of the tree after refresh opertaion
                                // chk whether the node was already opened
                                // if yes - call the expand funtion for that node
                                // reset the previous state of the tree
                                
                                if (self._openedItemIds) {
                                    if (self._openedItemIds[chargecodeItem.identifier]) {
                                        //Expand Node
                                        var itemNode = self.getNodeByItemIdentity(chargecodeItem.identifier);
                                        if (itemNode) {
                                            self._expandNode(itemNode);
                                        }
                                    }
                                }
                            }
                        }
						var publishObj = {
						 	treeID: self._treeID
						 };
	                	dojo.publish(EPMTreeEvents.ROOT_NODES_LOADED, [publishObj]);
                    },
                    
                    failure: function(errorObj){
                        //Show the error
                        self._displayErrorMessage(EPMFinancialTreeMessages.EPM_FINANCIAL_TREE_ERROR_MESSAGE);
                        
                    }
                };
                var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                EPMTreeClient.getAllResources(srh, this._projectID);
            }
        }
    });
})();
