/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

if (!dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMGridEditor"]) {
    dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMGridEditor"] = true;
    dojo.provide("com.ibm.epm.web.core.ui.internal.EPMGridEditor");
    
    dojo.require("dojox.grid.compat._data.dijitEditors");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");

	var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
	
    dojo.declare("com.ibm.epm.web.core.ui.internal.EPMGridEditor", dojox.grid.editors.Input, {
    	
        		
        /*  constructor : This is the constructor function
         *  Incoming Arguments : cell
         */
        constructor: function(cell){
			this._editorconnects = [];           
			this._editorconnects.push(dojo.connect(this.cell.grid,EPMGridPubSub.ON_KEY_DOWN, this, this._onKeyDown));			
        },
        
		
		/* KeyDown Event on grid bring control here */
		_onKeyDown: function(e){
			var keys = dojo.keys;
			if( e.keyCode === keys.ENTER && this.cell.grid && this.cell.grid._gridID == e.gridID && this.cell.field == e.cell.field) {
				this.onEnterKeyDown(e);			
			}      
        },
		
		/* On Enter key Event, can be overridden */
		onEnterKeyDown: function(e){
        },
		
		
		/* Destroy function */
		disconnectEvents : function(){
			dojo.forEach(this._editorconnects, dojo.disconnect);
            this._editorconnects = [];           
        }
    });
}
