/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

 (function() {
dojo.provide("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.ViewConstants");



/*
 * Dashboard constants.
 */
com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.ViewConstants = {

	/*
	 * Page action for viewing a viewlets.
	 */
	ACTION_VIEW_EPMVIEW: "com.ibm.epm.web.core.viewEPMPage",

	/*
	 * Page id of viewlet page.
	 */
	PAGE_ID: "com.ibm.epm.EPMViewPage",

	/*
	 * Contributor or personal scope.
	 */
	SCOPE_CONTRIBUTOR: "CONTRIBUTOR",
	
	/*
	 * Team area scope.
	 */
	SCOPE_TEAM_AREA: "TEAM_AREA",
	
	/*
	 * Project area scope.
	 */
	SCOPE_PROJECT_AREA: "PROJECT_AREA",

	/*
	 * Dashboard URL parameter for specifying the item ID of the dashboard to
	 * open.
	 */	
	URL_PARAM_ID: "id",

	/*
	 * Dashboard URL parameter for specifying a user ID (for public dashboards).
	 */	
	URL_PARAM_USER: "user",

	/*
	 * Dashboard URL parameter for specifying a team area name/path.
	 */	
	URL_PARAM_TEAM: "team",

	/*
	 * Dashboard URL parameter for specifying a project name.
	 */	
	URL_PARAM_PROJECT: "project",

	/*
	 * Dashboard URL parameter for specifying the tab ID of the dashboard to
	 * open.
	 */	
	URL_PARAM_TAB: "tab",
	
	//Reports View shortcut
	REPORTS_VIEW_HREF_P1:"/jazz/web/projects/",
	REPORTS_VIEW_HREF_P2:"#action=jazz.viewPage&id=com.ibm.team.reports",

	//Constants for Context Sensitive Help
	CSHELP_URL: "/help/rtopic/com.ibm.rational.epm.cshelp/topics/",
	CSHELP_INFO_CENTER_LABEL: "Information Center", //MessageUtil.getMessage(MessageBundleRQM, "labelInfoCtr"),
	CSHELP_INFO_CENTER_HREF: "/help/index.jsp",
	HELP_HREF: "/help/index.jsp",
	WELCOME_HREF: "/help/topic/com.ibm.rational.epm.welcome.doc/epm_welcome.html?noframes=true",
	//Tara admin view href
	TARA_ADMIN_HREF: "/rpc/admin",
	
	WORK_VIEW_TEMPLATE_ID: "workManagement",
	RESOURCE_VIEW_TEMPLATE_ID: "resourceManagement",
	TIME_VIEW_TEMPLATE_ID: "timeManagement",
	
	TOTAL_NO_OF_VIEWS: 3,
		
	HELP_CONTENT: "HELP_CONTENT",
	WELCOME: "WELCOME",
	HELP_ABOUT: "HELP_ABOUT"
};
 
})();
