/*******************************************************************************
 * Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.epm.web.core.ui.internal.EPMView.EPMViewPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.LeftNavigationLayout");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");
	
dojo.require("com.ibm.team.dashboard.web.client.internal.DashboardClient");
dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.dashboard.web.ui.internal.dnd.DraggableTabs");

dojo.require("com.ibm.epm.web.core.client.internal.WorkItemClient");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.dashboard.web.ui.Dashboard");
dojo.require("com.ibm.team.dashboard.web.ui.internal.DashboardContainer");

dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.ViewConstants");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.TopNav");
dojo.require("com.ibm.epm.work.web.ui.internal.WBSTreeWidget");

dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");
// Localization
dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages");


//
// Aliases
//
var EPMViewMessages = dojo.i18n.getLocalization("com.ibm.epm.web.core.ui", "Messages");
var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var ActionRegistry = null; // bind to ActionRegistry later
var DashboardClient = com.ibm.team.dashboard.web.client.internal.DashboardClient;
var DashboardContainer = com.ibm.team.dashboard.web.ui.internal.DashboardContainer;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;
var LeftNav = com.ibm.epm.web.core.ui.internal.EPMView.LeftNavigationLayout;
var WorkItemClient = com.ibm.team.workitem.web.client.internal.WorkItemClient;
var EPMWorkItemClient = com.ibm.epm.web.core.client.internal.WorkItemClient;
var EPMConstants = com.ibm.epm.web.core.util.internal.Constants;

var DraggableTabs = "com.ibm.team.dashboard.web.ui.internal.dnd.DraggableTabs";
var DashboardConstants = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.ViewConstants;
var DashboardUtil = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
var Util = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
var TopNav = com.ibm.epm.web.core.ui.internal.EPMView.TopNav;
var WBSTree = com.ibm.epm.work.web.ui.internal.WBSTreeWidget;
var Dashboard = com.ibm.team.dashboard.web.ui.Dashboard;
var EPMConfirmDialog = com.ibm.epm.web.core.ui.internal.EPMConfirmDialog;

var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
//Error handler 
var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler; 

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

/*
 * The widget containing the entire dashboard (left nav and content).
 */
dojo.declare("com.ibm.epm.web.core.ui.internal.EPMView.EPMViewPage",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/EPMView/templates/EPMViewPage.html"),

	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
	},
	
	postCreate: function() {
		// create the overall layout
		this._layout = new com.ibm.epm.web.core.ui.internal.EPMView.LeftNavigationLayout({});
		this._contentDiv = document.createElement("div");
		this._layout.setMainContent(this._contentDiv);
		this.resetDashboardTitle = true;
		
		// Cache the dashboard created for views in the array
		this.views = [];
		this.viewsIndex = [];
	
		this._main.appendChild(this._layout.domNode);
		
		this._topNav = jazz.app.currentApplication._topNav;
		if (!this._topNav) {
			this._topNav = new TopNav();
		}
		
		this._wbsTree = new WBSTree({mainPage: this});
		this._newWBSCommand = this._layout.addCommand({tree: this._wbsTree, imageClass: "create-wbs-command", buttonText: "Create <br> Program", boldFirstWord: true, size: "large"});
		var args = new Array();
		this._newWBSCommand.populateDropDown(args);

		var navSection = document.createElement("div");
		navSection.className = "com-ibm-team-repository-admin-navSection";
		var navSectionEntry = this._layout.addNavigationSection(navSection, EPMViewMessages.WBS_TITLE, true);

		this._layout._leftNav.appendChild(this._wbsTree.domNode);
		
		// late bind to ActionRegistry to ensure that workbench is instantiated
		ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
    	ActionRegistry.registerAction("com.ibm.epm.web.core.viewEPMPage", this, "viewEPMPage");
		ActionRegistry.registerAction("com.ibm.epm.web.core.viewDefaultPage", this, "viewDefaultPage");
		ActionRegistry.registerAction("com.ibm.epm.web.core.viewWorkItem", this, "viewWorkItem");
		ActionRegistry.registerAction("com.ibm.epm.web.core.similarityQuery", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.search", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.simpleQuery", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.runSavedQuery", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.runNewQuery", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.newQuery", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.editQuery", this, "dummyQueryAction");
		ActionRegistry.registerAction("com.ibm.epm.web.core.runDefaultQuery", this, "dummyQueryAction");

		// Register to window unload 
		dojo.addOnWindowUnload(this, this._handleWindowUnload);
		
		// List of subscriptions for this Widget
        this._subscriptions = [];
        
        this.eventSubscribe();
		
		this.clickConnection = this.connect(navSectionEntry.domNode, "onclick", function(event){
			if (event && event.preventDefault && event.target == navSectionEntry.domNode) {
				event.stopPropagation();
				event.preventDefault();
				dojo.stopEvent(event);
			}
		});

		//instantiate error object with main page container
		com.ibm.epm.web.core.ui.internal.EPMErrorHandler.instantiateErrorObject(this);
	},

	/**
      * eventSubscribe: Method to subscribe to the needed events. <br>
      */	
	eventSubscribe: function(){
        this._subscriptions = [ 
			dojo.subscribe(EPMTreePubSub.ON_SELECT, this, this._populatecreateMenu),
			dojo.subscribe(EPMTreePubSub.ON_EXPAND, this, this.updateCurrentSelectedNode),
			dojo.subscribe(EPMTreePubSub.ON_COLLAPSE, this, this._updateTitle),
			dojo.subscribe(EPMTreePubSub.ON_DESELECT, this, this._deselectTreeNodeInTitle),
			dojo.subscribe(EPMTreePubSub.ON_RENAME_NODE, this, this._updateTreeNodeInTitleOnRename),
			dojo.subscribe(EPMTreePubSub.ON_CREATE_NODE, this, this._disableCreateMenu),
			dojo.subscribe(EPMTreePubSub.TRIGGGER_DASHBOARD_ICON_UPDATE, this, this._updateIconInTitle)];
    },

	/**
      * _unsubscribeToAllEvents: Method to unsubscribe to all events. <br>
      */
    _unsubscribeToAllEvents: function(){
        if (this._subscriptions !== null) {
            for (var topic in this._subscriptions) {
                var handler = this._subscriptions[topic];
                if (handler) {
                    dojo.unsubscribe(handler);
                }
            }
        }
        this._subscriptions = [];
    },	

	init: function() {
		this.viewEPMPage();
	},
	
	/**
	 * destroy: Destroy all created objects
	 */	
	destroy: function() {
		// destroy the created views		
		if (this.viewsIndex) {
			for (var i = 0; i < this.viewsIndex.length; i++) {
				if (this.views) {
					if (this.views[this.viewsIndex[i]]) {
						this.views[this.viewsIndex[i]].destroy();
					}
				}
			}
		}
		
		if (this._topNav) {
			this._topNav.destroy();
		}
		if (this._layout) {
			this._layout.destroy();
		}
		
		this._unsubscribeToAllEvents();
		
		this.inherited(arguments);
	},

	viewDefaultPage: function(args) {
		this.viewEPMPage(args);
	},
	
	/**
	 * viewWorkItem: Registered function for action "com.ibm.epm.web.core.viewWorkItem"
	 * 					Constructing the default URL & calling viewEPMPage here. This is to resolve browser refresh problem from details view.
	 * 					This action is actually registered & activated by details view specific code.
	 * @param {Object} args
	 */
	viewWorkItem: function(args) {
		var self = this;
		var intervalID = setInterval(function(){
			if (self._topNav.isLoaded) {
				clearInterval(intervalID);
				for (var i = 0; i < self._topNav._usrViews.length; i++) {
					if (self._topNav._usrViews[i].templateId == DashboardConstants.WORK_VIEW_TEMPLATE_ID) {
						var newArgs = { id : self._topNav._usrViews[i].id};
						self.viewEPMPage(newArgs);
						return;
					}
				}					
			}
		}, 50);		
	},
	
	dummyQueryAction: function(args) {
		var self = this;
		var intervalID = setInterval(function(){
			if (self._topNav.isLoaded) {
				clearInterval(intervalID);
				for (var i = 0; i < self._topNav._usrViews.length; i++) {
					if (self._topNav._usrViews[i].templateId == DashboardConstants.RESOURCE_VIEW_TEMPLATE_ID) {
						var newArgs = { id : self._topNav._usrViews[i].id};
						self.viewEPMPage(newArgs);
						return;
					}
				}					
			}
		}, 50);	
	},

	/**
	 * viewEPMPage: Registered function for action "com.ibm.epm.web.core.viewEPMPage". This is the main function to load the dashboard for the user
	 * @param {Object} args
	 */	
	viewEPMPage: function(args) {
		// prepare arguments
		var scope = DashboardConstants.SCOPE_CONTRIBUTOR;
		var scopeItem;

		//if top nav is not loaded yet
		if(this._topNav) {
			if ((!this._topNav.isLoaded) || (this._topNav._noOfViews < DashboardConstants.TOTAL_NO_OF_VIEWS)) {
				var self = this;
				var intervalID = setInterval(function(){
					if (self._topNav.isLoaded) {
						clearInterval(intervalID);
						var view = self._topNav.getView(args.id);
						if (view) {
							if (!scopeItem) {
								location.href = view;
								return;
							}
						}
						
						// select the nav bar item here if the top nav took time to initialise
						if (self._dashboard) {
							var dashboardItem = self._dashboard.getDashboardItem();
							if (dashboardItem) {
								self._topNav.selectNavItem(dashboardItem.itemId);
							}
						}
					}
				}, 50);
			}
			
			if (!scopeItem) {
				var itemId = this._topNav.getViewId(args.id);
				if (itemId) {
					scopeItem = {
						id: itemId
					};
				}
			}
		}

		if (args.id) {
			if ((this._topNav) && this._topNav._usrViews && this._topNav._usrViews.length > 0) {
				// Adding hooks to handle static urls for being referenced from Welcome page
				switch (args.id) {
					// Work View: https://<ip>/jazz/epmWeb#action=com.ibm.epm.web.core.viewEPMPage&id=workManagement
					case DashboardConstants.WORK_VIEW_TEMPLATE_ID:
						args.id = this._topNav._usrViews[0].id;
						break;

					// Resource View: https://<ip>/jazz/epmWeb#action=com.ibm.epm.web.core.viewEPMPage&id=resourceManagement
					case DashboardConstants.RESOURCE_VIEW_TEMPLATE_ID:
						args.id = this._topNav._usrViews[1].id;
						break;

					// Time View: https://<ip>/jazz/epmWeb#action=com.ibm.epm.web.core.viewEPMPage&id=timeManagement
					case DashboardConstants.TIME_VIEW_TEMPLATE_ID:
						args.id = this._topNav._usrViews[2].id;
						break;

					default:
						break;
				}
			}
			
			// Update the scopeItem only if the id has been replaced correctly
			if ((args.id != DashboardConstants.WORK_VIEW_TEMPLATE_ID) &&
				(args.id != DashboardConstants.RESOURCE_VIEW_TEMPLATE_ID) &&
				(args.id != DashboardConstants.TIME_VIEW_TEMPLATE_ID)) {
				scopeItem = {
					id: args.id
				};
			}
		}

		// check if already showing
		if (this._dashboard) {
			if (scope != this._dashboard.scope || dojo.toJson(scopeItem) != dojo.toJson(this._dashboard.scopeItem) || getCurrentProjectArea().name != this._dashboard.projectArea) {
				// setActive to false for the viewlets in the previous view
				this.updateSetActive(this._dashboard._contentWidget, false);

				// different view; check if present in the views array
				this.getDashboardFromViewsArray(scopeItem.id);
			} else {
				// same dashboard - pass the current tab, if specified.
				this._dashboard.showTab(args.tab);
			}
		}
		
		// create new one if needed
		if ((!this._dashboard) && (scopeItem)) {
			var projectarea = getCurrentProjectArea();
			this._dashboard = new Dashboard({
				scope: scope,
				scopeItem: scopeItem,
				projectArea: projectarea.name,
				tab: args.tab
			});
			
			// set autosave
			if (Util.userIsAdmin()) {
				var dashboardContainer = this._dashboard._contentWidget;
				if (dashboardContainer) {
					// setEditMode can be called only after _setContent2 is called
					dojo.connect(dashboardContainer, "_setContent2", this, function(){
						if (dashboardContainer.isEditable() !== Constants.EDIT_AUTO_SAVE) {
							setTimeout(dojo.hitch(dashboardContainer, dashboardContainer.setEditMode, Constants.EDIT_AUTO_SAVE), 0);
							dashboardContainer.tabs.setEditMode(true);
						}
					});
					
					// Reset the dashboardTitle
					dojo.connect(dashboardContainer, "showViewletPage", this, function(){
						if (this.resetDashboardTitle) {
							var dashboardTitle = dashboardContainer.metaNav._dashboardTitle;
							//Fetch all child nodes and delete one by one.
							if (dashboardTitle.hasChildNodes()) {
								var length = dashboardTitle.childNodes.length;
								for (var i = 0; i < length; i++) {
									if (dashboardTitle.childNodes[i]) {
										dashboardTitle.removeChild(dashboardTitle.childNodes[i]);
									}
								}
							}
							this.resetDashboardTitle = false;
						}

						this.updateCurrentSelectedNode();				
					});
				}
			}
			
			this._dashboard.addListener(dojo.hitch(this, this._onLoad), "onload");
			this._dashboard.addListener(dojo.hitch(this, this._onTabChange), "tab");
			
			// Store the dashboard loaded in the views array for quicker access later
			this.views[scopeItem.id] = this._dashboard;
			this.viewsIndex.push(scopeItem.id);
		}
		
		if (this._title) {
			// "touch" the title so that it doesn't revert between navigations
			PlatformUI.getWorkbench().setTitle(this._title);
		}	
	},

	/*
	 * getView: Function to fetch the view from the views array if it was already created
	 */	
	getDashboardFromViewsArray: function(id) {
		this._dashboard = this.views[id];				
		if (this._dashboard) {
			var dashboardItem = this._dashboard.getDashboardItem();
			if (dashboardItem) {
				// update the global title variable with the current one
				this._dashboardTitle = this._dashboard._contentWidget.metaNav._dashboardTitle;
				
				// update the selected node
				this.updateCurrentSelectedNode();
				
				// update the domNode with the selected view and refresh the last loaded tab in the view
				this._setContent(this._dashboard);
				
				// setActive to true after switching
				this.updateSetActive(this._dashboard._contentWidget, true);
			}
		}
	},

	/*
	 * updateSetActive: Function to update the setActive flag while switching the views
	 */	
	updateSetActive: function(dashboardContainer, active) {
		var currentPage = dashboardContainer.currentPage;
		if ((currentPage) && (currentPage.isActive != active)) {
			setTimeout(dojo.hitch(currentPage, currentPage.setActive, active), 0);
			this.clearDisplay();
		}	
	},
		
	/* string */ _getCurrentHref: function() {
		var scopeItem = this._dashboard.scopeItem;
		if (this._dashboard.scope == DashboardConstants.SCOPE_CONTRIBUTOR) {
			scopeItem = this._dashboard.scopeItem.id;
		}
		return DashboardUtil.getDashboardHref(this._dashboard.scope, scopeItem, this._dashboard.tab);
	},

	_onLoad: function() {
		if (this._dashboard) {
			this._updateURL();
			
			var dashboardItem = this._dashboard.getDashboardItem();
			if (dashboardItem) {
				// select the nav bar item corresponding to this view
				this._topNav.selectNavItem(dashboardItem.itemId);
				
				// Remove the dashboard specific toolbar from the domNode
				var toolbar = this._dashboard._contentWidget.metaNav._toolbar;
				if (toolbar && toolbar.domNode && toolbar.domNode.parentNode) {
					toolbar.domNode.parentNode.removeChild(toolbar.domNode);
				}
				
				// Hide the dashboard title
				this._dashboardTitle = this._dashboard._contentWidget.metaNav._dashboardTitle;
				if (this._dashboardTitle) {
					this._dashboardTitle.innerHTML = "";
					this._dashboardTitle.style.visibility = "hidden";
				}
				
				// Hide breadcrumbs for shared dashboards
				this._breadcrumbs = this._dashboard._contentWidget.metaNav._breadcrumbs;
				if (this._breadcrumbs) {
					this._breadcrumbs.domNode.style.display = "none";
				}
				
				this._setContent(this._dashboard);
				
				// If there is already a selected element set the title
				if (this.selectedNode) {
					dashboardItem.title = this.selectedNode;
					this._dashboardTitle.style.visibility = "";
				}
			}
		}
	},
	
	_onTabChange: function(/* string */ propertyId, /* string */ tab) {
		this._updateURL();
		
		// Update the href for the selected button in the nav bar
		if (this._topNav) {
			this._topNav.updateSelectedNavBarItemHref(location.href);
		}
	},
	
	_setContent: function(/* Widget */ widget) {
		if (this._contentDiv.firstChild != widget.domNode) {
			// swap in new widget
			if (this._contentDiv.firstChild) {
				this._contentDiv.replaceChild(widget.domNode, this._contentDiv.firstChild);
			}
			else {
				this._contentDiv.appendChild(widget.domNode);
			}
			this._contentWidget = widget;
		}
	},
	
	_updateURL: function() {
		if (this._dashboard && this._dashboard.getDashboardItem()) {
			location.href = this._getCurrentHref();
		}
	},

	/*
	 * Function to display the error message on the dashboard page
	 */	
	errorDisplay:function(err, code){
		// update error message seen in the main page
    	if (this._dashboard._contentWidget instanceof DashboardContainer) {
    		// verify if the content widget is loaded and then set the error message
				this._showErrorMessage(err, code);
		}
    },

	/*
	 * Function to invoke MetaNav#showMessage to 
	 * 				display the error / warning / info based on the errorcode returned from server
	 */	
	_showErrorMessage:function(errorObj, errorCode){
		this._error = errorObj;
		var errType = "error"; 
		if ( ( errorCode ) ) {
			if (errorCode.substring(10, 9) == "W") 
				errType = "warn";
			else if (errorCode.substring(10, 9) == "I")
				errType = "info";	
		}
		if (!errorObj || errorObj.status == 0 || errorObj.status == 12002 || errorObj.status >= 12029) {
			this._dashboard._contentWidget.metaNav._showErrorMessage;
		}
		else
			this._dashboard._contentWidget.metaNav.showMessage({message:" ", actions: [{label: errorObj, callback: dojo.hitch(this, this._showErrorAlert)}], type: errType});
	},

	/*
	 * Function to show alert if message is too long
	 */
	_showErrorAlert: function()
	{
		// display error in an alert box
		alert(this._error);
	},

	/*
	 * Function to clear the message from the dashboard
	 */		
    clearDisplay:function(){
    	// clear error message from the main page
    	if (this._dashboard._contentWidget instanceof DashboardContainer) {
    		// verify if the content widget is loaded and then clear the error message
    		this._dashboard._contentWidget.metaNav.hideMessage();
    	}
    },
	
	
	/**
	 * Display the error message and erase it after some time
	 * @param {Object} errorMessage
	 */
	_displayAndClearErrorMessage: function(errorMessage) {
        var self = this;
        EPMErrorHandler.setError(errorMessage);
        
        // Set an interval and clear the error message
        var intervalID = setInterval(function(){
            self._clearErrorMessage();
            clearInterval(intervalID);
        }, 10000);  
    },
	/**
	 * Clear the error message
	 */
	 
    _clearErrorMessage: function(){
        EPMErrorHandler.clearError();
    },
	
	/**
	 * _populatecreateMenu: temp method to disable the create button for the resource types other than program and project.
	 * publishedObj: object published from the WBS tree.
	 */
	_populatecreateMenu: function(publishedObj){
			if (this._wbsTree._wbsTree) {
				if (this._wbsTree._wbsTree._isNodeNew(publishedObj)) {
					this._newWBSCommand.disabled = true;
				}
				else {
					this._newWBSCommand.disabled = false;
				}
			}
			
			if ((publishedObj) && (publishedObj.treeID === EPMConstants.WBS_TREE_ID)) {
				var nodeIdentifier = dojo.isArray(publishedObj.identifier) ? publishedObj.identifier[0] : publishedObj.identifier;
				if ((this.selectedNodeIdentifier) && (this.selectedNodeIdentifier == nodeIdentifier)) {
					return;
				}

				this.selectedNodeIdentifier = nodeIdentifier;
				this._updateTitle(publishedObj);
			}
	},

	/**
	 * updateTitle: Updates the dashboard title with the selected name and icon
	 */	
	_updateTitle: function(publishedObj){
		if ((publishedObj) && (publishedObj.treeID === EPMConstants.WBS_TREE_ID)) {
			if (!publishedObj.collapseAll) {
				var iconClass = dojo.isArray(publishedObj.iconClass) ? publishedObj.iconClass[0] : publishedObj.iconClass;
				var iconUrl = dojo.isArray(publishedObj.iconUrl) ? publishedObj.iconUrl[0] : publishedObj.iconUrl;
				
				this._updateSelectedNodeName(publishedObj.name, iconUrl, iconClass);
			} else {
				this.updateCurrentSelectedNode();
			}
		}
	},

	/**
	 * updateTitleWithTreeSelection: Updates the title with the selected name
	 */
	updateTitleWithTreeSelection: function(selectedElementName, iconUrl, iconClass) {
		if (!selectedElementName) {
			selectedElementName = " ";
		}
		
		if (this._dashboardTitle) {
			var length = 0;
			if (this._dashboardTitle.hasChildNodes()) {
				length = this._dashboardTitle.childNodes.length;
				for (var i=0; i<length; i++) {
					// Added an extra null/undefined check to make sure that it doesn't throw an error here.
					if (this._dashboardTitle.childNodes[i]) {
						this._dashboardTitle.removeChild(this._dashboardTitle.childNodes[i]);
					}
				}
				length = this._dashboardTitle.childNodes.length;
			}
			
			//hiding the title if the view is Timesheets
			if  (this._topNav._usrViews && (this._topNav._usrViews[2]) && this._topNav._usrViews[2].id) {
			
				if(this._dashboard.scopeItem.id&&this._dashboard.scopeItem.id==this._topNav._usrViews[2].id)
				{
					return;
				}
			}
			var textNode = document.createTextNode(selectedElementName);
			if (this._dashboardTitle.firstChild) {
				if (iconUrl) {
					var image = document.createElement("img");
					image.src = iconUrl;
					image.style.marginRight = "6px";
					this._dashboardTitle.replaceChild(image, this._dashboardTitle.firstChild);
					this._dashboardTitle.appendChild(textNode);
				} else if(iconClass){
					var spanElement = this._buildImageFromClassName(iconClass);
					this._dashboardTitle.replaceChild(spanElement, this._dashboardTitle.firstChild);
					this._dashboardTitle.appendChild(textNode);
				}
				else {
					this._dashboardTitle.replaceChild(textNode, this._dashboardTitle.firstChild);
				}
			}
			else {
				if (length === 0) {
					if (iconUrl) {
						var image = document.createElement("img");
						image.src = iconUrl; 
						image.style.marginRight = "6px";
						this._dashboardTitle.appendChild(image);
					}else if (iconClass){
						var spanElement = this._buildImageFromClassName(iconClass);
						this._dashboardTitle.appendChild(spanElement);
					}
					this._dashboardTitle.appendChild(textNode);
				}
			}
			this._dashboardTitle.title = selectedElementName;
			this._dashboardTitle.style.visibility = "";
		}
	},

	/**
	 * Update the icon when tree or details view publish a type change event.
	 * @param {Object} iconNode
	 * @param {Object} isUrl
	 */
	_updateIconInTitle: function(iconNode, isUrl){
		if (iconNode) {
			if (isUrl === true) {
				var iconUrl = dojo.isArray(iconNode.src) ? iconNode.src[0] : iconNode.src;
				if (iconUrl) {
					var newImage = document.createElement("img");
					newImage.src = iconUrl;
					newImage.style.marginRight = "6px";
					this._dashboardTitle.replaceChild(newImage, this._dashboardTitle.firstChild);
				}
			}
			else {
				var iconClass = dojo.isArray(iconNode.className) ? iconNode.className[0] : iconNode.className;
				if (iconClass) {
					var spanElement = this._buildImageFromClassName(iconClass);
					this._dashboardTitle.replaceChild(spanElement, this._dashboardTitle.firstChild);
				}
			}
		}
	},

	/**
	 * Method to build an image from the class name.
	 * @param {Object} iconClass
	 */
	_buildImageFromClassName: function(iconClass){
		var spanElement = document.createElement("span");
		dojo.addClass(spanElement, iconClass);
		
		var image = document.createElement("img");
		image.src = this._blankGif;
		image.style.width = "16px";
		image.style.height = "16px";
		image.style.marginRight = "6px";
		spanElement.appendChild(image);
		return spanElement;
	},
	
	/**
	 * _deselectTreeNodeInTitle: Removes the selected tree node in the title as its deselected (used to handle delete of an selected element in the tree)
	 */	
	_deselectTreeNodeInTitle: function(publishedObj){
		if ((publishedObj) && (publishedObj.treeID === EPMConstants.WBS_TREE_ID)) {
			var nodeIdentifier = dojo.isArray(publishedObj.identifier) ? publishedObj.identifier[0] : publishedObj.identifier;
			if (nodeIdentifier == this.selectedNodeIdentifier) {
				this.selectedNodeIdentifier = "";
				this.selectedNode = "";
				this.updateTitleWithTreeSelection(" ");
			}
		}
	},

	/**
	 * _updateTreeNodeInTitleOnRename: Handle case when the selected node is renamed
	 */	
	_updateTreeNodeInTitleOnRename: function(publishedObj){
		if ((publishedObj) && (publishedObj.treeID === EPMConstants.WBS_TREE_ID)) {
			var treeItem = publishedObj.item;
			if (treeItem) {
				var nodeIdentifier = dojo.isArray(treeItem.identifier) ? treeItem.identifier[0] : treeItem.identifier;
				if (nodeIdentifier == this.selectedNodeIdentifier) {
					var iconUrl = dojo.isArray(treeItem.iconUrl)?treeItem.iconUrl[0]: treeItem.iconUrl; 
					var iconClass = dojo.isArray(treeItem.iconClass)?treeItem.iconClass[0]: treeItem.iconClass; 
					this._updateSelectedNodeName(treeItem.name, iconUrl, iconClass);
				}
			}
		}
	},

	/**
	 * _updateSelectedNodeName: Update the selected node name with the specified name
	 */		
	_updateSelectedNodeName: function(name, iconUrl, iconClass) {		
		if (this.selectedNodeIdentifier.indexOf(EPMConstants.UNSAVED) != -1) {
			this.selectedNode = "(" + EPMViewMessages.UNSAVED_WBS_ELEMENT + ") " + name;
		} else {
			this.selectedNode = name;
		}

		this.updateTitleWithTreeSelection(this.selectedNode, iconUrl, iconClass);
	},
	
	/**
	 * _disableCreateMenu: Disables the create menu population for the new node.
	 */
	_disableCreateMenu: function(){
		this._newWBSCommand.disabled = true;
	},

	/**
	 * updateCurrentSelectedNode: Fetch the currently selected node in the tree and update the title
	 */	
	updateCurrentSelectedNode: function(){
		this.selectedNode = "";
		this.selectedNodeIdentifier = "";
		var iconClass = null;
		var iconUrl = null;
		
		var tree = dijit.byId(EPMConstants.WBS_TREE_ID);
		if (tree && tree._selectedNode) {
			var item = tree._selectedNode.item;
            if (item && item.name) {
				this.selectedNode = dojo.isArray(item.name) ? item.name[0] : item.name;
				this.selectedNodeIdentifier = dojo.isArray(item.identifier) ? item.identifier[0] : item.identifier;
				iconClass = dojo.isArray(item.iconClass)?item.iconClass[0]:item.iconClass;
				iconUrl = dojo.isArray(item.iconUrl)?item.iconUrl[0]:item.iconUrl;
			}
		}
		this._updateSelectedNodeName(this.selectedNode,iconUrl,iconClass);
	},

    /*
     * Event handler for window unload event. 
     */
    _handleWindowUnload: function(){
		this.destroy();
	}
});

    var oldSetEditMode = com.ibm.team.dashboard.web.ui.internal.ViewletContainer.prototype.setEditMode;
	com.ibm.team.dashboard.web.ui.internal.ViewletContainer.prototype.setEditMode =
	function(editing) {
		var self = this;
		if (this._viewlet == null) {
			return;
		}
		oldSetEditMode.apply(self, arguments);
	};

    var oldSelectTabAction = com.ibm.team.dashboard.web.ui.internal.dnd.DraggableTabs.prototype._selectTabAction;
	com.ibm.team.dashboard.web.ui.internal.dnd.DraggableTabs.prototype._selectTabAction = 
	 	function(/*Widget*/ widget) {
			var self = this;
            var viewletContainer = this.dashboardContainer.currentPage.columns;
			var currentViewletPage = viewletContainer[0];
			if (currentViewletPage) {
				var currentViewletWidget = currentViewletPage.widgets[0];
				if (currentViewletWidget) {
					var currentViewlet = currentViewletWidget._viewlet;
					if (currentViewlet && dojo.isFunction(currentViewlet.isDirty)) {
						var isViewletDirty = currentViewlet.isDirty();
						if (isViewletDirty === true) {
							var buttonlist = [{
								label: EPMViewMessages.OK,
								action: dojo.hitch(this, _discardChanges, widget)
							}, {
								label: EPMViewMessages.CANCEL,
								action: dojo.hitch(this, _cancelOperation)
							}];
							
							var labelList = [{
								label: EPMViewMessages.SWITCHING_TAB_EXCEPTION
							}];
							
							this.discardUnsavedDialog = new EPMConfirmDialog({
								labelList: labelList,
								title: EPMViewMessages.DISCARD_CHANGES_TITLE,
								buttonlist: buttonlist
							});
							this.discardUnsavedDialog.show();
							return;
							
						}
					}
				}
			}
			oldSelectTabAction.apply(self, arguments);
			
			function _discardChanges(widget){
			    // Disable the last stored object to be focused back again
			    // This was causing the date picker editor to be popped up
			    // when it should not have in dialog.close(). For details
			    // refer WI 15713.
                this.discardUnsavedDialog.dialog._lastFocus = null;
                
				this.discardUnsavedDialog.destroy();
				
				// set the discard flag since we would discard the changes later and not immediately
				if ((this.dashboardContainer) && (this.dashboardContainer.currentPage)) {
					var viewletContainer = this.dashboardContainer.currentPage.columns;
					var currentViewletPage = viewletContainer[0];
					if (currentViewletPage) {
						var currentViewletWidget = currentViewletPage.widgets[0];
						if (currentViewletWidget) {
							var currentViewlet = currentViewletWidget._viewlet;
							// Set discard flag to true
							currentViewlet.setDiscardFlag();
						}
					}
				}
				
				// Call the reference of the original function
				oldSelectTabAction.apply(self, arguments);
			}
			function _cancelOperation(){
                // Disable the last stored object to be focused back again
                // This was causing the date picker editor to be popped up
                // when it should not have in dialog.close(). For details
                // refer WI 15713.
			    this.discardUnsavedDialog.dialog._lastFocus = null;
			    
				this.discardUnsavedDialog.destroy();
			}
		};
})();
