/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.web.core.ui.internal.EPMView.LeftNavigationLayout");
dojo.require("jazz.ui.SideNavigationLayout");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Button");

(function() {
dojo.declare("com.ibm.epm.web.core.ui.internal.EPMView.LeftNavigationLayout",
	[jazz.ui.SideNavigationLayout], {

	constructor: function(args){
		
	},
	
	addCommand: function(args) {
		args["class"] = "net-jazz-ajax-SideNavigationLayout-navCommand";
		var button = new com.ibm.epm.web.core.ui.internal.EPMView.Button(args);
		this._leftNav.appendChild(button.domNode);
		return button;
	},
    
    /**
     * Overridden method for handling animation when the splitter is opened.
     * This method publishes an event for the ScheduleGanttViewlet to resize
     * the Gantt's width appropriately.
     */
    _onShowAnimationEnd: function(){
        this.inherited(arguments);
        this._publishEvent();
    },

    /**
     * Overridden method for handling animation when the splitter is collapsed.
     * This method publishes an event for the ScheduleGanttViewlet to resize
     * the Gantt's width appropriately.
     */    
    _onHideAnimationEnd: function() {
        this.inherited(arguments);
        this._publishEvent();
    },
    
    /**
     * Overridden method for handling the dragging movement of the splitter.
     * This method publishes an event for the ScheduleGanttViewlet to resize
     * the Gantt's width appropriately.
     */    
    _stopDragging: function(e){
        this.inherited(arguments);
        this._publishEvent();
    },
    
    /**
     * Publish an event for the ScheduleGanttViewlet
     */
    _publishEvent: function() {
        // Get the dimensions of my left navigator
        var splitterDom = dojo.contentBox(this._leftNav);
        
        // Construct an object to be be published
        var data = {
            type: "TreeGridSplitter",
            navState: this._currentLeftNavState,
            splitterDom: splitterDom
        };
        
        // Publish the object
        dojo.publish("com.ibm.epm.web.core.ui.internal.EPMView.LeftNavigationLayout.onEnd", [data]);
    }    		
});

})();
