/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.financial.web.ui.internal.FinancialDetailsGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.require("com.ibm.epm.web.core.ui.internal.FinancialConstants");
    dojo.requireLocalization("com.ibm.epm.financial.web.ui", "Messages");
   
    var Messages = dojo.i18n.getLocalization("com.ibm.epm.financial.web.ui", "Messages");
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    var FinancialConstants = com.ibm.epm.web.core.ui.internal.FinancialConstants;
    
    dojo.declare("com.ibm.epm.financial.web.ui.internal.FinancialDetailsGridModel", abstractGridModel, {
        newElementPrefix: "_unsaved",
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID){
            var row = {
                "id": rowID,
                "href": rowID,
                "name": "",
				"description": "",
                "forecast": 0.00,
                "estimate": 0.00,
                "actual": 0.00,
				"resourceType": "financialDetails",
				"forecastVariance": 0.0,
				"estimateVariance": 0.0,
				"action": "",
				"isForecastCalculate": true,
				"chargeCodeUri"	: "",			         
                "loadedelement": null
            };
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.name = loadedElement.name;
				row.description=loadedElement.description;
                row.forecast = loadedElement.forecast;
                row.estimate = loadedElement.estimate;
				row.actual = loadedElement.actual;
				row.resourceType = loadedElement.resourceType;
				row.isForecastCalculate = loadedElement.isForecastCalculate;
				row.chargeCodeUri = loadedElement.chargeCodeUri;
                row.loadedelement = [loadedElement]; 
				row.forecastVariance = loadedElement.forecast - loadedElement.actual;
				row.estimateVariance = loadedElement.estimate - loadedElement.actual;
            }
        },
        
        prepareSaveParams: function(row){
            var saveParams = {};
            return saveParams;
        },
        
        _getNewElementURI: function(row){
            return "";
        }
    });
})();

