/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.web.core.ui.internal.MouseTooltip");

(function(){
    dojo.declare("com.ibm.epm.web.core.ui.internal.MouseTooltip", dijit.Tooltip, {
    
    
        _open: function(args){
            // summary:
            //		shows the InnerHTML at the specified position
            //
            // args: Object
            //		innerHTML: HTML to be displayed
            //		target: DomNode
            //			DOM node ; place tooltip relative to this node
            //		orient: Object
            //			structure specifying possible positions of popup relative to "around" node
            
            //
            // examples:
            //		1. opening at the mouse position
            //			dijit.popup.open({HTML: HTML to display, x: evt.pageX, y: evt.pageY});
            //		2. opening the tooltip around the target node
            //			dijit.popup.open({HTML: HTML to display, target: this.domNode});
            var target = args.target || this._connectNodes[0];
            //			if(!target){ return; }
            
            if (this._showTimer) {
                clearTimeout(this._showTimer);
                delete this._showTimer;
            }
            dijit._showTooltip(args);
            
            this._connectNode = target;
        },
        _close: function(target){
            // summary: hide the tooltip; usually not called directly.
            dijit._hideTooltip(target);
            //			delete this._connectNode;
            if (this._showTimer) {
                clearTimeout(this._showTimer);
                delete this._showTimer;
            }
        }
        //dijit.showTooltip = function(args){
        //	// summary:
        //	//	Display tooltip w/specified contents to right specified node
        //	//	(To left if there's no space on the right, or if LTR==right)
        //	if(!masterTT){ masterTT = new dijit._MasterTooltip(); }
        //	return masterTT._show(args);
        //},
        ////	hideTooltip = function(aroundNode){
        ////		// summary: hide the tooltip
        ////		if(!masterTT){ var masterTT = new dijit._MasterTooltip(); }
        ////			return masterTT.hide(aroundNode);
        ////		}
    
    });
    
})();
dijit._showTooltip = function(args){
    // summary:
    //	Display tooltip w/specified contents to right specified node
    //	(To left if there's no space on the right, or if LTR==right)
    if (!dijit._masterTT) {
        dijit._masterTT = new dijit._MasterTooltip();
    }
    return dijit._masterTT._show(args);
};
dijit._hideTooltip = function(aroundNode){
    // summary: hide the tooltip
    if (!dijit._masterTT) {
        dijit._masterTT = new dijit._MasterTooltip();
    }
    return dijit._masterTT._hide(aroundNode);
};
dojo.addOnLoad(function(){

    // for some reason dojo.moduleUrl refuses to work in an onload...?
    // have to override the template with a string
    dijit._MasterTooltip.prototype.templateString = 
	"<div class='dijitTooltip dijitTooltipLeft' id='dojoTooltip'>" +
    	"<div class='dijitTooltipWrapper'>" +
    		"<div class='dijitTooltipTopWrapper'>" +
    			"<div class='dijitTooltipTrimWrapperRel'>" +
    				"<div class='dijitTooltipTopTrim'></div>" +
    			"</div>" +
    		"</div>" +
    		"<div class='dijitTooltipContainer dijitTooltipContents' dojoAttachPoint='containerNode' waiRole='alert'>" +
    			"<div class='dijitTooltipSideTrim'>" +
    				"<div class='dijitTooltipInnerContentWrapper' dojoAttachPoint='innerContentWrapper'>" +
    					"<div dojoAttachPoint='contentNode' class='dijitTooltipInnerContent'>" +
    					"</div>" +
    				"</div>" +
    			"</div>" +
    		"</div>" +
    		"<div class='dijitTooltipBottomWrapper'>" +
    			"<div class='dijitTooltipTrimWrapperRel'>" +
    				"<div class='dijitTooltipBottomTrim'></div>" +
    			"</div>" +
    		"</div>" +
    		"<div class='dijitTooltipCornerBL'></div>" +
    		"<div class='dijitTooltipCornerBR'></div>" +
    		"<div class='dijitTooltipCornerTL'></div>" +
    		"<div class='dijitTooltipCornerTR'></div>" +
    	"</div>" +
    	"<div dojoAttachPoint='connectorWrapper'><div class='dijitTooltipConnector'></div>" +
    "</div>";
    
    // override the dijit._MasterTooltip.show() function
    dijit._MasterTooltip.prototype._show = function(args){
        // summary:
        //	Display tooltip w/specified contents to right specified node
        //	(To left if there's no space on the right, or if LTR==right)
        
        this.containerNode.innerHTML = args.innerHTML;
        
        // Firefox bug. when innerHTML changes to be shorter than previous
        // one, the node size will not be updated until it moves.  
        this.domNode.style.top = (this.domNode.offsetTop + 1) + "px";
        
        if (args.zIndex) {
            this.domNode.style.zIndex = args.zIndex;
        }
        
        // reset height in IE6 so CSS expression will work
        if (dojo.isIE && dojo.isIE < 7) {
            this.innerContentWrapper.style.height = "1px";
            this.innerContentWrapper.style.height = "";
        }
        
        if (dojo.hasClass(this.domNode, "dijitTooltipBlue")) {
            var width = document.documentElement.clientWidth * 0.8;
            var height = document.documentElement.clientHeight * 0.8;
            this.innerContentWrapper.style.maxWidth = width + "px";
            this.innerContentWrapper.style.maxHeight = height + "px";
        }
        else {
            this.innerContentWrapper.style.maxWidth = "";
            this.innerContentWrapper.style.maxHeight = "";
        }
        
        // position the element and change CSS according to position
        if (args.target) {
            var align = this.getAlign(args.target);
            if (!align) {
                return;
            }
        }
        this.connectorWrapper.style.display = "";
        
        //var args = {x: 700, y: 550,orient:'BR'};
        var orient = args.orient ||
        {
            'BL': 'TL',
            'TL': 'BL'
        };
        var pos = args.target ? dijit.placeOnScreenAroundElement(this.domNode, args.target, align) : dijit.placeOnScreen(this.domNode, args, orient == 'R' ? ['TR', 'BR', 'TL', 'BL'] : ['TL', 'BL', 'TR', 'BR']);
        
        // adjust position if necessary
        var viewportHeight = document.documentElement.clientHeight;
        var tipCoords = dojo.coords(this.domNode, false);
        var y = tipCoords.y;
        var connector = dojo.query(".dijitTooltipConnector", this.domNode)[0];
        
        if (pos.corner == 'TL' || pos.corner == 'BL') {
            dojo.addClass(this.domNode, "dijitTooltipRight");
            dojo.removeClass(this.domNode, "dijitTooltipLeft");
        }
        else {
            dojo.addClass(this.domNode, "dijitTooltipLeft");
            dojo.removeClass(this.domNode, "dijitTooltipRight");
        }
        if (pos.corner == 'TL' || pos.corner == 'TR') {
            dojo.addClass(connector, "dijitTooltipConnectorTop");
            dojo.addClass(this.containerNode, "dijitTooltipContainerTop");
            
            // Adjust position for custom style
            var offset = 0;
            while (y + tipCoords.h - offset > viewportHeight - 5 && y - offset - 3 > 5) {
                offset++;
            }
            this.domNode.style.top = (pos.y - offset - 3) + "px";
        }
        else {
            dojo.removeClass(connector, "dijitTooltipConnectorTop");
            dojo.removeClass(this.containerNode, "dijitTooltipContainerTop");
            
            // Adjust position for custom style
            this.domNode.style.top = pos.y + 10 + "px";
        }
        // ensure we are using as much space as possible if this is an image preview
        if (dojo.hasClass(this.domNode, "dijitTooltipBlue") && this.domNode.clientWidth < width) {
            var start = pos.x + 3;
            this.domNode.style.left = start + "px";
            var offset = 3;
            do {
                var oldWidth = this.domNode.clientWidth;
                this.domNode.style.left = start - offset + "px";
                offset += 3;
            }
            while (oldWidth < this.domNode.clientWidth && this.domNode.clientWidth <= width);
        }
        
        // determine if we should show the connector (don't if the node is hidden by the tooltip)
        // don't show it if we are using a menu
        var nodeCoords = dojo.coords(args.target, true);
        var tipCoords = dojo.coords(this.domNode, true);
        if (dojo.hasClass(this.domNode, "dijitTooltipMenu") ||
        tipCoords.y + tipCoords.h < nodeCoords.y ||
        tipCoords.y > nodeCoords.y + nodeCoords.h ||
        (dojo.hasClass(this.domNode, "dijitTooltipLeft") && tipCoords.x + tipCoords.w > nodeCoords.x + nodeCoords.w) ||
        (dojo.hasClass(this.domNode, "dijitTooltipRight") && tipCoords.x < nodeCoords.x)) {
            this.connectorWrapper.style.display = "none";
        }
        else {
            var midpoint = nodeCoords.y + nodeCoords.h / 2 - 5;
            connector.style.top = midpoint - tipCoords.y + "px";
        }
        
        
        this.isShowingNow = true;
        //		this.aroundNode = aroundNode;
    };
    dijit._MasterTooltip.prototype._hide = function(target){
        if (this._onDeck) {
            // this hide request is for a show() that hasn't even started yet;
            // just cancel the pending show()
            this._onDeck = null;
            return;
        }
        this.fadeIn.stop();
        this.isShowingNow = false;
        this.aroundNode = null;
        this.fadeOut.play();
    };
    // determine where the node is in the viewport and generate the align param for dijit.placeOnScreenAroundElement accordingly
    //   if aroundNode is in the right half of the viewport, try to place the tooltip on the left and vice versa
    //   if aroundNode is in the top half of the viewport, try to place the tooltip on the bottom and vice versa
    dijit._MasterTooltip.prototype.getAlign = function(/*DomNode*/aroundNode){
        var aroundNodePos = dojo.coords(aroundNode, true);
        // if all the coordinates are 0, the node no longer exists and the show should be cancelled
        if (aroundNodePos.h == 0 && aroundNodePos.l == 0 && aroundNodePos.t == 0 && aroundNodePos.w == 0 && aroundNodePos.x == 0 && aroundNodePos.y == 0) {
            return false;
        }
        
        var scrollTop = self.pageYOffset;
        if (!scrollTop) {
            scrollTop = document.body.scrollTop;
        }
        var scrollLeft = self.pageXOffset;
        if (!scrollLeft) {
            scrollLeft = document.body.scrollLeft;
        }
        
        var forceLeft = this.orientation ? this.orientation.indexOf("L") != -1 : false;
        var forceRight = this.orientation ? this.orientation.indexOf("R") != -1 : false;
        var forceTop = this.orientation ? this.orientation.indexOf("T") != -1 : false;
        var forceBottom = this.orientation ? this.orientation.indexOf("B") != -1 : false;
        
        var invertRightLeft = forceLeft || (!forceRight && (document.body.offsetWidth - ((aroundNodePos.x + (aroundNodePos.w / 2)) - scrollLeft) < document.body.offsetWidth / 2));
        invertRightLeft = invertRightLeft ? !this.isLeftToRight() : this.isLeftToRight();
        if (forceBottom || (!forceTop && (document.body.offsetHeight - ((aroundNodePos.y + (aroundNodePos.h / 2)) - scrollTop) < document.body.offsetHeight / 2))) {
            if (dojo.hasClass(this.domNode, "dijitTooltipMenu")) {
                return invertRightLeft ? {
                    'TL': 'BL',
                    'TR': 'BR'
                } : {
                    'TR': 'BR',
                    'TL': 'BL'
                };
            }
            return invertRightLeft ? {
                'BR': 'BL',
                'BL': 'BR'
            } : {
                'BL': 'BR',
                'BR': 'BL'
            };
        }
        if (dojo.hasClass(this.domNode, "dijitTooltipMenu")) {
            return invertRightLeft ? {
                'BL': 'TL',
                'BR': 'TR'
            } : {
                'BR': 'TR',
                'BL': 'TL'
            };
        }
        return invertRightLeft ? {
            'TR': 'TL',
            'TL': 'TR'
        } : {
            'TL': 'TR',
            'TR': 'TL'
        };
    };
    
    dijit._MasterTooltip.prototype.hide = function(aroundNode){
        // summary: hide the tooltip
        if (!this.aroundNode || this.aroundNode !== aroundNode) {
            return;
        }
        this.isShowingNow = false;
        this.aroundNode = null;
        this._onHide();
    };
    
});
