/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.web.ui.internal.ResourceQueryEditorViewlet");
    
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.ViewConstants");
    dojo.require("com.ibm.epm.web.core.ui.internal.Viewlet");
    dojo.require("com.ibm.epm.web.core.ui.internal.view.queryeditor.QueryEditor");
    dojo.require("com.ibm.epm.web.core.ui.internal.page.QueryEditorPageController");
    dojo.require("com.ibm.epm.web.core.ui.internal.page.QueryEditorPageView");
 
    
    dojo.require("dijit.Tree");
    dojo.require("dojo.data.ItemFileReadStore");
    dojo.require("net.jazz.ajax.ui.PlatformUI");
    // Constants
    dojo.require("com.ibm.epm.resource.web.ui.internal.ResourceConstants");
	// Localization
    dojo.requireLocalization("com.ibm.epm.resource.web.ui", "Messages");
    
    var ResourceQueryEditorViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.web.ui", "Messages");
    var Viewlet = com.ibm.epm.web.core.ui.internal.Viewlet;
    var ViewConstants = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.ViewConstants;
    var RESOURCE_QUERY_TYPE = "user";
    var Constants = com.ibm.epm.resource.web.ui.internal.ResourceConstants;
	
    dojo.declare("com.ibm.epm.resource.web.ui.internal.ResourceQueryEditorViewlet", Viewlet, {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.web", "ui/internal/templates/ResourceQueryEditorViewlet.html"),
        contextHelpId:Constants.RESOURCE_QUERY_EDITOR_VIEWLET_CONTEXT_HELP_ID,
		
        init: function(){
			this.inherited(arguments);

			this.setCSHelpId(this.contextHelpId);
            this._updateTitle();
 		
        },
        
	    destroy: function() {
       		if(this.view) {
            	this.view.destroy();
            }
            
			this.inherited(arguments);
		},
        
        refresh: function(){
        	if(this.view){
        		this.view.destroy();
            }
        		
            this._content.innerHTML = "";
 
            this.view = new com.ibm.epm.web.core.ui.internal.page.QueryEditorPageView({
                queryType: RESOURCE_QUERY_TYPE
            });
            
 			if(this._viewletContainer._bodyContainer) {
				dojo.style(this._viewletContainer._bodyContainer, "overflow", "hidden");
			}
			            
            this._content.appendChild(this.view.domNode);
            var kwArgs = {
                id: "",
                type: RESOURCE_QUERY_TYPE
            };
            this.view.controller.editQuery(kwArgs);
        },
        
        update: function(){
        },
        
        
        settingsChanged: function(oldSettings, newSettings){
            var scopeChanged = false;
            var updateTitle = false;
            if (newSettings.scope != oldSettings.scope || newSettings.scopeItemId != oldSettings.scopeItemId) {
                updateTitle = true;
                scopeChanged = true;
            }
            if (updateTitle || newSettings.userTitle != oldSettings.userTitle) {
                this._updateTitle();
            }
            if (scopeChanged || (newSettings.scope != ViewConstants.SCOPE_CONTRIBUTOR && newSettings.scopeSubteams != oldSettings.scopeSubteams)) {
                this.getSite().refresh();
            }
            else {
                this.update();
            }
        },
        
        _updateTitle: function(){
            this.getSite().setTitle(ResourceQueryEditorViewletMessages.RESOURCE_QUERY_EDITOR);
        }
    });
    
    
})();
