/**
 * @author paul
 */
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.risk.web.ui.internal.RiskActionsGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
	dojo.requireLocalization("com.ibm.epm.risk.web.ui", "Messages");

    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
	var RiskMessages = dojo.i18n.getLocalization("com.ibm.epm.risk.web.ui", "Messages");
    
    dojo.declare("com.ibm.epm.risk.web.ui.internal.RiskActionsGridModel", abstractGridModel, {
  constructor: function(){
			this._containingGrid = arguments[0]._containingGrid;
		},
         /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
	getEmptyRow: function(rowID,collectionItemHandle){
            
			var row;
			
			 if(collectionItemHandle){
				row = {
                "id": rowID,
                "href": rowID,
                "name": collectionItemHandle.name?collectionItemHandle.name:"",
                "cost": collectionItemHandle.cost?collectionItemHandle.cost:0  ,
				"duration": collectionItemHandle.duration?collectionItemHandle.duration:1,
				"summary": collectionItemHandle.summary?collectionItemHandle.summary:"",
				"workitem": collectionItemHandle.workitem?collectionItemHandle.workitem:"",
				"workItemType": collectionItemHandle.workItemType?collectionItemHandle.workItemType:"",
				"workItemTypeIcon": collectionItemHandle.workItemTypeIcon?collectionItemHandle.workItemTypeIcon:"",
				"createtask":collectionItemHandle.createtask?collectionItemHandle.createtask:""
            	};
			}
			else {
				row = {
				"id": rowID,
                "href": rowID,
                "name": "",
                "cost": "",
				"summary": "",
				"duration": "",
				"workitem": "",
				"workItemType": "",
				"workItemTypeIcon": "",
				"createtask": ""		
            	};
			}
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName === null) {
                row.name = loadedElement.summary;
                row.summary = loadedElement.summary;                
				row.cost = loadedElement.cost;
				row.duration = loadedElement.duration;
				row.workitem = loadedElement.workitem;
				row.workItemType = loadedElement.workItemType;
				row.workItemTypeIcon = loadedElement.workItemTypeIcon;
				row.createtask = loadedElement.createtask;
				row.loadedelement = [loadedElement];
            }            
        },
		
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        },
		
		prepareSaveParams: function(row){
			var saveParams = {};
			return saveParams;
		},
		
		_getNewElementURI: function(row){
			return "";
		}
    });
})();
