/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.risk.web.ui.internal.RiskDescription");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.DojoData");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskUtil");
    dojo.require("dojo.data.ItemFileReadStore");
	dojo.require("dijit.form.Textarea");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskGridView");
    
    // Localization
    dojo.requireLocalization("com.ibm.epm.risk.web.ui", "Messages");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskConstants");
    
    var RiskConstants = com.ibm.epm.risk.web.ui.internal.RiskConstants;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    var dateUtil = com.ibm.epm.risk.web.ui.internal.RiskUtil;
	var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
    var RiskMessages = dojo.i18n.getLocalization("com.ibm.epm.risk.web.ui", "Messages");
    
    dojo.declare("com.ibm.epm.risk.web.ui.internal.RiskDescription", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.risk.web", "ui/internal/templates/RiskDescription.html"),
        wbsNodeType: "",
        wbsNodeName: "",
    	rownode: null,    
        
        
        /**
         *  postCreate : postCreate for the widget.
         *  Incoming Arguments : none
         *  Outgoing Argument : none
         *
         */
        postCreate: function(){
            this._createDescription();
			dojo.subscribe(RiskMessages.RISKUPDATE, this, "UpdateRiskDescription");
            
        },
        
        /**
         *  UpdateRiskValues : This function is to populate various attributes
         *  Incoming Arguments : Data from server to populate the fields.
         *  Outgoing Argument : none
         *
         */
        UpdateRiskDescription: function(data){
           this.rownode = data;
		    this.DescriptionEditor.attr('value',this.rownode.description);
        },
        /**
         *  _createDescription : This function is to create the Description Text, Edit button  and label.
         *  Incoming Arguments : none
         *  Outgoing Argument : none
         *
         */
        _createDescription: function(){
			var self=this;
            this.DescriptionEditor = new dijit.form.Textarea({
                onBlur: function(){
					var value = this.attr("value");
                    if (self.rownode && self.containerViewlet._riskGrid) {
                        self.rownode.description = value;
						self.containerViewlet._riskGrid.UpdateRowFields(self.rownode.rowIndex, value, "description");
                    }
                },
                disabled: false,
				intermediateChanges: true
            });
			this._riskDescriptionEditor.appendChild(this.DescriptionEditor.domNode);
        },
		
		_handleBlur: function(e){
			if (this.rownode && this.containerViewlet._riskGrid && e.target) {
				this.rownode.description = e.target.value;
				this.containerViewlet._riskGrid.UpdateRowFields(this.rownode.rowIndex, this.rownode.description, "description");
			}
		},
		
		disableDescriptionEdit: function(value){
            if (this.rownode !== null) {
               this.DescriptionEditor.attr('disabled', value);
            }
        },
		
		toggleDescriptionEditor: function(state){
			//var oldState = this.DescriptionEditor.disabled;
            //if (oldState != state) {
				this.DescriptionEditor.attr('readOnly',state);
				if (state) {
					 this.DescriptionEditor.attr('value',"");
				}
            //}
        },
        /*
         * Destroy all the objects created in the viewlet.
         */
        destroy: function(){
            if (this._riskChart) {
                this._riskChart.destroy();
                delete this._riskChart;
            }           
        }
		
    });
})();
