/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.risk.web.ui.internal.RiskDiscussion");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.DojoData");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskUtil");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");
    dojo.require("dojo.data.ItemFileReadStore");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMToolbar");
	dojo.require("dijit.form.Textarea");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskGridView");
    
    // Localization
    dojo.requireLocalization("com.ibm.epm.risk.web.ui", "Messages");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskConstants");
    
    var RiskConstants = com.ibm.epm.risk.web.ui.internal.RiskConstants;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    var dateUtil = com.ibm.epm.risk.web.ui.internal.RiskUtil;
	var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
    var RiskMessages = dojo.i18n.getLocalization("com.ibm.epm.risk.web.ui", "Messages");
    
    
    dojo.declare("com.ibm.epm.risk.web.ui.internal.RiskDiscussion", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.risk.web", "ui/internal/templates/RiskDiscussion.html"),
        wbsNodeType: "",
        wbsNodeName: "",
        rownode: null,
        
        
        /**
         *  postCreate : postCreate for the viewlet.
         *  Incoming Arguments : none
         *  Outgoing Argument : none
         *
         */
        postCreate: function(){
            this._createDescription();
			dojo.subscribe(RiskMessages.RISKUPDATE, this, "UpdateRiskDiscussions");
            
        },
        
        /**
         *  _createDescription : This function is to create the Description Text, Edit button  and label.
         *  Incoming Arguments : none
         *  Outgoing Argument : none
         *
         */
        _createDescription: function(){
			var self = this;
            this.DiscussionEditor = new dijit.form.Textarea({
				onBlur: function(){
					var value = this.attr("value");
                    if (self.rownode && self.containerViewlet._riskGrid) {
                        self.rownode.comments = value;
                        self.containerViewlet._riskGrid.UpdateRowFields(self.rownode.rowIndex, value, "comments");
                    }
                },
                disabled: false,
				intermediateChanges: true
            });
			
			this.discLabel = document.createElement("label");
            this.discLabel.innerHTML = "" ;
            
			this._riskDiscussionLabel.appendChild(this.discLabel);
			this._riskDiscussionEditor.appendChild(this.DiscussionEditor.domNode);
        },
		
		_handleBlur: function(e){
			if (this.rownode && this.containerViewlet._riskGrid && e.target) {
				this.rownode.comments = e.target.value;
				this.containerViewlet._riskGrid.UpdateRowFields(this.rownode.rowIndex, this.rownode.comments, "comments");
			}
		},
		
		toggleDiscussionWidget: function(state){
			this.DiscussionEditor.attr('readOnly',state);
			if (state) {
				this.DiscussionEditor.attr('value', "");
				this.discLabel.innerHTML = "";
			}
        },
		/**
         *  UpdateRiskDiscussions : This function is to populate various attributes
         *  Incoming Arguments : Data from server to populate the fields.
         *  Outgoing Argument : none
         *
         */
		UpdateRiskDiscussions: function(data){
			//Update the description box
			this.rownode = data;
			this.discLabel.innerHTML = data.internalComments;
			if(!data.comments)
			{
				data.comments = "";
			}
			this.DiscussionEditor.attr('value', data.comments);
        },
		
			/*
		 * Adds a new comment to teh risk
		 */ 
		_addComments: function(add){

		},
        
        /*
         * Destroy all the objects created in the viewlet.
         */
        destroy: function(){
            if (this._riskChart) {
                this._riskChart.destroy();
                delete this._riskChart;
            }           
        }
		
    });
})();
