/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.risk.web.ui.internal.RiskUtil");
    
    dojo.require("dojo.parser");
    dojo.require("dojo.date");
    dojo.require("dojo.date.locale");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskConstants");
    var RiskConstants = com.ibm.epm.risk.web.ui.internal.RiskConstants;
    com.ibm.epm.risk.web.ui.internal.RiskUtil = {
        
        /**
         *
         * @param {Object} inDatum
         */
		formatDate: function(inDatum){
			if (inDatum && (inDatum !== "") && (!isNaN(inDatum))) {
				var leastDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate(RiskConstants.LEAST_DATE);
				if (0 >= dojo.date.compare(leastDate, inDatum, 'date')) {
					return dojo.date.locale.format(new Date(Number(inDatum)), {selector: 'date', formatLength: 'medium'});
				}
			}
			return "";
        }
    };
})();
