/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.TreeDNDManager");
    
    dojo.require("dojo.dnd.Manager");
    dojo.require("com.ibm.epm.work.web.ui.internal.TreeDNDAvatar");
    
    var TreeDNDAvatar = com.ibm.epm.work.web.ui.internal.TreeDNDAvatar;
        
    dojo.declare("com.ibm.epm.work.web.ui.internal.TreeDNDManager", dojo.dnd.Manager, {
        
        /**
         * Overidden method from dojo.dnd.Manager to address "avatar is null" issue
         * @param {Object} flag
         */
        canDrop: function(flag){
            // summary: called to notify if the current target can accept items
            var canDropFlag = Boolean(this.target && flag);
            if(this.canDropFlag != canDropFlag){
                this.canDropFlag = canDropFlag;
                if (this.avatar) {
                    this.avatar.update();
                }    
            }
        },
        
        /**
         * Overidden method to create the avatar as seen on DND
         */        
        makeAvatar: function(){
            return new TreeDNDAvatar(this);
        }        
    });
    
    /**
     * Overrides the global dojo.dnd.manager to this implementation of the manager
     */
    dojo.dnd.manager = function() {
        if(!dojo.dnd._manager){
            dojo.dnd._manager = new com.ibm.epm.work.web.ui.internal.TreeDNDManager();
        }
        return dojo.dnd._manager;
    };
})();