/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.work.web.ui.internal.WBSConstants");

(function(){

    /*
     * WBS constants.
     */
    com.ibm.epm.work.web.ui.internal.WBSConstants = {
        /*
         * Grid editors
         */
        CALENDAR: "Calendar",
        PARENT: "Parent",
		PLANNED_FOR: "PlannedFor",
        PROGRAM_LINK: "Program",
        TIMECODE: "TimeCode",
        CHARGECODE: "ChargeCode",
        
        /*
         * Link names
         */
        PROPOSED_SCHEDULE: "ProposedSchedule",
        CRITICAL_PATH: "ProjectCriticalPath",
        CONSTRAINT: "Constraint",
        DEPENDENCY_LINK: "DependsOn",
        BLOCKS_LINK: "Blocks",
		BASELINE: "baseline",
		BASELINE2: "baseline2",
		NAME: "name",
		CHILDREN_LINK: "Children",
		PROJECTS_LINK: "Projects",
		ITERATIONS_LINK: "Iteration",
        
        PROPOSED_SCHEDULE_LINKTYPE: "com.ibm.epm.proposedSchedule",
        SCHEDULE_PREFIX: "/schedule",
        DEPENDENCY_LINKTYPE: "com.ibm.epm.work.linktype.dependency.startdatetoenddate",
        
		/*
		 * Field names 
		 */
		PROPOSED_START_FIELD_NAME: "proposedstart",
		PROPOSED_FINISH_FIELD_NAME: "proposedfinish",
		PROPOSED_DURATION_FIELD_NAME: "proposedduration",
		PROPOSED_EFFORT_FIELD_NAME: "proposedeffort",
		PLANNED_START_FIELD_NAME: "plannedstart",
		PLANNED_FINISH_FIELD_NAME: "plannedfinish",
		PLANNED_DURATION_FIELD_NAME: "plannedduration",
		PLANNED_EFFORT_FIELD_NAME: "plannedeffort",
		ACTUAL_START_FIELD_NAME: "actualstart",
		ACTUAL_FINISH_FIELD_NAME: "actualfinish",
		ACTUAL_EFFORT_FIELD_NAME: "actualeffort",
		PERCENT_C_FIELD_NAME: "percentC",
		PERCENT_EC_FIELD_NAME: "percentEC",
		PERCENT_DC_FIELD_NAME: "percentDC",
		NAME_FIELD_NAME: "name",
		
        /*
         * WBS Element types
         */
        EPM_MILESTONE_TYPE: "milestone",
        EPM_TASK_TYPE: "task",
        EPM_SUMMARY_TASK_TYPE: "summarytask",
        EPM_CHANGE_REQUEST_TYPE: "changerequest",
        EPM_ISSUE_TYPE: "issue",
        EPM_DEFECT_TYPE: "defect",
        EPM_RISK_TYPE: "risk",
		EPM_DOCUMENT_TYPE: "document",
		
        /*
         * WBS resource types
         */
		EPM_PROGRAM_TYPE: "program",
        EPM_PROJECT_TYPE: "project",
        WORKITEM_TYPE: "workitem",
		ITERATION_TYPE: "iteration",
		EPM_PROGRAM_TYPE_NAME: "Program",
		EPM_PROJECT_TYPE_NAME: "Project",
		EPM_ITERATION_TYPE_NAME: "Iteration",
		EPM_RISK_TYPE_NAME: "Risk",
		
		/*
		 * Schedule
		 */
		PROPOSED_SCHEDULE_PARAM: "proposedSchedule",
		COMMA: ",",
		STARTDATE: "startDate",
		FINISHDATE: "finishDate",
		DURATION: "duration",
		EQUALTO: "=",
		TIMESTAMP: " 00:00:00",
		SLASH: "/",
		EMPTY_STRING: "",
		LEAST_DATE: "1970-01-01",
        
		/*
		 * Constraints 
		 */
		CONSTRAINTTYPE: "constraintType",
		CONSTRAINTDATE: "constraintDate",
		
		/*
		 *Constraint default value 
		 */
		DEFAULT_CONSTRAINT_VALUE: " - ",
		/*
		 * Assignment Type
		 */
		ASSIGNMENT_TYPE_EFFORT	:  "Effort",
		ASSIGNMENT_TYPE_DURATION:  "Duration",
		ASSIGNMENT_TYPE_PARAM	:  "assignmentType",
		
        /*
         * Grid
         */
		WBS_OVERVIEW_GRID_ID : "WBS Overview",
		WBS_SCHEDULE_GRID_ID: "WBS Schedule",
        WBS_GRID_ID: "WBS Grid Gantt",
		WBS_BASELINE_GRID_ID : "WBS Baseline",
        
        /*
         * Tree
         */
        WBS_TREE_ID: "WBSTree",
        
        /*
         * Dependency types
         */
        FINISH_TO_START: "finishToStart",
        
        /*
         * Gantt timescale types
         */
        GANTT_YEAR: "Year",
        GANTT_QUARTER: "Quarter",
        GANTT_MONTH: "Month",
        GANTT_WEEK: "Week",
        
        /*
         * dnd Events
         */
        DND_MOVER_CLASS: "dojo.dnd.Mover",
        DND_MOVE_START: "/dnd/move/start",
        DND_MOVE_STOP: "/dnd/move/stop",
        
        //MenuIDs
        CREATE_PROJECT_ID: "CREATE_PROJECT",
        CREATE_WORKITEM_ID: "CREATE_WORKITEM",
        CREATE_SUMMARY_TASK_ID: "CREATE_SUMMARY_TASK",
        CREATE_MILESTONE_ID: "CREATE_MILESTONE",
        CREATE_CHANGE_REQUEST_ID: "CREATE_CHANGE_REQUEST",
        CREATE_DEFECT_ID: "CREATE_DEFECT",
        CREATE_ISSUE_ID: "CREATE_ISSUE",
        CREATE_RISK_ID: "CREATE_RISK",
        CREATE_TASK_ID: "CREATE_TASK",
        
        EXPORT_AS_XML_ID: "EXPORT_AS_XML",
        MSP_ERRORCODE:"ERRORCODE",
        
		RENAME_ID: "RENAME_ALL",
        EXPAND_ALL_ID: "EXPAND_ALL",
        COLLAPSE_ALL_ID: "COLLAPSE_ALL",
		REMOVE_ID: "REMOVE_WI",
		CURRENT_ITERATION_ID: "CURRENT_ITERATION",
        
        TASK_ASSIGNMENT: "TaskAssignment",
        UN_ASSIGNED: "Unassigned",
        
        //VARIABLE FOR RISK MATRIX ROWS
        TOTAL_MATRIX_ROWS: 5,
        MANIPULATION_FACTORY: 20,
        RADIX_PARAMETER: 10,
        
        RISKMATRIX: "Risk Matrix",
        RISKGRIDNAME: "EPMRiskGrid",
		
		//IMPORT
        MAP_RESOURCE :"MapResources",
		PROJECTS_URI : "projects",
		PROFILE_URI : "profile",
        
        //Append required for date to be in yyyy-mm-dd hh:mm:ss.fffffffff format
        DATE_APPEND_ZERO_TIME: " 00:00:00.000000000",
		
		EVENT_CALENDAREXCEPTION_CLOSE: "exceptionDialogClose",
		
		EVENT_CALENDARDATE_SELECTED: "calendarDateSelected",
		
		RISK_MANAGEMENT_VIEWLET_CONTEXT_HELP_ID: "cst_risk",
		
		WBS_OVERVIEW_VIEWLET_CONTEXT_HELP_ID: "cst_wbs_overview",
		
		WBS_SCHEDULE_VIEWLET_CONTEXT_HELP_ID: "cst_schedule_gantt",
		
		WBS_DETAILS_VIEWLET_CONTEXT_HELP_ID: "cst_wbsdetails",
		WBS_BASELINE_VIEWLET_CONTEXT_HELP_ID: "cst_baselines",
		
		//critical path
		 CRITICAL_PATH_URI : "criticalPath",
		 
		//resolve dependency
		RESOLVE_DEPENDENCY_KEY : "resolveDependency",
		 
		// Icon Class Constants
		CRITICAL_PATH_ICON_CLASS: "criticalPathButtonIcon",
		GOTOTODAY_ICON_CLASS: "gotoTodayButtonIcon",
		RESOLVEDEP_ICON_CLASS: "resolvedependencyButtonIcon",
		DEPENDENCY_ICON_CLASS: "dependencyButtonIcon",
		DEL_DEPENDENCY_ICON_CLASS: "deleteDependencyButtonIcon",
		REMOVE_WBS_ICON_CLASS: "removeWBSButtonIcon",
		
		/*
		 * Labour Forecast Type
		 */
		LABOUR_FORECAST_TYPE_CALCULATE	:  "Calculate",
		LABOUR_FORECAST_TYPE_MANUAL     :  "Manual",
		LABOUR_FORECAST_TYPE_PARAM	    :  "labourForecast",
		
		//WBS constraints
   		AS_SOON_AS_POSSIBLE: "AsSoonAsPossible",
    	AS_LATE_AS_POSSIBLE: "AsLateAsPossible",
    	FINISH_NO_EARLIER_THAN: "FinishNoEarlierThan",
    	FINISH_NO_LATER_THAN: "FinishNoLaterThan",
    	MUST_FINISH_ON: "MustFinishOn",
    	MUST_START_ON: "MustStartOn",
    	START_NO_EARLIER_THAN: "StartNoEarlierThan",
    	START_NO_LATER_THAN: "StartNoLaterThan"  
    };
    
})();
