/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub");

(function(){

    com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub = {
        // Published by WBS Grid/Gantt Viewlet
        /**
         * the object publish: NONE
         */
        ON_REFRESH: "OnRefresh",
        
        // Published by Gantt widget
        /**
         * the object publish:
         * publishObj = {
         *		id			: identifier,
         *		startDate 	: proposed start date,
         *		endDate 	: proposed end date
         *	}
         */
        // ON_UPDATE_GANTTBAR : "OnUpdateGanttBar",
        
        /**
         * the object publish:
         * publishObj = ganttBarId; //gantt widget id
         */
        ON_AFTER_UPDATE_GANTTBAR: "OnAfterUpdateGanttBar",
        
        /**
         * the object publish:
         * publishObj = targetDomNode; //div node
         */
        ON_GANTTBAR_RESIZE_START: "GanttBarResizeStart",
        
        /**
         * the object publish:
         * publishObj = targetDomNode; //div node
         */
        ON_GANTTBAR_RESIZE_END: "GanttBarResizeEnd",
        
        /**
         * the object publish:
         * publishObj = targetDomNode; //div node
         */
        ON_GANTTBAR_RESIZE_ABORT: "GanttBarResizeAborted",
        
        /**
         * the object publish:
         * publishObj = {
         *		sourceId	: identifier of predecessor,
         *		targetId 	: identifier of successor
         *	}
         */
        ON_CREATE_DEPENDS: "createDependency",
        
        /**
         * the object publish:
         * publishObj = targetDomNode; //div node
         */
        ON_GANTTBAR_MOVE_ABORT: "GanttBarMoveAborted",
        
        /**
         *  the object publish:
         *  publishObj = {
         *		identifier : identifier of the WBS element,
         *		treeID  : unique ID of the WBSTree,
         *		gridID  : unique ID of the WBSGrid,
         *		rowIndex : rowIndex of the row in the grid
         *	}
         */
        ON_GANTT_MOUSE_OVER: "GanttMouseOver",
        
        /**
         *  the object publish:
         *  publishObj = {
         *		identifier : identifier of the WBS element,
         *		treeID  : unique ID of the WBSTree,
         *		gridID  : unique ID of the WBSGrid,
         *		rowIndex : rowIndex of the row in the grid
         *	}
         */
        ON_GANTT_MOUSE_OUT: "GanttMouseOut",
        
        /**
         *  the object publish:
         *  publishObj = {
         *		identifier : identifier of the WBS element,
         *		treeID  : unique ID of the WBSTree,
         *		gridID  : unique ID of the WBSGrid,
         *		rowIndex : rowIndex of the row in the grid
         *	}
         */
        ON_GANTT_ROW_SELECT: "GanttRowSelect", 
		
		/**
         *  the object publish:
         *  publishObj = Nothing.
		 */
		DISCARD_UNSAVED_NODES: "discardUnsavedNodes",
		
		ON_DATE_EDITOR: "onDateEditor"
    };
    
})();
