/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.work.web.ui.internal.WBSTreeWidget");

// Icon class constants
dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.epm.web.core.client.internal.EPMTreeClient");
dojo.require("com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient");
dojo.require("com.ibm.epm.web.core.client.internal.WorkItemClient");


// Events published by the Grid/Gantt view
dojo.require("com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub");
// Events published by the WBS Tree Widget
dojo.require("com.ibm.epm.work.web.ui.internal.WBSTreePubSub");
// Needed for dojo.keys
dojo.require("dojo._base.event");

// tool bar widgets
dojo.require("dijit.form.Button");
dojo.require("jazz.ui.Dialog");

dojo.require("dojo.io.iframe");

// Data store
dojo.require("dojo.data.ItemFileWriteStore");

// Localization
dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");

//TreeUtil
dojo.require("com.ibm.epm.web.core.tree.TreeUtil");

//ControllerUtil
dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
dojo.require("com.ibm.epm.web.core.grid.controller.TreeBasedGridController");
dojo.require("com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants");

// Base class definition of EPMTree
dojo.require("com.ibm.epm.web.core.ui.internal.EPMWBSTree");
dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");

dojo.require("com.ibm.epm.work.web.ui.internal.WBSConstants");
// EPM Core Constants
dojo.require("com.ibm.epm.web.core.ui.internal.EPMConstants");
// Create Project Wizard
dojo.require("com.ibm.epm.work.web.ui.internal.projectwizard.ProjectWizard");
dojo.require("com.ibm.epm.work.web.ui.internal.msp.ImportWizard");
//Error Handler
dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");

//Grid model 
dojo.require("com.ibm.epm.web.core.grid.controller.GridModelClient");

//Confirm Dialog
dojo.require("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");

dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");

// General Constants
dojo.require("com.ibm.epm.web.core.util.internal.Constants");

// DND Support
dojo.require("dijit._tree.dndSource");
dojo.require("com.ibm.epm.work.web.ui.internal.TreeDNDSource");
dojo.require("com.ibm.epm.web.core.util.internal.Constants");
 
// Client
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.epm.web.core.grid.controller.ControllersFactory");

var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

var WBSConstants = com.ibm.epm.work.web.ui.internal.WBSConstants;
var CORE_Constants = com.ibm.epm.web.core.util.internal.Constants;
var WorkItemClient = com.ibm.team.workitem.web.client.internal.WorkItemClient;
var EPMWorkItemClient = com.ibm.epm.web.core.client.internal.WorkItemClient;
var EPMTreeClient = com.ibm.epm.web.core.client.internal.EPMTreeClient;
var EPMWebUIServiceClient = com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient;
var GridModelClient = com.ibm.epm.web.core.grid.controller.GridModelClient;
//Error handler 
var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler; 
//Confirm dialog
var EPMConfirmDialog = com.ibm.epm.web.core.ui.internal.EPMConfirmDialog;

var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
var ControllersFactory = com.ibm.epm.web.core.grid.controller.ControllersFactory;
(function(){

    // Client
    var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
    var controllerID = com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.WBSGeneralGridController;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
    // Localization
    var WorkMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
    
    // WBSTree base class
    //    var WBSTree = com.ibm.epm.work.web.ui.internal.WBSTree;
    
    var IconClass = com.ibm.epm.web.core.ui.internal.IconClassConstants;
    
    var WBSGridGanttPubSub = com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub;
    var WBSTreePubSub = com.ibm.epm.work.web.ui.internal.WBSTreePubSub;
    var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
	var EPMConstants = com.ibm.epm.web.core.ui.internal.EPMConstants;
    
    // MSProject Import
    var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var IMPEX_SERVICE_URI = "com.ibm.epm.impex.component.service.IEPMImpexService/";
    var _currentBindRequest;
    var _currentUploadFrameNumber = 100;
    
    //TreeUtil
    var TreeUtil = com.ibm.epm.web.core.tree.TreeUtil;
    
    // Base class definition of EPMTree
    var EPMTree = com.ibm.epm.web.core.ui.internal.EPMWBSTree;
    
    // General Constants
    var Constants = com.ibm.epm.web.core.util.internal.Constants;
    
    dojo.declare("com.ibm.epm.work.web.ui.internal.WBSTreeWidget", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.work.web", "ui/internal/templates/WBSTreeWidget.html"),
        CREATE_BUTTON_EVENT: "createButtonEvent",
        DEFAULT_PUBLISHED_OBJECT: "defaultPublishedObject",
        _createDisabled: false,
        
        // stores the various attributes of the 'Rename' menu item
		renameItem: {},
		// stores the various attributes of the 'Remove' menu item
		removeItem: {},
		
        constructor: function(args){
            // Attach to the side navigation domNode
            this._layout = args.mainPage._leftNav;
            
            // initialize the 'Rename' menu item
			this.renameItem = {
                "type": EPMConstants.MENU_TYPE,
                "id": WBSConstants.RENAME_ID,
                "parentID": null,
                "addSeparator": true,
                label: WorkMessages.RENAME,
                iconClass: IconClass.RENAME_ICON_CLASS,
                _onClick: dojo.hitch(this, this._rename)
        	};
			
			// initialize the 'Remove' menu item
			this.removeItem = {
	            "type": EPMConstants.MENU_TYPE,
	            "id": WBSConstants.REMOVE_ID,
	            "parentID": null,
	            "addSeparator": true,
	            label: WorkMessages.REMOVE,
	            iconClass: IconClass.REMOVE_ICON_CLASS,
	            _onClick: dojo.hitch(this, this._removeWorkItem)
	        };
        },
        
        postCreate: function(){            
            // Label for the WBSTree
            var statusLabel = document.createElement("label");
			//Added space to align it with 'WorkBreakdown text'.
            statusLabel.innerHTML = WorkMessages.STATUSLABEL_INNERHTML;
            
            this.LHS.appendChild(statusLabel);
            
            // List of subscriptions for this Widget
            this._subscriptions = [];
            
            this.eventSubscribe();
            
            this._openedItemIds = [];
            
            //Define the TreeStore and TreeData
            this._treeData = null;
            this._treeStore = null;
            this._wbsTree = null;
			
			// The controller needs to be initialized before the tree
			// is loaded as its the place where we store the WI
			// types to be showed in the grid's type column.
            if (!this._controller) {
                this._controller = controllerUtil.getTreeBasedGridController(controllerID);
            }
            
            this._createTree();
            
            // get the data for display	
            // this._getTopLevelWBSElements();
            
            this._content.appendChild(this._wbsTree.domNode);
        },
        
        eventSubscribe: function(){
            this._subscriptions = [ // Grid events on change of values
			dojo.subscribe(GridEvents.REPLACE_NODE, this, "_replaceNode"),
			dojo.subscribe(GridEvents.RENAME_NODE, this, "_renameExistingNode"),
			
 			dojo.subscribe(WBSTreePubSub.ON_NEW, this, "_createWbsElement"), // EPMGrid events for mouse hover and select
			dojo.subscribe(EPMGridPubSub.ON_ROW_CLICK, this, "_selectNodeOnRowClick"), 
			
			// WBSTree event to refresh
 			dojo.subscribe(WBSGridGanttPubSub.ON_REFRESH, this, "refresh"), // Gantt mouse hover events
			dojo.subscribe(WBSGridGanttPubSub.DISCARD_UNSAVED_NODES, this, "_removeAllUnsavedNodes"),
			
			dojo.subscribe(WBSGridGanttPubSub.ON_GANTT_ROW_SELECT, this, "_selectNodeOnRowClick"),
			dojo.subscribe(this.CREATE_BUTTON_EVENT, this, this._createWBSItemFromButton),
            dojo.subscribe(EPMTreePubSub.ON_KEY_DOWN, this, "_onKeyDown"),
            dojo.subscribe(EPMTreePubSub.ON_REQUEST_NEW_NODE, this, "_onKeyDown"),
            dojo.subscribe(EPMTreePubSub.ON_WI_TYPE_CHANGE, this, "_onWITypeChange"),
            dojo.subscribe(EPMTreePubSub.ON_EXPAND, this, "_onExpandNode"),
            dojo.subscribe(WBSTreePubSub.ON_DRAG_N_DROP, this, "_onDragNDrop",
            dojo.subscribe(EPMTreePubSub.ON_PARENT_CHILD_SAVE, this, "_onDragNDropSave"))];
        },
        
        _createTree: function(){
            // Call the tree util to create the store, add loading icon and message as the root node
			// This is removed once the elements are completely loaded
			var props = TreeUtil.getTreeStore(WBSConstants.WBS_TREE_ID, EPMConstants.LOADING, IconClass.LOADING_ICON_CLASS);
            props._containingWidget = this;
            props.dndController = "com.ibm.epm.work.web.ui.internal.TreeDNDSource";
            this._wbsTree = new EPMTree(props);
            this._wbsTree.startup();
            
			this.idIconMap = new Array();
			this.idLabelMap = new Array();
			
            //Array of nodes for which we dont want to enable Tree Menu 
            var nodes = [WBSConstants.EPM_TASK_TYPE, WBSConstants.EPM_MILESTONE_TYPE];
            
            //TODO Get all Programs , keeping projects for now
            var rootURIs = [ //"/projects", //TODO might be required when project @ root level will be supported.
				"/program"];
            var childrenLinks = ["Projects", "Iteration", "Children"];
            this._wbsTree.initialize(rootURIs, childrenLinks, "WBSTree", nodes, this.menuImage);
//			this._initMenu();
//			this._initHardCodedMenu();
        },
        
        handleRootElementFailure: function(errorObj){
            //TODO have to check with the error code not with the message here.
            if (errorObj.errorMessage == WorkMessages.USER_NOT_PART_OF_ANY_PROJECT_AREA) {
                this._disableCreate();
            }
        },
        
        _disableCreate: function(){
            if (this.importButton) {
                this.importButton.setDisabled(true);
            }
            this._createDisabled = true;
        },
        
        
        _createWorkItem: function(workItemType, iconUrl, e){
			this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
            var resourceType = WBSConstants.WORKITEM_TYPE;
            this._addWBSChildElement(e, resourceType, workItemType, iconUrl);
        },
              
		_createIteration: function(e){
			this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
			var resourceType = WBSConstants.ITERATION_TYPE;
			var workItemType = "";
			this._addWBSChildElement(e, resourceType, workItemType, null);
		},

        _createProject: function(e){
            var resourceType = WBSConstants.EPM_PROJECT_TYPE;
            var workItemType = "";
			// Get the focused node data - parent id, parent name		
            this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
            var parentItem = this._ctxNode.item;
			var parentNodeID = dojo.isArray(parentItem.identifier) ? parentItem.identifier[0] : parentItem.identifier;
			this._loadProjectWizard(parentNodeID);
        },
		
		/**
		 * _loadProjectWizard: To get the work item data from the rowURI.
		 * 						On success populates the project wizard dialog.
		 * @param {Object} nodeID: WBSTree node id.
		 */
        _loadProjectWizard: function(nodeID){
            var self = this;
            var getWBSItemDataFunctions = {
                success: function(loadedElement){
					self._projectWizardPopup(loadedElement);
                },
                failure: function(errorObj){
                    self.handleError(errorObj.errorMessage, self.errorOpeningWorkItem);
                }
            };
            
            var srh = new ServiceResponseHandler(getWBSItemDataFunctions, "success", "failure");
			GridModelClient.getURI(srh, nodeID);
        },

		/**
		 * _projectWizardPopup: Populates project creation dialog
		 * @param {Object} parentID
		 * @param {Object} parentName
		 */
		_projectWizardPopup: function(parentNodeData) {
			// Nullify the dialog if already exists	
            if (this.newDlg) {
				this.newDlg.destroy();
                this.newDlg = null;
            }

			this.projectwizard = new com.ibm.epm.work.web.ui.internal.projectwizard.ProjectWizard();			

            this.newDlg = new jazz.ui.Dialog({
                contentNode : this.projectwizard.domNode,
				primaryTitle: WorkMessages.PORJECT_WIZARD_TITLE,
				width: "400px",
				onOpen: dojo.hitch(this, this._openDlg),
				onClose: dojo.hitch(this, this._closeDlg)
            });
 
			this.projectwizard.load(this._wbsTree, this.newDlg, parentNodeData);
		},
        
        _addWBSChildElement: function(e, wbsResourceType, workItemType, iconUrl){
        
            var menuWidget = dijit.getEnclosingWidget(e.target);
            var menuLabel = menuWidget.label;
            
            this._ctxNode = this._wbsTree.getNodeContext();
            var wbsElementname = this._getChildName(menuLabel, this._ctxNode);
            
            var parentID;
            var nodeItem = this._ctxNode.item;
            if (dojo.isArray(this._ctxNode.item)) {
                nodeItem = this._ctxNode.item[0];
            }
            parentID = this._ctxNode.item.identifier;
            if (dojo.isArray(nodeItem.identifier)) {
                parentID = nodeItem.identifier[0];
            }
            
            var tempID = controllerUtil.getRandomNumber();
            var tempProjname = wbsElementname;
			
			
            var resourcetypeiconclass = (wbsResourceType != WBSConstants.WORKITEM_TYPE) ?
											wbsResourceType  + "Icon" : workItemType + "Icon";
            var parentNode = this._getNodeByItemIdentity(parentID);
            var item = {
                "href": tempID + "_unsaved",
                "name": tempProjname,
                "identifier": tempID + "_unsaved",
                "resourcetype": wbsResourceType,
                "workItemType": workItemType,
                "parentIdentifier": parentID,
                "detailLevel": false,
				"iconClass": resourcetypeiconclass,
				"iconUrl": iconUrl,
                "label": menuLabel,
				"rpcSequenceValue": this._wbsTree._getSequencevalueForNewNode(parentNode)
            };
			
			this._addItemToTreeAndGrid(item, parentNode);            
            // Close the popup menu
//            this._wbsTree.closeMenu();
            
            if ((this._ctxNode.isExpandable === true) && (this._ctxNode.isExpanded === false)) {
                this._wbsTree._expandNode(this._ctxNode);
            }
        },
        
        /**
         * _createWBSItemFromButton: Generic method called when the createButton event is published from button. <br>
         * publishedObj: Details of the item to be created. <br>
         * parentNode: node under which the item has to be created. <br>
         */
        _createWBSItemFromButton: function(publishedObj, parentNode){
        	var resourceType = null;
			var workItemType = null;
			var resourcetypeiconclass = publishedObj.iconClass;
			var iconUrl = null;
			
            if (this._createDisabled == true) {
                return;
            }
            
            if (publishedObj == this.DEFAULT_PUBLISHED_OBJECT) {
                this._createProgram();
                return;
            }

            var parentID = null;           
			var parentName = null; 
			var tempID = controllerUtil.getRandomNumber();
            var tempName = publishedObj.label;

            if (parentNode) {
                parentID = parentNode.item.identifier;
                tempName = this._getChildName(publishedObj.label, parentNode);
				parentName = parentNode.item.name;
            }
            var wbsResourceType = publishedObj.resourceType;
			
            if (wbsResourceType == WBSConstants.EPM_PROJECT_TYPE) {
                resourceType = WBSConstants.EPM_PROJECT_TYPE;
                workItemType = "";
                
                if (dojo.isArray(parentID)) {
                    parentID = parentID[0];
                }
                
				this._loadProjectWizard(parentID);
				return;
            }else if(wbsResourceType == EPMConstants.ITERATION_ID){
                resourceType = WBSConstants.ITERATION_TYPE;
                workItemType = "";
				resourcetypeiconclass = publishedObj.iconClass;
			}else{
            	resourceType = WBSConstants.WORKITEM_TYPE;
				workItemType = wbsResourceType;				
	            nodeId = wbsResourceType;
				iconUrl = publishedObj.iconUrl;
			}
 						
            var item = {
                "href": tempID + "_unsaved",
                "name": tempName,
                "identifier": tempID + "_unsaved",
                "resourcetype": resourceType,
                "workItemType": workItemType,
                "parentIdentifier": parentID,
                "detailLevel": false,
				"iconClass": resourcetypeiconclass,
				iconUrl: iconUrl,
                "label": publishedObj.label,
				"rpcSequenceValue": this._wbsTree._getSequencevalueForNewNode(parentNode)
            };
			
			this._addItemToTreeAndGrid(item,parentNode);
        },
        
		
		
		_addItemToTreeAndGrid: function(item, parentNode){
            if (parentNode) {
            	// Check if the parent node is expandable and already expanded
                if ((parentNode.isExpandable === true) &&
                    (parentNode.isExpanded === false)) {
                    
                    // The parent node is not expanded.
                    // Store a reference to the item to be created
                    // after the expansion of the parent node
                    // The item will be created in _onExpandNode()
                    // which is listening for an ON_EXPAND event.
                    this._pendingAddItem = item;
                    
                    // Expand the parent Node    
                    this._wbsTree._expandNodeUsingID(parentNode.item.identifier);
                } else {
                
                	// The parent can either not be expanded
                	// or is already expanded. Just add a new node now.
                    this._wbsTree._addNode(parentNode.item, item, 0);
                }    
            }
            else {
                this._wbsTree._addNode(null, item, 0);
            }
            //select the created node.
            this._selectNodeById(item.identifier);
            
            this._publishCreateNodeEvent(item);
		},
		
        /**
         * _getChildName: fetches the list of children name and returns the unique name.
         * @param {Object} wbsElementType: wbs element type being created.<br>
         * @param {Object} parentNode: parentNode under which the node is getting created.<br>
         * Outgoing: returns the unique name for the wbs element.<br>
         *
         */
        _getChildName: function(wbsElementType, parentNode){
            var childNameCounter = 0;
            var childernNames = new Array();
            
            if (parentNode.hasChildren()) {
                var children = parentNode.getChildren();
                dojo.forEach(children, function(child){
                    childernNames.push(child.label);
                });
            }
            
            var uniqueName = this._getUniqueName(wbsElementType, childernNames);
            return uniqueName;
        },
        
        /**
         * _getUniqueName: retruns a unique name for the wbs element by comparing the name from the siblings.
         * Incoming:
         * @param {Object} wbsElementType: The type of WBS element being created.
         * @param {Object} siblingNames: The name of siblings which shouldn't get duplicated.
         *
         * Outgoing: unique name of the WBS element.
         */
        _getUniqueName: function(wbsElementType, siblingNames){
            var nameCounter = 0;
            do {
                nameCounter++;
                var proposedName = wbsElementType + "_" + nameCounter;
                var nameAlreadyPresent = false;
                
                if (siblingNames) {
                    for (var i = 0; i < siblingNames.length; i++) {
                        if (proposedName == siblingNames[i]) {
                            nameAlreadyPresent = true;
                            break;
                        }
                    }
                }
            }
            while (nameAlreadyPresent == true);
            
            return proposedName;
        },
		
		/**
		 * Call to confirm and invoke the resolve dependency
		 * @param {Object} e
		 * 
		 */
		_resolveDependencies: function(e){
			this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
			var parentID = this._getCurrentNodeID();
//            this._wbsTree.closeMenu();
			
			 var buttonlist = [{
                                            label: WorkMessages.YES,
                                            action: dojo.hitch(this, this._YesButtonHandler,this._ctxNode, parentID)
                                        }, {
                                            label: WorkMessages.NO,
                                            action: dojo.hitch(this, this._NoButtonHandler)
                                        }];
			 
										
			var labelList = [ {label: WorkMessages.WARNING_BEFORE_RESOLVING_DEPENDENCY
                                        }];
										
		     					
			this.resolveDependencyDialog = new EPMConfirmDialog({
                                            labelList: labelList,
                                            title: WorkMessages.RESOLVE_DEPENDENCY,
                                            buttonlist: buttonlist
                                        });
                                        
            this.resolveDependencyDialog.show();
			
						
			
			
		},
		
		/**
		 * Make the call if user clicks on yes 
		 */
		_YesButtonHandler: function(ctxtNode, parentID){
			if (this.resolveDependencyDialog != null) {
				this.resolveDependencyDialog.destroy();
				this._calculateCriticalPath(ctxtNode, parentID);
			}
		},
		/**
		 * close and destroy if user clicks of No 
		 */
		_NoButtonHandler: function(){
            if(this.resolveDependencyDialog != null)
			{
				this.resolveDependencyDialog.destroy();
			}
        },
		
		/**
		 * Make a post call to critical path service .
		 * The critical path is freshly computed and then 
		 * the tasks which are inconsistent are updated with
		 * the earlystart and earlyfinish dates.
		 * @param {Object} projectId
		 */
		_calculateCriticalPath: function(ctxtNode, projectId, force)
		{
			var self = this;
			force = (force==true) ? force : false;
			var serviceObj = {
                success: function(data){
					if (ctxtNode.item) {
						//trigger grid and gantt update as well.
						self._wbsTree.nodeRefresh(ctxtNode.item, true);
					}
                },
                failure: function(errorObj){
					var controller = self._controller;
					if(!controller.isViewActive()){
						controller = controllerUtil.getTreeBasedGridController(com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.ScheduleGridController);
					}
					if (errorObj.errorMessage && controller && controller.isViewActive()) {
						var workitemIndex = errorObj.errorMessage.indexOf(WBSConstants.WORKITEM_TYPE);
						if (workitemIndex && workitemIndex > -1) {
							var workitemID = errorObj.errorMessage.substring(workitemIndex);
							var rowIndex = controller.getRowIndex(workitemID);
							if (rowIndex && rowIndex > -1) {
								var row = controller.getRowByIndex(rowIndex);
								controller._propogateErrorMessage(errorObj.errorMessage, row, workitemID);
							}
							//Truncate the message as we don't need to display the work item number.
							self._displayAndClearErrorMessage(errorObj.errorMessage.substring(0, workitemIndex), errorObj.errorCode);
						} else 
						{
							if(errorObj.errorCode == "CRIPM2241E")
							{
								//display a dialog to confirm force action
								self._okToResolveDependency(ctxtNode, projectId);
								
								//discard if cancel selected or call this method (recursive) with force=true option
							}
							else 
							self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
						}
						
					}else{
						if(errorObj.errorCode == "CRIPM2241E")
							{
								//display a dialog to confirm force action
								self._okToResolveDependency(ctxtNode, projectId);
								
								//discard if cancel selected or call this method (recursive) with force=true option
							}
							else 
							self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
					}
                }
            };
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            
            var inputparams = {"resolveDependency":true};
            
            if(force == true) {
           		inputparams = {"resolveDependency":true, "forceProjectAssignmentExtension":true};
           	}
           
			GridModelClient.postURI(srh,  projectId + WBSConstants.SLASH + WBSConstants.CRITICAL_PATH_URI  , inputparams);	
			
		},
		
		
		/**
		 * Resolve Project Dependency
		 * Invoke a warning message 
		 * On Yes , make the call to the server 
		 * 
		 */
		_okToResolveDependency: function(ctxNode, projectId){
			var buttonlist = [{
	            label: WorkMessages.YES,
                action: dojo.hitch(this, this._WarningYesButtonHandler,ctxNode, projectId)
            }, {
                label: WorkMessages.NO,
                action: dojo.hitch(this, this._WarningNoButtonHandler)
            }];

			var labelList = [{
				label: WorkMessages.WARNING_BEFORE_RESOLVING_DEPENDENCY_IF_ASSIGNMENT_EXISTS
            }];
                             
			
			this.resolveDependencyWarningDialog = new EPMConfirmDialog({
                                            labelList: labelList,
                                            title: WorkMessages.RESOLVE_DEPENDENCY,
                                            buttonlist: buttonlist
                                        });
            this.resolveDependencyWarningDialog.show();
		},

		
		/**
		 * Make the call if user clicks on yes 
		 */
		_WarningYesButtonHandler: function(ctxtNode, parentID){
			if (this.resolveDependencyWarningDialog != null) {
				this.resolveDependencyWarningDialog.destroy();
				this._calculateCriticalPath(ctxtNode, parentID, true);
			}
		},
		/**
		 * close and destroy if user clicks of No 
		 */
		_WarningNoButtonHandler: function(){
            if(this.resolveDependencyWarningDialog != null)
			{
				this.resolveDependencyWarningDialog.destroy();
			}
        },
        
		/**
		 * Call to confirm and invoke the export project
		 * @param {Object} e
		 */
        _exportProject: function(e){
        	this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
			var parentID = this._getCurrentNodeID();
//            this._wbsTree.closeMenu();
			
			 var buttonlist = [{
                                            label: WorkMessages.OK,
                                            action: dojo.hitch(this, this._OkButtonHandler,parentID)
                                        }, {
                                            label: WorkMessages.CANCEL,
                                            action: dojo.hitch(this, this._CancelButtonHandler)
                                        }];
			 
										
			var labelList = [ {label: WorkMessages.EXPORT+"?"
                                        }];
										
		     					
			this.exportDialog = new EPMConfirmDialog({
                                            labelList: labelList,
                                            title: WorkMessages.EXPORT,
                                            buttonlist: buttonlist
                                        });
                                        
            this.exportDialog.show();
          
        },
		
		
		/**
		 * Make the call if user clicks on Ok
		 */
		_OkButtonHandler: function(parentID){
			if(this.exportDialog != null)
			{
				 this.exportDialog.destroy();
				 location.href = TeamServerClient._getServicePrefix() + IMPEX_SERVICE_URI + "?PROJECT_ID=" + parentID;
			
			}
		},
		/**
		 * close and destroy if user clicks of Cancel
		 */
		_CancelButtonHandler: function(){
            if(this.exportDialog!= null)
			{
				this.exportDialog.destroy();
			}
        },
		
		
        //===========================================
        destroy: function(){
        
            if (this._wbsTree) {
                this._wbsTree.destroy(arguments);
                
            }
            TreeUtil.destroyTreeStore();
            this._unsubscribeToAllEvents();
        },
        
        /**
         * _unsubscribeToAllEvents: Method to unsubscribe to all events. <br>
         */
        _unsubscribeToAllEvents: function(){
            if (this._subscriptions != null) {
                for (var topic in this._subscriptions) {
                    var handler = this._subscriptions[topic];
                    if (handler) {
                        dojo.unsubscribe(handler);
                    }
                }
            }
            this._subscriptions = [];
        },
        
        _getElementType: function(labelName){
            var wbsElementType = "epm" + labelName.toLowerCase();
            wbsElementType = wbsElementType.replace(" ", "");
            return wbsElementType;
        },
        
        // refresh the WBS tree
        refresh: function(){
            //            // save the state of the tree before refresh
            //            if (this._wbsTree) {				
            //                this._openedItemIds = this._wbsTree._openedItemIds;
            //            }            
            ////            // get the data for display	
            ////            this._getTopLevelWBSElements();
            ////            
            
            this._wbsTree.refreshTree();
        },
        
		/**
		 * Method to remove all the unsaved tree nodes from the WBS Tree.
		 */
		_removeAllUnsavedNodes: function(){
			this._wbsTree.removeUnsavedTreeNodes();	
		},
		
        // Method to get the identifier from the related href
        _getResourceID: function(relatedHref){
        
            var index = relatedHref.lastIndexOf("/");
            
            if (index > 0) {
                return relatedHref.substring(index + 1, relatedHref.length);
            }
        },
        
        //Method to extract the resource type from the href
        _getResourceType: function(relatedHref){
        
            var index = relatedHref.lastIndexOf("/");
            
            if (index > 0) {
                relatedHref = relatedHref.substring(0, index);
                index = relatedHref.lastIndexOf("/");
                return relatedHref.substring(index + 1);
            }
        },
        
        
        
        _getItemNodeByIdentity: function(identifier){
        
            var node = this._wbsTree.getNodeByItemIdentity(identifier);
            if (node) {
                return node.item;
            }
            else {
                return null;
            }
        },
        
        _getNodeByItemIdentity: function(identifier){
            var node = this._wbsTree.getNodeByItemIdentity(identifier);
            if (node) {
                return node;
            }
            else {
                return null;
            }
            
        },
        
        
        _createStore: function(item){
        
        },
        
        _nodePresent: function(item){
        
        },
        
        /*
         *
         * _createProgram : Create program
         *  Incoming : None
         *  OutGoing : None
         */
        _createProgram: function(){
        
            var tempID = controllerUtil.getRandomNumber();
            var existingProgramNames = this._wbsTree.getRootLevelNames();
            var tempProgname = this._getUniqueName(WorkMessages.PROGRAM, existingProgramNames);
            
            var item = {
                "href": tempID + "_unsaved",
                "name": tempProgname,
                "identifier": tempID + "_unsaved",
                "parentIdentifier": null,
                "detailLevel": false,
                "resourcetype": WBSConstants.EPM_PROGRAM_TYPE,
                "iconClass": IconClass.PROGRAM_ICON_CLASS,
				"iconUrl":null
            };
            
            this._wbsTree._addNode(null, item, 0);
            
            //select the created node.
            this._selectNodeById(item.identifier);
            
            this._publishCreateNodeEvent(item);
        },
        
        /**
         *  _publishCreateNodeEvent : Published the WBSTreePubSub.ON_CREATE_NODE and pass the WBS tree ID in the event object
         *  Incoming : none
         *  Outgoing : none
         *
         */
        _publishCreateNodeEvent: function(item){
            var publishedObj = {
				name:item.name,
				identifier: item.identifier,
				resourcetype: item.resourcetype,
				rpcSequenceValue: item.rpcSequenceValue
			};
            publishedObj.uniqueIdentifier = {
                treeID: WBSConstants.WBS_TREE_ID
            };
            
            dojo.publish(WBSTreePubSub.ON_CREATE_NODE, [publishedObj]);
        },
		
        /**
         *  _createWbsElement : Create WBS elements other than project.
         *  Incoming : row
         *  Outgoing : none
         *
         */
        _createWbsElement: function(row){
            var tempID = controllerUtil.getRandomNumber();
            var tempProjname = row.name;
            var resourcetypeiconclass = row.resourcetype + "Icon";
            
            var item = {
                "href": tempID + "_unsaved",
                "name": tempProjname,
                "identifier": tempID + "_unsaved",
                "resourcetype": row.resourcetype,
                "parentIdentifier": row.parentId,
                "detailLevel": false,
                "iconClass": resourcetypeiconclass,
				"iconUrl": null
            };
            var node = this._getItemNodeByIdentity(row.parentId);
            
            this._wbsTree._addNode(node, item, 0);
            
            //select the created node.
            this._selectNodeById(item.identifier);
            
            this._publishCreateNodeEvent(item);
        },
        
        /**
         * _selectNodeById: select the node.
         * Incoming id: id of the row to be selected.
         * Outgoing: None.
         */
        _selectNodeById: function(id){
            if (id) {
                var createdNode = this._wbsTree._itemNodeMap[id];
                if (createdNode) {
                    this._wbsTree._selectTreeNode(createdNode);
                }
            }
        },
		
		 /**
         * _rename: called when user clicks on 'Rename' menu item.
         * @param {Object} TreeNode
         * Outgoing: none.
         */
        _rename: function(e){
            this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode);
            this._wbsTree._renameNode(this._ctxNode);
        },

        /**
         * _setCurrentIteration: called when user clicks on 'Set as Current' menu item.
         * @param {Object} e: event.
         * Outgoing: none.
         */
		_setCurrentIteration: function(event) {
			this._ctxNode = this._wbsTree.getNodeContext();
			if (this._ctxNode) {
				this.closeMenu(this._ctxNode);
				var uri = this._ctxNode.item.href;
				var params = {
	                currentIteration: true
	            };
				this._wbsTree._makePostCall(uri, params);
	
				// Update the previously set current iteration node
				if (this._wbsTree.currentIterationHref) {
					var prevCurrentIterationNode = this._wbsTree.getNodeByItemIdentity(this._wbsTree.currentIterationHref);
					if (prevCurrentIterationNode) {
						// Update the tree node icons for the previous iteration's nested iterations
						this.updateIconForNestedIterations(prevCurrentIterationNode, IconClass.ITERATION_ICON_CLASS, 0);
					}	
				}

				// update the new current iteration
				this._wbsTree.currentIterationHref = this._ctxNode.item.identifier[0];
									
				// Disable menu item option
	            if ((event) && (event.target)) {
					var menuItem = dijit.getEnclosingWidget(event.target.parentNode);
					menuItem.attr('disabled', true);
				}
				
				// Update tree node icon to indicate current iteration
				this._ctxNode.iconNode.src = this._blankGif;
				// Update the tree node icons for the current iteration's nested iterations
				this.updateIconForNestedIterations(this._ctxNode, IconClass.CURRENT_ITERATION_ICON_CLASS, 1);
				dojo.publish(EPMTreePubSub.TRIGGGER_DASHBOARD_ICON_UPDATE, [this._ctxNode.iconNode, false]);
			}
		},

        /**
         * updateIconForNestedIterations: Update the iconClass for all nodes in the tree hierarchy for nested iterations
         * @param parentNode
         * @param iconClass
         * @param currentIteration
         * Outgoing: none.
         */
		updateIconForNestedIterations: function(parentNode, iconClass, currentIteration) {
			if (parentNode) {
				var resourcetype = dojo.isArray(parentNode.item.resourcetype) ? parentNode.item.resourcetype[0] : parentNode.item.resourcetype;
				if (resourcetype != WBSConstants.ITERATION_TYPE) {
					return;
				}

				this._wbsTree.model.store.setValue(parentNode.item, 'currentIteration', currentIteration);
				this._wbsTree.model.store.setValue(parentNode.item, 'iconClass', iconClass);
				parentNode.iconNode.className = "dijitTreeIcon " + iconClass;
				parentId = parentNode.item.parentIdentifier;
				if (parentId) {
					parentNode = this._wbsTree.getNodeByItemIdentity(parentId);
					if (currentIteration == 0) {
						currentIteration = -1;
					}
					this.updateIconForNestedIterations(parentNode, iconClass, currentIteration);
				}
			}
		},
		
        /**
         * _expandAll: called when user clicks on 'Expand All' menu item.
         * @param {Object} e: event.
         * Outgoing: none.
         */
        _expandAll: function(e){
            
            this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
            if (this._ctxNode.hasChildren()) {
                this._wbsTree.expandSpecifiedNode(this._ctxNode);
            }
        },
        
        /**
         * _collapseAll: called when user clicks on 'Collapse All' menu item.
         * @param {Object} e: event.
         * Outgoing: none.
         */
        _collapseAll: function(e){
//            this._wbsTree.closeMenu();
            this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
            if (this._ctxNode.hasChildren()) {
                this._wbsTree._collapseSpecifiedNode(this._ctxNode);
            }
        },

        /**
         * _removeWorkItem: called when user clicks on 'Remove' menu item.
         * @param {Object} e: event.
         * Outgoing: none.
         */
        _removeWorkItem: function(e){
            this._ctxNode = this._wbsTree.getNodeContext();
			this.closeMenu(this._ctxNode, e);
            this._wbsTree.confirmAndRemoveNode(this._ctxNode);
        },
		
		closeMenu: function(node, e){
			var data = node.item;
			var menu = data.menu;
			if (menu) {
				menu = dojo.isArray(menu)?menu[0]:menu;
				dijit.popup.close(menu);
			}
		},
		
        /**
         *  _selectNodeOnRowClick : Event handler when there is a row click event on the Grid
         *  Incoming : publishedObject
         *  Outgoing : none
         *
         */
        _selectNodeOnRowClick: function(publishedItem){
            var row = this._validateAndGetRow(publishedItem);
            if (row && row.id) {
                this._wbsTree._selectNodeById(row.id);
            }
        },
        
        /**
         * _validateAndGetRow: Method to validate the published data and verify the grid id.
         * Incoming: publishedItem by grid.
         * Outgoing: row selected/hovered upon.
         *
         */
        _validateAndGetRow: function(publishedItem){
			var controller = this._controller;
			var row = null;
            if (controller && ((publishedItem.gridID == WBSConstants.WBS_OVERVIEW_GRID_ID) ||
							   (publishedItem.gridID == WBSConstants.WBS_SCHEDULE_GRID_ID))) {
                if ((publishedItem) && (publishedItem.rowIndex > -1)) {
					if (publishedItem.gridID == WBSConstants.WBS_SCHEDULE_GRID_ID) {
						controller = controllerUtil.getTreeBasedGridController(com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.ScheduleGridController);
            		}
                    row = controller.getRowByIndex(publishedItem.rowIndex);
                }
            }
            return row;
        },
        
        needToChangeField: function(publishedData){
            var boolNeedToChangeField = false;
            if (this.needToHandleEvent(publishedData) == true &&
            publishedData.fieldName &&
            publishedData.fieldName == "name") {
            
                boolNeedToChangeField = true;
                
            }
            return boolNeedToChangeField;
        },
        
        needToHandleEvent: function(publishedData){
            var boolNeedToHandleEvent = false;
            if (publishedData.uniqueIdentifier &&
            publishedData.uniqueIdentifier.treeID &&
            publishedData.uniqueIdentifier.treeID == this._wbsTree.id) {
            
                boolNeedToHandleEvent = true;
                
            }
            return boolNeedToHandleEvent;
        },
        
        // Replace the temp node in the tree with actual data from the server
        //Gets acitvated when Save operation is done by the WBSGrid
        
        _replaceNode: function(publishedItem){
            console.log("Caught the replace node in the tree " + this._wbsTree.id);
            console.log(publishedItem);
            var publishedData = null;
			var iconUrl = null;
            
            if (dojo.isArray(publishedItem)) {
                publishedData = publishedItem[0];
            }
            else {
                publishedData = publishedItem;
            }
            if (this.needToHandleEvent(publishedData) == false) {
                console.log("Event ignored due to ID mismatch");
                return;
            }
            var nodeID = publishedData.oldRowID;
            var oldItem = this._getItemNodeByIdentity(nodeID);
            
            var newNodeData = publishedData.newObject;
            
            //_deleteNode
            //delete the old node and add the new node to the same parent node
            var parentID = oldItem.parentIdentifier;
            this._wbsTree._deleteItemNode(oldItem);
            
            //Create the new item
            console.log(newNodeData);
			var resourcetype = dojo.isArray(newNodeData.resourcetype)? newNodeData.resourcetype[0] :newNodeData.resourcetype;
			 var resourceIconClass = resourcetype + "Icon";
			var newItem = {
            
                "href": newNodeData.identifier,
                "name": newNodeData.title,
                "identifier": newNodeData.identifier, // using relatedHref itself as Identifier
                "parentIdentifier": parentID,
                "detailLevel": false,
                "resourcetype": newNodeData.resourcetype,
                "iconClass": resourceIconClass,
				"iconUrl" : iconUrl,
				"rpcSequenceValue": newNodeData.rpcSequenceValue
            
            };
            this._wbsTree._updateTitle(newItem, newNodeData);
			
			if(resourcetype == CORE_Constants.WORKITEM && oldItem.workItemType){
				
				var containingProjectID = this._wbsTree._getContainingProjectID(oldItem);
				if(containingProjectID == null){
					return;
				}
				var wiConfig = ControllersFactory.getWIConfigHandler().getWIConfig(containingProjectID, oldItem.workItemType);
				newItem.iconUrl = wiConfig.iconUrl;
				newItem.label = wiConfig.label;
			}
			

            //Get the parent Item
            var parentNode = this._getItemNodeByIdentity(parentID);
			
			if (parentNode) {
				if ((resourcetype == WBSConstants.ITERATION_TYPE) &&
					(parentNode.resourcetype == WBSConstants.ITERATION_TYPE)) {
					// Set currentIteration of parent to -1.
					this._wbsTree.model.store.setValue(parentNode, 'currentIteration', -1);
				}
            }
			
            //Add the new node
            this._wbsTree._addNode(parentNode, newItem, 0);
			
			// On the replace node event all the unsaved nodes have been saved in the grid
			if (this._wbsTree.hasNewNode) {
				this._wbsTree.hasNewNode = false;
			}
            
            // If the new is added due to collapse donot expand the parent node and select the newly added node
			if (!publishedItem.isParentCollapsed) {
	            // Expand the parent node for the saved node
				this._wbsTree._expandNodeUsingID(parentID);
				
				// select the newly saved element
				this._wbsTree._selectNodeById(newNodeData.identifier);
			}
        },

		/**
		 * _replaceExistingNode: Registered method for event renameNode.
		 * 							Updates the tree node label, does not replace the node. 
		 * @param {Object} publishedItem
		 */
        _renameExistingNode: function(publishedItem){
		    console.log("Caught the reanme existing node in the tree " + this._wbsTree.id);
		    var publishedData = dojo.isArray(publishedItem) ?  publishedItem[0] : publishedItem;
		    if (publishedData.treeID != this._wbsTree.id) {
				console.log("Event ignored due to ID mismatch");
				return;
		    }			

			var nodeHref = dojo.isArray(publishedData.href[0]) ? publishedData.href[0] : publishedData.href;
			var treeItem = this._getItemNodeByIdentity(nodeHref);
			this._wbsTree.updateNodeName(treeItem, publishedData.newTitle);
		},
		
        _getTreeBasedController: function(){
            if (!this.TreeBasedGridController) {
                this.TreeBasedGridController = controllerUtil.getTreeBasedGridController(controllerID);
            }
            return this.TreeBasedGridController;
        },
        
        _performUploadSubmit: function(e, isRestart){
            if (e) {
                e.preventDefault();
            }
            
            // we always rebuild the input, so remove the change event
            dojo.disconnect(this._uploadFileInput_onchange_handle);
            
			if (this._uploadFileInput.value.lastIndexOf(".xml") == -1) {
				this.newDlg.hide();
				this.newDlg.destroy();
				alert(WorkMessages.INVALID_FILE);
				return;				
			}
			
            //this.newDlg.hide();
            this.newDlg.containerNode.childNodes[1].style.visibility = "visible";
            this.newDlg.containerNode.childNodes[2].style.visibility = "hidden";
            
            var fullPath;
            
            // Check to see if the file is already loaded
            if (isRestart) {
                fullPath = this._priorFullPath;
            }
            else {
                fullPath = this._uploadFileInput.value;
            }
            if (fullPath.length === 0) {
                this._showFormHideMessage();
                return;
            }
            
            this._priorFullPath = fullPath;
            var parts = fullPath.split("\\");
            var fileName = parts[parts.length - 1];
            
            var self = this;
            //JSLint will give an error here. Please ignore, otherwise it breaks MSP Import.
            if (this._currentBindRequest != null) {
                this._currentBindRequest.cancel();
                this._currentBindRequest = null;
            }
            /*
             * Internet Explorer (with dojo) has a bug such that if you wait ten seconds after one file upload, the
             * next one breaks. Resetting the iframe fixes the problem
             * Unfortunately this code reaches into iframe private variables.
             */
            if (dojo.io.iframe._frame) {
                document.body.removeChild(dojo.io.iframe._frame);
            }
            var frameName = "dojoIoIframe" + _currentUploadFrameNumber++;
            dojo.io.iframe._iframeName = frameName;
            dojo.io.iframe._frame = null;
            
            var parentID = this._getCurrentNodeID();

            // uploading file below			
            this._currentBindRequest = dojo.io.iframe.send({
                form: this._uploadForm,
                url: TeamServerClient._getServicePrefix() + IMPEX_SERVICE_URI + "?PARENT_ID=" + parentID,
                content: {
                    mimetype: "text/xml",
                    fileFields: "uploadFileInput"
                },
				method:"post",
                handleAs: "html",
                handle: function(response, ioArgs){
                    if (response instanceof Error) {
                        return;
                    }
                    data = response;
					self.newDlg.hide();
                    self.newDlg.destroy();
                    alert(WorkMessages.IMPORT_SUCCESS);
                    
					var parentID = self._getCurrentNodeID();
					var projectHref = data.firstChild.attributes[4].nodeValue;
					for (var i = 0; i < data.firstChild.childNodes.length; i++) {
						if (data.firstChild.childNodes[i].nodeName == "summary") {
							var summary = data.firstChild.childNodes[i].firstChild.nodeValue;
							break;
						}
					}
					
					self._insertProjectToTree(projectHref, summary, parentID);
                }
            });
        },
        
		_insertProjectToTree: function(projectHref, summary, parentID) {
			var iconUrl =  this.idIconMap[WBSConstants.EPM_PROJECT_TYPE];
            var item = {
                "href": projectHref,
                "name": summary,
                "identifier": projectHref,
                "resourcetype": WBSConstants.EPM_PROJECT_TYPE,
                "workItemType": "",
                "parentIdentifier": parentID,
                "detailLevel": false,
				"topLevel": true,
                "iconClass": null,
				"iconUrl" : iconUrl
            };
            var node = this._getItemNodeByIdentity(parentID);
			this._wbsTree._addNode(node, item, 0);
			this._wbsTree._addTempChildNode(item);

            if ((this._wbsTree._ctxNode.isExpandable) && (!this._wbsTree._ctxNode.isExpanded)) {
                this._wbsTree._expandNode(this._wbsTree._ctxNode);
            }

			var createdNode = this._wbsTree._itemNodeMap[projectHref];
			this._wbsTree._selectTreeNode(createdNode);
			this._publishCreateNodeEvent(item);
		},
		
		_getCurrentNodeID: function(){
			
			this._ctxNode = this._wbsTree.getNodeContext();
            
            var nodeID;
            if (dojo.isArray(this._ctxNode.item)) {
                if (dojo.isArray(this._ctxNode.item[0].identifier)) {
                    nodeID = this._ctxNode.item[0].identifier[0];
                }
                else {
                    nodeID = this._ctxNode.item[0].identifier;
                }
            }
            else {
                if (dojo.isArray(this._ctxNode.item.identifier)) {
                    nodeID = this._ctxNode.item.identifier[0];
                }
                else {
                    nodeID = this._ctxNode.item.identifier;
                }
            }
			
			return nodeID;
		},
		
//        _importProject: function(e){
//        
//            this._uploadForm = document.createElement("form");
//            
//            if (dojo.isIE) {
//                encType = this._uploadForm.getAttributeNode("enctype");
//                encType.value = "multipart/form-data";
//                formMethod = this._uploadForm.getAttributeNode("method");
//                formMethod.value = "POST";
//            }
//            else {
//                this._uploadForm.setAttribute("enctype", "multipart/form-data");
//                this._uploadForm.setAttribute("method", "POST");
//            }
//            
//            var div = document.createElement("div");
//            dojo.style(div, "height", "1000px");
//            dojo.style(div, "width", "1000px");
//            dojo.style(div, "position", "absolute");
//            //            with (div.style) {
//            //                height = "1000px";
//            //                width = "1000px";
//            //                position: "absolute"
//            //            };
//            document.body.appendChild(div);
//            
//            this.newDlg = new dijit.Dialog({
//                refocus: false,
//                title: "Import MSP Project"
//                //dojoAttachPoint: "icons",
//            }, div);
//            if (this.newDlg) {
//                var input = document.createElement("INPUT");
//                input.type = "file";
//                input.name = "uploadFileInput";
//                input.className = "UploadControl";
//                input.disabled = false;
//                this._uploadFileInput = input;
//                this._uploadFileInput_onchange_hhbandle = dojo.connect(this._uploadFileInput, "onchange", this, "_performUploadSubmit");
//                this._uploadForm.appendChild(input);
//                this.newDlg.containerNode.appendChild(document.createElement("BR"));
//                var text = document.createElement("A");
//                var textNode = document.createTextNode(WorkMessages.IMPORT_IN_PROGRESS);
//                text.appendChild(textNode);
//                this.newDlg.containerNode.appendChild(text);
//                this.newDlg.containerNode.appendChild(this._uploadForm);
//                this.newDlg.containerNode.childNodes[1].style.visibility = "hidden";
//                this.newDlg.show();
//            }
//            
//        },
		
		
		
		/**
		 * Display the error message and erase it after some time
		 * @param {Object} errorMessage
		 */
		_displayAndClearErrorMessage: function(errorMessage, errorCode) {
            var self = this;
            EPMErrorHandler.setError(errorMessage, errorCode);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._clearErrorMessage();
                clearInterval(intervalID);
            }, 10000);  
        },
		/**
		 * Clear the error message
		 */
		 
        _clearErrorMessage: function(){
            EPMErrorHandler.clearError();
        },
	
	objectConverter: function(arrayOrArgs){
        var o = {};
        var a = (dojo.isArray(arrayOrArgs)) ? arrayOrArgs : arguments;
        for (var i = 0; i < a.length; i++) {
            o[a[i]] = '';
        }
        return o;
	},	
	
	_importProject: function(e){
            var resourceType = WBSConstants.EPM_PROJECT_TYPE;
            var workItemType = "";
			// Get the focused node data - parent id, parent name		
            this._ctxNode = this._wbsTree.getNodeContext();
            var parentID = this._ctxNode.item.identifier;
            if (dojo.isArray(parentID)) {
                parentID = this._ctxNode.item.identifier[0];
            }
			var parentName = this._ctxNode.item.name;
			if (dojo.isArray(parentName)) {
				parentName = this._ctxNode.item.name[0];
			}	
			
			this._mspimportWizardPopup(parentID, parentName);
   },
	
	_mspimportWizardPopup: function(parentID, parentName) {
			// Nullify the dialog if already exists	
            if (this.newDlg) {
				this.newDlg.destroy();
                this.newDlg = null;
            }

			this.projectwizard = new com.ibm.epm.work.web.ui.internal.msp.ImportWizard();			
            

            this.newDlg = new jazz.ui.Dialog({
                contentNode : this.projectwizard.domNode,
				primaryTitle : WorkMessages.IMPORT_HEADER,
				width: "565px",
				onOpen: dojo.hitch(this, this._openDlg),
				onClose: dojo.hitch(this, this._closeDlg)

            });
			this.newDlg._bodyContainer.style.overflow = "hidden";
			this.projectwizard.load(this._wbsTree, this.newDlg, parentID, parentName);
//			this._wbsTree.closeMenu();
			
	},

	/*
     *  _openDlg : Function to set the flag when MSP or project creation dialog is opened
     */
    _openDlg: function(){
		this.newDlgOpen = true;
	},

	/*
     *  _closeDlg : Function to set the flag when MSP or project creation dialog is closed
     */
    _closeDlg: function(){
		this.newDlgOpen = false;
	},
			
    _onKeyDown: function(data) {

		if ((!data.event.altKey) && (!data.event.ctrlKey) &&(!data.event.shiftKey)) {
		    // Check if Insert was pressed
		    // If yes, create a new task wbs 
		    if (data.keySet.keyCode === dojo.keys.INSERT){
	
		        var parentNode = this._wbsTree._selectedNode;
	
		        var resourceType = parentNode.item.resourcetype;
		        var isLeafType = false;
	
		        if (resourceType != Constants.EPM_PROGRAM) {
		            if (parentNode.item.workItemType) {
		                isLeafType = this._isALeafType(parentNode.item);
		            }
		        }
	
		        // Check if this key was pressed on a leaf type
		        // If yes, then we need to add a new object under its parent
		        if (!isLeafType) {
	
		            // Check to see if the parentNode itself is an unsaved item
		            // If yes, then ignore this request to create a new item
		            if (!this._isUnsavedParent(parentNode)) {
		                var newObject = null;
		                // We want to allow creation of tasks only if the parent was not
		                // a program. Otherwise, we will create a new project.
		                if (resourceType != Constants.EPM_PROGRAM) {
		                    newObject = {
		                            id: "task",
		                            label: "Task",
									iconClass: IconClass.TASK_ICON_CLASS,
									resourceType: "task"
		                    };
		                } else {
		                    // We want to create a new project under the program
		                    newObject = {
		                            id: "project",
		                            label: "Project",  
									resourceType: WBSConstants.EPM_PROJECT_TYPE
		                    };       
		                }
	
		                if (newObject != null) {
		                    this._createWBSItemFromButton(newObject, parentNode);
		                }
		            }
		        } else {
	
		            // Get the grand parent node and add a new task under it
		            if (parentNode.item.parentIdentifier) {
		                var grandParentNode = this._getNodeByItemIdentity(parentNode.item.parentIdentifier);
		                newObject = {
		                        id: "task",
		                        label: "Task",
								iconClass: IconClass.TASK_ICON_CLASS,
								resourceType: "task"
		                };
	
		                // Check to see if the grandParentNode itself is an unsaved item
		                // NOTE: This is currently not possible (but who knows someone may have introduced a bug ?)
		                // If yes, then ignore this request to create a new item
		                if (!this._isUnsavedParent(grandParentNode)) {
		                    this._createWBSItemFromButton(newObject, grandParentNode);
		                }    
		            }
		        }
		    } else if (data.keySet.keyCode === dojo.keys.DELETE) {

				// Check if Delete was pressed
			    // If yes, delete the wbs element 	
				this._wbsTree.confirmAndRemoveNode(this._wbsTree._selectedNode);
			}
		}
    },
    
    _isALeafType: function(node) {
        
        var isLeafType = false;
        var containingProjectID = this._wbsTree._getContainingProjectID(node);
        if (containingProjectID) {
            var wiConfigs = ControllersFactory.getWIConfigHandler().getAllWIConfig(containingProjectID);
            var nodeType = dojo.isArray(node.workItemType) ? node.workItemType[0] : node.workItemType;
            isLeafType = this._isLeafWorkitemType(wiConfigs, nodeType);
        }
        return isLeafType;  
    },
    
    _onWITypeChange: function(publishObj) {
        
        var itemType = publishObj.workItemType;
        var oldItemType = publishObj.oldWorkItemType;
        var iconClass = "dijitTreeIcon " + itemType + "Icon";
        var row = this._validateAndGetRow(publishObj);
		var isUrl = true;
        if (row && row.id) {
            var treeNode = this._wbsTree.getNodeByItemIdentity(row.id);
            if (treeNode) {
				if (itemType == WBSConstants.ITERATION_TYPE) {
					treeNode.iconNode.src = this._blankGif;
					treeNode.iconNode.className = iconClass;
					isUrl = false;
				}
				else {
					// Change the icon in the tree when a new type is chosen
					var iconUrl = this._getIconUrlForWorkItemType(publishObj.workItemType, treeNode);
					if (iconUrl) {
						treeNode.iconNode.src = iconUrl;
						if (oldItemType == WBSConstants.ITERATION_TYPE) {
							treeNode.iconNode.className = null;
						}
						else {
							treeNode.iconNode.className = iconClass;
						}
					}
					this._wbsTree.model.store.setValue(treeNode.item, 'workItemType', itemType);
				}
				dojo.publish(EPMTreePubSub.TRIGGGER_DASHBOARD_ICON_UPDATE, [treeNode.iconNode, isUrl]);
			}
        }
    },
    
    _getIconUrlForWorkItemType: function(workItemType, treeNode) {
        var iconUrl = null;
        var containingProjectID = this._wbsTree._getContainingProjectID(treeNode.item);
		if(containingProjectID == null){
			return;
		}
		var wiConfig = ControllersFactory.getWIConfigHandler().getWIConfig(containingProjectID, workItemType);
		iconUrl = wiConfig.iconUrl;
        
        return iconUrl;
    },
    
    _isUnsavedParent: function(parentNode) {
        
        var unsaved = false;
        if (parentNode) {
            if (parentNode.item) {
                if (parentNode.item.identifier) {
                    if (parentNode.item.identifier[0].indexOf(EPMConstants.NEWElEMENTSUFFIX) != -1) {
                        unsaved = true;
                    }
                }
            }   
        }
        
        return unsaved;
    },
    
    /**
     * _onExpandNode: Handler for ON_EXPAND event from EPMTree. <br>
     * Adds a new node to the tree if one had been requested before <br>
     * the parent node was expanded. Info to add the new node is in _pendingAddItem. <br>
     * incoming: Reference to the expanded node's item. <br>
     */
    _onExpandNode: function(publishObj) {
    
    	// Check if we have pending add request after ON_EXPAND event.
    	// If yes, then create the item.
        if (this._pendingAddItem) {
            
            // The publishObj is a reference to the expanded node's item
        	if (publishObj) {
                
                // Check if the same identifiers are still valid
                // as before the parent node was expanded.
                // If not, then change them.
                var tempID = controllerUtil.getRandomNumber();
                var newhref = tempID + "_unsaved";
                if (newhref != this._pendingAddItem.href) {
                    this._pendingAddItem.href = newhref;
                    this._pendingAddItem.identifier = tempID + "_unsaved";
                    var parentNode = this._getNodeByItemIdentity(publishObj.identifier);
                    
                    // Check if we were sent a base label to use
                    if (this._pendingAddItem.label) {
                        var tempName = this._getChildName(this._pendingAddItem.label, parentNode);
                        this._pendingAddItem.name = tempName;
                    } else {
                        // Extract out the label name from the initial name
                        // and construct a new name using that
                        if (this._pendingAddItem.name) {
                            var index = this._pendingAddItem.name.indexOf("_");
                            if (index != -1) {
                                var label = this._pendingAddItem.name.substring(0, index);
                                if (label) {
                                    var tempName = this._getChildName(label, parentNode);
                                    this._pendingAddItem.name = tempName;
                                }
                            }
                        }    
                    }  
                }
                
	        	this._wbsTree._addNode(publishObj, this._pendingAddItem, 0);
	        	this._pendingAddItem = null;
	        }
        }
    },
    
    /**
     * Handles the event published from TreeDNDSource.onDndDrop() to persist the change
     * on the server.
     * @param {Object} publishObj: {
            sourceNode: Node moved,
            targetNode: New parent nide
        }
     */
    _onDragNDrop: function(publishObj) {
        
        var scheduleControllerID = com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.ScheduleGridController;
        
        if (publishObj) {
            if (publishObj.sourceNode && publishObj.targetNode) {
                var sourceItem = publishObj.sourceNode.item;
                var targetItem = publishObj.targetNode.item;
                
                if (sourceItem && targetItem) {                  
                    var okToMove = false;
                    
                    // Get the overview view's controller
                    var controllerToUse = controllerUtil.getTreeBasedGridController(controllerID);
                    
                    // Check to see if the controller is initialized and the overview view is active.
                    // If not, then we must try the schedule view's controller
                    if (controllerToUse.isInitialized() && controllerToUse.isViewActive()) {
                    
                        // Replace a possibly stale controller with an initialized one
                        this._controller = controllerToUse;
                        okToMove = true;
                    } else {
                        // Get the schedule's controller since the overview view's controller is not valid
                        var scheduleController = ControllersFactory.getGanttController(scheduleControllerID);
                        
                        // Check if the schedule controller is initialized and active
                        if (scheduleController.isInitialized() && scheduleController.isViewActive()) {
                            
                            // Save the schedule view's controller as the controller to use
                            controllerToUse = scheduleController;
                            okToMove = true;
                        }
                    }
                    
                    if (okToMove) {
                        // Request the tree to persist the change on the server
                        this._wbsTree.updateParentChildLinks(WBSConstants.WBS_TREE_ID, sourceItem, targetItem, controllerToUse);
                    } else {
                        var oldParentItem = this._getItemNodeByIdentity(sourceItem.parentIdentifier);
                        // Update Parent Identifiers
						var targetParentIdentifier = (this._wbsTree.tree.dragNdropAsPeer)? targetItem.parentIdentifier[0] : targetItem.identifier[0];
                        if(sourceItem.parentIdentifier[0] != targetParentIdentifier){
	                        // Revert the node in the tree to its original location
	                        this._wbsTree.model.pasteItem(sourceItem, targetItem, oldParentItem, false);
						}
                        
                        // Issue a message indicating that the DND is enabled only when either the overview/schdule
                        // view is enabled
                        var errorMessage = WorkMessages.ERROR_DND_NOT_SUPPORTED;
                        this._displayAndClearErrorMessage(errorMessage);
                    }     
                }
            }
        }
    },
    
    /**
     * Handles the updates needed after the POST from drag-n-drop is complete.
     * If the POST results in an error, publishObj.error is set to true. In this case
     * the tree node is moved back to its original parent and the grid is updated for the 
     * change. If however, the save was successful, the tree items are updated and the grid
     * synchronized to match the tree structure.
     * 
     * @param {Object} publishObj = {
                sourceItem: source item,
                targetItem: target item (new parent),
                oldParentItem: old parent item,
                treeID: treeID (Tree where DND was initiated),
                postToServer: Boolean to indicate if we need to POST to server
                error: Boolean to indicate if the server threw an exception
                       true: Server threw an exception on persisting change
                       false: Success on saving change on server
     * }
     */    
    _onDragNDropSave: function(publishObj) {
        
        if(publishObj) {
            if (publishObj.treeID === WBSConstants.WBS_TREE_ID) {
                if (publishObj.sourceItem && publishObj.targetItem && publishObj.oldParentItem) {
                    
                    // Grab a handle to the 3 items in question: source, target, old parent
                    var sourceItem = publishObj.sourceItem;
                    var targetItem = publishObj.targetItem;
                    var oldParentItem = publishObj.oldParentItem;
                    
                    // Check if there was an error saving the parent-child change on the server
                    if (publishObj.error) {
                        
                        // Error on parent-child save
                        // Make the switch of sending the target as the old parent and vice-versa
                        // NOTE: The moveItem method's signature is
                        // moveItem: function(treeID, sourceItem, targetItem, oldParentItem, copyOrMove, controller)
                        // and we are sending the oldParentItem as the second argument as we want
                        // the tree to move the node back to where it was dragged from.
                        this._wbsTree.moveItem(WBSConstants.WBS_TREE_ID, sourceItem, oldParentItem, 
                            targetItem, false, this._controller);
                        
                    } else {
                        
                        // No error on parent-child change happened
                           
                        // Update Parent Identifiers
						var targetParentIdentifier = (this._wbsTree.tree.dragNdropAsPeer)? targetItem.parentIdentifier[0] : targetItem.identifier[0];
                        if(sourceItem.parentIdentifier[0] != targetParentIdentifier){
                        	this._wbsTree._updateIdentifiersOnParentChildChange(sourceItem, targetItem);
						}
						//Update the Sequence Value
                        this._wbsTree._treeStore.setValue(sourceItem, "rpcSequenceValue", publishObj.rpcSequenceValue);
						
                        // Refetch the items from the store after the change
                        sourceItem = this._getItemNodeByIdentity(sourceItem.identifier[0]);
                        targetItem = this._getItemNodeByIdentity(targetItem.identifier[0]);
                        
                        // Request the grid to refresh itself    
                        this._wbsTree._syncGridOnParentChildChange(WBSConstants.WBS_TREE_ID, sourceItem, 
                            targetItem, oldParentItem);
							
						// select the dropped node
						this._selectNodeById(sourceItem.identifier[0]);
                    }    
                } 
            }
        }
    },
	
	/**
	* onNameChangeValidate function will be called when you enter
	* value in the tree node.
	* In WBS tree the check is made to see if the name is just spaces or empty string.
	*/
	onNameChangeValidate: function(oldValue, newValue){
		if((newValue != null)){
			var trimmedNewValue = dojo.trim(newValue);
			if(trimmedNewValue.length == 0){
				this._displayAndClearErrorMessage(WorkMessages.ERROR_NAME_CANNOT_BE_EMPTY);
				return false;	
			}
		}
		return true;
	},
	
	/************************************Context Menu provider functions *******************************/
	/**
	 * Constant Menu items 
	 */
	__programMenuItems: null,
	__createProjectMenuItem: null,
	__expandAllItem: null,
	__collapseAllItem: null,
	__createIterationMenuItem: null,
	__exportProjectMenuItem: null,
	__resolveDependencies: null,
	
	/**
	 * 
	 * @param {Object} resourceType
	 * @param {Object} wiConfigs
	 */
	
	getContextMenuItems: function(resourceType, wiConfigs, node){
		if(resourceType == WBSConstants.EPM_PROGRAM_TYPE){
			return this.createProgramMenuItems();
		}else if(resourceType == WBSConstants.EPM_PROJECT_TYPE){
			return this.createProjectMenuItems(wiConfigs);
		}else if(resourceType == WBSConstants.WORKITEM_TYPE){
			return this.createWorkItemsMenuItems(wiConfigs, node.workItemType);
		}else if(resourceType == WBSConstants.ITERATION_TYPE){
			return this.createIterationMenuItems(wiConfigs, node.currentIteration);
		}else if(resourceType == EPMConstants.NEWElEMENTSUFFIX){
			return this.createNewElementMenuItems();
		}else if(resourceType == WBSConstants.EPM_RISK_TYPE){
			return this.createRiskMenuItems();
		}else{
			console.log("Unsupported WBS element type" + resourceType);
		}
		
	},
	
	createProgramMenuItems: function(){
		if(this.__programMenuItems == null){
			var programMenuItems = new Array();
			programMenuItems.push(this.getCreatePopUpMenuItem());
			programMenuItems.push(this.getCreateProjectMenuItem());
			programMenuItems.push(this.renameItem);
			
			var importProject = {
	                "type": EPMConstants.MENU_TYPE,
	                "id": WorkMessages.IMPORT,
	                "parentID": null,
	                "addSeparator": true,
	                label: WorkMessages.IMPORT,
	                iconClass: "ImportButtonIcon",
	                _onClick: dojo.hitch(this, this._importProject)
	        };
			programMenuItems.push(importProject);
			this.addExpandCollapseMenuItems(programMenuItems);
			this.__programMenuItems = programMenuItems;
		}
		
		return this.__programMenuItems;
	},
	
	createProjectMenuItems: function(wiConfigs){
		var projectMenuItems = new Array();
		
		projectMenuItems.push(this.getCreatePopUpMenuItem());
		projectMenuItems.push(this.getCreateProjectMenuItem());
		projectMenuItems.push(this.getCreateIterationMenuItem());
		this._addWorkItemsMenuItems(projectMenuItems, wiConfigs);
		projectMenuItems.push(this.renameItem);
		projectMenuItems.push(this.getExportProjectMenuItem());
		projectMenuItems.push(this.getResolveDependenciesMenuItem());
		this.addExpandCollapseMenuItems(projectMenuItems);
		
		return projectMenuItems;
	},
	
	createWorkItemsMenuItems: function(wiConfigs, workItemType){
		var workItemMenuItems = new Array();
		var isLeafLevelElement = this._isLeafWorkitemType(wiConfigs, workItemType);
		if (!isLeafLevelElement) {
			workItemMenuItems.push(this.getCreatePopUpMenuItem());
			this._addWorkItemsMenuItems(workItemMenuItems, wiConfigs);
			workItemMenuItems.push(this.renameItem);
		}
		else {
			var renameMenuForLeafNode = this.renameItem;
			renameMenuForLeafNode.addSeparator = false;
			workItemMenuItems.push(renameMenuForLeafNode);
		}
		if (!isLeafLevelElement) {
			this.addExpandCollapseMenuItems(workItemMenuItems);
		}
		workItemMenuItems.push(this.removeItem);
		return workItemMenuItems;
	},

	_addSetCurrentIterationMenu: function(currentIteration) {
		var currentIterationMenu = {
			"type": EPMConstants.MENU_TYPE,
			"id": WBSConstants.CURRENT_ITERATION_ID,
			"parentID": null,
			"addSeparator": true,
			label: WorkMessages.CURRENT_ITERATION,
			iconClass: IconClass.CURRENT_ITERATION_MENU_ICON_CLASS,
			disabled: currentIteration,
			_onClick: dojo.hitch(this, this._setCurrentIteration)
		};
		
		return currentIterationMenu;
	},
		
	createIterationMenuItems: function(wiConfigs, currentIteration){
		var iterationMenuItems = new Array();
		
		iterationMenuItems.push(this.getCreatePopUpMenuItem());
		iterationMenuItems.push(this.getCreateIterationMenuItem());

		// Add "Set as Current" menu item
		iterationMenuItems.push(this._addSetCurrentIterationMenu(currentIteration));

		this._addWorkItemsMenuItems(iterationMenuItems, wiConfigs);
		
		iterationMenuItems.push(this.renameItem);
		this.addExpandCollapseMenuItems(iterationMenuItems);
		
		return iterationMenuItems;
	},
	
	createNewElementMenuItems: function(){
		var newElementMenuItems = new Array();
		
		var renameItemForNew = this.renameItem;
		renameItemForNew.addSeparator = false;		
		
		newElementMenuItems.push(renameItemForNew);
		newElementMenuItems.push(this.removeItem);
		return newElementMenuItems;
	},
	
	createRiskMenuItems: function(){
		var riskMenuItems = new Array();
		
		var renameItemForRisk = this.renameItem;
		renameItemForRisk.addSeparator = false;		
		
		riskMenuItems.push(renameItemForRisk);
		return riskMenuItems;
	},
	
	getCreatePopUpMenuItem: function(){
		if(this.__createPopUpMenuItem == null){
			this.__createPopUpMenuItem = {
	            "type": EPMConstants.POPUP_TYPE,
	            "id": EPMConstants.CREATE_ID,
	            "parentID": null,
	            "addSeparator": false,
	            label: WorkMessages.CREATE_LABEL,
	            iconClass: IconClass.CREATE_ICON_CLASS
	        };
		}
		return this.__createPopUpMenuItem;	
	},
	
	getCreateProjectMenuItem: function(){
		if(this.__createProjectMenuItem == null){
			this.__createProjectMenuItem = {
				"type": EPMConstants.MENU_TYPE,
				"id": WBSConstants.EPM_PROJECT_TYPE,
				"parentID": EPMConstants.CREATE_ID,
				"addSeparator": false,
				label: WorkMessages.PROJECT,
				iconClass: IconClass.PROJECT_CLOSED_ICON_CLASS,
				_onClick: dojo.hitch(this, this._createProject)
			};
		}
		return this.__createProjectMenuItem;
	},
	
	getCreateIterationMenuItem: function(){
		if (this.__createIterationMenuItem == null){
			this.__createIterationMenuItem = {
				"type": EPMConstants.MENU_TYPE,
				"id": EPMConstants.ITERATION_ID,
				"parentID": EPMConstants.CREATE_ID,
				"addSeparator": false,
				label: WorkMessages.ITERATION,
				iconClass: IconClass.ITERATION_ICON_CLASS,
				_onClick: dojo.hitch(this, this._createIteration)
			};
		}
		return this.__createIterationMenuItem;
	},
	
	_addWorkItemsMenuItems: function(menuItems, wiConfigs){
		if(!menuItems || !wiConfigs){
			return;
		}
		for(var i in wiConfigs){
			var wiConfig = wiConfigs[i];
			if (wiConfig.id in this.objectConverter([WBSConstants.EPM_RISK_TYPE, WBSConstants.EPM_DOCUMENT_TYPE, WBSConstants.EPM_PROJECT_TYPE])) {
				continue;
			}
			
			if(!wiConfig.iconUrl){
				//Menu is not getting build if there are no icon url.
				continue;
			}
			var workItemMenuItem = {
				"type": EPMConstants.MENU_TYPE,
				"id": wiConfig.id,
				"parentID": EPMConstants.CREATE_ID,
				"addSeparator": false,
				label: wiConfig.label,
				iconUrl: wiConfig.iconUrl,
				_onClick: dojo.hitch(this, this._createWorkItem, wiConfig.id, wiConfig.iconUrl)
			};
			menuItems.push(workItemMenuItem);
		}
	},
	
	_isLeafWorkitemType: function(wiConfigs, workItemType){
		if(!workItemType){
			return false;
		}
		var wiConfig = wiConfigs[workItemType];
		if(!wiConfig){
			return false;
		}
		return wiConfig.isLeafElement;
	},
	
	addExpandCollapseMenuItems: function(menuItems){
		if(this.__expandAllItem == null){
			this.__expandAllItem = {
	            "type": EPMConstants.MENU_TYPE,
	            "id": WBSConstants.EXPAND_ALL_ID,
	            "parentID": null,
	            "addSeparator": true,
	            label: WorkMessages.EXPAND_ALL,
	            iconClass: IconClass.EXPAND_ALL_ICON_CLASS,
	            _onClick: dojo.hitch(this, this._expandAll)
	        };
		}
		menuItems.push(this.__expandAllItem);
		
		if(this.__collapseAllItem == null){
				this.__collapseAllItem = {
	            "type": EPMConstants.MENU_TYPE,
	            "id": WBSConstants.COLLAPSE_ALL_ID,
	            "parentID": null,
	            "addSeparator": false,
	            label: WorkMessages.COLLAPSE_ALL,
	            iconClass: IconClass.COLLAPSE_ALL_ICON_CLASS,
	            _onClick: dojo.hitch(this, this._collapseAll)
	        };
		}
		menuItems.push(this.__collapseAllItem);
	},
	getExportProjectMenuItem: function(){
		if(this.__exportProjectMenuItem == null){
			this.__exportProjectMenuItem = {
			    "type": EPMConstants.MENU_TYPE,
			    "id": WorkMessages.EXPORT,
			    "parentID": null,
			    "addSeparator": true,
			    label: WorkMessages.EXPORT,
			    iconClass: IconClass.EXPORT_ICON_CLASS,
			    _onClick: dojo.hitch(this, this._exportProject)
	        };
		}
		return this.__exportProjectMenuItem;
	},
	
	getResolveDependenciesMenuItem: function(){
		if(this.__resolveDependencies == null){
			this.__resolveDependencies = {
				"type": EPMConstants.MENU_TYPE,
			    "id": WorkMessages.RESOLVE_DEPENDENCY,
			    "parentID": null,
			    "addSeparator": true,
			    label: WorkMessages.RESOLVE_DEPENDENCY_BUTTON_TITLE,
			    iconClass: IconClass.RESOLVE_DEPENDENCY,
			    _onClick: dojo.hitch(this, this._resolveDependencies)
			};
		}
		return this.__resolveDependencies;
	},
	
	/************************************Button Menu provider functions *******************************/
	
	getCommandButtonMenuItems: function(resourceType
							, wiConfigs, workItemType, parentNode){
		if(resourceType == WBSConstants.EPM_PROGRAM_TYPE){
			return this.createProgramButtonMenuItems(parentNode);
		}else if(resourceType == WBSConstants.EPM_PROJECT_TYPE){
			return this.createProjectButtonMenuItems(wiConfigs, parentNode);
		}else if(resourceType == WBSConstants.WORKITEM_TYPE){
			return this.createWorkItemsButtonMenuItems(wiConfigs, workItemType, parentNode);
		}else if(resourceType == WBSConstants.ITERATION_TYPE){
			return this.createIterationButtonMenuItems(wiConfigs, parentNode);
		}else {
			console.log("Unsupported WBS element type " + resourceType);
		}
	},
	
	createProgramButtonMenuItems: function(parentNode){
		var programMenuItems = new Array();
		programMenuItems.push(this._getCreateProjectButtonMenuItem(parentNode));
		return programMenuItems;
	},
	
	createProjectButtonMenuItems: function(wiConfigs, parentNode){
		var projectMenuItems = new Array();
		projectMenuItems.push(this._getCreateProjectButtonMenuItem(parentNode));
		projectMenuItems.push(this._getCreateIterationButtonMenuItem(parentNode));
		this._addWIsToButtonMenuItem(projectMenuItems, wiConfigs, parentNode);
		return projectMenuItems;
	},
	
	createWorkItemsButtonMenuItems: function(wiConfigs, workItemType, parentNode){
		var wiMenuItems = new Array();
		if(!this._isLeafWorkitemType(wiConfigs, workItemType)){
			this._addWIsToButtonMenuItem(wiMenuItems, wiConfigs, parentNode);
		}
		return wiMenuItems;
	},
	
	createIterationButtonMenuItems: function(wiConfigs, parentNode){
		var iterationMenuItems = new Array();
		iterationMenuItems.push(this._getCreateIterationButtonMenuItem(parentNode));
		this._addWIsToButtonMenuItem(iterationMenuItems, wiConfigs, parentNode);
		return iterationMenuItems;
	},
	
	_getCreateProjectButtonMenuItem: function(parentNode){
		var projectItemMenu = new dijit.MenuItem({
			label: WorkMessages.PROJECT,
			resourceType: WBSConstants.EPM_PROJECT_TYPE,
			iconClass: IconClass.PROJECT_CLOSED_ICON_CLASS,
			onClick: dojo.hitch(this, this._createWBSItemFromButton, this, parentNode)
		});
		projectItemMenu.onClick = dojo.hitch(this, this._createWBSItemFromButton, projectItemMenu, parentNode);
		return projectItemMenu;
	},
	
	_getCreateIterationButtonMenuItem: function(parentNode){
		var iterationMenuItem = new dijit.MenuItem({
			label: WorkMessages.ITERATION,
			resourceType: EPMConstants.ITERATION_ID,
			iconClass: IconClass.ITERATION_ICON_CLASS,
			onClick: dojo.hitch(this, this._createWBSItemFromButton, this, parentNode)
		});
		iterationMenuItem.onClick = dojo.hitch(this, this._createWBSItemFromButton, iterationMenuItem, parentNode);
		return iterationMenuItem;
	},
	
	_addWIsToButtonMenuItem: function(menuItems, wiConfigs, parentNode){
		for(var i in wiConfigs){
			var wiConfig = wiConfigs[i];
			if (wiConfig.id in this.objectConverter([WBSConstants.EPM_RISK_TYPE, WBSConstants.EPM_DOCUMENT_TYPE, WBSConstants.EPM_PROJECT_TYPE])) {
				continue;
			}
			if(!wiConfig.iconUrl){
				//Menu is not getting build if there are no icon url.
				continue;
			}
			var wiMenuItem = new dijit.MenuItem({
				label: wiConfig.label,
				resourceType: wiConfig.id,
				iconUrl: wiConfig.iconUrl,
				onClick: dojo.hitch(this, this._createWBSItemFromButton, this, parentNode)
			});
			wiMenuItem.onClick = dojo.hitch(this, this._createWBSItemFromButton, wiMenuItem, parentNode);
			var img = new Image();
			img.src = wiConfig.iconUrl;
			wiMenuItem.iconNode.appendChild(img);
			menuItems.push(wiMenuItem);
		}
	}
	
  });
})();
