/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function() {

dojo.provide("com.ibm.epm.web.core.ui.internal.common.ErrorDialog");

dojo.require("com.ibm.epm.web.core.ui.internal.common.MessageDialog");
dojo.requireLocalization("com.ibm.epm.web.core.ui.internal.common", "Messages");

var CommonMessages	= dojo.i18n.getLocalization("com.ibm.epm.web.core.ui.internal.common", "Messages");

/**
 * Displays an error dialog.
 */
com.ibm.epm.web.core.ui.internal.common.ErrorDialog = function() {
	
	this.displayError = function(errorMsg) {
		var errorDialog = new com.ibm.epm.web.core.ui.internal.common.MessageDialog(
			{title: CommonMessages.ERROR, prompt: errorMsg, promptType: "Error", buttonType: "Ok"});
		dojo.connect(errorDialog.rightButton, "onclick", errorDialog.dialog,
			function (e) {
				dojo.stopEvent(e);
				errorDialog.close();
			}
		);
	};	
	
};

})();
