/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.msp.MapResourcesGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    
    dojo.declare("com.ibm.epm.work.web.ui.internal.msp.MapResourcesGridModel", abstractGridModel, {
        newElementPrefix: "_unsaved",
        
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID, collectionItemHandle){
            var row;
            if ((rowID.indexOf("unsaved")) == -1) {
                row = {
                    "id": rowID,
                    "href": rowID,
                    "tarausers": "",
					"taraId" : "",
					"resourcetype" : "Profile",
                     "name": collectionItemHandle.name ? collectionItemHandle.name : "",
					"mspId" : collectionItemHandle.mspId ? collectionItemHandle.mspId : ""
                
                };
            }
            else {
                row = {
                    "id": rowID,
                    "href": rowID,
                    "tarausers": "",
					"taraId" : "",
					"resourcetype" : "Profile",
                    "name": collectionItemHandle.name ? collectionItemHandle.name : "",
					"mspId" : collectionItemHandle.mspId ? collectionItemHandle.mspId : ""
                
                };
            }
            
            return row;
        },
        
        prepareSaveParams_link: function(row, linkName){
            return null;
        },
        
        getRowPostURI_link: function(row, linkName, newElementID){
            return null;
        },
        
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.name = loadedElement.name;
                row.action = loadedElement.action;
            }
        }
    });
})();
