	/*******************************************************************************
	* Licensed Materials - Property of IBM
	* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
	*
	* Note to U.S. Government Users Restricted Rights:
	* Use, duplication or disclosure restricted by GSA ADP Schedule
	* Contract with IBM Corp.
	*******************************************************************************/
	(function(){
	dojo.provide("com.ibm.epm.work.web.ui.internal.msp.MapResourcesGridview");
		
		dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
		dojo.require("com.ibm.epm.work.web.ui.internal.msp.MapResourcesGridModel");
		dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
		dojo.require("com.ibm.epm.web.core.grid.controller.ControllersFactory");
		dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog");
		dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");
		dojo.require("com.ibm.epm.work.web.ui.internal.WBSConstants");
		dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
		dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
		// Localization
		dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");
		
		var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
		var ControllersFactory = com.ibm.epm.web.core.grid.controller.ControllersFactory;
		var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
		var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
		var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
		var WBSConstants = com.ibm.epm.work.web.ui.internal.WBSConstants;
		var MspMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
		var MapResourcesGridController = null;
		var AdminClient = com.ibm.team.repository.web.client.internal.AdminClient;
		
		var SelectContributorDialog = com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;
		
		var profiles = [];
		var profilesName = [];
		var UserList = ["",MspMessages.MORE];
		
		dojo.declare("com.ibm.epm.risk.web.ui.internal.DynamicSelect", dojox.grid.editors.Select, {
		
		fieldName: null,
		
		constructor: function(inCell){	
			this.fieldName = inCell.field;
			this.inCell = 	inCell;    
		},

		doclick : function(e){
			if(e.target && e.target.nodeName == "OPTION" || e.target.nodeName == "SELECT" && e.target.value == MspMessages.MORE){	
				if(this.inCell.grid && this.inCell.grid.edit){
					this.inCell.grid.edit.apply();
				}
			}
		},
		
		format: function(inDatum, inRowIndex){
		
			var row = this.cell.grid.model.getRow(inRowIndex);
			if (this.fieldName === "tarausers" &&  row && row.resourcetype == "Profile") {
				if (profilesName && profilesName.length > 0) {
					this.options = this.values = profilesName;
				}
			}else if(this.fieldName === "tarausers" &&  row && row.resourcetype == "User") {
				this.options = this.values = UserList;
			}
		    return this.inherited("format", arguments);
		}
		});
		
		var DynamicSelect = com.ibm.epm.risk.web.ui.internal.DynamicSelect;
		
	dojo.declare("com.ibm.epm.work.web.ui.internal.msp.MapResourcesGridview", abstractView, {
		templateString: '<div class="com-ibm-epm-work-web-ui-internal-msp-MapResourcesGrid"><div class="MapResourcesGridClass" dojoAttachPoint="_MapResourcesGridContent"></div></div>',
		newElementPrefix: "_unsaved",
		preValue : "",
		CurValueFlag : false,
		UserDialogFlag:false,
		Inprogress : false,
		
		constructor: function(){
			this._mspsubcription = [];
			this._mspconnects = [];
			this.autoMapFlag = [];		
		},
		
		/*  
		 * buildRatesGrid calls the buildGrid() in abstractView.
		 * buildGrid() creates the controller, initializes and the dataModel mapping will be done with RiskGrid.
		 */
		buildMapResourceGrid: function(profileHref,profileNames){
			
		    if (!this._gridModel) {
		        this._gridModel = new com.ibm.epm.work.web.ui.internal.msp.MapResourcesGridModel();
		    }
		    if (!this.MapResourcesGridController) {
		        this.MapResourcesGridController = ControllersFactory.getEPMRiskGridQueryController("MapResourcesGridController");
				this._controller = this.MapResourcesGridController;
		    }
		    else {
		        this.MapResourcesGridController.setAllElementsURI(this._treeID);				
		    }
		    this.buildGrid(this, this._gridModel, this.MapResourcesGridController);
			profiles = profileHref;
			profilesName = profileNames;
			this.autoMapFlag =[];
		},
		
		createView: function(){        
		    this.inherited('createView', arguments);
			this._mspsubcription = [dojo.subscribe(GridEvents.FIELD_CHANGED, this, this.fieldChanged)];       
		},
		
		/*
		 * getGridInternalID: Override the abstract class and returns the ID of the grid.
		 * Incoming: None
		 * Outgoing: None.
		 */
		getGridInternalID: function(){
			return WBSConstants.MAP_RESOURCE;
		},
		
		/*
		 * This is name the Grid.
		 */
		getGridTitle: function(){
			return MspMessages.MAP_RESOURCE_GRID_TITLE;
		},
		
		/*
		 * This is called by controller. Returns the Attachpoint to the controller.
		 */
		getAttachpoint: function(){
			return this._MapResourcesGridContent;
		},
		
		/*
		 * This is called by abstractView while creating the view.
		 * getGridLayout() is to return grid structure to abstractView.
		 */
		getGridLayout: function(){
			var MapResourcesGridLayout = [{
				noscroll: false,
				defaultCell: {
		            styles: 'text-align: left;'
		        },
		        rows: [[{
		            name: MspMessages.MICROSOFT_PROJECT_USERS,
		            width: 14.5,
		            field: "name",
		            editor: dojox.grid.editors.Input
		        }, {
					name: MspMessages.RESOURCE_TYPE,
		            width: 10,
		            field: "resourcetype",
		            editor: dojox.grid.editors.Select,
		            options: ["Profile", "User"],
		            values: ["Profile", "User"]
				},				{
		            name: MspMessages.TARA_PROJECT_USERS,
		            width: 14.5,
		            field: "tarausers",
					styles: 'vertical-align: top;',
		            editor: DynamicSelect
		        }]]
		    }];	
		    return MapResourcesGridLayout;
		},
		
		
		_jazzUserDialog :function(id){
			var self = this;			
		    var disableAlreadyAssignedUsers = null;
		    this.ownerListWidget = new SelectContributorDialog({
		        hideAdminGuest: true,
		        allowMultiple: false
		    });
		    this.connect(this.ownerListWidget, "onOK", dojo.hitch(this, function(selectedUserList){
				var item = this._generalGrid.model.store._getItemByIdentity(id);
				this._generalGrid.model.store._setValueOrValues(item, "tarausers", selectedUserList[0].name, true);
				this._generalGrid.model.store._setValueOrValues(item, "taraId", "user/" + selectedUserList[0].userId, true);
				this.CurValueFlag = 	true;	
				
		    }));
			
			this.connect(this.ownerListWidget, "onClose", dojo.hitch(this, function(){
				this.UserDialogFlag = false;
				if(!this.CurValueFlag){
					var item = this._generalGrid.model.store._getItemByIdentity(id);				
					this._generalGrid.model.store._setValueOrValues(item, "tarausers",this.preValue, true);
			}}));
			var rowx = this._generalGrid.model.store._getItemByIdentity(id);
			this.ownerListWidget.searchText.value = rowx.name;
			this.ownerListWidget._doSearch();
		    this.ownerListWidget.searchText.focus();
		},
		
		/*
		 * _doAutoMappingofUser
		 * This method tries to find a matching Tara user for the incoming msp user
		 * If a match is found, then the field is updated in the grid.
		 * 
		 */
		_doAutoMappingofUser: function (value, mspid) {
		value = value.replace(/\*/g,"%");
		value = value.replace(/\?/g,"_");
		var params = {
			searchTerm: value,
			pageSize: 1,
			hideAdminGuest: true,
			hideUnassigned: true,
			hideArchivedUsers: true
		};
		var rowindex = -1;
		for (var i = 0; i < this._generalGrid.model.getRowCount(); i++) {
			if (this._generalGrid.model.getRow(i).mspId == mspid) {
				rowindex = i;
				break;
			}
		}
		if (rowindex >= 0) {
			var self = this;
			var serviceObj = {
				success: function(obj){
					self._loadAutoMappedUserInGrid(obj, rowindex);
				},
				failure: function(errorObj){
				}
			};
			var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
			AdminClient.getContributors(params, srh);
			}
		},
		
		/*
		 * _loadAutoMappedUserInGrid
		 * This method updates the Tara user name,  in the grid.
		 * 
		 */
		_loadAutoMappedUserInGrid: function (resultSet, rowIndex) {
			var row = this._generalGrid.model.getRow(rowIndex);
			this.autoMapFlag[row.id] = false;
			if (resultSet && resultSet.elements && (resultSet.elements.length > 0) && resultSet.elements[0]) {			
				var item = this._generalGrid.model.store._getItemByIdentity(row.id);
				this._generalGrid.model.store._setValueOrValues(item, "tarausers", resultSet.elements[0].name, true);
				this._generalGrid.model.store._setValueOrValues(item, "taraId", "user/" + resultSet.elements[0].userId, true);
				this.autoMapFlag[row.id] = true;
				this._generalGrid.model.store._setValueOrValues(item, "resourcetype", "User", true);
			}
		},
		
		/*
		 * Override the function defined in EPMGrid.
		 *
		 */
		isCellEditable: function(event){
		    var cellIndex = parseInt(event.cellIndex, 10);
		    if (cellIndex === 0 || this.Inprogress) {
		        return false;
		    }
		    return true;
		},
		
		
		/*
		 * This is get the first row of the grid.
		 *
		 */
		getfirstRow: function(){
		    var self = this;
		    var data1;
		    if (!self._controller) {
		        var MapResourcesGridController = ControllersFactory.getEPMRiskGridQueryController("MapResourcesGridController");
		        data1 = MapResourcesGridController.getRowByIndex(0);
		    }
		    else {
		        data1 = self._controller.getRowByIndex(0);
		    }
		    return data1;
		},
		
		/**
		 * Adding new row to the user mapping grid.
		 */
		addelement: function(UID,user){
		   var row = {
		        "relativeHref": "_unsaved" + UID,
		        "name": user,
		        "tarausers": "",
				"taraId" : "",
				"resourcetype" : "Profile",
				"mspId" : UID
		    
		    };
		    this._controller._insertElement(row, null, false);
			this._doAutoMappingofUser(user, UID);
			this.scrollToSelectedRow();
		},
		
		/**
		 * Creating a userMap List.
		 */
		getuserMap : function(){
			var map = "";			
			for (var i = 0 ; i < this._generalGrid.model.getRowCount(); i++) {
				var row = this._generalGrid.model.getRow(i);
				if (row.taraId != "") {
					map = map + row.mspId + ":" + row.taraId + ",";
				}
			}
			return  map.toString().substring(0,(map.toString().length -1));
		},
		
		/**
		 * Checking for unmapped user.
		 */
		Unmappeduser : function(){			
			for (var i = 0 ; i < this._generalGrid.model.getRowCount(); i++) {
				var row = this._generalGrid.model.getRow(i);
				if (row.taraId == "") {
					return true;
				}
			}
			return false;
		},
		
		/**
		 * Creating a userMap List.
		 */
		setprofile : function(profile){		
			for (var i = 0 ; i < this._generalGrid.model.getRowCount(); i++) {	
				var row = this._generalGrid.model.getRow(i);
				this.autoMapFlag[row.id] = false;	
				if(row.tarausers==""){
					var item = this._generalGrid.model.store._getItemByIdentity(row.id);
					this.autoMapFlag[row.id] = true;
					this._generalGrid.model.store._setValueOrValues(item, "resourcetype", "Profile", true);
					this._generalGrid.model.store._setValueOrValues(item, "tarausers", profile, true);					
				}
			}
		},
		/**
		 * fieldChanged : On field change of resource type, mapped resource gets changed based on the changed field.
		 */            		
		fieldChanged : function(data){
			if (data.controllerID == "MapResourcesGridController" && data.fieldName == "resourcetype" || data.fieldName == "tarausers" && data.newValue == ""){
				var item = this._generalGrid.model.store._getItemByIdentity(data.row.id);
				if(!this.autoMapFlag[data.row.id]){
					this._generalGrid.model.store._setValueOrValues(item, "tarausers", "", true);
					this._generalGrid.model.store._setValueOrValues(item, "taraId", "", true);
				}
				this.autoMapFlag[data.row.id] = false;
			}else if(data.controllerID == "MapResourcesGridController" && data.fieldName == "tarausers" && data.newValue == MspMessages.MORE && !this.UserDialogFlag){
		
				var item = this._generalGrid.model.store._getItemByIdentity(data.row.id);				
				this.preValue = data.oldValue;
				this.UserDialogFlag = true;
				this.CurValueFlag = false;												
				this._jazzUserDialog(data.row.id);
			}else if(data.controllerID == "MapResourcesGridController" && data.fieldName == "tarausers"){								
				var indx = dojo.indexOf(profilesName,data.newValue); 
	            if(indx >= 0){
					var profileId = profiles[indx];
					var item = this._generalGrid.model.store._getItemByIdentity(data.row.id);
					this._generalGrid.model.store._setValueOrValues(item, "taraId", profileId, true);
	            }				
				
			}				
		},
		
		destroy: function(){
			dojo.forEach(this._mspsubcription, dojo.unsubscribe);
		    this._mspsubcription = [];
			dojo.forEach(this._mspconnects, dojo.disconnect);
		    this._mspconnects = [];
			this.inherited(arguments);
		}
		
	});
	})();
