/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){

    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.TreeWidget");
    
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
	
    var Messages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
	
	/*
	 * Common superclass for the TimecodesTreeWidget and ChargecodesTreeWidget classes.
	 */
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.TreeWidget", [dijit._Widget, dijit._Templated], {
    
        /*
         * After instantiation, call setContainingPage() to set this variable to the page
         * (subclass of AdminGrid) that created this.
         */
        _containingPage: null,
    
        /*
         * Called by page that creates this tree view, allowing this tree view to access
         * the containing page via this._containingPage.
         */
        setContainingPage: function(page) {
            this._containingPage = page;
        },
        
        /*
         * On notification of a node's name changing, notify containing page that
         * the page is now dirty. (This will enable the save button.)
         *
         * The subclass must subscribe itself to events ON_RENAME_NODE and ON_CREATE_NODE, 
         * both of which must invoke _onRenameNode.
         */
        _onRenameNode: function(e){
            if (this._containingPage)
                this._containingPage.onApplyCellEdit(e);
        }
        
    });
})();
