/********************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar");
    
    dojo.require("dijit._Calendar");
    dojo.require("dojo.date.locale");
    
    // Client
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.epm.admin.web.client.internal.calendar.CalendarClient");
    
    //Util
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    dojo.require("com.ibm.epm.web.core.client.QueryUtil");
    dojo.require("dijit.Tooltip");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarExceptionDialog");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
	dojo.require("com.ibm.epm.admin.web.ui.internal.Util.AdminUtil");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
	dojo.require("jazz.ui.Dialog");
	
    // Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");

  	var Messages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    var CalendarClient = com.ibm.epm.admin.web.client.internal.calendar.CalendarClient;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var QueryUtil = com.ibm.epm.web.core.client.QueryUtil;
	var adminUtil = com.ibm.epm.admin.web.ui.internal.Util.AdminUtil;
	var dashboardUtil = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
	
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar", dijit._Calendar, {
        templateString: "<div><table tabindex=\"0\" dojoAttachEvent=\"onkeydown : _KeyDown \"  cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<span class=\"dijitInline dijitCalendarIncrementControl dijitCalendarDecrease\"><span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarDecreaseInner\">-</span></span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitCalendarMonthLabelSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<span class=\"dijitInline dijitCalendarIncrementControl dijitCalendarIncrease\"><span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarIncreaseInner\">+</span></span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onmouseover: _onDayHover, onmouseout: _onDayUnHover, onclick: _onSingleClick, ondblclick: _onDoubleClick\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\t\n<div style=\"padding:5px\"><button dojoAttachPoint=\"_exceptionDialogButton\" dojoAttachEvent=\"onclick : _openExceptionDialog\">${exceptionBtnLabel}</button></div></div>",
        exceptions: [],
        hrsBlocked: [],
        exceptionArray: [],
        inheritedExceptionArray: [],
        calendarURI: "",
        hrsPerDay: 0,
        tooltipNode: null,
        weekday : [Constants.SUNDAY, Constants.MONDAY, Constants.TUESDAY, Constants.WEDNESDAY, Constants.THURSDAY, Constants.FRIDAY, Constants.SATURDAY],
		_timeStamp : 0,
		_isLoading: false,
        
		constructor: function() {
			this.exceptionBtnLabel = Messages.EXCEPTION_BUTTON_LABEL;
		},
			
		postCreate: function() {
			this.inherited(arguments);
			//this._exceptionDialogButton.innerHTML = Messages.EXCEPTION_BUTTON_LABEL;
		},
		
        /**
         * Loads a calendar
         * calendarURI - uri of calendar to load
         * isAdoptedFromCalendar - should be false for external calls (required internally)
         * resetDate - should be true for external calls (required internally)
         * dialogForCalendar - dialog object, if the calendar is being displayed in a dialog
         */
        load: function(calendarURI, isAdoptedFromCalendar, resetDate, dialogForCalendar){
           
		    var self = this;
			//If unsaved row is selected then reset the calendar
			if(calendarURI.indexOf("unsaved") != -1){
				//Reset the calendar URI
				self.calendarURI = calendarURI;
				self.resetCalendar();
				if(resetDate){
					//Reset the date
					self.goToToday();
				}else{
					
					self._populateGrid();
				}
				return;
			}

			this._startLoading();

            if(dialogForCalendar){
            	this._dialogForCalendar = dialogForCalendar;
            }
            var serviceObj = {
                success: function(calendar){
                    self._checkForParentCalendar(calendar);
                    if (!isAdoptedFromCalendar)
                    {
                        self.hrsPerDay = calendar.hrsPerDay;
                    }
                    self._getExceptions(calendarURI, isAdoptedFromCalendar, resetDate);
                },
                failure: function(errorObj)
                {
                	// Using alerts here since the same code is also used for the dialogs
                    alert(errorObj.errorMessage);
					self._loadingComplete();
                }
            };
            if (!isAdoptedFromCalendar)
            {
                this.calendarURI = calendarURI;
            }
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            CalendarClient.getURI(srh, calendarURI);
        },
        
		/**
		 * Resets the calendar. Removes all the existing exceptions
		 */
		resetCalendar:function(){
			
			//Clear the exceptions array
			this.exceptionArray = [];
            this.exceptions = [];
			this.inheritedExceptionArray = [];
			
		},
        /**
         * Checks if the calendar is adopted, if so then exceptions of parent calendar
         */
        _checkForParentCalendar: function(data)
        {
            var caf = Constants.CALENDAR_ADOPTED_FROM;
            if (data[caf])
            {
                var adoptedFromURI = data[caf].relativeHref;;
                this.load(adoptedFromURI, true, false);
            }
        },
        
        /**
         * Gives exceptions for a given calendar
         */
        _getExceptions: function(calendarURI, isAdoptedFromCalendar, resetDate)
        {
            var self = this;
            this.exceptionArray = [];
            this.exceptions = [];
            var serviceObj = {
                success: function(data) {
                	var queryResult = null;
                	if(data) {
               			queryResult = QueryUtil.getQueryResultSet(data);
                    }
                    if(queryResult != null) {
						if(isAdoptedFromCalendar) {
							self.inheritedExceptionArray = queryResult;
						} else {
							self.exceptionArray = queryResult;
						}
                    }
                    if(resetDate)
                    {
                    	self.goToToday();
                    }
                    else
                    {
                   		self._populateGrid();
                    }
					self._loadingComplete();
                },
                failure: function(errorObj)
                {
                	// Using alerts here since the same code is also used for the dialogs
                    alert(errorObj.errorMessage);
					self._loadingComplete();
                }
            };
            
            var fromDate = new Date();
            fromDate.setTime(this.displayMonth.getTime());
            fromDate = this._getTime(fromDate);
            var toDate = new Date();
            toDate.setTime(this.displayMonth.getTime()); 
            toDate.setMonth(toDate.getMonth() + 1);
            toDate = this._getTime(toDate);
            
            // The below JSON expression loads all exceptions for a given calendar in the displayed month
            // ExceptionFromDate <= EndOfMonth && ExceptionToDate >= BeginningOfMonth 
            var jsonExpression = '{"attributeExpressions":[{"attributeId":"toDate","operator":"after","values":["' + fromDate + '"],"variables":[]},{"attributeId":"fromDate","operator":"before","values":["' + toDate + '"],"variables":[]},{"attributeId":"calendar/selfURI", "operator":"is","values":["' + calendarURI +'"],"variables":[]}],"termExpressions":[],"similarityExpressions":[],"operator":"AND"}';
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            CalendarClient.executeQuery(srh, Constants.EXCEPTION_URI, jsonExpression);        	
        },

		/**
		 * Set the time part of a date to 0
		 */
		_getTime: function(date)
		{
			date.setHours(0);
			date.setMinutes(0);
			date.setSeconds(0);
			date.setMilliseconds(0);
			return date.getTime();
		},

		/**
		 * Called by the exception dialog to add a newly created exception
		 */
        addException: function(date, data, exception)
        {
        	exception.self = [];
        	exception.self.relativeHref = data.relativeHref;
        	exception.isInherited = false;
        	this.exceptionArray.push(exception);
        	this._populateGrid();
        },

		/**
		 * Called by the exception dialog to update an exception
		 */
        updateException: function(date, exceptionURI, exception)
        {
        	exception.self = [];
        	exception.self.relativeHref = exceptionURI;
        	for(var i = 0; i < this.exceptionArray.length; i++)
        	{
        		var ex = this.exceptionArray[i];
        		if(ex && ex.self.relativeHref == exception.self.relativeHref)
        		{
        			this.exceptionArray[i] = exception;
        			break;
        		}
        	}
        	this._populateGrid();
        },
        
      	/**
		 * Called by the exception dialog to remove an exception
		 */
        removeException: function(date, exceptionURI)
        {
        	for(var i = 0; i < 31; i++)
        	{
        		var ex = this.exceptions[i];
        		if(ex && ex.self.relativeHref == exceptionURI)
        		{
        			this.exceptions[i] = null;
        			break;
        		}
        	}
        	
        	for(var i = 0; i < this.exceptionArray.length; i++)
        	{
        		var ex = this.exceptionArray[i];
        		if(ex && ex.self.relativeHref == exceptionURI)
        		{
        			this.exceptionArray[i] = null;
        			break;
        		}
        	}
        	this._populateGrid();
			this.load(this.calendarURI, false, false);
        },
        
		/*  On Enter key on calender the exception dialog pops up.
		 *  Added as a short cut for keyboard accessibilty as dijit calender is not keyboard accessible.
		 *  First date of displayed month with be passed to the calender dialog.
		 */
		 
		_KeyDown: function(e)
        {
            var keys = dojo.keys;
			var currentDate = this.attr('value');
            switch (e.keyCode) {
                case keys.ENTER:
					if(this.value){
						this.onValueSelected(this.value);
					}
                    break;
                case keys.LEFT_ARROW:
					dojo.stopEvent(e);   
					var newDate = dojo.date.add(currentDate, "day", -1);
					this.attr('value', newDate);
					this._onAfterDateChange(currentDate, newDate);
                    break;
                case keys.RIGHT_ARROW:
					dojo.stopEvent(e);   
					var newDate = dojo.date.add(currentDate, "day", 1);
					this.attr('value', newDate);
					this._onAfterDateChange(currentDate, newDate);
                    break;
                case keys.UP_ARROW:
					dojo.stopEvent(e);   
					var newDate = dojo.date.add(currentDate, "day", -7);
					this.attr('value', newDate);
					this._onAfterDateChange(currentDate, newDate);
                    break;
                case keys.DOWN_ARROW:
					dojo.stopEvent(e);   
					var newDate = dojo.date.add(currentDate, "day", 7);
					this.attr('value', newDate);
					this._onAfterDateChange(currentDate, newDate);
                    break;
            }
		},
		
		/**
		 * @Override
		 * Called on click of a date
		 */
        onValueSelected: function(/*Date*/date)
        {
			// Return error for unsaved calendar
			if(this.calendarURI.indexOf("unsaved") != -1){
				
				this._displayErrorMessage(Messages.EXCEPTIONS_CANNOT_BE_CREATED_FOR_UNSAVED_CALENDAR);
				return;
			}
            if (this.calendarDlg){
                this.calendarDlg.destroy();
            }
            
            var title = Messages.EXCEPTIONS_FOR + dojo.date.locale.format(date, {
                    selector: 'date',
                    formatLength: 'long'
                });
            
            this.calendarExceptionDialog = new com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarExceptionDialog();
            this.calendarDlg = new jazz.ui.Dialog({
                contentNode: this.calendarExceptionDialog.domNode,
				width: "480px",
                primaryTitle: title,
				onOpen: dojo.hitch(this, this._onOpenExceptionDialog, date),
				onClose: dojo.hitch(this, this._onCloseExceptionDialog)
            });
        },
		
		_onOpenExceptionDialog: function(/*Date*/date) {
			if(this._dialogForCalendar){
            	this._dialogForCalendar.hide();
            }
			this._loadDialogInfo(date);
		},
				
		_onCloseExceptionDialog: function() {
			this.calendarExceptionDialog.destroy();
			if(this._dialogForCalendar){
            	this._dialogForCalendar.unhide();
            }
		},
		
		/**
		 * _canClick
		 * Checks if a click is allowed or not
		 */
		_canClick: function(/*Event*/evt) {
			var canClick = false;
			var node = evt.target;
			dojo.stopEvent(evt);
			while(!node.dijitDateValue){
				node = node.parentNode;
			}
			if(!dojo.hasClass(node, "dijitCalendarDisabledDate")){
				canClick = true;
			}
			return canClick;
		},

		/**
		 * @Override
		 * Called on double click of a calendar cell.
		 * Double click when done on a cell of another month, first loads the exception.
		 * Since this is a async call, we will wait till the _isLoading is set to false or user waits for 3secs
		 */
		_onDoubleClick: function(/*Event*/evt){
			if(this._canClick(evt)){
				var self = this;
				var passCounter = 0;
	            var intervelID = setInterval(function(){
	                if (!self._isLoading || passCounter > 30) {
	                    clearInterval(intervelID);
						self.onValueSelected(self.value);
	                }
					passCounter ++;
	            }, 100);
			}
		},
		
		/**
		 * @Override
		 * Called on single click of a calendar cell
		 */
		_onSingleClick: function(/*Event*/evt){
			//ignore any single clicks made within 500ms
			if( (evt.timeStamp - this._timeStamp) < 500 ) {
				return;
			}
			this._timeStamp = evt.timeStamp; 
			var oldDate = this.value;
			if(this._canClick(evt)){
				var node = evt.target;
				while(!node.dijitDateValue){
					node = node.parentNode;
				}
				this.attr('value', node.dijitDateValue);
				this._onAfterDateChange(oldDate, this.value );
			}
		},
		
		/**
		 * _onAfterDateChange
		 * After a date change, check if a new month has come. If so, then load new exceptions
		 * The new month comes if the user has selected the next month's date in the current month's view or
		 * is navigating using keyboard
		 */
		_onAfterDateChange: function(oldDate, newDate) {
			var month_diff = dojo.date.difference(oldDate, newDate, "month");
			if( Math.abs(month_diff) == 1) {
				this.load(this.calendarURI, false, false);
				this.adjusted = true;
			}
		},
        
		/**
		 * @Override
		 * Called on refresh of calendar to get css class of each date 
		 */
        getClassForDate: function(/*Date*/dateObject, /*String?*/ locale)
        {
            var className = "";
            
            if (dojo.date.compare(dateObject, this.displayMonth, "date") < 0 ||
            dojo.date.compare(dateObject, dojo.date.add(this.displayMonth, "month", 1), "date") >= 0)
            {
                return "dijitCalendarPreviousMonth";
            }
          	var inheritedClassName = this._getClassFromExceptions(dateObject, this.inheritedExceptionArray, true);
       		var className = this._getClassFromExceptions(dateObject, this.exceptionArray, false);
			if(className == "")
			{
				return inheritedClassName;
			}
            return className;
        },
        
		/**
		 * Gives css class of a date after going through loaded exceptions
		 */
        _getClassFromExceptions: function(dateObject, exceptionArray, isInherited)
        {
        	var className = "";
	        if (exceptionArray.length > 0) {
	            for (var i = 0; i < exceptionArray.length; i++) {
	                var ex = exceptionArray[i];
	                if (!ex) {
	                    continue;
	                }
	                if (dojo.date.compare(dateObject, DateUtil.parseDate(ex.fromDate), "date") >= 0 &&
	                dojo.date.compare(dateObject, DateUtil.parseDate(ex.toDate), "date") <= 0) {
	                	if(ex.exceptionType == Constants.SIMPLE) {
	                        if (dateObject.getMonth() == this.displayMonth.getMonth()) {
	                            this.exceptions[dateObject.getDate()] = ex;
	                            this.exceptions[dateObject.getDate()].isInherited = isInherited;
	                        }
	                        className = Constants.NON_WORKING_DAY_CLASS;
	                        break;
	                    }
	                    else if (ex.exceptionType == Constants.WEEKLY) {
	                        if (this.weekday[dateObject.getDay()] == ex.dayOfWeek) {
	                            if (dateObject.getMonth() == this.displayMonth.getMonth()) {
	                                this.exceptions[dateObject.getDate()] = ex;
	                                this.exceptions[dateObject.getDate()].isInherited = isInherited;
	                            }
	                            className = Constants.NON_WORKING_DAY_CLASS;
	                            break;
	                        }
	                    }
	                    else if (ex.exceptionType == Constants.YEARLY) {
	                        // ex defines Month Index from 1-12 and dateObject.getMonth returns
	                        // month index from 0-11. 
	                        if (dateObject.getDate() == ex.dayOfMonth &&
	                        (dateObject.getMonth() + 1) == ex.monthOfYear) {
	                            if (dateObject.getMonth() == this.displayMonth.getMonth()) {
	                                this.exceptions[dateObject.getDate()] = ex;
	                                this.exceptions[dateObject.getDate()].isInherited = isInherited;
	                            }
	                            className = Constants.NON_WORKING_DAY_CLASS;
	                            break;
	                        }
	                    }
	                }
	            }
	        }
	        return className;
        },
        
        /**
         * @Override
         * Loads exceptions when month is changes and displays the calendar
         */
       	_adjustDisplay: function(/*String*/part, /*int*/amount){
			this.displayMonth = dojo.date.add(this.displayMonth, part, amount);
			if(part == "month" || part == "year")
			{
				this.load(this.calendarURI, false, false);
				this.adjusted = true;
			}
			else
			{
				this._populateGrid();
			}
		},
        
        /**
         * Displays tooltip onmouseover of a date
         */
        _onDayHover: function(/*Event*/evt)
        {
            var node = evt.target;
            dojo.stopEvent(evt);
            while (!node.dijitDateValue)
            {
                node = node.parentNode;
            }
            if (!dojo.hasClass(node, "dijitCalendarDisabledDate")) {
                this._showTooltip(node);
            }
        },
        
        /**
         * Hides tooltip onmouseout of a date
         */
        _onDayUnHover: function(/*Event*/evt)
        {
            var node = evt.target;
            dojo.stopEvent(evt);
            this._hideTooltip(node);
        },
        
		/**
		 * Show the tooltip
		 */
        _showTooltip: function(node)
        {
            this.tooltipNode = node;
            var date = new Date(node.dijitDateValue);
            if (dojo.date.compare(date, this.displayMonth, "date") >= 0 &&
            dojo.date.compare(date, dojo.date.add(this.displayMonth, "month", 1), "date") < 0)
            {
                var ex = this.exceptions[date.getDate()];
                if (ex)
                {
					var mlComment = ex.comment.replace(/\n/g, "<br>");
                    dijit.showTooltip(mlComment, node);
                }
            }
        },
        
        /**
         *  Hide the tooltip
         */
        _hideTooltip: function(node)
        {
            dijit.hideTooltip(node);
            // FIXME: make sure that pesky tooltip doesn't reappear!
            // would be nice if there were a way to hide tooltip without regard to aroundNode.
            dijit._masterTT._onDeck = null;
        },
        
        /**
         * Loads the calendar exception dialog with the widget
         */
        _loadDialogInfo: function(/*Date*/date)
        {
            this._hideTooltip(this.tooltipNode);
            this.calendarExceptionDialog.loadData(date, this);
        },
        
		/**
		 * Displays error message
		 */
		_displayErrorMessage:function(errorMessage){
			var errorObj = {};
			errorObj.errorMessage = errorMessage;
			adminUtil.displayErrorMessage("errorMsgCalendar",errorObj);
		},
		
		_startLoading: function() {
			this._isLoading = true;
			dashboardUtil.showMessage(Messages.LOADING_CALENDAR_INFO);
		},
		
		_loadingComplete: function() {
			this._isLoading = false;	
			dashboardUtil.hideMessageArea();
		},
		
		closeExceptionDialog: function() {
			if(this.calendarDlg) {
				this.calendarDlg.close();
			}			
		},
		
		_openExceptionDialog: function() {
			if (this.value) {
				this.onValueSelected(this.value);
			}			
		},
		
		destroy: function() {
			if (this.tooltipNode) {
				this._hideTooltip(this.tooltipNode);
			}
			this.inherited(arguments);
		}
		
    });
})();
