/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarGridModel");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.AdminGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");

  	var Messages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");    
    var abstractGridModel = com.ibm.epm.admin.web.ui.internal.view.AdminGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarGridModel", abstractGridModel, {
        newElementPrefix: "_unsaved",
        constructor: function(){
        },
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID){
            var row;
            if (rowID == "Blank_Row_unsaved") {
            
                row = {
                    "id": rowID,
                    "name": "",
                    "hrsperday": "",
                    "hasexceptions": "no",
                    "loadedelement": null
                };
            }
            else {
                row = {
                    "id": rowID,
                    "name": Messages.NEW_CALENDAR,
                    "hrsperday": "8",
                    "hasexceptions": "no",
                    "loadedelement": null
                };
            }
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.name = loadedElement.name;
                row.hrsperday = loadedElement.hrsPerDay;
                row.loadedelement = [loadedElement];
            }
        },
        
        prepareSaveParams: function(row){
            var saveParams = {
                name: row.name,
                hrsPerDay: row.hrsperday,
				calendarType: Constants.SYSTEM_CALENDAR_TYPE
            };
            return saveParams;
        },
        
        _getNewElementURI: function(row){
            return Constants.CALENDAR_URI;
        },
        
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        },
        
        getRowPostURI: function(row){
            var rowURI = this._getRowURI(row.id);
            var rowURIObj = {
                rowURI: rowURI,
                isNew: false
            };
            if (rowURI == null) {
                rowURIObj.rowURI = this._getNewElementURI(row);
                rowURIObj.isNew = true;
            }
            return rowURIObj;
        }
    });
})();
