/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.competencies.ProfileCompetencyProficiencyAssociation");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.systemprofile.EPMCompetenciesGridView");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
	dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants");
    dojo.require("dijit.form.Button");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMToolbar");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
	dojo.require("com.ibm.epm.admin.web.ui.internal.Util.AdminUtil");
    dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");

    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
	var AdminMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var EPMUserConstants = com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants;
	var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
	var adminUtil = com.ibm.epm.admin.web.ui.internal.Util.AdminUtil;
    var IconClassConstants = com.ibm.epm.web.core.ui.internal.IconClassConstants;    
	
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.competencies.ProfileCompetencyProficiencyAssociation", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.admin.web", "ui/internal/view/competencies/templates/ProfileCompetencyProficiencyAssociation.html"),
        
        _grid: null,
        
        /*
         * Remains false until user makes a change to the data in this dialog
         * (either by adding, deleting or editing a row). Used when OK button is
         * pressed to determine if save button needs to be enabled.
         */
        _dataChanged: false,
        
		constructor: function(){
            this.okButtonLabel=AdminMessages.OK;
            this.cancelButtonLabel=AdminMessages.CANCEL;
            this.dialogSummaryLabel=AdminMessages.COMPETENCY_ASSOCIATION_DIALOG_SUMMARY;
		},
		
        _createCompetencyProficiencyGrid: function(){
            this._grid = new com.ibm.epm.admin.web.ui.internal.view.systemprofile.EPMCompetenciesGridView({
				profile: this._resourceData
            });
            this._content.appendChild(this._grid.domNode);
			dojo.style(this._grid.domNode, "height", "100%"); // TODO should be CSS style
			this._grid.buildCompetencyGrid(this);
        },
        
        loadCompetencyProficiency: function(row, editor){
            this._dataChanged = false;
            this._resourceData = row;
            this._editor = editor;
			this._createToolbar();
            this._createCompetencyProficiencyGrid();
        },
        
        _onOK: function(){
			if (this._grid._controller) {
				var modifiedRows = this._grid._controller.getModifiedRows();
				if (modifiedRows && modifiedRows.length > 0) {
					for (var i in modifiedRows) {
						var selectedRow = modifiedRows[i].row;
						if (selectedRow) {
							selectedRow.modified = true;
							var found = false;
							if(!this._resourceData.competencyassignment){
								this._resourceData.competencyassignment = [];
							}
							for (var x in this._resourceData.competencyassignment) {
								if (this._resourceData.competencyassignment[x].id === selectedRow.id) {
									this._resourceData.competencyassignment[x] = selectedRow;
									found = true;
									break;
								}
							}
							if (!found) {
								this._resourceData.competencyassignment.push(selectedRow);
							}
						}
					}
				}
				
				var CompetencyProficiency = this._grid.getSelectOptionsForProficiency();
				var CompetencyProficiencyId = this._grid.getSelectOptionsForProficiencyId();
				var Competencies = this._grid.getSelectOptionsForCompetency();
				var CompetencyIds = this._grid.getSelectOptionsForCompetencyId();
				
				this._resourceData.competencyparams = [];
				
				for (var i in this._resourceData.competencyassignment) {
					var selectedRow = this._resourceData.competencyassignment[i];
					if (selectedRow && selectedRow.deleted) {
						if (selectedRow.id.indexOf("unsaved") < 0) {
							this._resourceData.competencyparams.push("id=" + selectedRow.id + ":del");
						}
					}
					else 
						if (selectedRow && selectedRow.modified) {
							var proficiencyId = "";
							for (var j = 0; j < CompetencyProficiency.length; j++) {
								if (CompetencyProficiency[j] == selectedRow.proficiencyLevel) {
									proficiencyId = CompetencyProficiencyId[j];
									break;
								}
							}
							
							var competencyId = "";
							for (var k = 0; k < Competencies.length; k++) {
								if (Competencies[k] == selectedRow.name) {
									competencyId = CompetencyIds[k];
									break;
								}
							}
							
							var x = "";
							if (selectedRow.id && selectedRow.id.length > 0 && selectedRow.id.indexOf("unsaved") < 0) {
								if (competencyId != selectedRow.loadedelement[0].competencyid) {
									x = EPMUserConstants.EPM_COMPETENCY + "=" + competencyId + ":add," + EPMUserConstants.EPM_COMPETENCY + "=" + selectedRow.loadedelement[0].competencyid + ":del";
								}
								
								if (proficiencyId != selectedRow.loadedelement[0].pid) {
									if (x.length > 0) {
										x = x + ",";
									}
									x = x + EPMUserConstants.EPM_PROFICIENCY + "=" + proficiencyId + ":add," + EPMUserConstants.EPM_PROFICIENCY + "=" + selectedRow.loadedelement[0].pid + ":del";
								}
								if (x.length > 0) {
									x = x + ",id=" + selectedRow.id;
								}
							}
							else {
								if (competencyId) {
									x = EPMUserConstants.EPM_COMPETENCY + "=" + competencyId;
									if (proficiencyId && proficiencyId.length > 0) {
										x = x + "," + EPMUserConstants.EPM_PROFICIENCY + "=" + proficiencyId;
									}
								}
							}
							if (x.length > 0) {
								this._resourceData.competencyparams.push(x);
							}
							
						} //END OF if condition of selectedRow
				} //END OF FOR() LOOP
				// So that OK button can detect that the dialog has made changes
				if (this._resourceData.competencyparams.length > 0) {
					this._dataChanged = true;
				}
			}//END OF IF CONDITION

            /*
             * If any data has been changed, update the cell editor in the profile
             * grid so that it has the new value, and publish an event to notify the subscriber
             * that the change happened (so it can enable the Save button).
             */
            if (this._dataChanged) {
				var publishedObj = {
					gridID: Constants.COMPETENCY_GRID_TITLE
				}
				dojo.publish(Constants.DIALOG_CHANGE_EVENT, [publishedObj]);
			}
			this._updateEditorValue();
            this._editor.closeDialog();
        },
		
		_updateEditorValue: function()
		{
            var comprow = "";
            var allRows = this._grid._generalGrid.model.data;
            for (var h in allRows) {
                if (comprow.length > 0) {
                    comprow = comprow + " , ";
                }
                comprow = comprow + allRows[h].name 
                    + "(" + allRows[h].proficiencyLevel + ")";
            }
						
            this._resourceData.CompetencyValue = comprow;
	
            this._editor.setRowData();
        },
		
        /*
         * Cancel button pressed. Must exit the dialog without having any pending edits
         * remaining to be saved, so reset any pending deletes that may be in the
         * competencyassignment array back to what they were when the dialog was initialized.
         */
		_onCancel: function() {
            this._editor.closeDialog();
        },
        
        destroy: function(){
            if (this._grid && this._grid.destroy) {
				this._content.removeChild(this._grid.domNode);
                this._grid.destroy();
                delete this._grid;
            }
        },
        
        /*
         * Disable/enable the remove button on the toolbar.
         */
        disableRemoveButton: function(state){
            var oldState = this.removeButton.attr('disabled');
            if (oldState != state) {
                this.removeButton.attr('disabled',state);
                if (state)
                    this.removeButton.attr('iconClass',IconClassConstants.EPM_DELETE_ICON_CLASS + " " + IconClassConstants.EPM_DISABLED_ICON_CLASS);
                else
                  this.removeButton.attr('iconClass',IconClassConstants.EPM_DELETE_ICON_CLASS);
            }
        },
        
        /*
         * Disable/enable the add button on the toolbar.
         */
        disableAddButton: function(state){
            var oldState = this.addButton.attr('disabled');
            if (oldState != state) {
                this.addButton.attr('disabled',state);
                if (state)
                    this.addButton.attr('iconClass',IconClassConstants.EPM_ADD_ICON_CLASS + " " + IconClassConstants.EPM_DISABLED_ICON_CLASS);
                else
                  this.addButton.attr('iconClass',IconClassConstants.EPM_ADD_ICON_CLASS);
            }
        },

		_createToolbar: function(){ 
			this.removeButton = new dijit.form.Button({
                title: AdminMessages.REMOVE,
				label : AdminMessages.REMOVE,
				showLabel : false,
                iconClass: IconClassConstants.EPM_DELETE_ICON_CLASS,
                onClick: dojo.hitch(this, this._deleteAssignment)
            }); 
			this.disableRemoveButton(true);
			
			this.addButton = new dijit.form.Button({
                title: AdminMessages.ADD,
				label : AdminMessages.ADD,
				showLabel : false,
                iconClass: IconClassConstants.EPM_ADD_ICON_CLASS,
                onClick: dojo.hitch(this, this._addAssignment)
            }); 
			this.disableAddButton(true);
			
			this.refreshButton = new dijit.form.Button({
                title: AdminMessages.REFRESH,
				label : AdminMessages.REFRESH,
				showLabel : false,
                iconClass: IconClassConstants.EPM_REFRESH_ICON_CLASS,
                onClick: dojo.hitch(this, this._refreshAssignment)
            });
            
			var rightContentList = [this.addButton,this.removeButton,this.refreshButton];
            
            this._assignmentToolBar = new EPMToolbar({
                rightContentList: rightContentList
            });            
            
            
            this._competenciesBar.appendChild(this._assignmentToolBar.domNode);			
        },
		
		/**
         * Adds a competency assignment in the grid
         */
		_addAssignment:function(){
			if(this._grid)
			{
				this._grid.addAssignment();
			}
		},
		
		/**
         * Handle the error
         */
        displayError: function(message){
			var error = {errorMessage: message};
            adminUtil.displayErrorMessage("errorMsgSystemProfile", error);
			this._editor.closeDialog();
        },
		
		_deleteAssignment: function() {
            // Determine what (if any) row is selected for deletion
			var selectedRowIndexes = this._grid._generalGrid.selection.getSelected();
			
            // Only continue with delete if a row was selected
			if (selectedRowIndexes && selectedRowIndexes.length > 0) {
				var selectedRow = this._grid._generalGrid.model.getRow(selectedRowIndexes[0]);
				if (selectedRow) {
					// Remove the selected row from this dialog's grid
					this._grid.deleteAssignment(selectedRowIndexes[0]);
					this._dataChanged = true;
					/*
                     * Mark the row as deleted so that, while saving the parameters are prepared properly
                    */
					if (this._resourceData.competencyassignment && this._resourceData.competencyassignment.length > 0) {
						for (var i = 0; i < this._resourceData.competencyassignment.length; i++) {
							var row = this._resourceData.competencyassignment[i];
							if (row && row.id && (row.id === selectedRow.id)) {
								this._resourceData.competencyassignment[i].deleted = true;
								break;
							}
						}
					}
				}
			}
		},
		
		_refreshAssignment:function(){
			this.destroy();
			if(this._resourceData)
			{
				this._resourceData.competencyassignment = null;
			}
			this._createCompetencyProficiencyGrid();
		}
    });
})();
