/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.web.core.ui.internal.view.queryeditor.QueryEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.epm.web.core.client.internal.QueryClient");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.TabController");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.SectionContainer");
dojo.require("com.ibm.epm.web.core.ui.internal.view.queryeditor.TermSection");
dojo.require("com.ibm.epm.web.core.ui.internal.view.queryeditor.ConditionSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ErrorSection");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.UserSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.TeamAreaSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ResultColumnsSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.OrderColumnsSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.TextAreaSection");

// Localization
dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages");
	


(function(){

var checkNotNull= net.jazz.ajax.toolbox.lang.checkNotNull;
var PlatformUI= net.jazz.ajax.ui.PlatformUI;

var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;

var QueryClient= com.ibm.epm.web.core.client.internal.QueryClient;
var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var ImagePool= com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;
var ErrorSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.ErrorSection;

var TabController= com.ibm.team.workitem.web.ui.internal.view.queryeditor.TabController;
var Constants= com.ibm.team.workitem.web.ui.internal.view.queryeditor.Constants;
var SectionContainer= com.ibm.team.workitem.web.ui.internal.view.queryeditor.SectionContainer;
var TermSection= com.ibm.epm.web.core.ui.internal.view.queryeditor.TermSection;
var ConditionSection= com.ibm.epm.web.core.ui.internal.view.queryeditor.ConditionSection;

var EditableTableSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection;
var UserSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.UserSection;
var TeamAreaSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.TeamAreaSection;
var ResultColumnsSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.ResultColumnsSection;
var OrderColumnsSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.OrderColumnsSection;
var TextAreaSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.TextAreaSection;

var isGuest= com.ibm.team.repository.web.client.session.isGuest;

var QueryEditorMessages = dojo.i18n.getLocalization("com.ibm.epm.web.core.ui", "Messages");

var ignoredAttributes = ["archived",
						 "contextId",
						 "itemId",
						 "mergePredecessor",
						 "userId",
						 "workingCopyMergePredecessor",
						 "workingCopyPredecessor",
						 "selfURI",
						 "link:com.ibm.epm.assignment.projectResourceLink:source",
						 "link:com.ibm.epm.assignment.resourceLink:source",
						 "details",
						 "link:com.ibm.epm.resource.StaticPoolUserLink:target/reference",
						 "link:com.ibm.epm.resource.StaticPoolUserLink:target/parent",
						 "link:com.ibm.epm.resource.StaticPoolUserLink:target/statusUpdate",
						 "link:com.ibm.epm.resource.profile.instance.profileLink:source",
						 "link:com.ibm.epm.resource.epmuser.rateLink:source",
						 "link:com.ibm.epm.resource.profile.rateLink:source",
						 "link:com.ibm.epm.assignment.profile.instance.competencyLink:source",
						 "link:com.ibm.epm.resource.profile.competencyLink:source",
						 "id",
						 "modified",
						 "link:com.ibm.epm.resource.epmuser.calendarLink:target/calendarAdoptedFrom",
						 "calendarType"
						 ];


var displayNameRegistry = {
	name : "Name",
	emailAddress : "Email Address" ,
	experienceInYears : "Experience (in years)",
	proficiencyLevel : "Proficiency Level",
	costRate : "Cost Rate",
	description : "Description",
	sellingRate : "Selling Rate"	
};


dojo.declare("com.ibm.epm.web.core.ui.internal.view.queryeditor.QueryEditor", [dijit._Widget, dijit._Templated], {
	templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/view/queryeditor/templates/QueryEditor.html"),
	
	TITLE: QueryEditorMessages.QUERY_EDITOR_TITLE,
	//Description Section variables
	DESC_TITLE:QueryEditorMessages.DESCRIPTION_SECTION_TITLE,
	DESC_EDIT_ACTION_NAME:QueryEditorMessages.DESCRIPTION_SECTION_EDIT_ACTION_NAME,
	DESC_EMPTYMESSAGE:QueryEditorMessages.DESCRIPTION_SECTION_EMPTYMESSAGE,	
	
	//Team Area Section Variables	
	TA_TITLE:QueryEditorMessages.TEAMAREA_SECTION_TITLE,
	TA_ADD_ACTION_NAME:QueryEditorMessages.TEAMAREA_SECTION_ADD_ACTION_NAME,
	TA_EMPTYMESSAGE:QueryEditorMessages.TEAMAREA_SECTION_EMPTYMESSAGE,
	
	USER_TITLE:QueryEditorMessages.USER_SECTION_TITLE,
	USER_ADD_ACTION_NAME:QueryEditorMessages.USER_SECTION_ADD_ACTION_NAME,
	USER_EMPTYMESSAGE:QueryEditorMessages.USER_SECTION_EMPTYMESSAGE,
	
	//ResultColumn Section Variables	
	RESCOL_TITLE:QueryEditorMessages.RESULTCOL_SECTION_TITLE,
	RESCOL_ADD_ACTION_NAME:QueryEditorMessages.RESULTCOL_SECTION_ADD_ACTION_NAME,
	RESCOL_EMPTYMESSAGE:QueryEditorMessages.RESULTCOL_SECTION_EMPTYMESSAGE,
	
	//Order Column Section Variables	
	ORDCOL_TITLE:QueryEditorMessages.ORDERCOL_SECTION_TITLE,
	ORDCOL_ADD_ACTION_NAME:QueryEditorMessages.ORDERCOL_SECTION_ADD_ACTION_NAME,
	ORDCOL_EMPTYMESSAGE:QueryEditorMessages.ORDERCOL_SECTION_EMPTYMESSAGE,
	
	/////////////////////////////////////////////////////////////////////////////
	// Widget creation
	
	constructor: function(args) {
		this.parentController= args.parentController;	
		this.userOption=QueryEditorMessages.USER_OPTION;
		this.profileOption=QueryEditorMessages.PROFILE_OPTION;
		this.runBtn=QueryEditorMessages.RUN_BUTTON;
		this.saveBtn=QueryEditorMessages.SAVE_BUTTON;
		this.savecopyBtn=QueryEditorMessages.SAVECOPY_BUTTON;
		this.name=QueryEditorMessages.NAME_LABEL+":";
		this.conditions=QueryEditorMessages.CONDITIONS_TAB;
		this.details=QueryEditorMessages.DETAILS_TAB;		
		this.resultLayout=QueryEditorMessages.RESULT_LAYOUT_TAB;
		this.queryEditorSectionDetails=QueryEditorMessages.QUERY_EDITOR_SECTION_DETAILS_LABEL;
		this.creator=QueryEditorMessages.CREATOR_LABEL +":";
	},
	
	postCreate: function(){
		
		this._createTabs();
		this._createControls();
		
		this.typeIcon.src= ImagePool.WORKITEM_QUERY;
		this._setTitle(this.TITLE);
		
		this._errorSection= new ErrorSection();
		this._errorDiv.appendChild(this._errorSection.domNode);
		
		this._dirtySubscription= dojo.subscribe(EventTopics.QUERY_EDITOR_CHANGED, this, this._setDirty);
		
		var srh= new ServiceResponseHandler(this, "_setAttributeTree", "_handleAttributeError");
		QueryClient.getAttributeTree(this.parentController._queryEditorPageView.queryType, srh);
	},
	
	destroy: function() {
		try {
			dojo.unsubscribe(this._dirtySubscription);
			this._tabController.destroy();
			if(this._descriptionSection) this._descriptionSection.destroy();
			if(this._teamAreaAssociations) this._teamAreaAssociations.destroy();
			if(this._userAssociations) this._userAssociations.destroy();
			if(this._resultColumns) this._resultColumns.destroy();
			if(this._orderColumns) this._orderColumns.destroy();
			if(this._container) this._container.destroy();
			this.inherited(arguments);
		} catch (e) {
			
		}
	},
	
	_createTabs: function(){
		
		var tabStyleName= "Selected";
		var tabController= new TabController();
		this._tabController= tabController;
		
		tabController.registerTab(this._tabConditions, this._tabConditionsContent, tabStyleName);
		tabController.registerTab(this._tabDetails, this._tabDetailsContent, tabStyleName);
		tabController.registerTab(this._tabResultLayout, this._tabResultLayoutContent, tabStyleName);
		
		tabController.showTab(this._tabConditions);
	},
	
	_createControls: function() {		
		
		var descriptionSection= new TextAreaSection({ title: this.DESC_TITLE, editActionName: this.DESC_EDIT_ACTION_NAME, emptyMessage: this.DESC_EMPTYMESSAGE });
		this._descriptionSectionDiv.appendChild(descriptionSection.domNode);
		this._descriptionSection= descriptionSection;
			
		var teamAreaAssociations= new TeamAreaSection({ title:this.TA_TITLE ,addActionName: this.TA_ADD_ACTION_NAME, emptyMessage: this.TA_EMPTYMESSAGE });
		this._teamAreaSharingColumn.appendChild(teamAreaAssociations.domNode);
		this._teamAreaAssociations= teamAreaAssociations;


		var userAssociations= new UserSection({ title:this.USER_TITLE, addActionName: this.USER_ADD_ACTION_NAME, emptyMessage: this.USER_EMPTYMESSAGE });
		this._userSharingColumn.appendChild(userAssociations.domNode);
		this._userAssociations= userAssociations;


		var resultColumns= new ResultColumnsSection({ title: this.RESCOL_TITLE, addActionName: this.RESCOL_ADD_ACTION_NAME, emptyMessage: this.RESCOL_EMPTYMESSAGE, supportOrdering: true });
		this._resultsColumn.appendChild(resultColumns.domNode);
		this._resultColumns= resultColumns;

		var orderColumns= new OrderColumnsSection({ title: this.ORDCOL_TITLE, addActionName: this.ORDCOL_ADD_ACTION_NAME, emptyMessage: this.ORDCOL_EMPTYMESSAGE, supportOrdering: true });
		this._orderColumn.appendChild(orderColumns.domNode);
		this._orderColumns= orderColumns;
	},
	
	_createTermPart: function(/* TermDTO */ term){
		
		if (this._container)
			this._container.destroy();
			
		var termSection= new TermSection({ attributes: this._attributeTree, term: term, queryType: this.parentController._queryEditorPageView.queryType });
		var container= new SectionContainer({
			sectionWidget: termSection
		});
		this._termSection= termSection;
		this._tabConditionsContent.appendChild(container.domNode);
		
		this._container= container;
	},
	
	/////////////////////////////////////////////////////////////////////////////
	// API
	
	showQuery: function(query) {
		this._isDirty= (query.stateId ? false : true);
		this._errorSection.clearError();
		this._internalShowQuery(query);
		if (!query.stateId) {
			//Throws error when the viewlet is minimised in IE. Hence added the try catch
			try {
				this._nameInput.focus();
			}
			catch(e) {
				//dont do anything.
			}
		}
		if(query.itemId)
		{
			var srh= new ServiceResponseHandler(this, "_setAttributeTree", "_handleAttributeError");
			QueryClient.getAttributeTreeForQuery(this.parentController._queryEditorPageView.queryType, srh, query.itemId);
		}
	},
	
	_internalShowQuery: function(query, keepName) {
		this._query= query;
		
		this._suspendDirtyEvents= true;
		
		this._showName(query.name, keepName);
		this._showCreator(query.creator);
		this._descriptionSection.setText(query.description);
		this._teamAreaAssociations.setInput(query.teamAreaAssociations);
		this._userAssociations.setInput(query.userAssociations);
		this._resultColumns.setInput(query.columns);
		this._orderColumns.setInput(query.sorting);
		
		if (this._attributeTree) {
			this._createTermPart(query.expression)
		}
		this._tabController.showTab(this._tabConditions);
		
		this._suspendDirtyEvents= false;
		this._updateDirtyState();
	},
	
	_setTitle: function(title) {
		dojox.data.dom.replaceChildren(this._titleTextSpan, document.createTextNode(title));
	},
	
	/////////////////////////////////////////////////////////////////////////////
	
	// Values
	clearName: function() {
		this._isClear = true;
		this._nameInput.value= "";
	},
	
	_showName: function(name, keepName) {
		if (!((keepName || this._isClear) && name == "" && this._nameInput.value != "" )) {
			this._nameInput.value= name;
		}
		this._isClear = false;

	},
	
	_getName: function() {
		return this._nameInput.value;
	},
	
	_hasNameChanged: function() {
		return this._query.name != this._getName();
	},
	
	_showCreator: function(creator) {
		if (creator)
			dojox.data.dom.replaceChildren(this._queryCreator, document.createTextNode(creator.label));
	},
	
	/////////////////////////////////////////////////////////////////////////////
	// Callbacks
	
	_setDirty: function() {
		if (!this._isDirty && !this._suspendDirtyEvents) {
			this._isDirty= true;
			this._updateDirtyState();			
		}
	},
	
	_updateDirtyState: function() {
		this._updateSaveButtonEnablement();
		this._setTitle(this.TITLE + (this._isDirty ? "*" : ""));
	},
	
	_updateSaveButtonEnablement: function() {
		var value= this._getName();
		var isInvalid= isGuest() || !(value && value.length > 0);
		this._saveCmd.disabled= isInvalid || !this._isDirty;
		if (this._query.stateId) {
			this._saveCopyCmd.disabled= isInvalid;
		} else {
			this._saveCopyCmd.disabled= true;
		}
	},
	
	_handleNameChange: function() {
		if (this._hasNameChanged())
			dojo.publish(EventTopics.QUERY_EDITOR_CHANGED, []);
		this._updateSaveButtonEnablement();
	},
	_handleQueryTypeChange: function() {
		this.parentController._queryEditorPageView.queryType = this._queryType.value;
		this.parentController.editQuery({ id: "", type: this._queryType.value});
		//this.postCreate();
		var srh= new ServiceResponseHandler(this, "_setAttributeTree", "_handleAttributeError");
		QueryClient.getAttributeTree(this.parentController._queryEditorPageView.queryType, srh);
	},
	
	changeQueryTypeInEditor: function(queryType) {
		for(var i=0; i < this._queryType.options.length; i++) {
			if(this._queryType.options[i].value == queryType){
				this._queryType.selectedIndex = i;
			}
		}
	},
	_handleRunClick: function() {
		if (!this._termSection)
			return;
		
		var expression= this._termSection.getTerm();
		
		var query= new Object();
		query.name= this._getName();
		query.itemId= "";
		query.internalExpression= expression;
		
		var sortOrder= this._orderColumns.getValues();
		var resultColumns= this._resultColumns.getValues();
		var columnArgs= { sortOrder: sortOrder, columnIdentifiers: this._getLabel(resultColumns)};
		
		this.parentController.runQuery(query, columnArgs);
	},
	
	_getLabel: function(uiItems) {
		var ids= new Array();
		var label = "";
		for (var i= 0; i < uiItems.length; i++) {
			label = uiItems[i].label;
			ids.push(label);
		}
		return ids;
	},
	
	_handleSaveClick: function() {
		this._handleSave(false);
	},
	
	_handleSaveCopyClick: function() {
		this._handleSave(true);
	},
	
	_handleSave: function(createCopy) {

		this._startOperation("Saving Query '" + this._getName() + "'", "operation.query.save");
		
		var args= this._collectSaveArgument(createCopy);
		var srh= new ServiceResponseHandler(this, "_querySaved", "_handleSaveError");
		QueryClient.saveQuery(this.parentController._queryEditorPageView.queryType, srh, args);
	},
	
	_collectSaveArgument: function(createCopy) {
		
		var args= new Object();
		
		if (this._query && !createCopy) {
			if (this._query.stateId) {
				args.itemId= this._query.itemId;
				args.stateId= this._query.stateId;
			}
		}
		if (this._hasNameChanged() || createCopy) {
			args.name= this._getName();
		}
		if (this._descriptionSection.hasChanged()) {
			args.description= this._descriptionSection.getText();
		}
		if (this._teamAreaAssociations.hasChanged()) {
			var teamAreas= this._teamAreaAssociations.getValues();
			args.teamAreaAssociations= this._getIds(teamAreas);
		}
		if (this._userAssociations.hasChanged()) {
			var users= this._userAssociations.getValues();
			args.contributorAssociations= this._getIds(users);
		}
		if (this._resultColumns.hasChanged()) {
			var resultColumns= this._resultColumns.getValues();
			args.resultColumns= this._getIds(resultColumns);
		}
		if (this._orderColumns.hasChanged()) {
			
			var orderColumns= this._orderColumns.getValues();
			args.sortColumns= this._getIds(orderColumns);
			
			var directions= new Array();
			for (var i= 0; i < orderColumns.length; i++) {
				directions.push(orderColumns[i].ascending);
			}
			args.sortDirections= directions;
		}
			
		args.expression= this._termSection.getTerm();
		
		return args;
	},
	
	_getIds: function(uiItems) {
		var ids= new Array();
		for (var i= 0; i < uiItems.length; i++) {
			ids.push(uiItems[i].id);
		}
		return ids;
	},
	
	_querySaved: function(operationReport) {
		
		if (operationReport) {
			if (operationReport.query) {
				this._isDirty = false;
				this._internalShowQuery(operationReport.query);
			}
			this._errorSection.showReport(operationReport);
		}
		this._stopOperation();
		dojo.publish(EventTopics.BUILDER_POST_SAVE, []);
	},

	_setAttributeTree: function(/* TreeDTO */ tree) {		
		var filteredAttributes = this._filterIgnoredAttributes(tree.children);
		tree.children = filteredAttributes;
		this._attributeTree= tree;			
		this._resultColumns.setCachedAttributeTree(this._attributeTree);
		this._orderColumns.setCachedAttributeTree(this._attributeTree);
		if (this._query) {
			this._internalShowQuery(this._query, /* keepName */ true);
		}
	},
	

	//Filter attributes
	_filterIgnoredAttributes: function(/*TreeDTO*/ tree){					
		var filterdTree = new Array();
		for (var i= 0; i < tree.length; i++) {
			var attribute= tree[i];		
			if(!this._isIgnoredAttribute(attribute.item)) {
				if (tree[i].children) {
					attribute.children= this._filterIgnoredAttributes(tree[i].children);
				}
					
				if (attribute.item.isQueryable || attribute.item.children){
					//Keep attribute name only
					var label = attribute.item.label;
					var newLabel = label.substring(label.lastIndexOf("/") + 1, label.length);
					if(displayNameRegistry[newLabel])
						attribute.item.label = displayNameRegistry[newLabel];
					else				
						attribute.item.label = newLabel;
					filterdTree.push(attribute);
				}
			}									
		}
		return filterdTree;
	},
	
	_isIgnoredAttribute: function(attribute){
		for(i=0; i<ignoredAttributes.length; i++){
			if (attribute.id == ignoredAttributes[i]) {
				return true;
			}
			else
			{
				var newLabel = attribute.id.substring(attribute.id.lastIndexOf("/") + 1, attribute.id.length);
				if (newLabel == ignoredAttributes[i]) {
					return true;
				}
			}
		}
		return false;
	},
	
	_startOperation: function(name, id) {
		this._currentOperation= this.parentController.createOperation(name, id);
		this.parentController.startOperation(this._currentOperation);
		this._errorSection.clearError();
	},
	
	_stopOperation: function() {
		this.parentController.finishOperation(this._currentOperation);
	},
	
	_handleAttributeError: function(e) {
		this._stopOperation();
		this._errorSection.showError(QueryEditorMessages.LOADING_ATTRIBUTE_FAILED, e);
	},
	
	_handleSaveError: function(operationReport) {
		this._stopOperation();
		this._errorSection.showReport(operationReport);
	}
});
	
})();
