/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.rates.RatesGridModel");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.AdminGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    var abstractGridModel = com.ibm.epm.admin.web.ui.internal.view.AdminGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.rates.RatesGridModel", abstractGridModel, {
        newElementPrefix: "_unsaved",
        constructor: function(){
        },
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID){
            var row;
            if (rowID == "Blank_Row_unsaved") {
            
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": "",
                    "description": "",
                    "costRate": "",
                    "sellingRate": "",
                    "loadedelement": null
                };
            }
            else {
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": "New Rate",
                    "description": "",
                    "costRate": "0",
                    "sellingRate": "0",
                    "loadedelement": null
                };
            }
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.name = loadedElement.name;
                row.description = loadedElement.description;
                row.costRate = loadedElement.costRate;
                row.sellingRate = loadedElement.sellingRate;
                row.loadedelement = [loadedElement];
                if (this.selectedRateURI == row.id) {
                    var controller = controllerUtil.getEPMGridController("RatesController");
                    var rowIndex = controller.getRowIndex(row.id);
                    dojo.publish("selectRateNode", [rowIndex]);
                }
            }
        },
        
        prepareSaveParams: function(row){
            var saveParams = {
                name: row.name,
                description: row.description,
                costRate: row.costRate,
                sellingRate: row.sellingRate
            };
            return saveParams;
        },
        
        _getNewElementURI: function(row){
            return "rates";
        },
        
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        }
    });
})();
