/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.systemprofile.EPMCompetenciesGridModel");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.AdminGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    // Constants
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    
    //Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    
    var AdminViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var abstractGridModel = com.ibm.epm.admin.web.ui.internal.view.AdminGridModel;
    
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.systemprofile.EPMCompetenciesGridModel", abstractGridModel, {
    
        newElementPrefix: Constants.UNSAVED,
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID, collectionItemHandle){
        
            //If the Flag is undefined, the data is pulled from the server and contolled by the 
            //Abstract controller
            //else the data is inserted directly by the View            
            var row;

            row = {
                    "id": rowID,
                    "href": rowID,
                    "name": collectionItemHandle.name ? collectionItemHandle.name : "",
                    "proficiencyLevel": collectionItemHandle.proficiencyLevel ? collectionItemHandle.proficiencyLevel : "",
					"competencyid":collectionItemHandle.competencyid ? collectionItemHandle.competencyid : "",
					"pid":collectionItemHandle.pid ? collectionItemHandle.pid : ""
                };
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
        
            if (linkName == null) {
                row.name = loadedElement.name;
                row.proficiencyLevel = loadedElement.proficiencyLevel;
				row.competencyid = loadedElement.competencyid;
				row.pid = loadedElement.pid;
                row.loadedelement = [loadedElement];
            }
        },
        
        /*
         * Prepares the parameter for the Post call
         * Incoming : Row infomation
         * Outgoing : Save Parameters
         */
        prepareSaveParams: function(row){
        
            //Get the details from the Details view
            
            var saveParams = null;
            if (row.name != "") {
                //Prepare details with sample information
                saveParams = {
                    name: row.name,
                    proficiencyLevel: row.proficiencyLevel,
					id: row.id,
					relativeHref: row.relativeHref,
					competencyid: row.competencyid,
					pid: row.pid

                };

            }
            else {
                //TODO display message.
            }
            return saveParams;
        },
        
        /*
         * Get Post call URI method
         * Incoming : Row Info
         * Outgoing : Post call URI
         */
        _getNewElementURI: function(row){
        
            return Constants.COMPETENCY_URI;
        },
        
        /*
         * URI for Row level Info
         * Incoming : RowHandle, Row Id
         * Outgoing : URI to get row information
         */
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        }
    });
})();
