/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.timecodes.TimecodesGridModel");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.AdminGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    // Constants
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var abstractGridModel = com.ibm.epm.admin.web.ui.internal.view.AdminGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.timecodes.TimecodesGridModel", abstractGridModel, {
        newElementPrefix: "_unsaved",
        constructor: function(){
        },
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID, treeElementHandle){
            var row = {
                "id": rowID,
                "href": rowID,
                "parentId": null,
                "name": treeElementHandle.title,
                "resourcetype": treeElementHandle.resourcetype,
                "description": "",
                "code": "",
                "loadedelement": null
            };
            if (treeElementHandle.parentIdentifier) {
                if (dojo.isArray(treeElementHandle.parentIdentifier)) {
                    row.parentId = treeElementHandle.parentIdentifier[0];
                }
                else {
                    row.parentId = treeElementHandle.parentIdentifier;
                }
            }
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.name = loadedElement.name;
                row.description = loadedElement.description;
                row.code = loadedElement.code;
                row.loadedelement = [loadedElement];
                
                this._updateParent(row, loadedElement);
            }
        },
        
        _updateParent: function(row, loadedElement){
            var parentLink = getLink(loadedElement, Constants.ParentTimeCode);
            if (parentLink && parentLink[0]) {
                row.parentId = parentLink[0].relativeHref;
            }
        },
        
        prepareSaveParams: function(row){
            var saveParams = {
                name: row.name,
                description: row.description,
                code: row.code
            }
            if (row.parentId != null && row.parentId != "") {
				var parent = getLink(row.loadedelement[0], Constants.ParentTimeCode);
				if (parent != null) {
					if (parent.relativeHref != row.parentId) {
						saveParams.parent = row.parentId;
						saveParams.ParentTimeCode = row.parentId + ":" + Constants.ADD;
					}					
				}
				else {
					saveParams.parent = row.parentId;
					saveParams.ParentTimeCode = row.parentId + ":" + Constants.ADD;
				}
            }
            return saveParams;
        },
        
        _getNewElementURI: function(row){
            return "timecodes";
        }
    });
})();

