/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserPoolsGridView");
    dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserPoolsGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants");
    //Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var AdminViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
	var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
    var PoolsGridModel =com.ibm.epm.admin.web.ui.internal.view.user.EPMUserPoolsGridModel;
    var ControllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var EPMUserConstants = com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserPoolsGridView", abstractView, {
    
	templateString: '<div class="com-ibm-epm-admin-web-ui-internal-view-user-EPMUserPoolsGrid"><div class="com-ibm-epm-web-core-ui-internal-templates-EPMGrid" dojoAttachPoint="userpoolsGridAttachPoint"/></div>',
        /* 
         * Builds the skill Grid
         */
        buildPoolGrid: function(poolsLink){
        
            if (!this._gridModel) {
                this._gridModel = new PoolsGridModel();
            }

			if(!poolsLink || poolsLink===""){
				this.userPoolGridcontroller = ControllerUtil.getEPMGridController(EPMUserConstants.EPM_USER_POOLS_CONTROLLER_ID);
			}
			else{
				this.userPoolGridcontroller =ControllerUtil.getEPMUserGridController(EPMUserConstants.EPM_USER_POOLS_CONTROLLER_ID, poolsLink);
			}
            this.buildGrid(this, this._gridModel, this.userPoolGridcontroller);
        },
        
		
		
        /*
         * getGridTitle funtion - Override the abstract class and returns the title of the grid.
         *
         */
        getGridTitle: function(){
			return AdminViewletMessages.EPM_USER_POOLS_GRID_TITLE;
        },
        /*
         * getGridInternalID funtion - Override the abstract class and returns the ID of the grid.
         *
         */
        getGridInternalID: function(){
			return EPMUserConstants.EPM_USER_POOLS_GRID_TITLE;
        },
        /*
         * This is called by controller. Returns the Attachpoint to the controller.
         */
        getAttachpoint: function(){
            return this.userpoolsGridAttachPoint;
        },
		
		addPool:function(selectedPoolRow){
			if(selectedPoolRow){
			    this.userPoolGridcontroller._insertElement(selectedPoolRow, null, false);
                this.scrollToSelectedRow();
			}
		},
      
		
        /*
         * This is called by abstractView while creating the view.
         * getGridLayout() is to return grid structure to abstractView.
         */
        getGridLayout: function(){
        
            var poolGridLayout = [{
            
                rows: [[{
                    name: AdminViewletMessages.POOL,
                    width: "auto",
                    field: "name"
                }]]
            
            }];
            
            return poolGridLayout;
        }
            
    });
})();
