/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){

    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserSkillsGridView");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserSkillGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.skills.SkillsGridView");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants");
	dojo.require("com.ibm.epm.admin.web.client.internal.proficiency.ProficiencyClient");
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
	dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
    //Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var AdminViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var SkillsGridView = com.ibm.epm.admin.web.ui.internal.view.skills.SkillsGridView;
	var ProficiencyClient = com.ibm.epm.admin.web.client.internal.proficiency.ProficiencyClient;
    var SkillsGridModel = com.ibm.epm.admin.web.ui.internal.view.user.EPMUserSkillGridModel;
    var ControllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var EPMUserConstants = com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
	
	var selectOptionsForProficiency = [];
	var selectOptionsForProficiencyId = [];
	
	var selectOptionsForSkill = [];
	var selectOptionsForSkillId = [];
	
	dojo.declare("com.ibm.epm.admin.web.ui.internal.view.systemprofile.DynamicSelect", dojox.grid.editors.Select, {
    
        fieldName: null,
		//returnIndex: true,
        constructor: function(inCell){
        
            this.fieldName = inCell.field;
            
        },
        format: function(inDatum, inRowIndex){
        
        
            if (this.fieldName === EPMUserConstants.PROFICIENCY_LEVEL) {
				if (selectOptionsForProficiency && selectOptionsForProficiency.length > 0) {
					this.options = this.values = selectOptionsForProficiency;
				}
				else {
					this.options = this.values = [];
				}
            }
			if (this.fieldName === EPMUserConstants.NAME) {
				if (selectOptionsForSkill && selectOptionsForSkill.length > 0) {
					this.options = this.values = selectOptionsForSkill;
				}
				else {
					this.options = this.values = [];
				}
            }
            return this.inherited("format", arguments);
        }
    });
    
    var DynamicSelect = com.ibm.epm.admin.web.ui.internal.view.systemprofile.DynamicSelect;
	
	
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserSkillsGridView", SkillsGridView, {
    	dirty: false,
        /* 
         * Builds the skill Grid
         */
        buildSkillGrid: function(skillsLink){
        
			var self = this;
			this.getoptions(self.setSelectOptionsForProficiency,EPMUserConstants.PROFICIENCY_URI);
			this.getoptions(self.setSelectOptionsForSkill,EPMUserConstants.SKILL_URI);
            
            if (!this._gridModel) {
                this._gridModel = new SkillsGridModel();
            }
            if (skillsLink) {
                if (skillsLink === "") {
                    this.userSkillGridController = ControllerUtil.getEPMGridController(EPMUserConstants.EPM_USER_SKILLS_CONTROLLER_ID, skillsLink);
                }
                else {
                    this.userSkillGridController = ControllerUtil.getEPMUserGridController(EPMUserConstants.EPM_USER_SKILLS_CONTROLLER_ID, skillsLink);
                }
            }
            else {
                this.userSkillGridController = ControllerUtil.getEPMGridController(EPMUserConstants.EPM_USER_SKILLS_CONTROLLER_ID, skillsLink);
            }
            
            
            this.buildGrid(this, this._gridModel, this.userSkillGridController);
        },
        
		postCreate: function(){
			dojo.subscribe(GridEvents.FIELD_CHANGED, this, this.setEditorDirty);			
        },
        /*
         * This is called by abstractView while creating the view.
         * getGridLayout() is to return grid structure to abstractView.
         */
        getGridLayout: function(){
        
            var skillGridLayout = [{
            
                rows: [[{
                    name: AdminViewletMessages.SKILL,
                    width: 14,
                    field: EPMUserConstants.NAME,
					editor: DynamicSelect
                },{
                    name: AdminViewletMessages.PROFICIENCY_LEVEL,
                    width: "auto",
                    field: EPMUserConstants.PROFICIENCY_LEVEL,
					editor: DynamicSelect
                }]]
            
            }];
            
            return skillGridLayout;
        },
		setEditorDirty: function(args)
		{
			if(this._containingPage && (EPMUserConstants.EPM_USER_SKILLS_CONTROLLER_ID == args.controllerID))
				this._containingPage.setDirty(true);
		},
		
		addAssignment: function()
		{
			var rowID = this._controller.getUniqueRowID(EPMUserConstants.NEW_ELEMENT_UNSAVED_PREFIX);
			var rows = {
				"id": rowID,
                "relativeHref": rowID,
                "name": selectOptionsForSkill ? selectOptionsForSkill[0] : "",
                "proficiencyLevel": selectOptionsForProficiency ? selectOptionsForProficiency[0] : "",
				"skillid":"",
				"pid":""
			};
			this._controller._insertElement(rows, null, false);
			this.scrollToSelectedRow();
            this.startFirstCellEdit();
		},
		
		getoptions : function(funtion,uri){
			var self = this;
			var serviceObj = {
                        success: function(data){
                           var collectionElements1 = [];
						   var collectionElements2 = [];
						   for (var i = 0; i < data.length; i++) {							
								collectionElements1.push(data[i].title);
								collectionElements2.push(data[i].relativeHref);
							}
							
						   funtion(collectionElements1,collectionElements2); 
                        },
                        failure: function(errorObj){
                        }
                    };
                    var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                    ProficiencyClient.getURI(srh, uri);
		},
		
		setSelectOptionsForProficiency: function(options, values){
        	if (options) {
				selectOptionsForProficiency = options;
				selectOptionsForProficiencyId = values;
			}
        },
		
		getSelectOptionsForProficiency: function()
		{
			return selectOptionsForProficiency;
		},
		
		getSelectOptionsForProficiencyId: function()
		{
			return selectOptionsForProficiencyId;
		},
		setSelectOptionsForSkill: function(options, values){
        	if (options) {
				selectOptionsForSkill = options;
				selectOptionsForSkillId = values;
			}
        },
		
		getSelectOptionsForSkill: function()
		{
			return selectOptionsForSkill;
		},
		
		getSelectOptionsForSkillId: function()
		{
			return selectOptionsForSkillId;
		},
		
		/**
		 * Checks if the list of Skills contains any value.
		 */
		checkSkillsExist: function()
		{
			return (selectOptionsForSkill && selectOptionsForSkill.length > 0);
		},
		
		/**
		 * Checks if the list of Proficiencies contains any value.
		 */
		checkProficienciesExist: function()
		{
			return (selectOptionsForProficiency && selectOptionsForProficiency.length > 0);
		}
		
    });
})();
