/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.wbsGrids.WBSBaselineGridView");
    
    dojo.require("dijit.Toolbar");
    dojo.require("dijit.form.Button");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGrid");
    dojo.require("com.ibm.epm.web.core.ui.internal.DojoData");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.TreeBasedGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
    
    dojo.require("com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants");
    dojo.require("com.ibm.epm.work.web.ui.internal.wbsGrids.WBSBaselineGridModel");
    
    
    
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    dojo.require("dojox.grid.compat._data.dijitEditors");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");
    dojo.require("com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub");
    
    dojo.require("com.ibm.epm.work.web.ui.internal.WBSConstants");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.web.core.util.internal.GridColumnUtil");
    
    // EPM Core Constants
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMConstants");
    
    //EPMErrorHandler
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    
    //ServiceResponseHandler
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    
    //  EPMErrorHandler
    
    var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var GridModelClient = com.ibm.epm.web.core.grid.controller.GridModelClient;
    var EPMConstants = com.ibm.epm.web.core.ui.internal.EPMConstants;
    var Constants = com.ibm.epm.web.core.util.internal.Constants; // For Tree id 
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
    var wbsElementURI = "/wbsElement/";
    
    var controllerID = com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.WBSBaselineGridController;
    var TreeBasedGridController = com.ibm.epm.web.core.grid.controller.TreeBasedGridController;
    var getController = com.ibm.epm.web.core.grid.controller.TreeBasedGridController.getTreeBasedGridController;
    var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
    
    dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");
    var WorkMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
    var dateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    
    var WBSConstants = com.ibm.epm.work.web.ui.internal.WBSConstants;
    var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    var GridColumnUtil = com.ibm.epm.web.core.util.internal.GridColumnUtil;
    
    
    dojo.declare("com.ibm.epm.work.web.ui.internal.wbsGrids.WBSBaselineGridView", abstractView, //	[dijit._Widget, dijit._Templated],
    {
        templatePath: dojo.moduleUrl("com.ibm.epm.work.web", "ui/internal/wbsGrids/templates/BaselineView.html"),
        _isBuzy: false,
        newDlg: null,
		overRideCellClasses: false,
        
        constructor: function(treeID){
          this._startUp();
        },
        
		_startUp : function(){
			
			this.baseline1_Label = WorkMessages.WBS_BASELINE1_LABEL;
			this.baseline2_Label = WorkMessages.WBS_BASELINE2_LABEL;
			this.current_Label = WorkMessages.WBS_CURRENT_LABEL;
			this.show_Button = WorkMessages.WBS_SHOW_BUTTON;
			
		},
        /*
         * Remove the attached dom node and Destroy the grid
         */
        _cleanup: function(){
            if (this._wbsGeneralGrid) {
                this.wbsBaselineGridAttachPoint.removeChild(this._wbsGeneralGrid.domNode);
                this._wbsGeneralGrid.destroy();
            }
        },
        
        /*
         * Subscribe to the onselect event
         * And build the grid
         */
        postCreate: function(){
        
            this.buildWBSGeneralGrid();
        },
        
        /*
         * Set the Baseine1 selected value in model
         */
        _setSelected1InModel: function(arg){
            this._gridModel.setTheIdForBaseline1(arg);
        },
        
        /*
         * Set the Baseline2 selected value in model
         */
        _setSelected2InModel: function(arg){
            this._gridModel.setTheIdForBaseline2(arg);
        },
        
        /*
         * Reset the values in Model
         *
         */
        _resetTheValues: function(){
            this._gridModel.setTheIdForBaseline1(null);
            this._gridModel.setTheIdForBaseline2(null);
            this._gridModel.resetTheBaseline1Values(true);
            this._gridModel.resetTheBaseline2Values(true);
            this.refreshGrid();
        },
        
        /*
         * On change of Option in select
         * Set the new value in model
         */
        _changedOption1: function(){
            this._setSelected1InModel(this._baselinelist1.value);
        },
        
        
        /*
         * On change of Option in select
         * Set the new value in model
         */
        _changedOption2: function(){
            this._setSelected2InModel(this._baselinelist2.value);
        },
        
        
        
        /*
         * On click of show
         * Check the Check box's and Set the values
         * Then Refresh the Grid
         */
        _onClickOfShow: function(){
            if (this.baselineCheckBox1.checked == true) {
                this._setSelected1InModel(this._baselinelist1.value);
                this._gridModel.resetTheBaseline1Values(false);
            }
            else {
                this._setSelected1InModel(null);
                this._gridModel.resetTheBaseline1Values(true);
                
            }
            
            if (this.baselineCheckBox2.checked == true) {
                this._setSelected2InModel(this._baselinelist2.value);
                this._gridModel.resetTheBaseline2Values(false);
            }
            else {
                this._setSelected2InModel(null);
                this._gridModel.resetTheBaseline2Values(true);
            }
            
            
            /*
             *Dynamically change the layout
             *Depending on what is Checked
             */
            var updatedLayout = this.getGridLayout();
            
            if (this._generalGrid) {
                this._generalGrid.setStructure(updatedLayout);
            }
            
            this.refreshGrid();
            
            this.update();
        },
        
        
        
        /*
         * On Selection of a Project  node in the Tree
         * Check if it is a project and make the Get Call
         * After the success if there are Baselines Populate in the Select Tag
         * Get the selected node directly from tree and also listen to select event
         */
        onRowSelect: function(){
        
            var tree = dijit.byId(Constants.WBS_TREE_ID);
		   
            if (tree && tree._selectedNode && this._controller && this._controller.id == controllerID ) {
                var item = tree._selectedNode.item;
                if (item && item.resourcetype == WBSConstants.EPM_PROJECT_TYPE) {
                    if (this.CurrentSelectedProject == null) {
                        this.CurrentSelectedProject = item.identifier;
                    }
                    if (this.CurrentSelectedProject != item.identifier) {
                        this.CurrentSelectedProject = item.identifier;
                        this._resetTheValues();
                    }
                    
                    
                    var self = this;
                    var serviceObj = {
                        success: function(data){
                            self._populateSelectTags(data);
                            return;
                            
                        },
                        failure: function(errorObj){
                            EPMErrorHandler.setError(errorObj.errorMessage, errorObj.errorCode);
                        }
                    };
                    
                    var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                    
                    GridModelClient.getURI(srh, item.identifier + WBSConstants.SLASH + WBSConstants.BASELINE);
                }
            }
            
            
        },
        
        
        
        /*
         * Get the Resource Id from the Uri
         */
        _getResourceIDFromURI: function(relatedHref){
            var index = relatedHref.lastIndexOf("/");
            if (index > 0) {
                return relatedHref.substring(index + 1, relatedHref.length);
            }
        },
        
        
        /*
         * Populate the Select tag
         * Check , if there are older options already populated
         * Delete them
         * And then add the new options
         * A flag to be set if there is only one baseline , so as to populate only in first baseline
         */
        _populateSelectTags: function(data){
            var boolBaseline2flag = true;
            
            if (data.length == 1) {
                boolBaseline2flag = false;
            }
            
            this._populateSelectTag(data, this._baselinelist1, true);
            this._populateSelectTag(data, this._baselinelist2, boolBaseline2flag);
            
            
        },
        
        /*
         * Populates a select tag
         * Incoming : data , selectag
         * Data has the collection of baselines , traverse and populate in incoming tag
         * If there is only one baseline , do not populate the second select tag .
         */
        _populateSelectTag: function(data, selectTag, boolBaseline2flag){
            if (data != null && dojo.isArray(data)) {
                if (selectTag.options) {
                    var length = selectTag.length;
                    for (var i = 0; i < length; i++) {
                        selectTag.remove(0);
                    }
                }
                var noOfBaselines = data.length;
                if (boolBaseline2flag == true) {
                    for (var j = 0; j < noOfBaselines; j++) {
                        var optionNode = new Option(data[j].title, this._getResourceIDFromURI(data[j].relativeHref));
                        selectTag.options[j] = optionNode;
                    }
                }
            }
        },
        
        
        /**
         * Destroy function calls destroy of AbstractGridView and unsubscribe to other events.
         */
        destroy: function(){
            this.inherited(arguments);
        },
        
        
        /*
         * Build the gird
         * Pass two links [Baseline,Baseline2]
         * There is no physical link, handle accordingly
         */
        buildWBSGeneralGrid: function(){
            if (!this._gridModel) {
                this._gridModel = new com.ibm.epm.work.web.ui.internal.wbsGrids.WBSBaselineGridModel();
            }
            var wbsGeneralGridController = controllerUtil.getTreeBasedGridController(controllerID);
            this.buildGrid(this, this._gridModel, wbsGeneralGridController, [WBSConstants.BASELINE, WBSConstants.BASELINE2]);
        },
        
        /*
         * While creating the view set the autoheight true
         * Let the viewlet grow as the data is added
         */
        createView: function(){
            this.inherited('createView', arguments);
            this._generalGrid.autoHeight = true;
            this._generalGrid.update();
            
            
            
        },
        
        
        /**
         * getGridTitle: Returns the title of the grid.
         * Incoming:
         *	none
         * Outgoing:
         *  none
         */
        getGridTitle: function(){
            return WorkMessages.WBS_BASELINE_GRID_ID;
        },
        
        /**
         * getGridInternalID: Returns the ID of the grid.
         * Incoming:
         *	none
         * Outgoing:
         *  none
         */
        getGridInternalID: function(){
            return WBSConstants.WBS_BASELINE_GRID_ID;
        },
        /*
         * Return false
         */
        isCellEditable: function(event){
            var rowIndex = parseInt(event.rowIndex, 10);
            if (isNaN(rowIndex)) {
                return false;
            }
            var row = this._getTreeBasedController().getRowByIndex(rowIndex);
            
            
        },
        
        
        /**
         * _getTreeBasedController: To create/return the controller.
         * 							Added extra check for TreeBasedGridController._gridData. In case not found, recreating the controller again.
         * 							This extra check is because some times, the controller is partailly available without gridData.
         * Incoming: none.
         * Outgoing: TreeBasedGridController.
         */
        _getTreeBasedController: function(){
            if (!this.TreeBasedGridController) {
                this.TreeBasedGridController = controllerUtil.getTreeBasedGridController(controllerID);
            }
            if ((this.TreeBasedGridController) && (!this.TreeBasedGridController._gridData)) {
                delete this.TreeBasedGridController;
                this.TreeBasedGridController = controllerUtil.getTreeBasedGridController(controllerID);
            }
            return this.TreeBasedGridController;
        },
        
        /*
         * Return the attachPoint
         */
        getAttachpoint: function(){
            return this.wbsBaselineGridAttachPoint;
        },
        
        /*
         * Handle the error
         */
        handleError: function(errorMessage){
            this.inherited("handleError", arguments);
            this._displayError(errorMessage);
        },
        
        /*
         * Return the layour for Baseline1 only
         */
        getBaseline1Layout: function(){
            var gridLayoutBaseline1 = [{
                noscroll: false,
                rows: [[{
                    name: WorkMessages.WBS_BASELINE1_START, //1
                    width: 12,
                    field: "baseline1proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_BASELINE1_FINISH, //2
                    width: 12,
                    field: "baseline1proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE1_DURATION, //3
                    width: 10,
                    field: "baseline1duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name:WorkMessages.WBS_BASELINE1_EFFORT, //4
                    width: 10,
                    field: "baseline1effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }]]
            }];
            
            return gridLayoutBaseline1;
        },
        
        /*
         * Return the layout for Baseline2 only
         */
        getBaseline2Layout: function(){
            /*
             * Layout for Baseline2 only
             */
            var gridLayoutBaseline2 = [{
                noscroll: false,
                //                defaultCell: {styles: 'text-align: left;'},
                rows: [[{
                    name: WorkMessages.WBS_BASELINE2_START, //1
                    width: 12,
                    field: "baseline2proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_FINISH, //2
                    width: 12,
                    field: "baseline2proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_DURATION, //3
                    width: 10,
                    field: "baseline2duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_EFFORT, //4
                    width: 10,
                    field: "baseline2effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }]]
            }];
            
            return gridLayoutBaseline2;
        },
        
        /*
         * Return the layout for Current only
         */
        getActualLayout: function(){
            /*
             * Layout for Current only
             *
             */
            var gridLayoutforCurrent = [{
                noscroll: false,
                //                defaultCell: {styles: 'text-align: left;'},
                rows: [[{
                    name: WorkMessages.WBS_CURRENT_START, //1
                    width: 12,
                    field: "proposedstart",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_CURRENT_FINISH, //2
                    width: 12,
                    field: "proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_CURRENT_DURATION, //3
                    width: 10,
                    field: "proposedduration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_CURRENT_EFFORT, //4
                    width: 10,
                    field: "proposedeffort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }]]
            }];
            
            return gridLayoutforCurrent;
        },
        
        
        /*
         * Return the layout for All the fields
         */
        getLayoutforAll: function(){
        
            var gridLayoutAll = [{
                noscroll: false,
                //  defaultCell: {styles: 'text-align: left;'},
                rows: [[{
                    name: WorkMessages.WBS_BASELINE1_START, //1
                    width: 12,
                    field: "baseline1proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_START, //2
                    width: 12,
                    field: "baseline2proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_CURRENT_START, //3
                    width: 12,
                    field: "proposedstart",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE1_FINISH, //4
                    width: 12,
                    field: "baseline1proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_FINISH, //5
                    width: 12,
                    field: "baseline2proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_CURRENT_FINISH, //6
                    width: 12,
                    field: "proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE1_DURATION, //7
                    width: 10,
                    field: "baseline1duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_DURATION, //8
                    width: 10,
                    field: "baseline2duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_CURRENT_DURATION, //9
                    width: 10,
                    field: "proposedduration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name:WorkMessages.WBS_BASELINE1_EFFORT, //10
                    width: 10,
                    field: "baseline1effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_EFFORT, //11
                    width: 10,
                    field: "baseline2effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }, {
                    name: WorkMessages.WBS_CURRENT_EFFORT, //12
                    width: 10,
                    field: "proposedeffort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }]]
            }];
            
            return gridLayoutAll;
        },
        
        /*
         * Return the layout for Baseline1 and Baseline2
         */
        getLayoutforBaseline1andBaseline2: function(){
            var gridLayoutBaseline1And2 = [{
                noscroll: false,
                //                defaultCell: {styles: 'text-align: left;'},
                rows: [[{
                    name: WorkMessages.WBS_BASELINE1_START, //1
                    width: 12,
                    field: "baseline1proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_START, //2
                    width: 12,
                    field: "baseline2proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_BASELINE1_FINISH, //3
                    width: 12,
                    field: "baseline1proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_FINISH, //4
                    width: 12,
                    field: "baseline2proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE1_DURATION, //5
                    width: 10,
                    field: "baseline1duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_DURATION, //6
                    width: 10,
                    field: "baseline2duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name:WorkMessages.WBS_BASELINE1_EFFORT, //7
                    width: 10,
                    field: "baseline1effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_EFFORT, //8
                    width: 10,
                    field: "baseline2effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }]]
            }];
            
            
            return gridLayoutBaseline1And2;
        },
        
        
        /*
         * Return the layout for Baseline1 and Baseline2
         */
        getLayoutforBaseline2andCurrent: function(){
            /*
             * Layout for Baseline 2 and Current
             */
            var gridLayoutBaseline2andCurrent = [{
                noscroll: false,
                //                defaultCell: {styles: 'text-align: left;'},
                rows: [[{
                    name: WorkMessages.WBS_BASELINE2_START, //1
                    width: 12,
                    field: "baseline2proposedstart",
                    formatter: dateUtil.formatDate
                
                
                }, {
                    name: WorkMessages.WBS_CURRENT_START, //2
                    width: 12,
                    field: "proposedstart",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_FINISH, //3
                    width: 12,
                    field: "baseline2proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_CURRENT_FINISH, //4
                    width: 12,
                    field: "proposedfinish",
                    formatter: dateUtil.formatDate
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_DURATION, //5
                    width: 10,
                    field: "baseline2duration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_CURRENT_DURATION, //6
                    width: 10,
                    field: "proposedduration",
					styles: 'text-align:right;',
					formatter: GridColumnUtil.formatDays
                
                }, {
                    name: WorkMessages.WBS_BASELINE2_EFFORT, //7
                    width: 10,
                    field: "baseline2effort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }, {
                    name: WorkMessages.WBS_CURRENT_EFFORT, //8
                    width: 10,
                    field: "proposedeffort",
					styles: 'text-align:right;',
                    formatter: GridColumnUtil.formatHours
                
                }]]
            }];
            
            return gridLayoutBaseline2andCurrent;
        },
        
        /*
         * Check the selected check boxs and return the layout accordingly
         * If nothing is checked just return
         * Check for the values to determine the color
         * Currently only btw baseline1 and Current
         */
        getGridLayout: function(){
        
            var self = this;
            
            /*
             * Formatter to change style of the text
             */
            _formatbaseline = function(inData, inRowIndex){
                var row = null;
                if (this.grid && this.grid.model) {
                    row = this.grid.model.getRow(inRowIndex);
                }
                
                if (row) {
                
                    if (this.field == "proposedstart" || this.field == "baseline1start" || this.field == "baseline1finish" || this.field == "proposedfinish") {
                        inData = dateUtil.formatDate(inData);
                    }
                    if (this.field == "proposedstart" || this.field == "proposedfinish" || this.field == "proposedduration" || this.field == "proposedeffort") {
                    
                        if (this.field == "proposedduration") {
                            if (inData > 0 && row.proposedduration > row.baseline1duration) {
                                var font = "font-weight: bold;";
                                this.customStyles.push(font);
                                var color = "color : rgb(255,69,0);"
                                this.customStyles.push(color);
                            }
                        }
                        if (this.field == "proposedeffort") {
                            if (inData > 0 && row.proposedeffort > row.baseline1effort) {
                                var font = "font-weight: bold;";
                                this.customStyles.push(font);
                                var color = "color : rgb(255,69,0);"
                                this.customStyles.push(color);
                                
                            }
                        }
                        if (this.field == "proposedstart") {
                            if (inData && Date.parse(row.proposedstart) > Date.parse(row.baseline1proposedstart)) {
                                var font = "font-weight: bold;";
                                this.customStyles.push(font);
                                var color = "color : rgb(255,69,0);"
                                this.customStyles.push(color);
                                
                            }
                            
                        }
                        
                        if (this.field == "proposedfinish") {
                            if (inData && Date.parse(row.proposedfinish) > Date.parse(row.baseline1proposedfinish)) {
                                var font = "font-weight: bold;";
                                this.customStyles.push(font);
                                var color = "color : rgb(255,69,0);"
                                this.customStyles.push(color);
                                
                            }
                            
                        }
						if (this.field == "proposedduration") {
							inData = GridColumnUtil.formatDays(inData);
						}
						if (this.field == "proposedeffort") {
							inData = GridColumnUtil.formatHours(inData);
						}
                        
                    }
                    
                }
                
                
                return inData;
                
            };
            
            
            
            /*
             * Check the checkboxes and return the layout accordingly
             *
             */
            if (this.baselineCheckBox1.checked == true && this.baselineCheckBox2.checked == false && this.CurrentCheckBox.checked == false) {
                return self.getBaseline1Layout();
            }
            
            if (this.baselineCheckBox1.checked == false && this.baselineCheckBox2.checked == true && this.CurrentCheckBox.checked == false) {
                return self.getBaseline2Layout();
            }
            
            if (this.baselineCheckBox1.checked == false && this.baselineCheckBox2.checked == false && this.CurrentCheckBox.checked == true) {
                return self.getActualLayout();
            }
            
            if (this.baselineCheckBox1.checked == true && this.baselineCheckBox2.checked == true && this.CurrentCheckBox.checked == false) {
                return self.getLayoutforBaseline1andBaseline2();
            }
            
            if (this.baselineCheckBox1.checked == true && this.baselineCheckBox2.checked == false && this.CurrentCheckBox.checked == true) {
                /*
                 * Layout for Baseline 1 and Current
                 */
                var gridLayoutBaseline1andCurrent = [{
                    noscroll: false,
                    //                defaultCell: {styles: 'text-align: left;'},
                    rows: [[{
                        name: WorkMessages.WBS_BASELINE1_START, //1
                        width: 12,
                        field: "baseline1proposedstart",
                        formatter: dateUtil.formatDate
                    
                    
                    }, {
                        name: WorkMessages.WBS_CURRENT_START, //2
                        width: 12,
                        field: "proposedstart",
                        formatter: dateUtil.formatDate,
                        formatter: _formatbaseline
                    
                    }, {
                        name: WorkMessages.WBS_BASELINE1_FINISH, //3
                        width: 12,
                        field: "baseline1proposedfinish",
                        formatter: dateUtil.formatDate
                    
                    }, {
                        name: WorkMessages.WBS_CURRENT_FINISH, //4
                        width: 12,
                        field: "proposedfinish",
                        formatter: _formatbaseline
                    
                    }, {
                        name: WorkMessages.WBS_BASELINE1_DURATION, //5
                        width: 10,
                        field: "baseline1duration",
						styles: 'text-align:right;',
						formatter: GridColumnUtil.formatDays
                    
                    }, {
                        name: WorkMessages.WBS_CURRENT_DURATION, //6
                        width: 10,
                        field: "proposedduration",
                        formatter: _formatbaseline,
						styles: 'text-align:right;'
                    
                    }, {
                        name:WorkMessages.WBS_BASELINE1_EFFORT, //7
                        width: 10,
                        field: "baseline1effort",
						styles: 'text-align:right;',
						formatter: GridColumnUtil.formatHours
                    
                    }, {
                        name: WorkMessages.WBS_CURRENT_EFFORT, //8
                        width: 10,
                        field: "proposedeffort",
                        formatter: _formatbaseline,
                        styles: 'text-align: right;'
                    
                    }]]
                }];
                return gridLayoutBaseline1andCurrent;
            }
            
            if (this.baselineCheckBox1.checked == false && this.baselineCheckBox2.checked == true && this.CurrentCheckBox.checked == true) {
                return self.getLayoutforBaseline2andCurrent();
            }
            
            if (this.baselineCheckBox1.checked == true && this.baselineCheckBox2.checked == true && this.CurrentCheckBox.checked == true) {
                return self.getLayoutforAll();
            }
            return;
        }
        
        
        
        
    });
})();
