
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
if (!dojo._hasResource["com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog"]) {
    dojo._hasResource["com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog"] = true;
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog");
    
    dojo.require("jazz.ui.Dialog");
    dojo.require("dijit.form.Button");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    
	dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");
	dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil");	
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    /*
     * Aliases
     */
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    var Messages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");

    var IconClassConstants = com.ibm.epm.web.core.ui.internal.IconClassConstants;
    var AssignmentUtil = com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog", [dijit._Widget, dijit._Templated], {
    
        dialog: null,
        competenciesString: "",
        skillsString: "",
        rateMap: [],
        profileInfoIdMap: [],
        context: null,
        lastSelectedIndex: "",
        multipleAssignment: true,
        widgetsInTemplate: true,
        
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.assignment.web", "ui/internal2/templates/AddProfileDialog.html"),
        
        /*
         * constructor: To initialize the message variables.
         * Incoming: None
         * Outgoing: None.
         */
        constructor: function(){
            this.msgAdd = Messages.ADD_BUTTON;
            this.msgRemove = Messages.REMOVE;
            this.msgOK = Messages.ADD_BUTTON;
            this.msgCancel = Messages.CANCEL;
        },
        
        /*
         * postCreate: To perform neccessary oprations before rendering the dialog.
         * Incoming: None
         * Outgoing: None.
         */
        postCreate: function(){
            this.configureUI();
            this.dialog = new jazz.ui.Dialog({
                contentNode: this.contentNode,
                primaryTitle: Messages.ADD_PROFILE_DIALOG_TITLE,
				closeOnEsc: false,//We are providing both Enter and Esc in this dialog
                width: "500px"
            });
            if (!this.multipleAssignment) {
                var leftList = dojo.byId("unselectedList");
                var rightList = dojo.byId("selectedList");
                if (rightList) {
                    rightList.multiple = false;
                }
                if (leftList) {
                    leftList.multiple = false;
                }
            }
        },
        
        /*
         * configureUI: It configure the UI of the dialog.
         * Incoming: None
         * Outgoing: None.
         */
        configureUI: function(){
            // Unselected list title
            this._unselectedListTitle.innerHTML = Messages.ALL_ITEMS;
            // Selected list title
            this._selectedListTitle.innerHTML = Messages.SELECTED_ITEMS;
            // Description title
            this._description.innerHTML = Messages.DESCRIPTION_LABEL;
            // Competencies list title
            this._competencies.innerHTML = Messages.COMPETENCIES_LABEL;
            // Skills list title
            this._skills.innerHTML = Messages.SKILLS_LABEL;
            
            var self = this;
            this.selectButton = new dijit.form.Button({
                title: this.msgAdd,
				label : this.msgAdd,
				showLabel : false,
                iconClass: IconClassConstants.EPM_ADD_TO_RIGHT_CLASS,
                onClick: dojo.hitch(this, this._handleEventSelectButtonClicked)
            });
            
            this.unSelectButton = new dijit.form.Button({
                title: this.msgRemove,
				label : this.msgRemove,
				showLabel : false,
                iconClass: IconClassConstants.EPM_ADD_TO_LEFT_CLASS,
                onClick: dojo.hitch(this, this._handleEventRemoveButtonClicked)
            });
            
            this.moveRightButton.appendChild(this.selectButton.domNode);
            this.moveLeftButton.appendChild(this.unSelectButton.domNode);
            this.populateUnselectedList();
            // OK button
            this.connect(this._addButton, "onclick", this._handleEventAddButtonClicked);
            // Cancel button
            this.connect(this._cancelButton, "onclick", this._handleEventCancelButtonClicked);
            // Key up listener
            this._keyUpHandler = this.connect(this.domNode, "onkeyup", this._handleEventKeyUp);
            
        },
        
        /*
         * populateUnselectedList: Load all the system profile in unselected listbox.
         * Incoming: None
         * Outgoing: None.
         */
        populateUnselectedList: function(){
            var self = this;
            
            var serviceObject = {
            
                success: function(profileList){
                    if (profileList) {
                        var unSelectedList = dojo.byId("unselectedList");
                        if (unSelectedList) {
                            for (var i = 0; i < profileList.length; i++) {
                                unSelectedList.options[i] = new Option(profileList[i].title, profileList[i].relativeHref);
                            }
                        }
                    }
                },
                failure: function(errorObj){
                
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getSystemProfile(srh);
        },
        
        /*
         * _handleEventDoubleClickedUnselected: when double click action is performed in unselected list.
         * Incoming: event e.
         * Outgoing: None.
         */
        _handleEventDoubleClickedUnselected: function(e){
            var SelectedList = dojo.byId("selectedList");
            var unselectedList = dojo.byId("unselectedList");
            if (SelectedList && unselectedList) {
                var selectedOptionsLength = SelectedList.getElementsByTagName("option").length;
                if (!this.multipleAssignment && selectedOptionsLength >= 1) {
                    alert(Messages.ONLY_ONE_ASSIGNMENT_ALLOWED_FOR_WORKITEM);
                }
                else {
                    if (this.profileInfoIdMap[e.target.value]) {
                        var selectedText = unselectedList[unselectedList.selectedIndex].text;
                        SelectedList.options[selectedOptionsLength] = new Option(selectedText, e.target.value);
                    }
                }
            }
        },
        
        /*
         * _handleEventDoubleClickedSelected: when double click action is performed in selected list.
         * Incoming: event e.
         * Outgoing: None.
         */
        _handleEventDoubleClickedSelected: function(e){
            var UnSelectedList = dojo.byId("selectedList");
            if (UnSelectedList) {
                UnSelectedList.remove(e.target.index);
            }
        },
        
        /*
         * _handleEventSelectButtonClicked: when -> button is clicked.
         * Incoming: None.
         * Outgoing: None.
         */
        _handleEventSelectButtonClicked: function(){
            var unSelectedList = dojo.byId("unselectedList");
            var SelectedList = dojo.byId("selectedList");
            if (unSelectedList && SelectedList) {
                var options = unSelectedList.getElementsByTagName("option");
                var selectedOptionsLength = SelectedList.getElementsByTagName("option").length;
                
                for (var i = 0; i < options.length; i++) {
                
                    if (options[i].selected) {
                        if (this.profileInfoIdMap[options[i].value]) {
                            if (!this.multipleAssignment && selectedOptionsLength >= 1) {
                                alert(Messages.ONLY_ONE_ASSIGNMENT_ALLOWED_FOR_WORKITEM);
                            }
                            else {
                                SelectedList.options[selectedOptionsLength] = new Option(options[i].text, options[i].value);
                                selectedOptionsLength = selectedOptionsLength + 1;
                            }
                        }
                        else {
                            var self = this;
                            
                            var serviceObject = {
                            
                                success: function(profileInfo){
                                    self.createProfileParam(profileInfo);
                                    var iSelectedList = dojo.byId("selectedList");
                                    if (iSelectedList) {
                                        var selectedOptionsLength = iSelectedList.getElementsByTagName("option").length;
                                        iSelectedList.options[selectedOptionsLength] = new Option(profileInfo.name, profileInfo.relativeHref);
                                    }
                                },
                                failure: function(errorObj){
                                
                                }
                            };
                            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
                            ResourceAssignmentClient.getResourceData_Href(srh, options[i].value);
                        }
                        
                        
                    }
                    
                }
            }
        },
        
        /*
         * _handleEventRemoveButtonClicked: when <- button is clicked.
         * Incoming: None.
         * Outgoing: None.
         */
        _handleEventRemoveButtonClicked: function(){
            var SelectedList = dojo.byId("selectedList");
            if (SelectedList) {
                var selectedOptions = SelectedList.getElementsByTagName("option");
                
                for (var i = 0; i < selectedOptions.length; i++) {
                    if (selectedOptions[i].selected) {
                        SelectedList.remove(i);
                    }
                }
            }
        },
        
        /*
         * _handleEventOKButtonClicked: when ok button of dialog is clicked.
         * Incoming: None.
         * Outgoing: None.
         */
        _handleEventAddButtonClicked: function(){
            var SelectedList = dojo.byId("selectedList");
            if (SelectedList) {
                var selectedOptions = SelectedList.getElementsByTagName("option");
                var param = [];
                for (var i = 0; i < selectedOptions.length; i++) {
                    param[i] = this.profileInfoIdMap[SelectedList.options[i].value];
                }
                // Redirect
                this.context.assignProfile(param);
                this.destroy();
            }
        },
        
        /*
         * _handleEventCancelButtonClicked: when cancel button of dialog is clicked.
         * Incoming: event.
         * Outgoing: None.
         */
        _handleEventCancelButtonClicked: function(event){
            dojo.stopEvent(event);
            this.destroy();
        },
        
        /*
         * _handleEventKeyUp: Handle key event for enter and escape key.
         * Incoming: event.
         * Outgoing: None.
         */
        _handleEventKeyUp: function(event){
            dojo.stopEvent(event);

            if (event.keyCode === dojo.keys.ESCAPE) {
                // Handle escape key presses
                // Default action is clicking Cancel button 
                this.destroy();
            }
        },
        
        /*
         * _profileSelected: get the href from event
         * Incoming: event
         * Outgoing: None.
         */
        _profileSelected: function(e){
            var relativeHref = e.target.value;
			this.clearAllProfileInfo();
            this._fillProfileDetails(relativeHref);
        },
        
        /*
         * _fillProfileDetails: get all profile information based on relativeHref.
         * Incoming: relativeHref.
         * Outgoing: None.
         */
        _fillProfileDetails: function(relativeHref){
            var self = this;
            var serviceObject = {
                success: function(profileInfo){
                    self.createProfileParam(profileInfo);
					var description = profileInfo.description?profileInfo.description:"";
                    self.createDescriptionLabel(description);
					self.SkillValue = "";
					self.CompetencyValue ="";
					if (profileInfo.skillassignment && profileInfo.skillassignment.length > 0) {
						for (var i in profileInfo.skillassignment) {
							if(self.SkillValue.length > 0)
							{
								self.SkillValue = self.SkillValue + " , ";
							}
							self.SkillValue = self.SkillValue 
							+ profileInfo.skillassignment[i].skill.title 
							+ "(" + profileInfo.skillassignment[i].proficiency.title + ")";
						}
					}
					if (profileInfo.competencyassignment && profileInfo.competencyassignment.length > 0) {
						for (var k in profileInfo.competencyassignment) {
							if(self.CompetencyValue.length > 0)
							{
								self.CompetencyValue = self.CompetencyValue + " , ";
							}
							self.CompetencyValue = self.CompetencyValue + profileInfo.competencyassignment[k].competency.title 
							+ "(" + profileInfo.competencyassignment[k].proficiency.title + ")";
						}
					}
				
				
                    self.createCompetenciesList(self.CompetencyValue);
                    self.createSkillsList(self.SkillValue);
                },
                failure: function(errorObj){
                    //do nothing
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getResourceData_Href(srh, relativeHref);
        },
        
        /*
         * createDescriptionLabel: Prepare description label for dialog.
         * Incoming: description.
         * Outgoing: None.
         */
        createDescriptionLabel: function(description){
            if (this.DescriptionText.hasChildNodes()) {
                while (this.DescriptionText.childNodes.length >= 1) {
                    this.DescriptionText.removeChild(this.DescriptionText.firstChild);
                }
            }
            var descriptionLabel = document.createElement("label");
            
            descriptionLabel.innerHTML = description;
            
            this.DescriptionText.appendChild(descriptionLabel);
        },
        
        /*
         * createCompetenciesList: loop through all the competencies to get information of them.
         * Incoming: competencies.
         * Outgoing: None.
         */
        createCompetenciesList: function(competencies){
			if (competencies) {
				this.CompetenciesList.innerHTML = Messages.WAITING_TO_LOAD;
				if (competencies.length > 0) {
					this.CompetenciesList.innerHTML = competencies;
				}
			}
			else{
				this.CompetenciesList.innerHTML = "";
			}
			
//            for (var i = 0; i < competencies.length; i++) {
//                if (this.CompetenciesList.innerHTML == Messages.WAITING_TO_LOAD) {
//                    this.competenciesString = competencies[i].title ;
//                }
//                else {
//                    this.competenciesString = this.competenciesString + ", " + competencies[i].title;
//                }
//                this.CompetenciesList.innerHTML = this.competenciesString;
//            }
            
        },
        
        /*
         * createSkillsList: loop through all the skills to get information of them.
         * Incoming: skills.
         * Outgoing: None.
         */
        createSkillsList: function(skills){
            if (skills) {
                this.SkillsList.innerHTML = Messages.WAITING_TO_LOAD;
				if(skills.length  > 0){
				this.SkillsList.innerHTML = skills;
			}
//                for (var i = 0; i < skills.length; i++) {
//                    if (this.SkillsList.innerHTML == Messages.WAITING_TO_LOAD) {
//                        this.skillsString = skills[i].title;
//                    }
//                    else {
//                        this.skillsString = this.skillsString + ", " + skills[i].title;
//                    }
//                    this.SkillsList.innerHTML = this.skillsString;
//                }
            }
            else {
                this.SkillsList.innerHTML = "";
            }
        },
        
        /*
         * createProfileParam: prepare the Profile map.
         * Incoming: profile.
         * Outgoing: None.
         */
        createProfileParam: function(profile){
            var self = this;
			var description = "";
			if(profile.description){
				description = profile.description.replace(/\\/g, "\\\\");
	            description = description.replace(/,/g, "\\,");
	            description = description.replace(/\[/g, "\\[");
	            description = description.replace(/]/g, "\\]");
	            description = description.replace(/\=/g, "\\=");
			}
            var profileParam = {
                name: profile.name,
                description: description,
                experienceInYears: profile.experienceInYears,
                costRate: "0",
                sellingRate: "0",
                profileTemplateId: profile.relativeHref
            };
            
            if (profile.Rate) {
                var serviceObj2 = {
                    success: function(rateData){
                        if (!rateData) {
//    						self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                        }
                        else {
                        	profileParam.costRate = rateData.costRate;
							profileParam.sellingRate = rateData.sellingRate;
                            self.profileInfoIdMap[profile.relativeHref] = profileParam;
                        }
                    },
                    failure: function(errorObj){
//                        self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                    }
                };
                var srh2 = new ServiceResponseHandler(serviceObj2, "success", "failure");
                ResourceAssignmentClient.getURI(srh2, profile.Rate.relativeHref);
            }
            else {           
                //Set default rate
                AssignmentUtil.setDefaultRate(profileParam);
                this.profileInfoIdMap[profile.relativeHref] = profileParam;
            }
        
        },
        
        clearAllProfileInfo: function(){
            this.DescriptionText.innerHTML = Messages.WAITING_TO_LOAD;
            this.SkillsList.innerHTML = Messages.WAITING_TO_LOAD;
            this.CompetenciesList.innerHTML = Messages.WAITING_TO_LOAD;
            
        },
        
        /*
         * destroy: destroy locally created objects and connectors .
         * Incoming: None.
         * Outgoing: None.
         */
        destroy: function(){
            // Disconnect handlers
            if (this._keyUpHandler !== null) {
                this.disconnect(this._keyUpHandler);
                this._keyUpHandler = null;
            }
            
            //            this.dialog.hide();
            this.dialog.close();
            this.dialog.destroy();
        }
    });
}
