/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
/**
 * @author suryakant
 */
(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridView");
    
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridModel");
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor");
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.RateEditor");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    dojo.require("com.ibm.epm.web.core.util.internal.GridColumnUtil");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    dojo.require("com.ibm.epm.web.core.util.internal.Constants");
    //Constants
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    // Dialogs
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    
    // dojo library
    dojo.require("dijit.Tooltip");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllersFactory");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
	
	dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil");
	dojo.require("com.ibm.epm.web.core.util.internal.Util");
	
	var AssignmentUtil = com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil;
	
	//Controller Util
	 dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
	// One day in milliseconds
    var dayInMilli = 1000 * 60 * 60 * 24;
    
    var controllerFactory = com.ibm.epm.web.core.grid.controller.ControllersFactory;
    var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
    
    var AddProfileDialog = com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog;
    
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    var EPMConstants = com.ibm.epm.web.core.util.internal.Constants;
    var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
    var GridColumnUtil = com.ibm.epm.web.core.util.internal.GridColumnUtil;
	var AssignmentDashboardUtil = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
	var util = com.ibm.epm.web.core.util.internal.Util;
	
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridView", abstractView, {
        //	The file name was changed from AssignedResourceGrid.css to XAssignedResourceGrid.css
        //	IE never loads AssignedResourceGrid.css
        templateString: '<div class="com-ibm-epm-web-core-ui-internal-templates-EPMGrid com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid">' +
        '<div dojoAttachPoint="_taskResourceContent">' +
        '</div>' +
        '</div>',
        
        itemOfTypeEffort: false,
        projectHref: "",
        projectName: "",
        categoryId: "",
        projectAssignmentEffort: 0,
        projectAssignmentEffortChange: false,
        projectAssignmentScheduleChange: false,
        resourceOverAllocation: false,
        deleteOrUpdateFlag: true,
        updateOnlyFlag: false,
        rowToReplace: "",
		containingProjectId:"",
		
       
	   /*
	    * Constructor
	    */
	    constructor: function(){
            this._rowHoverArray = [];
            this._pconnects = [];
            this._psubscribes = [];
			this.rowsToSave = [];
        },
        
        /* 
         * buildRatesGrid calls the buildGrid() in abstractView.
         * buildGrid() creates the controller, initializes and the dataModel mapping will be done with TimecodesGrid.
         */
        buildAssignedResourcesGrid: function(nodeID, nodeType, nodeName, itemType, projectCategoryId,containingProjectId){
        
			this.containingProjectId = containingProjectId;
            this.itemOfTypeEffort = itemType;
            this.nodeName = nodeName;
            if (projectCategoryId != "") {
                this.projectCategoryId = projectCategoryId;
            }
            this.nodeId = nodeID;
            
            this.wbsNodeType = nodeType;
            
            if (!this._gridModel) {
                this._gridModel = new com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridModel(nodeID, nodeType,containingProjectId);
            }
            else {
            
                this._gridModel.setWBSNodeIdAndType(nodeID, nodeType,containingProjectId);
            }
            if (!this.assignmentResourceController) {
            
                this.assignmentResourceController = controllerFactory.getEPMAssignmentGridController(Constants.ASSIGNED_RESOURCES_GRID_ID);
                
            }
            else {
            
                this.assignmentResourceController.setAllElementsURI(this._treeID);
            }
            
            // set the node type
            this.assignmentResourceController.setWBSNodeType(nodeType);
            
			this.viewIsBusy = true;
            this.buildGrid(this, this._gridModel, this.assignmentResourceController, null);
            
            if (this._generalGrid) {
                var updatedLayout = this.getGridLayout();
                this._generalGrid.setStructure(updatedLayout);
            }
        },
        
        createView: function(){
        
            this.inherited('createView', arguments);
            
            this._generalGrid.isCellEditable = dojo.hitch(this, this.isCellEditable);
            
            this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_DBL_CLICK, this, this.onCellDblClick));
            this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_CLICK, this, this.onCellClick));
            this._pconnects.push(dojo.connect(this._generalGrid, "onApplyCellEdit", this, this.onApplyCellEdit));
            this._pconnects.push(dojo.connect(this._generalGrid, "onStartEdit", this, this.onStartEdit));
            this._pconnects.push(dojo.connect(this._generalGrid, "onRowMouseOver", this, this._onMouseOver));
            this._pconnects.push(dojo.connect(this._generalGrid, "onRowMouseOut", this, this._onMouseOut));
            this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_MOUSE_OVER, this, this.onCellMouseOver));
            this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_MOUSE_OUT, this, this.onCellMouseOut));
			this._pconnects.push(dojo.connect(this._generalGrid, 'onStyleRow', this, this._styleRow));
            this._psubscribes.push(dojo.subscribe(EPMConstants.UPDATE_REPLACED_ROW, this, this.updateRow));
			this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_KEY_DOWN, this, this._onKeyDown));
            this.taskTooltip = new dijit.Tooltip();
        },
        
        /*
         * getGridTitle: Override the abstract class and returns the title of the grid.
         * Incoming: None
         * Outgoing: None.
         */
        getGridTitle: function(){
            return ResourceAssignmentViewletMessages.ASSIGNEDRESOURCES_GRID_TITLE;
        },
        
        /*
         * getGridInternalID: Override the abstract class and returns the ID of the grid.
         * Incoming: None
         * Outgoing: None.
         */
        getGridInternalID: function(){
            return Constants.ASSIGNEDRESOURCES_GRID_TITLE;
        },
        
        /*
         * Get containing project information for project children
         */
        getContainingProjectInformation: function(){
        
            if (this.assignmentResourceController) {
                return this.assignmentResourceController._projectID;
            }
            return null;
        },
        
        /*
         * Sets the value for source grid
         */
        setSourceGrid: function(gridName){
        
            this._gridModel.setSourceGrid(gridName);
            
        },
        
        
        //        /*
        //         * Event Handler for Grid Row selection
        //         *
        //         */
        //        _selectGridOnRowClick: function(data){
        //        
        //            //Publish the row select event so that the description view can load the deatils
        //            if (data && data.gridID == Constants.ASSIGNEDRESOURCES_GRID_TITLE) {
        //            
        //                var row = this.assignmentResourceController.getRowByIndex(data.rowIndex);
        //                
        //                //Publish only if the WBS Node is project and  row has valid Proifle URL
        //                if (this.wbsNodeType && this.wbsNodeType == Constants.EPM_PROJECTS &&
        //                row &&
        //                row.id &&
        //                row.resourceRelativeHref.indexOf(Constants.PROFILE_URI) != -1) {
        //                
        //                    dojo.publish(Constants.ASSIGNMENT_GRID_ROW_SELECTION_EVENT, [row]);
        //                }
        //                
        //            }
        //        },
        
        /*
         * This is called by controller. Returns the Attachpoint to the controller.
         */
        getAttachpoint: function(){
            return this._taskResourceContent;
        },
        
        /*
         * Formats the date to the required format
         */
        formatDate: function(inDatum){
        
            return DateUtil.formatDate_Short(inDatum);
        },
		/*
		 * Formats the role string so that default role is 
		 * replaced by blank string
		 * Incoming :roleValues
		 * Outgoing:None
		 */
		formatRoleString:function(roleValues){
			var roleValuesStr = "";
			//check if default role is there don't display
			if (roleValues) {
				roleValuesStr = roleValues.toString();
				var index = roleValuesStr.indexOf(Constants.DEFAULT_ROLE);
				if (index != -1) {
					roleValuesStr = roleValuesStr.replace(Constants.DEFAULT_ROLE, "");
					//checkwhether it ends with a ","
					if (roleValuesStr.lastIndexOf(",") != -1) {
						roleValuesStr = roleValuesStr.substring(0, roleValuesStr.length - 1);
					}
				}
			}
			return util.addSpanforWhiteSpace(roleValuesStr);
		},
        
        /*
         * This is called by abstractView while creating the view.
         * getGridLayout() is to return grid structure to abstractView.
         */
        getGridLayout: function(){
        
            var assignedResourcesGridLayout = [];
            
            assignedResourcesGridLayout = [{
                noscroll: false,
                defaultCell: {
                    width: 8,
                    styles: 'text-align: left;'
                },
                rows: [[{
                    name: " ",
                    width: 1.5,
					value: "",
                    formatter: this.userOrProfile,
					title: ResourceAssignmentViewletMessages.FIRST_COLUMN_TITLE
                }, {
                    name: ResourceAssignmentViewletMessages.NAME,
                    width: 10,
                    field: "name",
                    editor: dojox.grid.editors.Input,
					title: ResourceAssignmentViewletMessages.NAME_TITLE
                }, {
	                name: ResourceAssignmentViewletMessages.ACTIONS,
	                width: 7,
	                field: "action",
	                headerClasses: "com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-unsortableColumn",
					title: ResourceAssignmentViewletMessages.ACTIONS_TITLE
                }]]
            }];
            if (this.wbsNodeType) {
                if (this.wbsNodeType.indexOf("project") != -1) {
                    assignedResourcesGridLayout[0].rows[0].push({
                        name: ResourceAssignmentViewletMessages.ROLE, //ROLE
                        width: 7,
                        field: "role",
						title: ResourceAssignmentViewletMessages.ROLE_TITLE,
						formatter: this.formatRoleString,
                    	cellClasses: 'cellEditable'
                    });
                }
            }
            assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.START_DATE,
                width: 7,
                field: "proposedstart",
                formatter: DateUtil.formatDate,
                editor: dojox.grid.editors.DateTextBox,
                editorClass: "dijit.form.DateTextBox",
                constraint: {
                    formatLength: 'short',
                    selector: "date"
                },
				title: ResourceAssignmentViewletMessages.START_DATE_TITLE
            });
            assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.END_DATE,
                width: 7,
                field: "proposedfinish",
                formatter: DateUtil.formatDate,
                editor: dojox.grid.editors.DateTextBox,
                editorClass: "dijit.form.DateTextBox",
                constraint: {
                    formatLength: 'short',
                    selector: "date"
                },
				title: ResourceAssignmentViewletMessages.END_DATE_TITLE
            });
            assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.DURATION,
                width: 5,
                field: "proposedduration",
                formatter: GridColumnUtil.formatDays,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
                editor: dojox.grid.editors.Dijit,
                editorClass: "dijit.form.NumberTextBox",
                constraint: {
                    min: 1,
                    places: 0
                },
                rangeMessage: ResourceAssignmentViewletMessages.DURATION_CANNOT_BE_NEGATIVE,
                invalidMessage: ResourceAssignmentViewletMessages.INVALID_DURATION_VALUE,
				title: ResourceAssignmentViewletMessages.DURATION_TITLE
            });
            
            
            var effortColumn = {
                name: ResourceAssignmentViewletMessages.EFFORT,
                width: 5,
                field: "effort",
                formatter: GridColumnUtil.formatHours,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
                editor: dojox.grid.editors.Dijit,
                editorClass: "dijit.form.NumberTextBox",
                constraint: {
                    min: 1,
                    places: 0
                },
                rangeMessage: ResourceAssignmentViewletMessages.EFFORT_CANNOT_BE_NEGATIVE,
                invalidMessage: ResourceAssignmentViewletMessages.INVALID_EFFORT_VALUE,
				title: ResourceAssignmentViewletMessages.EFFORT_TITLE
            };
            
            assignedResourcesGridLayout[0].rows[0].push(effortColumn);
            
            
            if (this.wbsNodeType) {
            
                if (this.wbsNodeType.indexOf("project") != -1) {
                
                    var columnsToAdd = this.getGridLayout_Project();
                    
                    for (var i = 0; i < columnsToAdd.length; i++) {
                    
                        assignedResourcesGridLayout[0].rows[0].push(columnsToAdd[i]);
                    }
                    
                }
                else 
                    if (this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1 || this.wbsNodeType.indexOf(EPMConstants.EPM_RISK) != -1) {
                    
                        var columnsToAdd = this.getGridLayout_WorkItem();
                        
                        for (var i = 0; i < columnsToAdd.length; i++) {
                        
                            assignedResourcesGridLayout[0].rows[0].push(columnsToAdd[i]);
                        }
                    }
            }
            return assignedResourcesGridLayout;
        },
        
        /*
         *
         */
        userOrProfile: function(/*String*/inDatum, /*Integer*/rowIndex){
            var returnString = "";
            if (this.grid) {
                var row = this.grid.model.getRow(rowIndex);
                if (row) {
                    if (row.resourceRelativeHref != "") {
                    
                        if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
                            returnString = '<img name="profileImage" title="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE + 
                            '" alt="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE + '" src =' +
                            dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/profile_obj.gif") +
                            " />";
                        }
                        else 
                            if (row.active && row.resourceRelativeHref.toUpperCase().indexOf("user".toUpperCase()) != -1) {
                                returnString = '<img name="resourceImage" title="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE + 
                                '" alt="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/resource_obj.gif") +
                                " />";
                            } else {
								returnString = '<img name="resourceImage" title="' + ResourceAssignmentViewletMessages.INACTIVE_ASSIGNMENT_IMAGE + 
                                '" alt="' + ResourceAssignmentViewletMessages.INACTIVE_ASSIGNMENT_IMAGE + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/inActiveResource_obj.gif") +
                                " />";
							}
                    }
                    else {
                        returnString = '<img name="profileImage" title="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE + 
                        '" alt="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE + '" src =' +
                        dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/profile_obj.gif") +
                        " />";
                    }
                }
            }
            return returnString;
        },
        
        getGridLayout_Project: function(){
        
            var assignedResourcesGridLayout = [];
			
			assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.CONTOUR_LABEL,
                width: 5,
                field: "value",
                formatter: GridColumnUtil.formatHours,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
                editor: dojox.grid.editors.Dijit,
                editorClass: "dijit.form.NumberTextBox",
                constraint: {
                    min: 1,
                    places: 0
                },
                rangeMessage: ResourceAssignmentViewletMessages.CONTOUR_CANNOT_BE_NEGATIVE_OR_ZERO_OR_MORE_THAN_WOKRING_HOURS,
                invalidMessage: ResourceAssignmentViewletMessages.INVALID_CONOTUR_VALUE,
				title: ResourceAssignmentViewletMessages.CONTOUR_TITLE
            });
			            
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.ASSIGNED_EFFORT,
                width: 8,
                field: "assignedeffort",
                formatter: GridColumnUtil.formatHours,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
				title: ResourceAssignmentViewletMessages.ASSIGNED_EFFORT_TITLE
            });
            
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.TASK,
                width: 3,
                field: Constants.TASKS_COL,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
				title: ResourceAssignmentViewletMessages.TASKS_TITLE
            });
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.COST_RATE,
                width: 6,
                field: "costRate",
                formatter: GridColumnUtil.formatRates,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
                editor: com.ibm.epm.resource.assignment.web.ui.internal2.RateEditor,
				title: ResourceAssignmentViewletMessages.COST_RATE_TITLE
            });
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.SELLING_RATE,
                width: 6,
                field: "sellingRate",
                formatter: GridColumnUtil.formatRates,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
                editor: com.ibm.epm.resource.assignment.web.ui.internal2.RateEditor,
				title: ResourceAssignmentViewletMessages.SELLING_RATE_TITLE
            });
            
            return assignedResourcesGridLayout;
        },
        
        getGridLayout_WorkItem: function(){
        
            var assignedResourcesGridLayout = [];
            
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.CONTOUR_LABEL,
                width: 5,
                field: "value",
                formatter: GridColumnUtil.formatHours,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
                editor: dojox.grid.editors.Dijit,
                editorClass: "dijit.form.NumberTextBox",
                constraint: {
                    min: 1,
                    places: 0
                },
                rangeMessage: ResourceAssignmentViewletMessages.CONTOUR_CANNOT_BE_NEGATIVE_OR_ZERO_OR_MORE_THAN_WOKRING_HOURS,
                invalidMessage: ResourceAssignmentViewletMessages.INVALID_CONOTUR_VALUE,
				title: ResourceAssignmentViewletMessages.CONTOUR_TITLE
            });
            
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.LABOUR_COST,
                width: 8,
                field: "labourChargecode",
                editor: com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor,
				title: ResourceAssignmentViewletMessages.CHARGE_CODE_TITLE
            });
            
            assignedResourcesGridLayout.push({
                name: ResourceAssignmentViewletMessages.REVENUE_COST,
                width: 8,
                field: "revenueChargecode",
                editor: com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor,
				title: ResourceAssignmentViewletMessages.REVENUE_CODE_TITLE
            
            });
            
            return assignedResourcesGridLayout;
        },
        /**
         *  updateDaysInDate : Updates the days in the date with the specified days
         *  Incoming :
         *  	date - Date to be updated
         *		days - Days to update the date with [+ve adds days, -ve subtracts days]
         *  Outgoing : none
         */
        updateDaysInDate: function(date, days){
            var oldDate = new Date(date);
            oldDate.setDate(oldDate.getDate() + days);
            return oldDate;
        },
        
        /**
         *  compareDates : Compares two dates if they are equal or not
         *  Incoming :
         *  	date - New date
         *		date - Old date
         *  Outgoing : true/false
         */
        compareDates: function(date1, date2){
            var oldDate = Date.parse(DateUtil.formatDate(date1));
            var newDate = Date.parse(DateUtil.formatDate(date2));
            var bEqual = false;
            
            if (oldDate == newDate) {
                bEqual = true;
            }
            return bEqual;
        },
        
        onStartEdit: function(inCell, inRowIndex){
            var row = this._generalGrid.model.getRow(inRowIndex);
            if (row) {
                this.curCellField = inCell.field;
                
                // Flag used to indicate if the updation needs to be propagated to other viewers
                this.updateFlag = false;
                
                if (inCell.field === "proposedduration") {
                    // save the oldVal of duration to handle the invalid entry case
                    this.proposeddurationOldVal = row.proposedduration;
                }
                
                if (inCell.field === "proposedstart") {
                    // save the oldVal of start date to handle the invalid entry case
                    this.proposedstartOldVal = row.proposedstart;
                }
                
                if (inCell.field === "proposedfinish") {
                    // save the oldVal of end date to handle the invalid entry case
                    this.proposedfinishOldVal = row.proposedfinish;
                }
                
                if (inCell.field === "effort") {
                    // save the oldVal of end date to handle the invalid entry case
                    this.proposedEffortOldVal = row.effort;
                }
                
                if (inCell.field === "value") {
                    // save the oldVal of end date to handle the invalid entry case
                    this.contourOldVal = row.value;
                }
                
            }
            
        },
        /**
         *  onApplyCellEdit : Event handler when "onApplyCellEdit" event is fired for the cell in the grid
         *  Incoming :
         *  	inValue - changed value for the cell
         *		inRowIndex - index of the row the cell belongs to
         *		inFieldIndex - index of the cell as per the grid layout
         *  Outgoing : none
         *
         */
        onApplyCellEdit: function(inValue, inRowIndex, inFieldIndex){
        
            //IE Issue : For the first edit the 0th index is undefined
            if (this._generalGrid._click[0] || this._generalGrid._click[1]) {
                var row = this._generalGrid.model.getRow(inRowIndex);
                if (row) {
                    var item = this._generalGrid.model.store._getItemByIdentity(row.id);
                    if (item) {
                        var cellFieldName = this.curCellField;
                        switch (cellFieldName) {
                            case "proposedstart":
                                this.handleChangeInProposedStartDate(inValue, item, row);
                                break;
                                
                            case "proposedfinish":
                                this.handleChangeInProposedFinishDate(inValue, item, row);
                                break;
                                
                            case "proposedduration":
                                this.handleChangeInDuration(inValue, item, row);
                                break;
                                
                            case "effort":
                                this.handleChangeInEffort(inValue, item, row);
                                break;
                                
                            case "value":
                                this.handleChangeInContour(inValue, item, row);
                                break;
                                
                        }
                        
                        if (this.updateFlag == true) {
                            this._controller._propogateUpdateElement(row, row.id, inRowIndex);
                        }
                    }
                }
                
            }
        },
        
        /**
         *  handleChangeInProposedStartDate : Handles client side validation and auto calculations when the start date is modified
         *  Incoming :
         *  	newValue - changed value for start date
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInProposedStartDate: function(newValue, item, row){
            if (!newValue) {
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, "proposedstart", this.proposedstartOldVal, true);
            }
            else {
                // Check if there is any change in the value
                if (!this.compareDates(newValue, this.proposedstartOldVal)) {
                    // Validate if the startdate is later than the end date, if yes revert to old value
                    if (newValue > row.proposedfinish) {
                    
                        this._generalGrid.model.store._setValueOrValues(item, "proposedstart", this.proposedstartOldVal, true);
                        
                        // if start date is set, calculate the finish date based on duration
                        if (row.proposedduration) {
                            // Calculate the duration between start and end date in terms of days
                            var proposeddurationOldVal = row.proposedduration;
                            var newFinishDate = DateUtil.updateDaysInDate(newValue, proposeddurationOldVal);
                            this._generalGrid.model.store._setValueOrValues(item, "proposedfinish", newFinishDate, true);
                            
                        }
                        this.updateFlag = true;
                    }
                    else {
                        if (row.id.indexOf(this.milestone) != -1) {
                            // set the finishdate to the new value of the start date
                            this._generalGrid.model.store._setValueOrValues(item, "proposedfinish", newValue, true);
                            row.proposedfinish = newValue;
                        }
                        
                        // if end date is set, calculate the duration
                        if (row.proposedfinish !== "") {
                            // Calculate the duration between start and end date in terms of days
                            var proposeddurationOldVal = row.proposedduration;
                            var proposedduration = Math.ceil((row.proposedfinish.getTime() - newValue.getTime()) / (dayInMilli)) + 1;
                            this._generalGrid.model.store._setValueOrValues(item, "proposedduration", proposedduration, true);
                            
                            //calculate the effort between the start date and end date
                            // Assuming 8 hours as the working hours
                            //var proposedEffortOldVal = row.effort;
                            //var proposedEffort = proposedduration * 8;
                            //this._generalGrid.model.store._setValueOrValues(item, "effort", proposedEffort, true);
                        }
                        this.updateFlag = true;
                    }
                }
            }
        },
        
        /**
         *  handleChangeInProposedFinishDate : Handles client side validation and auto calculations when the finish date is modified
         *  Incoming :
         *  	newValue - changed value for finish date
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInProposedFinishDate: function(newValue, item, row){
            if (!newValue) {
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, "proposedfinish", this.proposedfinishOldVal, true);
            }
            else {
                // Check if there is any change in the value
                if (!this.compareDates(newValue, this.proposedfinishOldVal)) {
                    // Validate if the enddate is lesser than the start date, if yes revert to old value
                    if (newValue < row.proposedstart) {
                        this._generalGrid.model.store._setValueOrValues(item, "proposedfinish", this.proposedfinishOldVal, true);
                    }
                    else {
                        if (row.id.indexOf(this.milestone) != -1) {
                            // set the finishdate to the new value of the start date
                            this._generalGrid.model.store._setValueOrValues(item, "proposedstart", newValue, true);
                            row.proposedstart = newValue;
                        }
                        
                        // if start date is set, calculate the duration
                        if (row.proposedstart !== "") {
                            // Calculate the duration between start and end date in terms of days
                            var proposeddurationOldVal = row.proposedduration;
                            var proposedduration = Math.ceil((newValue.getTime() - row.proposedstart.getTime()) / (dayInMilli)) + 1;
                            this._generalGrid.model.store._setValueOrValues(item, "proposedduration", proposedduration, true);
                            
                            //calculate the effort between the start date and end date
                            // Assuming 8 hours as the working hours
                            //                            var proposedEffortOldVal = row.effort;
                            //                            var proposedEffort = proposedduration * 8;
                            //                            this._generalGrid.model.store._setValueOrValues(item, "effort", proposedEffort, true);
                        }
                        this.updateFlag = true;
						row.lastModifiedField = "finishDate";
						if(row.loadedelement && row.loadedelement[0])
							row.loadedelement[0].lastModifiedField = "finishDate";
                    }
                }
            }
        },
        
        /**
         *  handleChangeInDuration : Handles client side validation and auto calculations when the duration is modified
         *  Incoming :
         *  	newValue - changed value for duration
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInDuration: function(newValue, item, row){
            if ((isNaN(newValue)) || (newValue <= 0)) {
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, "proposedduration", this.proposeddurationOldVal, true);
            }
            else {
				var error;
				var strProposedDuration = row.proposedduration.toString();
				if (strProposedDuration.indexOf('.') != -1) {
						error = {
							errorMessage: dojo.string.substitute(ResourceAssignmentViewletMessages.DECIMAL_DURATION_NOT_ALLOWED, [row.name])
						};
						this.handleError(error);
						row.proposedduration = this.proposeddurationOldVal;
						newValue = this.proposeddurationOldVal;
				}
            
                if ((row.id.indexOf(this.milestone) != -1) && (newValue != 1)) {
                    newValue = 1;
                    this._generalGrid.model.store._setValueOrValues(item, "proposedduration", newValue, true);
                }
                
                // Check if there is any change in the value
                if (newValue != this.proposeddurationOldVal) {
                    //calculate the effort between the start date and end date
                    // Assuming 8 hours as the working hours
                    //                    var proposedEffort = newValue * 8;
                    //                    this._generalGrid.model.store._setValueOrValues(item, "effort", proposedEffort, true);
                    
                    // both start and end dates are already set
                    if ((row.proposedstart !== "") && (row.proposedfinish !== "")) {
                        // calculate end date based on new value of duration
                        this.proposedfinishOldVal = row.proposedfinish;
                        row.proposedfinish = this.updateDaysInDate(row.proposedstart, newValue - 1);
                        this._generalGrid.model.store._setValueOrValues(item, "proposedfinish", row.proposedfinish, true);
                    }
                    
                    // start date is not yet set and end date is set
                    if ((row.proposedstart === "") && (row.proposedfinish !== "")) {
                        // calculate start date based on new value of duration and existing value of end date
                        this.proposedstartOldVal = row.proposedstart;
                        row.proposedstart = this.updateDaysInDate(row.proposedfinish, 1 - newValue);
                        this._generalGrid.model.store._setValueOrValues(item, "proposedstart", row.proposedstart, true);
                    }
                    
                    // end date is not yet set and start date is set
                    if ((row.proposedstart !== "") && (row.proposedstart === "")) {
                        // calculate end date based on new value of duration and existing value of start date
                        this.proposedfinishOldVal = row.proposedfinish;
                        row.proposedfinish = this.updateDaysInDate(row.proposedfinish, newValue - 1);
                        this._generalGrid.model.store._setValueOrValues(item, "proposedfinish", row.proposedfinish, true);
                    }
                    row.lastModifiedField = "duration";
					if(row.loadedelement && row.loadedelement[0])
						row.loadedelement[0].lastModifiedField = "duration";
                    this.updateFlag = true;
                }
            }
        },
        
        /**
         *  handleChangeInEffort : Handles client side validation when the effort is modified
         *  Incoming :
         *  	newValue - changed value for duration
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInEffort: function(newValue, item, row){
        
            if ((isNaN(newValue)) || (newValue <= 0)) {
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, "effort", this.proposedEffortOldVal, true);
            }
			else{
				var error;
				var strEffort = row.effort.toString();
				if (strEffort.indexOf('.') != -1) {
						error = {
							errorMessage: dojo.string.substitute(ResourceAssignmentViewletMessages.DECIMAL_EFFORT_NOT_ALLOWED, [row.name])
						};
						this.handleError(error);
						row.effort = this.proposedEffortOldVal;
						newValue = this.proposedEffortOldVal;
				}
				if (newValue != this.proposedEffortOldVal){
				 	
					row.lastModifiedField = "effort";
					if(row.loadedelement && row.loadedelement[0])
						row.loadedelement[0].lastModifiedField = "effort";
					
				 }
			} 
            
        },
        
        /**
         *  handleChangeInContour : Handles client side validation when the contour is modified
         *  Incoming :
         *  	newValue - changed value for duration
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInContour: function(newValue, item, row){
                
           if ((isNaN(newValue)) || (newValue <= 0)) {
            
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, "value", this.contourOldVal, true);
            }
			
        },
        
        /**
         * Overriding method isCellEditable to stop editing of various fields
         */
        isCellEditable: function(event){
            var rowIndex = parseInt(event.rowIndex, 10);
            if (isNaN(rowIndex)) {
                return true;
            }
            var row = this.assignmentResourceController.getRowByIndex(rowIndex);
			if (!row.active) {
				return false;
			}
			//Name cell for a resource is never editable. It is editable for a profile only
			if(event.cell.field == "name" && row.resourceRelativeHref.toUpperCase().indexOf("user".toUpperCase()) >= 0) {
				return false;
			}
			//No inline editing of cost rate and selling rate
            if (event.cell.field == "costRate" || event.cell.field == "sellingRate") {
                return false;
            }
			//For a saved row donot allow contour to be modified
            if (row.href.indexOf("_unsaved") < 0) {
				if (event.cell.field == "value" && this.wbsNodeType.indexOf(EPMConstants.EPM_PROJECT) === -1) {
					return false;
				}
			}
			//No inline editing of labor chargecode and revenue chargecode
			if (event.cell.field == "labourChargecode" || event.cell.field == "revenueChargecode") {
                return false;
			}
			//No inline editing of role
			if (event.cell.field == "role") {
                return false;
			}

            return true;
        },
        
        /**
         *  onCellDblClick : Handles the cell double click event
         *  Incoming :
         *  	event - a decorated event object
         *  Outgoing : none
         *
         */
		onCellDblClick: function(event) {
           //  Pop up the role dialog when column - Role is clicked
			this.roleDialog(event);
			this._onClick(event);
		},
		       
        /**
         *  onCellClick : Handles the cell click event
         *  Incoming :
         *  	event - a decorated event object
         *  Outgoing : none
         *
         */
        onCellClick: function(event){
			if (this._generalGrid.edit.isEditing()) {
				this.roleDialog(event);
			}
			this._onClick(event);
		},

        /**
         *  _onClick : Handles the cell click or double click event to validate various cells like start date, end date and duration
         *  Incoming :
         *  	event - a decorated event object
         *  Outgoing : none
         *
         */
        _onClick: function(event){
            if (event) {
                if ((event.cell.field == 'proposedstart') || (event.cell.field == 'proposedfinish')) {
                    var row;
                    row = this._generalGrid.model.getRow(event.rowIndex);
                    if (row) {
                        var dateTextEditor = event.cell.editor.editor;
                        if (dateTextEditor) {
                            // Get the instance of the date picker associated with this cell
                            var datePicker = dateTextEditor._picker;
                            if (datePicker) {
                                // change the constraints based the current values of the start and end dates
                                if ((event.cell.field === 'proposedstart') && (row.proposedfinish !== "")) {
                                    // disable all dates beyond end date
                                    dojo.mixin(datePicker.constraints, {
                                        max: row.proposedfinish
                                    });
                                }
                                
                                if ((event.cell.field === 'proposedfinish') && (row.proposedstart !== "")) {
                                    // disable all dates before start date
                                    dojo.mixin(datePicker.constraints, {
                                        min: row.proposedstart
                                    });
                                }
                            }
                            dateTextEditor.rangeMessage = ResourceAssignmentViewletMessages.END_DATE_CANNOT_BE_EARLIER_THAN_START_DATE;
                            dateTextEditor.invalidMessage = ResourceAssignmentViewletMessages.INVALID_DATE;
                        }
                        else {
                            // date picker hasn't been instantiated set the constraints in the cell
                            if ((event.cell.field === 'proposedstart') && (row.proposedfinish !== "")) {
                                // disable all dates beyond end date
                                dojo.mixin(event.cell.constraint, {
                                    max: row.proposedfinish
                                });
                            }
                            
                            if ((event.cell.field === 'proposedfinish') && (row.proposedstart !== "")) {
                                // disable all dates before start date
                                dojo.mixin(event.cell.constraint, {
                                    min: row.proposedstart
                                });
                            }
                        }
                    }
                } // startDate && endDate
                if (event.cell.field == "proposedduration") {
                    var numTextEditor = event.cell.editor.editor;
                    if (numTextEditor) {
                        numTextEditor.rangeMessage = ResourceAssignmentViewletMessages.DURATION_CANNOT_BE_NEGATIVE;
                        numTextEditor.invalidMessage = ResourceAssignmentViewletMessages.INVALID_DURATION_VALUE;
                    }
                    else {
                        event.cell.editor.rangeMessage = ResourceAssignmentViewletMessages.DURATION_CANNOT_BE_NEGATIVE;
                        event.cell.editor.invalidMessage = ResourceAssignmentViewletMessages.INVALID_DURATION_VALUE;
                    }
                }
                if (event.cell.field == "action") {
                    if (event.target.name == "deleteImage") {
                        this.unassignResources(event);
                        //                        console.log("deleteImage"); //TODO: need to replace with proper Function.
                    }
                    else 
                        if (event.target.name == "editImage") {
                        this.StartProfileEdit(event);
                        }
                        else 
                            if (event.target.name == "replaceImage") {
								this._publishReplaceWithUserEvent(event);                                
                            }
                }
                
                
            }
			
            event.stopPropagation();
            event.preventDefault();
            dojo.stopEvent(event);
        },
        
		_publishReplaceWithUserEvent:function(event){
			var row = this._generalGrid.model.getRow(event.rowIndex);                                
            if (row) {
                if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
                
                    var jsonParam = {
                        startDate: DateUtil.formatDateForSave(row.proposedstart, {
                            datePattern: 'yyyy-MM-dd',
                            selector: 'date'
                        }),
                        finishDate: DateUtil.formatDateForSave(row.proposedfinish, {
                            datePattern: 'yyyy-MM-dd',
                            selector: 'date'
                        }),
                        rowId: row.id,
                        effort: row.effort
                    };
                    skills = "";
                    competencies = "";
                    
                    var containsprofile = (row.loadedelement != null) && (row.loadedelement[0] != null) && (row.loadedelement[0].profile != null)
                    if (containsprofile) {
                        if (row.loadedelement[0].profile.skillassignment != null) {
                            jsonParam.skills = [];
                            for (var i in row.loadedelement[0].profile.skillassignment) {
                                jsonParam.skills.push(row.loadedelement[0].profile.skillassignment[i].skill.title)
                            }
                        }
                        if (row.loadedelement[0].profile.competencyassignment != null) {
                            jsonParam.competencies = [];
                            for (var i in row.loadedelement[0].profile.competencyassignment) {
                                jsonParam.competencies.push(row.loadedelement[0].profile.competencyassignment[i].competency.title)
                            }
                        }
                    }
                    
                    dojo.publish(Constants.REPLACE_PROFILE_WITH_USER_EVENT, [jsonParam]);
                }
            }
			
		},
        
        /*
         * Validation of data before assigning them
         */
        validateAndAssignResources: function(selectedRows, contourType, contourValue, roleValue, createProfileFlag, startDate,
		 finishDate, duration, effort){
        
            //no wbs element selected
            if (this.nodeName === "") {
                this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.NO_WBSELEMENT);
                return;
            }
            //no role selected
            if (roleValue === "") {
                this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.NO_ROLE);
                return;
            }
            
            //validating already assigned role
            var flag = this._checkAssignedRole(roleValue, this.wbsNodeType);
            if (flag) {
                return;
            }
            
            //validate Multiple assignments 
            if (selectedRows.length > 1) {
                flag = this._validateRoleInMultipleAssignment(roleValue, this.wbsNodeType);
                if (flag) {
                    return;
                }
            }
            
            this._assignResources(selectedRows, contourType, contourValue, roleValue, createProfileFlag, startDate, 
			finishDate, duration, effort);
        },
        
        
        
        /*
         * Assign resources
         */
        _assignResources: function(assignmentParam, contourType, contourValue, roleValue,createNewProfileAssignment, startDate, 
		finishDate, duration, effort){
        
            var duplicateAssignment = new Array();
            var flag;
            
            //Iterate through all selected rows and add them to the grid
            try {
                if (this._generalGrid && this._generalGrid.beginUpdate) {
                    this._generalGrid.beginUpdate();
                }
                
            for (var i = 0; i < assignmentParam.length; i++) {
                var relativeHref = this._controller.getUniqueRowID("projectAssignment_unsaved");
                
                var tempDate = new Date();//This also returns the current time. Hence reconstructing another date with only year, month and day info	
                var proposedStart = startDate;
                var proposedFinish = finishDate;
                var proposedDuration = duration;
                var proposedEffort = effort;
                
				var isCopiedFromProposedSchedule = false;
				if(proposedStart && proposedFinish){
					isCopiedFromProposedSchedule = true;
				}
                // If the availability search result is used to assign resources
                // use the search result dates, effort and contour for assignment
				if(assignmentParam[i].availabilitySearchFlag){
					
					var querySearchLevel = assignmentParam[i].availabilitySearchLevel;
					var querySearchEffort = assignmentParam[i].availabilitySearchEffort;
					var querySearchContour = assignmentParam[i].availabilitySearchContour;
					var querySearchType = assignmentParam[i].availabilitySearchType;
					
					
					var startDateInterval = assignmentParam[i].startDateInterval;
					var finishDateInterval = assignmentParam[i].finishDateInterval;
					var effort;
					
					if(Constants.SEARCH_LEVEL_TASK == querySearchLevel  && querySearchType == Constants.EFFORT_TYPE_ELEMENT)
					{
						effort =  new Array(1);
						effort[0] = querySearchEffort;
						
					}else{
						
						var availableEffortInterval = assignmentParam[i].availableEffortInterval;
						effort = availableEffortInterval.split(",");
					}
					
					var startDates = startDateInterval.split(",");
					var finishDates = finishDateInterval.split(",");
					var length = startDates.length;
					
					if(this.wbsNodeType && (this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1 || 
												this.wbsNodeType.indexOf(EPMConstants.EPM_RISK) != -1)){
						
						length = 1; // Even if we are using the project level search result, assign the first inteval for tasks
					}
					for(var j = 0; j < length ; j++){
						
						var duration = DateUtil.diffDates(DateUtil.parseDate(startDates[j]), DateUtil.parseDate(finishDates[j]),
						 "day") + 1;
						
						var tempRowId =  this._controller.getUniqueRowID(relativeHref + j);
						var row = {
	                    "relativeHref": tempRowId,
	                    "href": tempRowId,
	                    "role": roleValue,
	                    "proposedstart": DateUtil.parseDate(startDates[j]),
	                    "proposedduration": duration,
	                    "proposedfinish": DateUtil.parseDate(finishDates[j]),
	                    "contourType": contourType,
	                    "value": assignmentParam[i].contour,
	                    "costRate": assignmentParam[i].costRate,
	                    "labourChargecode": "",
	                    "labourChargecodeUri": "",
	                    "sellingRate": assignmentParam[i].sellingRate,
	                    "revenueChargecode": "",
	                    "revenueChargecodeUri": "",
	                    "effort": effort[j],
						"name":assignmentParam[i].name,
						"resourceRelativeHref": assignmentParam[i].resourceRelativeHref
	                
	                };
					
	                    // Add the row
	                    this._controller._insertElement(row, null, false);
	                    //A new row has been inserted and the view needs to be marked dirty.
						var publishedObj = {
							controllerID : Constants.ASSIGNED_RESOURCES_GRID_ID,
							fieldName : ""
						}
	                    dojo.publish(Constants.USER_PROFILE_ROW_ADDED_EVENT, [publishedObj]);
					}
				}
                else{
	                if (assignmentParam[i][Constants.BEST_START_DATE]) {
	                    proposedStart = DateUtil.parseDate(assignmentParam[i][Constants.BEST_START_DATE]);
	                    isCopiedFromProposedSchedule = false;
	                }
	                else 
	                    if (!startDate) {
	                    
	                        proposedStart = new Date(tempDate.getFullYear(), tempDate.getMonth(), tempDate.getDate());
	                    }
	                    else {
	                        proposedStart = DateUtil.parseDate(proposedStart);
	                        
	                    }
	                if (assignmentParam[i][Constants.BEST_FINISH_DATE]) {
	                    proposedFinish = DateUtil.parseDate(assignmentParam[i][Constants.BEST_FINISH_DATE]);
	                    isCopiedFromProposedSchedule = false;
	                }
	                else 
	                    if (!finishDate) {
	                        proposedFinish = new Date(tempDate.getFullYear(), tempDate.getMonth(), tempDate.getDate());
	                    }
	                    else {
	                        proposedFinish = DateUtil.parseDate(proposedFinish);
	                    }
	                
					if(assignmentParam[i][Constants.AVAILABLE_DURATION]){
						 proposedDuration = assignmentParam[i][Constants.AVAILABLE_DURATION];
					}
					else if( !isCopiedFromProposedSchedule || !proposedDuration)
	               	{
						 proposedDuration = DateUtil.diffDates(proposedStart, proposedFinish, "day") + 1; // Add one Day because start day is also considered.
					}   
	                if (assignmentParam[i][Constants.AVAILABLE_TIME]) {
	                    proposedEffort = assignmentParam[i][Constants.AVAILABLE_TIME];
	                    
	                }
	                else 
	                    if (effort == null) {
	                        proposedEffort = "1";
	                    }
	                
	                // The Assignment can be done for Project Profiles Grid or from the Query Results or from Project Assignment Grid
	                var row = {
	                    "relativeHref": relativeHref,
	                    "href": relativeHref,
	                    "role": roleValue,
	                    "proposedstart": proposedStart,
	                    "proposedduration": proposedDuration,
	                    "proposedfinish": proposedFinish,
	                    "contourType": contourType,
	                    "value": contourValue,
	                    "costRate": assignmentParam[i].costRate,
	                    "labourChargecode": "",
	                    "labourChargecodeUri": "",
	                    "sellingRate": assignmentParam[i].sellingRate,
	                    "revenueChargecode": "",
	                    "revenueChargecodeUri": "",
	                    "effort": proposedEffort
	                
	                };
	                
	                if (createNewProfileAssignment) {
	                    row.name = assignmentParam[i].name;
	                    row.resourceRelativeHref = "";
	                    row.profileName = assignmentParam[i].name;
	                    row.profileDescription = assignmentParam[i].description;
	                    row.profileExperienceInYear = assignmentParam[i].experienceInYears;
	                    row.profileSkills = [assignmentParam[i].skills];
	                    row.profileCompetencies = [assignmentParam[i].competencies];
	                    row.profileTemplateId = assignmentParam[i].profileTemplateId;
	                }
	                else {
	                    row.name = assignmentParam[i].name;
	                    row.resourceRelativeHref = assignmentParam[i].resourceRelativeHref;
	                }
	                    // Add the row
	                    this._controller._insertElement(row, null, false);
	                    //A new row has been inserted and the view needs to be marked dirty.
						var publishedObj = {
							controllerID : Constants.ASSIGNED_RESOURCES_GRID_ID,
							fieldName : ""
						}
	                    dojo.publish(Constants.USER_PROFILE_ROW_ADDED_EVENT, [publishedObj]);
						
						// fetch the contour value and update the row
						if (this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
							var projectId = this.containingProjectId.substring(this.containingProjectId.lastIndexOf(Constants.SLASH) + 1);
							var args = {};
							args.projectId = projectId;
							var userHref =  assignmentParam[i].resourceRelativeHref;
							if(userHref && userHref.indexOf(Constants.USER_URI) != -1){
								var userId = userHref.substring(userHref.lastIndexOf(Constants.SLASH) + 1);
								args.userId = userId;
							}
							AssignmentUtil.fetchWorkingHours(row.relativeHref,args,false);
						
						 }else if(this.wbsNodeType == EPMConstants.EPM_PROJECT ){
							var projectId = this.nodeId.substring(this.nodeId.lastIndexOf(Constants.SLASH) + 1);
							var args = {};
							args.projectId = projectId;
							var userHref =  assignmentParam[i].resourceRelativeHref;
							if(userHref && userHref.indexOf(Constants.USER_URI) != -1){
								var userId = userHref.substring(userHref.lastIndexOf(Constants.SLASH) + 1);
								args.userId = userId;
							}
							AssignmentUtil.fetchWorkingHours(row.relativeHref,args,true);
						 	
						 }
					} // end of else
                } // end of FOR
            } 
            catch (error) {
                console.log(error.message);				
            }
            finally {
                if (this._generalGrid && this._generalGrid.endUpdate) {
                    this._generalGrid.endUpdate();
                }
                this.scrollToSelectedRow();
            }
        },
        
		        
        getAssignmentRecord: function(rowToSave){
			var resourceHref = rowToSave.row.resourceRelativeHref;
			var assignmentURI = rowToSave.saveObject.rowURI;
	        for (var j = 0; j < this._generalGrid.model.getRowCount(); j++) {
	            var row1 = this.assignmentResourceController.getRowByIndex(j);
	            if (resourceHref == row1.resourceRelativeHref && row1.href.indexOf(Constants.UNSAVED) == -1 && row1.href != assignmentURI) {
					delete rowToSave.saveObject.params.User;
					delete rowToSave.saveObject.params.Project;
					var plannedScheduleIndex = row1.href.indexOf(Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT);
					if(plannedScheduleIndex != -1){
						rowToSave.saveObject. rowURI = row1.href.substring(0,plannedScheduleIndex);
					}else{
	                 	rowToSave.saveObject. rowURI = row1.href;
					 }
					 return rowToSave;
	            }
	        }
			rowToSave.saveObject. rowURI = assignmentURI;
			return rowToSave;
        },
        

        
        confirmDeletion: function(row, replaceWithProfile){
			var width = "300px";
            var self = this;
            var buttonlist;
            var dialogContent;
            var labelList;
            var confirmUnassignment = ResourceAssignmentViewletMessages.YOU_WANT_TO_CONTINUE;
            if (replaceWithProfile) {
                buttonlist = [{
                    label: ResourceAssignmentViewletMessages.UNASSIGN_ONLY,
                    action: dojo.hitch(this, this.makeAssignmentInactive)
                }, {
                    label: ResourceAssignmentViewletMessages.UNASSIGN_AND_REPLACE,
                    action: dojo.hitch(this, this.replaceAssignment)
                }, {
                    label: ResourceAssignmentViewletMessages.CANCEL
                }];
                dialogContent = ResourceAssignmentViewletMessages.REPLACE_OR_DELETE_ASSIGNMENT;
                labelList = [{
                    label: dialogContent
                }];
				width = "450px";
            }
            else {
                if (this.updateOnlyFlag) {
                    buttonlist = [{
                        label: ResourceAssignmentViewletMessages.OK,
                        action: dojo.hitch(this, this.makeAssignmentInactive)
                    }, {
                        label: ResourceAssignmentViewletMessages.CANCEL
                    }];
                    dialogContent = ResourceAssignmentViewletMessages.MAKE_ASSIGNMENT_INACTIVE;
                    labelList = [{
                        label: dialogContent 
                    }];
                    this.updateOnlyFlag = false;
					width = "400px";
                }
                else {
                    buttonlist = [{
                        label: ResourceAssignmentViewletMessages.YES,
                        action: dojo.hitch(this, this.deleteAssignment, row.id)
                    }, {
                        label: ResourceAssignmentViewletMessages.NO
                    }];
					
					if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
						if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
							dialogContent = ResourceAssignmentViewletMessages.DELETE_PROFILE_ASSIGNMENT;
						}else {
                    		dialogContent = ResourceAssignmentViewletMessages.DELETE_ASSIGNMENT;
                    	}
					}else {
						if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
							dialogContent = ResourceAssignmentViewletMessages.DELETE_PROFILE_ASSIGNMENT_WORKITEM;
						}else {
							dialogContent = ResourceAssignmentViewletMessages.DELETE_ASSIGNMENT_WORKITEM;
						}
					}
				    labelList = [{
                        label: dialogContent 
                    }];
					width = "350px";
                }
            }
            this.confirmDialog = new com.ibm.epm.web.core.ui.internal.EPMConfirmDialog({
                labelList: labelList,
                title: ResourceAssignmentViewletMessages.UNASSIGN_DIALOG_TITLE,
                buttonlist: buttonlist,
				width: width
            });
            this.confirmDialog.show();
        },
        
        makeAssignmentInactive: function(){
            AssignmentDashboardUtil.showMessage(ResourceAssignmentViewletMessages.DELETING_PROGRESS);

            var rowIndex = this._generalGrid.model.getRowByIdentity(this.rowToReplace.id);
			var row = this._generalGrid.model.getRow(rowIndex);
            
            var self = this;
            var serviceObject = {
            
                success: function(){
					self._controller._getAndUpdateRow(self.rowToReplace.id,self.rowToReplace.id, null);
					self._generalGrid.selection.unselectAll();
                    AssignmentDashboardUtil.hideMessageArea();
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
                    AssignmentDashboardUtil.hideMessageArea();
                }
            };
            var updateParam = {};
			if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
				var plannedScheduleArray = new Array();
				plannedScheduleArray.push(Constants.ID + "=" + row.loadedelement[0].tempPlannedSchedule.id + "," + Constants.ACTIVE + "=" + "false");
				updateParam.plannedSchedule = plannedScheduleArray;
					
			}else {
				updateParam.active = false;
			}
			var plannedScheduleIndex = row.id.indexOf(Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT);
			var rowId = row.id;
			if(plannedScheduleIndex != -1){
				rowId = row.id.substring(0,plannedScheduleIndex);
			}
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.createURI(srh, rowId, updateParam);
            this.confirmDialog.destroy();
        },
        
        replaceAssignment: function(){
        
            var replaceProfileDialog = new AddProfileDialog({
                context: this,
                multipleAssignment: false
            });
            this.confirmDialog.destroy();
        },
        
        deleteAssignment: function(rowId){
            AssignmentDashboardUtil.showMessage(ResourceAssignmentViewletMessages.DELETING_PROGRESS);
			var dataModel = this._controller.getDataModel();             
			var row = dataModel.store._getItemByIdentity(rowId);
			var self = this;
			if(row) {
				if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
					var rowIndex = this._generalGrid.model.getRowByIdentity(rowId);
					var row = this._generalGrid.model.getRow(rowIndex);
					if(row.loadedelement[0].plannedSchedule.length > 1){
						var serviceObject = {
							success: function(){
								self._controller._getAndUpdateRow(rowId,rowId, null);
								self._generalGrid.selection.unselectAll();
		                    	AssignmentDashboardUtil.hideMessageArea();
			                },
			                failure: function(errorObj){
			                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
			                    AssignmentDashboardUtil.hideMessageArea();
			                }
            			};
			            var updateParam = {};
						if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
							var plannedScheduleArray = new Array();
							plannedScheduleArray.push(Constants.ID + "=" + row.loadedelement[0].tempPlannedSchedule.id + "," + Constants.ACTIVE + "=" + "false");
							updateParam.plannedSchedule = plannedScheduleArray;
								
						}
						var plannedScheduleIndex = row.id.indexOf(Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT);
						var rowId = row.id;
						if(plannedScheduleIndex != -1){
							rowId = row.id.substring(0,plannedScheduleIndex);
						}
			            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            			ResourceAssignmentClient.createURI(srh, rowId, updateParam);
					}else{
						
						row.markedForDeletion = true;
            			this._controller._deleteElementByRow(row);
					}
//					var rowCount = this._controller.getDataModel().getRowCount();
//            
//            		for (var i = 0; i < rowCount; i++) {
//            
//                		var row = self._controller.getDataModel().getRow(i);
//						if(rowId.indexOf)
//					}
				}
            	else{
					row.markedForDeletion = true;
            		this._controller._deleteElementByRow(row);
				}
            }
            this.confirmDialog.destroy();
            AssignmentDashboardUtil.hideMessageArea();
        },
        /*
         * Loop through all the selected rows in assignment Grid and calls the unassignResource function.
         * Incoming: None
         * Outgoing: None
         */
        unassignResources: function(event){
            var row = this._controller.getDataModel().getRow(event.rowIndex);
            if (row) {
            	this._clearOneActionRow(row.id); 
                if (row.id && row.id.indexOf(Constants.UNSAVED) == -1) {
					var isPastPlannedDate = false;
					var finishDate = "";
					var startDate = "";
					if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
						finishDate = DateUtil.parseDate(row.loadedelement[0].tempPlannedSchedule.toDate);
						startDate = DateUtil.parseDate(row.loadedelement[0].tempPlannedSchedule.fromDate);
					}
					else {
						var plannedScheduleInfo;
						if(row.loadedelement[0].tempPlannedSchedule)
						{
							plannedScheduleInfo = row.loadedelement[0].tempPlannedSchedule;	
						}
						else if(row.loadedelement[0].plannedSchedule){
							plannedScheduleInfo = row.loadedelement[0].plannedSchedule;
						}
						
						finishDate = DateUtil.parseDate(plannedScheduleInfo.finishDate);
					}
					if (DateUtil.compareDates(finishDate, new Date()) <= 0) {
						isPastPlannedDate = true;
					}
					this.rowToReplace = row;
					if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
						this.confirmDeletion(row, false);
					}
					else {
						
						var self = this;
						var args = {};
						args.userId = row.resourceRelativeHref.substring(row.resourceRelativeHref.indexOf("/")+1);;
						args.projectId = self.nodeId.substring(self.nodeId.indexOf("/")+1);
						if (this.wbsNodeType == EPMConstants.EPM_PROJECT){
							args.isProjectAssignment = true;
							args.finishDate = DateUtil.formatDateForSave(finishDate, {datePattern: 'yyyy-MM-dd',selector: 'date'});
							args.startDate = DateUtil.formatDateForSave(startDate, {datePattern: 'yyyy-MM-dd',selector: 'date'});
						}
						else{
							args.isProjectAssignment = false;
						}
						var serviceObject = {
								success: function(itemInfo){
									AssignmentDashboardUtil.hideMessageArea();
									self.deleteOrUpdateFlag = true;
									if(itemInfo && itemInfo.value){
										if(itemInfo.value == "true"){
											if (!isPastPlannedDate) 
												self.deleteOrUpdateFlag = false;
											else 
												self.updateOnlyFlag = true;
											
											if (self.deleteOrUpdateFlag) 
												self.confirmDeletion(row, false);
											else 
												self.confirmDeletion(row, true);
										}
										else 
											self.confirmDeletion(row, false);
									}
								},
								failure: function(errorObj){
									AssignmentDashboardUtil.hideMessageArea();
									self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
								}
							};
						
						AssignmentDashboardUtil.showMessage(ResourceAssignmentViewletMessages.FETCHING_ASSIGNMENT_INFORMATION);
						var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            			ResourceAssignmentClient.hasActuals(srh, args);
						
					}
                }
                else {
                    this._controller._removeGridRow(row.id);
					this._generalGrid.selection.unselectAll();
                }
            }
        },
        
        assignProfile: function(param){
        	AssignmentDashboardUtil.showMessage(ResourceAssignmentViewletMessages.ASSIGNING_PROGRESS);
			
           var rowIndex = this._generalGrid.model.getRowByIdentity(this.rowToReplace.id);
			var row = this._generalGrid.model.getRow(rowIndex);
            
            var self = this;
            var serviceObject = {
            
                success: function(){
					self._controller._getAndUpdateRow(self.rowToReplace.id,self.rowToReplace.id, null);
                    self.updateRow(row);
					AssignmentDashboardUtil.hideMessageArea();
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
					AssignmentDashboardUtil.hideMessageArea();
                }
            };
			
			var updateParam = {};
			if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
				var plannedScheduleArray = new Array();
				plannedScheduleArray.push(Constants.ID + "=" + row.loadedelement[0].tempPlannedSchedule.id + "," + Constants.ACTIVE + "=" + "false");
				updateParam.plannedSchedule = plannedScheduleArray;
					
			}else {
				updateParam.active = false;
			}
            
            updateParam.profile = Constants.NAME + "=" + param[0].name + "," + Constants.DESCRIPTION + "=" + param[0].description + "," +
            Constants.EXPERIENCEINYEAR +
            "=" +
            param[0].experienceInYears +
            "," +
            Constants.PROFILETEMPLATEURI +
            "=" +
            param[0].profileTemplateId;
			var plannedScheduleIndex = row.id.indexOf(Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT);
			var rowId = row.id;
			if(plannedScheduleIndex != -1){
				rowId = row.id.substring(0,plannedScheduleIndex);
			}
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.createURI(srh, rowId, updateParam);
        },
        
        updateRow: function(item){
            var uri = "";
            if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                uri = this.nodeId + Constants.SLASH + Constants.PROJECT_ASSIGNMENT;
            }
            else 
                if (this.wbsNodeType == EPMConstants.WORKITEM) {
                    uri = this.nodeId;
                }
            var self = this;
            var serviceObject = {
            
                success: function(itemInfo){
                    if (itemInfo) {
                        if (self.wbsNodeType == EPMConstants.EPM_PROJECT) {
                            for (var i = 0; i < itemInfo.length; i++) {
                                if (itemInfo[i].title == "true") {
                                    var rowIndex = self._controller.getRowIndex(itemInfo[i].relativeHref);
                                    if (rowIndex < 0) {
                                        self.getAssignment(itemInfo[i].relativeHref, item);
                                        break;
                                    }
                                }
                            }
                        }
                        else 
                            if (self.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1 || self.wbsNodeType.indexOf(EPMConstants.EPM_RISK) != -1) {
                                var taskAssignment = [];
                                taskAssignment = itemInfo.TaskAssignment;
                                if (taskAssignment) {
                                    var href = "";
                                    var acctiveAssignmentArray = new Array();
                                    if (!dojo.isArray(taskAssignment)) {
                                        taskAssignment = [taskAssignment];
                                    }
                                    for (var i = 0; i < taskAssignment.length; i++) {
                                        if (taskAssignment[i].title == "true") {
                                            href = taskAssignment[i].relativeHref;
                                        }
                                    }
                                    self.getAssignment(href, item);
                                }
                            }
                    }
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getURI(srh, uri);
        },
        
        getAssignment: function(href, removeItem){
            var self = this;
            var serviceObject = {
            
                success: function(itemInfo){
                    if (itemInfo) {
                        var rowIndex = self._controller.getRowIndex(removeItem.id) + 1;
                        self._controller._insertElement(itemInfo, rowIndex, true);
						self._generalGrid.selection.unselectAll();
                    }
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getURI(srh, href);
        },
        
        /*
         * validates the role in case of multiple assignment
         * Incoming : selectedRows ,roleValue,wbsNodeType
         * Outgoing : None
         */
        _validateRoleInMultipleAssignment: function(roleValue, wbsNodeType){
        
            if (wbsNodeType == EPMConstants.EPM_PROJECT && roleValue == ResourceAssignmentViewletMessages.PM) {
                this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.MULTIPLEASSIGN_INVALID_PM);
                return true;
                
            }
            else 
                if (roleValue == ResourceAssignmentViewletMessages.OWNER) {
                    this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.MULTIPLEASSGN_INVALID_OWNER);
                    return true;
                }
            
            return false;
        },
        
        /*
         * checking if already assigned has owner or PM role
         * Incoming : roleValue , wbsNodeType
         * Outgoing : flag
         */
        _checkAssignedRole: function(roleValue, wbsNodeType){
        
            var self = this;
            var rowCount = this._controller.getDataModel().getRowCount();
            
            for (var i = 0; i < rowCount; i++) {
            
                var row = self._controller.getDataModel().getRow(i);
                if (wbsNodeType == EPMConstants.EPM_PROJECT && row.role == ResourceAssignmentViewletMessages.PM &&
                roleValue == ResourceAssignmentViewletMessages.PM) {
                    this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.MULTIPLEASSIGN_INVALID_PM);
                    return true;
                }
                else 
                    if (row.role == ResourceAssignmentViewletMessages.OWNER &&
                    roleValue == ResourceAssignmentViewletMessages.OWNER) {
                        this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.MULTIPLEASSGN_INVALID_OWNER);
                        return true;
                    }
                
            }//for
            return false;
            
        },
        
        /**
         *  format : This function is to format the values in the cell
         *  Incoming Arguments : inDatum, inRowIndex
         *  Outgoing Argument :
         *
         */
        formatRole: function(inDatum, inRowIndex){
            var self = this;
            
            var presentValues = self._controller.getDataModel().getRow(inRowIndex);
            
            return presentValues.role;
            
        },
        
        /**
         *  _saveAssignment : This function saves the modified rows of grid
         *  Incoming Arguments : none
         *  Outgoing Argument :	 none
         */
        _saveAssignment: function(){
            if (this._generalGrid) {
                this._generalGrid.edit.apply();                
                if (this._controller && this._controller.persistGrid) {
                    var modifiedRows = this._controller.getModifiedRows();                
                    if (this.wbsNodeType.indexOf("project") != -1) {
 						for (var i = 1; i < modifiedRows.length; i++){
							var plannedScheduleIndex = modifiedRows[i].saveObject.rowURI.indexOf(Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT);
							if(plannedScheduleIndex != -1){
								modifiedRows[i].saveObject.rowURI = modifiedRows[i].saveObject.rowURI.substring(0,plannedScheduleIndex);
							}
							this.rowsToSave.push(this.getRowToSave(modifiedRows[i]));
						}
						var tempArray = new Array(1);
						for (var i in this.rowsToSave){
							var assignmentRecord = null;
							if(this.rowsToSave[i] && this.rowsToSave[i].saveObject.isNew && this.rowsToSave[i].row.resourceRelativeHref != ""){
								assignmentRecord = this.getAssignmentRecord(this.rowsToSave[i]);
//								this.rowsToSave[i].saveObject. rowURI = assignmentHref;
							}
							else{
								assignmentRecord = this.rowsToSave[i];
							}
							if(assignmentRecord != null && assignmentRecord != "undefined"){
								tempArray.push(assignmentRecord);
							}
						}
						this.rowsToSave = [];
						AssignmentDashboardUtil._lockPage(ResourceAssignmentViewletMessages.SAVING);
						this._controller.saveRequests = tempArray.length - 1;
						this._controller._persistSequentially(tempArray,1,tempArray.length);
                    }
                    else {
                        var modifiedRows = this._controller.getModifiedRows();
                        
                        
                        for (var i = 1; i < modifiedRows.length; i++) {
                            var uri = modifiedRows[i].row.resourceRelativeHref;
                            if (uri.toUpperCase().indexOf("user".toUpperCase()) != -1) {
                                if (modifiedRows[i].saveObject && modifiedRows[i].saveObject.params && modifiedRows[i].saveObject.params.plannedSchedule) {
                                    this.preSaveOperation(modifiedRows[i], uri);
                                }
                                else {
                                    this._controller.persistGrid(true, true);
                                }
                            }
                            else {
                                if (modifiedRows[i].row.replaceWith != "") {
                                    this.preSaveOperation(modifiedRows[i], modifiedRows[i].row.replaceWith);
                                }
                                else {
                                    this._controller.persistGrid(true, true);
                                }
                            }
                        }
                        
                    }
                }
            }
        },
		
        /**
         *  preSaveOperation : This function perform the pre save operation for a resource assignment to a task
         *  Incoming Arguments : modified row, user URI
         *  Outgoing Argument :	 none
         */
        preSaveOperation: function(modifiedRow, uri){
            var self = this;
            var serviceObject = {
                success: function(itemInfo){
					AssignmentDashboardUtil.hideMessageArea();
					if(itemInfo.value){
						var overAllocation = "false";
						var extension = "false";
						var contourUpdate = "false";
						try{
							//Sample output: Overallocation:true/false,Extension:true/false,contourUpdate:true/false
							var result = itemInfo.value.split(",");
							overAllocation = result[0].split(":")[1];
						}catch(error){
							overAllocation = "false";
						}
						try{
							//Sample output: Overallocation:true/false,Extension:true/false,contourUpdate:true/false
							var result = itemInfo.value.split(",");
							extension = result[1].split(":")[1];
						}catch(error){
						    extension = "false";
						}
						try{
							//Sample output: Overallocation:true/false,Extension:true/false,contourUpdate:true/false
							var result = itemInfo.value.split(",");
							contourUpdate = result[2].split(":")[1];
						}catch(error){
							contourUpdate = "false";
						}
						
						itemInfo.Overallocation = overAllocation;
						itemInfo.Extension = extension;
						itemInfo.contourUpdate = contourUpdate;
						
					}
                      if (itemInfo.Overallocation === "true" || itemInfo.Extension === "true" || itemInfo.contourUpdate === "true") {
						self.projectAssignmentScheduleChange = itemInfo.Extension;
						self.resourceOverAllocation = itemInfo.Overallocation
                        self.showWarningDialog(itemInfo, modifiedRow);
                    }
                    else {
						
                        self._controller.persistGrid(true, true);
                    }
                },
                failure: function(errorObj){
					AssignmentDashboardUtil.hideMessageArea();
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
                }
            };
            
			var userId = uri.substring(uri.lastIndexOf("/")+1);
			
            var args = {
				startDate : DateUtil.formatDateForSave(modifiedRow.row.proposedstart),
				finishDate : DateUtil.formatDateForSave(modifiedRow.row.proposedfinish),
				projectId : this.containingProjectId,
				userId : userId,
				contour: modifiedRow.row.value
			};
			
			//If this is update operation, send the task assignment id.
			var taskAssignmentId = modifiedRow.row.id;
			if(taskAssignmentId && taskAssignmentId.indexOf(Constants.UNSAVED)== -1){
				args.taskAssignmentId = taskAssignmentId;
			}
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
			AssignmentDashboardUtil.showMessage(ResourceAssignmentViewletMessages.VALIDAITNG_ASSIGNMENT_CREATE_UPDATE);
            ResourceAssignmentClient.validateOverAllocationAndExtensionOfProjectAllocation(srh, args);
        },
        
        /**
         *  getProjectAssignmentforUser : This function get the project assignment for the user and validate the assignment schedule
         *  					against the project assignment schedule
         *  Incoming Arguments : modified row, project assignment URI
         *  Outgoing Argument :	 none
         */
        getProjectAssignmentforUser: function(modifiedRow, uri){
            var self = this;
            var serviceObject = {
            
                success: function(itemInfo){
                    if ((itemInfo) &&
                    (itemInfo.plannedSchedule) &&
                    (itemInfo.plannedSchedule[0])) {
                    
                        var projectPlannedSchedule = itemInfo.plannedSchedule[0];
                        var startDate = DateUtil.parseDate(projectPlannedSchedule.fromDate);
                        var finishDate = DateUtil.parseDate(projectPlannedSchedule.toDate);
                        self.projectAssignmentEffort = projectPlannedSchedule.effort;
                        if (!((DateUtil.compareDates(startDate, modifiedRow.row.proposedstart) <= 0) &&
                        (DateUtil.compareDates(finishDate, modifiedRow.row.proposedfinish) >= 0))) {
                            self.projectAssignmentScheduleChange = true;
                        }
                        self.getTaskAssignmentSchedule(modifiedRow);
                        
                    }
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
                    
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getResourceData_Href(srh, uri);
        },
        
        /**
         *  getTaskAssignmentSchedule : This function get all the task assignment for the user and validate the assignment schedule
         *  				   against all task assignment schedule and effort of project assignment with the total effort of task assignment
         *  Incoming Arguments : modified row
         *  Outgoing Argument :	 none
         */
        getTaskAssignmentSchedule: function(modifiedRow){
            var self = this;
            var resourceId = modifiedRow.row.resourceRelativeHref;
            var serviceObject = {
            
                success: function(itemInfo){
                    if (itemInfo) {
                        var totalEffort = 0;
                        if (modifiedRow.row.resourceRelativeHref.toUpperCase().indexOf(Constants.USER_URI.toUpperCase()) != -1) {
							
                            var modifiedPlannedSchedule; 
							if(modifiedRow.saveObject.params.plannedSchedule[0])
							{
									modifiedPlannedSchedule = modifiedRow.saveObject.params.plannedSchedule[0];
							}
							else if(modifiedRow.saveObject.params.plannedSchedule){
								
								modifiedPlannedSchedule = modifiedRow.saveObject.params.plannedSchedule;
							}
                            var plannedScheduleArray = modifiedPlannedSchedule.split(',');
                            for (var i = 0; i < itemInfo.QueryResult.length; i++) {
                                var taskPlannedSchedule = itemInfo.QueryResult[i].plannedSchedule;
                                var startDate = DateUtil.parseDate(taskPlannedSchedule.startDate);
                                var finishDate = DateUtil.parseDate(taskPlannedSchedule.finishDate);
                                var modifiedStartDate = DateUtil.parseDate(self.getAttributeValue(plannedScheduleArray, Constants.START_DATE));
                                var modifiedFinishDate = DateUtil.parseDate(self.getAttributeValue(plannedScheduleArray, Constants.FINISH_DATE));
                                if (modifiedRow.row.href != itemInfo.QueryResult[i].selfURI) {
                                    totalEffort = totalEffort + taskPlannedSchedule.effort;
                                    if (modifiedRow.row.loadedelement) {
                                        var oldStartDate = DateUtil.parseDate(modifiedRow.row.loadedelement[0].plannedSchedule.startDate);
                                        var oldFinishDate = DateUtil.parseDate(modifiedRow.row.loadedelement[0].plannedSchedule.finishDate);
                                        if (!((DateUtil.compareDates(oldStartDate, modifiedStartDate) <= 0) &&
                                        (DateUtil.compareDates(oldFinishDate, modifiedFinishDate) >= 0))) {
                                            if (!self.resourceOverAllocation &&
                                            !((DateUtil.compareDates(modifiedStartDate, startDate) > 0) &&
                                            (DateUtil.compareDates(modifiedFinishDate, finishDate) > 0))) {
                                                self.resourceOverAllocation = true;
                                            }
                                        }
                                    }
                                    else 
                                        if (!self.resourceOverAllocation &&
                                        !((DateUtil.compareDates(modifiedStartDate, startDate) > 0) &&
                                        (DateUtil.compareDates(modifiedFinishDate, finishDate) > 0))) {
                                            self.resourceOverAllocation = true;
                                        }
                                }
                            }
                            var modifiedEffort = self.getAttributeValue(plannedScheduleArray, Constants.ASSIGNMENT_EFFORT);
                            totalEffort = totalEffort + parseInt(modifiedEffort, 10);
                            if (self.projectAssignmentEffort < totalEffort) {
                                self.projectAssignmentEffortChange = true;
                            }
                        }
                        else {
                            for (var i = 0; i < itemInfo.QueryResult.length; i++) {
                                var taskPlannedSchedule = itemInfo.QueryResult[i].plannedSchedule;
                                var startDate = DateUtil.parseDate(taskPlannedSchedule.startDate);
                                var finishDate = DateUtil.parseDate(taskPlannedSchedule.finishDate);
                                totalEffort = totalEffort + taskPlannedSchedule.effort;
                                if (modifiedRow.row.loadedelement) {
                                    var startDate = DateUtil.parseDate(modifiedRow.row.loadedelement[0].plannedSchedule.startDate);
                                    var finishDate = DateUtil.parseDate(modifiedRow.row.loadedelement[0].plannedSchedule.finishDate);
                                    if (!self.resourceOverAllocation &&
                                    !((DateUtil.compareDates(startDate, startDate) > 0) &&
                                    (DateUtil.compareDates(finishDate, finishDate) > 0))) {
                                        self.resourceOverAllocation = true;
                                    }
                                }
                            }
                            var modifiedEffort = modifiedRow.row.loadedelement[0].plannedSchedule.effort;
                            totalEffort = totalEffort + parseInt(modifiedEffort, 10);
                            if (self.projectAssignmentEffort < totalEffort) {
                                self.projectAssignmentEffortChange = true;
                            }
                        }
                    }
                    if (self.resourceOverAllocation || self.projectAssignmentEffortChange || self.projectAssignmentScheduleChange) {
                        self.showWarningDialog(modifiedRow);
                    }
                    else {
                        self._controller.persistGrid(true, true);
                    }
                    
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(errorObj.errorMessage, errorObj.errorCode);
                }
            };
            
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getAllTaskAssignments(srh, resourceId, self.categoryId, false);
        },
        
        /**
         *  getAttributeValue : This function get the parent details if the parent is a Project else make a call to getProjectInfo to get
         *  			   the containing project details.
         *  Incoming Arguments : Array object, attribute Name
         *  Outgoing Argument :	 value of the attribute
         */
        getAttributeValue: function(valueArray, attributeName){
            for (var i = 0; i < valueArray.length; i++) {
                if (valueArray[i].indexOf(attributeName + "=") != -1) {
                    var effortIndex = valueArray[i].indexOf("=") + 1;
                    return valueArray[i].substring(effortIndex);
                }
            }
            return null;
        },
        
        /**
         *  showWarningDialog : show the warning dialog for user confirmation if any of the pre save validation fails.
         *  Incoming Arguments : modified row, item Info
         *  Outgoing Argument :	 none
         */
        showWarningDialog: function(itemInfo, modifiedRow){
            var buttonlist;
            var dialogContent;
            
            buttonlist = [{
                label: ResourceAssignmentViewletMessages.OK,
                action: dojo.hitch(this, this.saveAssignment, modifiedRow)
            }, {
                label: ResourceAssignmentViewletMessages.CANCEL,
				action: dojo.hitch(this, this.cancelSave)
            }];
            var labelList = [];
			
			if (itemInfo.Overallocation === "true") {
                labelList.push({
                    label:   ResourceAssignmentViewletMessages.RESOURCE_OVER_ALLOCATION
                });
		
            }
            if (itemInfo.Extension === "true") {
                labelList.push({
                    label:  ResourceAssignmentViewletMessages.PROJECT_ASSIGNMENT_SCHEDULE_CHANGE
                });
            }
			if (itemInfo.contourUpdate === "true") {
                labelList.push({
                    label:  ResourceAssignmentViewletMessages.PROJECT_ASSIGNMENT_CONTOUR_CHANGE
                });
            }
			
			//Add a blank line
			labelList.push({
                    label: "&nbsp&nbsp"
                });
				
            labelList.push({
                label: ResourceAssignmentViewletMessages.CONTINUE_OR_CANCEL_ASSIGNMENT
            });
            this.warningDialog = new com.ibm.epm.web.core.ui.internal.EPMConfirmDialog({
                labelList: labelList,
                title: ResourceAssignmentViewletMessages.WARNING_DIALOG_TITLE,
                buttonlist: buttonlist,
				width: "475px"
            });
            this.projectAssignmentScheduleChange = false;
            this.projectAssignmentEffortChange = false;
            this.resourceOverAllocation = false;
            this.warningDialog.show();
        },
        
        /**
         *  saveAssignment : Save the task assignment if user want to continue.
         *  Incoming Arguments : modified row
         *  Outgoing Argument :	 none
         */
        saveAssignment: function(modifiedRow){
            this.warningDialog.destroy();
            //this._controller._persistInParallel([modifiedRow]);
			this._controller.persistGrid(true, true);
        },
        /*
         * Called by the Resource Assignment Tab Manager to get the selected rows of the grid
         * Incoming: None
         * Outgoing: Array of Selected Rows
         */
        getSelectedRows: function(){
        
            var selectedProjectResourceRow = [];
            if (this._generalGrid) {
                var selectedRows = this._generalGrid.selection.getSelected();
                
                var length = selectedRows.length;
                
                selectedProjectResourceRow = new Array(length);
                
                for (var rowIndex = 0; rowIndex < selectedRows.length; rowIndex++) {
                
                    selectedProjectResourceRow[rowIndex] = this._generalGrid.model.getRow(selectedRows[rowIndex]);
                }
            }
            return selectedProjectResourceRow;
        },
		
		/*
         * Private Method
         * _onKeyDown: Handle the on key down event on the grid row and do the action 
         * Input: event e
         * outPut: None
         */
		_onKeyDown: function(e){
			//Donot process the row if an editor is open
            if (this._generalGrid.edit && this._generalGrid.edit.isEditing()) {
                return;
            }
            var keys = dojo.keys;			          
			switch (e.keyCode){
				case 69 /*e - Edit Profile*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.EDIT_PROFILE)){
						this.StartProfileEdit(e);
					}
					break;				
				case 46 /*Delete Key - Unassign profile or resource*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.UNASSIGN_BUTTON)){
						this.unassignResources(e);
					}
					break;
				case 82 /*r - Replace*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.REPLACE)){
						this._publishReplaceWithUserEvent(e); 
					}
					break;
				case keys.ENTER:
					this.onCellDblClick(e);
					break;
			}
					
		},
		
		_canDoAction: function(e, action){
			var row = this._generalGrid.model.getRow(e.rowIndex);
            if(row.markedForDeletion) {
            	return false;
            }
            if (row) {
				if (row.active) {
					if (row.resourceRelativeHref) {
						if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
							if((action == ResourceAssignmentViewletMessages.UNASSIGN_BUTTON) ||
								(action == ResourceAssignmentViewletMessages.EDIT_PROFILE) ||
								(action == ResourceAssignmentViewletMessages.REPLACE)){
								return true;
							}
						}
						else {
							if(action == ResourceAssignmentViewletMessages.UNASSIGN_BUTTON){
								return true;
							}
						}
					}
					else {
						if(action == ResourceAssignmentViewletMessages.UNASSIGN_BUTTON){
								return true;
						}
					}
				}
			}
			return false;
		},
        
        /*
         * Private Method
         * _MouseOut: Handle the on mouse over event on the grid row and add the action images to action column
         * Input: event e
         * outPut: None
         */
        _onMouseOver: function(e){
            if (e.rowIndex != -1) {
                //Donot process the row if an editor is open
                if (this._generalGrid.edit && this._generalGrid.edit.isEditing()) {
                    return;
                }
                this._clearAllActionRows();
                var row = this._generalGrid.model.getRow(e.rowIndex);
                if(row.markedForDeletion) {
                	return;
                }
                if (row) {
					if (row.active) {
						var columnCount = this._generalGrid.hasLayout();
						if (columnCount > 0) {
							var cellobj = this._generalGrid.getCell(this._getColumnIndex("action"));
							var cellDomNode = cellobj.getNode(e.rowIndex);
							if (row.resourceRelativeHref) {
								if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
									cellDomNode.innerHTML = '<img name="deleteImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.UNASSIGN_BUTTON +
									'" alt="' + ResourceAssignmentViewletMessages.UNASSIGN_BUTTON + '" src =' +
									dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_unassign.gif") +
									' />&nbsp<img name="editImage" style="margin-right: 7px; cursor: pointer;" title=" ' +
									ResourceAssignmentViewletMessages.EDIT_PROFILE +
									'" alt="' + ResourceAssignmentViewletMessages.EDIT_PROFILE + '" src =' +
									dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_edit.gif") +
									' />&nbsp<img name="replaceImage" style="margin-right: 7px; cursor: pointer;" title="' +
									ResourceAssignmentViewletMessages.REPLACE +
									'" alt="' + ResourceAssignmentViewletMessages.REPLACE + '" src =' +
									dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_replace.gif") +
									' />';
								}
								else {
									cellDomNode.innerHTML = '<img name="deleteImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.UNASSIGN_BUTTON +
									'" alt="' + ResourceAssignmentViewletMessages.UNASSIGN_BUTTON +  '" src =' +
									dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_unassign.gif") +
									" />";
								}
							}
							else {
								cellDomNode.innerHTML = '<img name="deleteImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.UNASSIGN_BUTTON +
								'" alt="' + ResourceAssignmentViewletMessages.UNASSIGN_BUTTON + '" src =' +
								dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_unassign.gif") +
								" />";
							}
                        this._rowHoverArray.push(row.id);
						}
					}
				}
            }
        },
        
        /*
         * Private Method
         * _MouseOut: Handle the on mouse out event on the grid row and remove the action images from action column
         * Input: event e
         * outPut: None
         */
        _onMouseOut: function(e){
            if (e.rowIndex != -1) {
                //Donot process the row if an editor is open
                if (this._generalGrid.edit && this._generalGrid.edit.isEditing()) {
                    return;
                }
                this._clearAllActionRows();
                var row = this._generalGrid.model.getRow(e.rowIndex);
                if(row)
                	this._clearOneActionRow(row.id);
            }
        },
        
        /*
         * Private Method
         * _clearOneActionRow: Clear action from this row
         * Input: event e
         * outPut: None
         */
        _clearOneActionRow: function(rowId){
            var row = this._generalGrid.model.store._getItemByIdentity(rowId);
            if (row) {
            	if(row.markedForDeletion) return;
                var actionValue = "";
                var columnCount = this._generalGrid.hasLayout();
                if (columnCount > 0) {
                    var cellobj = this._generalGrid.getCell(this._getColumnIndex("action"));
                    var rowIndex = this.assignmentResourceController.getRowIndex(rowId);
                    var cellDomNode = cellobj.getNode(rowIndex);
                    cellDomNode.innerHTML = actionValue;
                }
            }
        },
        
        /*
         * Private Method
         * _getColumnIndex: Returns the  column index of Action Column
         * Input: Column name
         * outPut: Integer index
         */
		_getColumnIndex: function(columnName) {
			var index = this._generalGrid.layout.cellCount - 1; //default to the last
			for(i=0; i<this._generalGrid.layout.cellCount; i++){
				if(this._generalGrid.layout.cells[i].field && this._generalGrid.layout.cells[i].field == columnName){
					index = i;
					break;
				}
			}
			return index;
		},
        
        /*
         * Private Method
         * _clearAllActionRow: Clear all actions from this row
         * Input: event e
         * outPut: None
         */
        _clearAllActionRows: function(){
            for (var i = 0; i < this._rowHoverArray.length; i++) {
                var rowId = this._rowHoverArray[i];
                this._clearOneActionRow(rowId);
            }
            this._rowHoverArray = [];
        },
        
        /**
         *  _getItemInfo : This function get the parent details if the parent is a Project else make a call to getProjectInfo to get
         *  			   the containing project details.
         *  Incoming Arguments : Assignment Information, modified row
         *  Outgoing Argument :	 none
         */
        _getItemInfo: function(assignmentInfo, modifiedRow){
            var self = this;
            var serviceObject = {
            
                success: function(itemInfo){
                    //TODO: need to check for all workitem type
                    if (itemInfo.relativeHref.indexOf(EPMConstants.WORKITEM) != -1 || itemInfo.relativeHref.indexOf(EPMConstants.EPM_RISK) != -1) {
                        if (itemInfo.Parent) {
                            var titleObj = dojo.fromJson(itemInfo.Parent[0].title);
                            if (titleObj.workItemType.indexOf(EPMConstants.EPM_PROJECT) != -1) {
                                self.projectHref = itemInfo.Parent[0].relativeHref;
                                self.projectName = titleObj.summary;
                                self.categoryId = titleObj.category;
                                self.validateProjectAssignment(assignmentInfo, modifiedRow);
                            }
                            else {
                                self.getProjectInfo(itemInfo.containingProject, assignmentInfo, modifiedRow);
                            }
                        }
                        else {
                            self.getProjectInfo(itemInfo.containingProject, assignmentInfo, modifiedRow);
                        }
                        
                    }
                },
                failure: function(errorObj){
                    var updatedLayout = self.getGridLayout();
                    self._generalGrid.setStructure(updatedLayout);
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getResourceData_Href(srh, this.nodeId);
        },
        
        /**
         *  getProjectInfo : This function get the containing project details for a workItem.
         *  Incoming Arguments : Assignment Information, modified row
         *  Outgoing Argument :	 none
         */
        getProjectInfo: function(projectUri, assignmentInfo, modifiedRow){
            var self = this;
            var serviceObject = {
            
                success: function(itemInfo){
                
                    self.projectHref = itemInfo.relativeHref;
                    self.projectName = itemInfo.summary;
					var titleObj = dojo.fromJson(itemInfo.constraint.workElement.title);
					self.categoryId = titleObj.category;
                    self.validateProjectAssignment(assignmentInfo, modifiedRow);
                },
                failure: function(errorObj){
                    var updatedLayout = self.getGridLayout();
                    self._generalGrid.setStructure(updatedLayout);
                }
            };
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getResourceData_Href(srh, projectUri);
        },
        
        validateProjectAssignment: function(assignmentInfo, modifiedRow){
            var projectAssignmentExist = false;
            for (var i = 0; i < assignmentInfo.ProjectResourceAssignment.length; i++) {
                var projectAssignmentHref = assignmentInfo.ProjectResourceAssignment[i].relativeHref;
                if (projectAssignmentHref.indexOf(this.projectHref + Constants.SLASH + Constants.PROJECT_ASSIGNMENT) != -1) {
                    this.getProjectAssignmentforUser(modifiedRow, assignmentInfo.ProjectResourceAssignment[i].relativeHref);
                    projectAssignmentExist = true;
                    break;
                }
            }
            if (!projectAssignmentExist) {
                this._controller.persistGrid(true, true);
            }
        },
        
        /*
         *
         */
        onCellMouseOver: function(e){
            if (e.rowIndex != -1) {
                if (e.cell.field == "task") {
                    var row = this._generalGrid.model.getRow(e.rowIndex);
                    
                    if (row) {
                        if (row.task != "0") {
                            this.taskTooltip.label = row.tooltipHTML.toString();
                            this.taskTooltip.open(e.cellNode);
                        }
                    }
                }
            }
        },
        
        /*
         *
         */
        onCellMouseOut: function(e){
            this.taskTooltip.close();
        },
        
        /**
         * Displays any error that may occur
         */
        handleError: function(errorObject){
            this.inherited("handleError", arguments);
            this._displayError(errorObject);
			var publishedObj = {
				disableSaveButton: false
			}
			dojo.publish(Constants.AFTER_ASSIGNEDGRID_ROW_SAVE_INPROGRESS, [publishedObj]);
        },
        
        _clearErrorMessage: function(){
            EPMErrorHandler.clearError();
        },
        /*
         * Display and clear the error message
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage, errorCode){
            var self = this;
            EPMErrorHandler.setError(errorMessage, errorCode);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._clearErrorMessage();
                clearInterval(intervalID);
            }, 10000);
        },

        /**
         * View's destructor
         */
        destroy: function(){
            dojo.forEach(this._pconnects, dojo.disconnect);
            this._pconnects = [];
            dojo.forEach(this._psubscribes, dojo.unsubscribe);
            this._psubscribes = [];
            this.inherited("destroy", arguments);
        },
        
        /*
         * This function returns an array containing user ids of assignments
         * incoming : None
         * OutGoing : Array of user ids
         */
        getAllAssignedUsers: function(){
            var alreadyAssignedUser = [];
            for (var i = 0; i < this._generalGrid.model.getRowCount(); i++) {
                var row = this.assignmentResourceController.getRowByIndex(i);
                if (row.active && row.resourceRelativeHref.toUpperCase().indexOf("user".toUpperCase()) != -1) {
                    var href = row.resourceRelativeHref;
                    var index = href.indexOf(Constants.SLASH);
                    if (index > -1) {
                        alreadyAssignedUser.push({
                            userId: href.substring(index + 1)
                        });
                    }
                }
            }
            return alreadyAssignedUser;
        },
        
        /**
         * @return Retrieves the sortable columns for this grid view
         */
        getSortableColums: function(){
            var sortableFields = {};
            sortableFields[Constants.NAME_COL] = Constants.NAME_COL;
            sortableFields[Constants.PROPOSED_START_COL] = Constants.PROPOSED_START_COL;
            sortableFields[Constants.PROPOSED_FINISH_COL] = Constants.PROPOSED_FINISH_COL;
            sortableFields[Constants.PROPOSED_DURATION_COL] = Constants.PROPOSED_DURATION_COL;
            sortableFields[Constants.EFFORT_COL] = Constants.EFFORT_COL;
            
            return sortableFields;
        },
        
        /**
         * @return true if the fieldname is present in ignore list
         */
        ignoreFieldChange: function(fieldName){
            //In future add more custom fields. These fields are updated programmatically and not by the GET call for the grid row.
            if (fieldName == Constants.TASKS_COL) {
                return true;
            }if (fieldName == Constants.ASSIGNED_EFFORT_COL) {
                return true;
            }
            return false;
        },
		
		/**
		 * Updates the roles value. Called by the roles pop up dialog from Assignment utility 
		 * @param {Object} selectedRow
		 * @param {Object} roleString
		 */
		updateRoles:function(selectedRow,roleString){
			
			var item = this._generalGrid.model.store._getItemByIdentity(selectedRow.id);
            this._generalGrid.model.store._setValueOrValues(item, "role", roleString, true);
        },
		
        /**
         * The current save has been cancelled by the user, reset the save button to enable after checking modified row count
         * @param none
         */
		cancelSave: function() {
			var modifiedRows = this._controller.getModifiedRows();
			if (modifiedRows.length > 1) {
				var publishedObj = {
					controllerID: Constants.ASSIGNED_RESOURCES_GRID_ID,
					fieldName: ""
				}
				dojo.publish(Constants.ASSIGNED_RESOURCES_FIELD_CHANGE_EVENT, [publishedObj]);
			}
            this.warningDialog.destroy();
		},
		
        /**
         *  saveComplete : Handles the pending request to enable the save button. this is called from the abstract grid
         *  Incoming : none
         *  Outgoing : none
         *
         */
		saveComplete: function() {
			//Release the page finally after save is complete.
			AssignmentDashboardUtil._releasePage();

		},
		
		/**
         *
         * @param {Object} row
         * This function is called from the onStyleRow listener event.
         * Depending upon the state of the task or if the timesheet is
         * for the project manager view, approriate class is attached to
         * the row node or the cell node.
         */
        _styleRow: function(row){
        	
			if(this._generalGrid){
				
				var item = this.assignmentResourceController.getRowByIndex(row.index);
	            
	            if (item) {
	                var assignmentState = item.active;
	                if (assignmentState) {
	                    return;
	                }
	                row.customClasses = row.customClasses + " " + "rowNonEditable";
	            }
			}
        },
		
		StartProfileEdit: function(eve){
			var nameColumnIndex = this._getColumnIndex("name");
			var cell = this._generalGrid.layout.cells[nameColumnIndex];
			this._generalGrid.edit.setEditCell(cell, eve.rowIndex);
		},
		
		roleDialog: function(event){
			if (event.cell.field == "role") {
				var row;
				row = this._generalGrid.model.getRow(event.rowIndex);
				if (row &&
				(row.resourceRelativeHref.indexOf(Constants.USER_URI) != -1)) {
					if (row.active) {
						AssignmentUtil.fetchTeamAreaAndRolesForProject(row.name, row, this.nodeId, this);
					}
					else {
						this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.ROLES_CANNOT_BE_MODIFIED_FOR_INACTIVE_USERS);
					}
				}
				else {
					this._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.ROLES_CANNOT_BE_ASSIGNED_TO_PROFILES);
				}
			}
		},
		
		/**
		 * 
		 */
		getRowToSave: function(modifiedRow){
			if(modifiedRow.row.resourceRelativeHref != ""){
				if(this.rowsToSave[modifiedRow.row.resourceRelativeHref]){
					var plannedSchedule = this.rowsToSave[modifiedRow.row.resourceRelativeHref].saveObject.params.plannedSchedule;
					var rate = this.rowsToSave[modifiedRow.row.resourceRelativeHref].saveObject.params.rate;
					if(plannedSchedule && modifiedRow.saveObject.params.plannedSchedule){
						var plannedScheduleInfo;
						if(modifiedRow.saveObject.params.plannedSchedule[0]){
							
							plannedScheduleInfo = modifiedRow.saveObject.params.plannedSchedule[0];
						}else{
							
							plannedScheduleInfo = modifiedRow.saveObject.params.plannedSchedule;
						}
						this.rowsToSave[modifiedRow.row.resourceRelativeHref].saveObject.params.plannedSchedule.push(plannedScheduleInfo);
						
					}else
						if(modifiedRow.saveObject.params.plannedSchedule){
							this.rowsToSave[modifiedRow.row.resourceRelativeHref].saveObject.params.plannedSchedule = modifiedRow.saveObject.params.plannedSchedule;
						}
					if(rate && modifiedRow.saveObject.params.rate){
						this.rowsToSave[modifiedRow.row.resourceRelativeHref].saveObject.params.rate.push(modifiedRow.saveObject.params.rate[0])
					}else
						if(modifiedRow.saveObject.params.rate){
							var rate = modifiedRow.saveObject.params.rate;
							this.rowsToSave[modifiedRow.row.resourceRelativeHref].saveObject.params.rate = rate;
						}
				}
				else{
					this.rowsToSave[modifiedRow.row.resourceRelativeHref] = modifiedRow;
				}
			}
			else{
				this.rowsToSave[modifiedRow.row.profileTemplateId + this.rowsToSave.length] = modifiedRow;
			}
		}
        
    });
})();
