/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectChargecodes");
    
    dojo.require("dijit.form.Button");
    // Widgets
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesGridView");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesTreeWidget");
    dojo.require("com.ibm.epm.web.core.ui.internal.MouseTooltip");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");
    dojo.require("com.ibm.epm.web.core.client.internal.EPMTreeClient");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
	dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    //Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
	dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
	
	var Messages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
    var EPMClient = com.ibm.epm.web.core.client.internal.EPMTreeClient;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    var HIDE_DELAY = 5000;
    var SHOW_DELAY = 500;
	var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectChargecodes", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.assignment.web", "ui/internal2/templates/ProjectChargecodes.html"),
        _chargecodesTree: null,
        _chargecodesGrid: null,
        
		constructor: function(){
			this.AssignLabel = Messages.CC_ASSIGN_BUTTON;
			this.RemoveLabel = Messages.CC_REMOVE_BUTTON;
		},
		
        postCreate: function(){
            this.inherited(arguments);
            this.mouseTooltip = new com.ibm.epm.web.core.ui.internal.MouseTooltip();
            // List of subscriptions for this Widget
            this._subscriptions = [];
            this.chargecodeLinks = new Array(1);
            this.cnt = 0;
        },
        
        _refreshCodes: function(){
            this.destroy();
            this._createWidgets();
            this.eventSubscribe();
        },
        
        
        /**
         * eventSubscribeToAllEvents: Method to subscribe to all events. <br>
         */
        eventSubscribe: function(){
            this._subscriptions = [
			dojo.subscribe(EPMTreePubSub.ON_MOUSE_OVER, this, "_onTreeMouseOver"), 
			dojo.subscribe(EPMTreePubSub.ON_MOUSE_OUT, this, "_onTreeMouseOut"),
			dojo.subscribe(GridEvents.LOADING_COMPLETED, this, "_onGridLoaded")];
			
        },
        
        /**
         * _unsubscribeToAllEvents: Method to unsubscribe to all events. <br>
         */
        _unsubscribeToAllEvents: function(){
            if (this._subscriptions != null) {
                for (var topic in this._subscriptions) {
                    var handler = this._subscriptions[topic];
                    if (handler) {
                        dojo.unsubscribe(handler);
                    }
                }
            }
            this._subscriptions = [];
        },
        
        /**
         * _getTreeDomNode: Method to get the tree node's domNode
         */
        _getTreeDomNode: function(){
            var domTreeNode = null;
            if ((this._chargecodesTree) && (this._chargecodesTree._chargecodesTree)) {
                domTreeNode = this._chargecodesTree._chargecodesTree.getNodeHover();
            }
            return domTreeNode ? domTreeNode.contentNode : null;
        },
		
		needToHandleEvent: function(publishedItem){
        
            var publishedData = null;
            if (dojo.isArray(publishedItem)) {
                publishedData = publishedItem[0];
            }
            else {
                publishedData = publishedItem;
            }
            
            var boolNeedToHandleEvent = false;
            
            if (this._chargecodesTree &&
            this._chargecodesTree._chargecodesTree &&
            publishedData.treeID &&
            publishedData.treeID == this._chargecodesTree._chargecodesTree.id) {
                boolNeedToHandleEvent = true;
            }
            
            return boolNeedToHandleEvent;
        },
        
        /**
         * _onGridCellMouseOver: To display the calendar attributes as tooltip
         * @param {Object} e
         */
        _onTreeMouseOver: function(e){
			
			if (this.needToHandleEvent(e) == false) {
                return;
            }
			
            if (this._chargecodesGrid) {
                if (dojo.isArray(e.href)) {
                    this._selectedrowID = e.href[0];
                }
                else {
                    this._selectedrowID = e.href;
                }
                var domTreeNode = this._getTreeDomNode();
            	if ((this._chargecodesTree) && (this._chargecodesTree.menuImage)) {
					this._chargecodesTree.menuImage.style.visibility = "hidden";
				}
                this._computeHint(domTreeNode);
            }
        },
        
        /**
         * 	_computeHint: 	Retrieve the attributes of the selected calendar in the grid,
         * 					copies to tooltip
         * 	@param {Object} e
         * 					event e is used to get the selected row to _calendarInfo,
         * 					copies the required attributes to toolTipInfo
         */
        _computeHint: function(e){
        
            if ((this._chargecodesGrid) &&
				(this._chargecodesGrid._controller) &&
			    (this._chargecodesGrid._controller._gridData)) {
            
                var rowIndex = this._chargecodesGrid._controller.getRowIndex(this._selectedrowID);
                var selectedRow = this._chargecodesGrid._controller.getRowByIndex(rowIndex);
                
                if (selectedRow) {
                    if (!this._showTimer) {
                        this._showTimer = setTimeout(dojo.hitch(this, function(){
                            var toolTipInfo = {
                                "Name": selectedRow.name,
                                "Description": selectedRow.description,
                                "Code": selectedRow.code,
                                "Billable": selectedRow.billable,
                                "State": selectedRow.state
                            };
                            this.showTooltip(toolTipInfo, e);
                        }), SHOW_DELAY);
                    }
                    
                    if (!this._hideTimer) {
                        this._hideTimer = setTimeout(dojo.hitch(this, function(){
                            this.hideTooltip(e);
                        }), HIDE_DELAY);
                    }
                }
            }
        },
        
        /**
         * showTooltip: Creates and displays the tooltip
         * 				Uses mouseTooltip to display tooltip
         * @param {Object} toolTipInfo
         * @param {Object} e
         */
        showTooltip: function(toolTipInfo, e){
            //ToolTipInfo structure is :
            //"Name"
            //"Description"
            //"Code"	
            var msg = "<b>";
            if (toolTipInfo.Name) {
                msg += Messages.CHARGECODE_NAME + ": " + toolTipInfo.Name;
                msg += "</b><br>";
            }
            if (toolTipInfo.Description) {
                msg += Messages.CHARGECODE_DESCRIPTION +": " + toolTipInfo.Description;
                msg += "</b><br>";
            }
            if (toolTipInfo.Code) {
                msg += Messages.CHARGECODE_CODE + ": " + toolTipInfo.Code;
                msg += "</b><br>";
            }
            if (toolTipInfo.Billable) {
                msg += Messages.CHARGECODE_BILLABLE + ": " + toolTipInfo.Billable;
                msg += "</b><br>";
            }
            if (toolTipInfo.State) {
                msg += Messages.CHARGECODE_STATE + ": " + toolTipInfo.State;
                msg += "</b><br>";
            }
            this.mouseTooltip._open({
                innerHTML: msg,
                target: e,
                zIndex: 10001
            });
        },
        
        /**
         * _onGridCellMouseOut: To remove the tooltip on mouse over
         * @param {Object} e
         */
        _onTreeMouseOut: function(e){
            if (this._showTimer) {
                clearTimeout(this._showTimer);
                delete this._showTimer;
            }
            if (this._hideTimer) {
                clearTimeout(this._hideTimer);
                delete this._hideTimer;
            }
            var domTreeNode = this._getTreeDomNode();
            if (this.mouseTooltip) {
                this.hideTooltip(domTreeNode);
            }
        },
        
        /**
         * hideTooltip: To close the created mouseTooltip
         * 				Uses mouseTooltip close() method
         * @param {Object} e
         */
        hideTooltip: function(e){
            this.mouseTooltip._close(e);
            dijit._masterTT._onDeck = null;
        },
        
        load: function(parent){
            this.parent = parent;
            this._refreshCodes();
			this.enableRemoveButton = false; 
            if (this.parent._selectedRow) {
                if ((this.parent.fieldtype == "Labour Code") && (this.parent._selectedRow.labourChargecodeUri.length > 0)) {
                    this._selectChargecode(this.parent._selectedRow.labourChargecodeUri);
					if (this.parent._selectedRow.labourChargecodeUri != "null") {
						this.enableRemoveButton = true;						
					}
                }
                else 
                    if ((this.parent.fieldtype == "Revenue Code") && (this.parent._selectedRow.revenueChargecodeUri.length > 0)) {
                        this._selectChargecode(this.parent._selectedRow.revenueChargecodeUri);
						if (this.parent._selectedRow.revenueChargecodeUri != "null") {
							this.enableRemoveButton = true;						
						}
                    }
            }
            this.projectID = this.parent.getController()._projectID;
            
        },
        
        
        destroy: function(){
            if (this._chargecodesTree) {
                this._treeContent.removeChild(this._chargecodesTree.domNode);
                this._chargecodesTree.destroy();
                delete this._chargecodesTree;
                
            }
            if (this._chargecodesGrid) {
                this._gridContent.removeChild(this._chargecodesGrid.domNode);
                this._chargecodesGrid.destroy();
                delete this._chargecodesGrid;
                
            }
            this._unsubscribeToAllEvents();
        },
        
        _assignChargecode: function(){
            if ((this._chargecodesGrid) && (this._chargecodesGrid._generalGrid)) {
                var selectedRowIndexes = this._chargecodesGrid._generalGrid.selection.getSelected();
                if (selectedRowIndexes !== null && selectedRowIndexes.length > 0) {
                    var selectedRow = this._chargecodesGrid._generalGrid.model.getRow(selectedRowIndexes[0]);
                    if (selectedRow) {
                        this._updateController(selectedRow);
                    }
                }
				else{
					alert(Messages.CHARGECODE_NOT_CREATED);
				}
            }
            this._closePopup();
        },
        
        _unassignChargecode: function(){
            var row = {
                name: "",
                href: "null"
            };
            this._updateController(row);
            this._closePopup();
        },
        
        _updateController: function(selectedRow){
            if ((this.parent) && (this.parent._gridController) && (this.parent._selectedRow)) {
                if (this.parent.fieldtype == "Labour Code") {
                    this.parent._selectedRow.labourChargecode = selectedRow.name;
                    this.parent._selectedRow.labourChargecodeUri = selectedRow.href;
                }
                else 
                    if (this.parent.fieldtype == "Revenue Code") {
                        this.parent._selectedRow.revenueChargecode = selectedRow.name;
                        this.parent._selectedRow.revenueChargecodeUri = selectedRow.href;
                    }
                
                this.parent._gridController.setRowData(this.parent._selectedRow, this.parent._selectedRow.id, this.parent._selectedRowIndex);
				
				//Inform the parent that the grid has been modified
				var _fieldName = (this.parent.fieldtype == "Labour Code") ? "labourChargecode" : "revenueChargecode";
				var publishedObj = {
					controllerID: Constants.ASSIGNED_RESOURCES_GRID_ID,
					fieldName: _fieldName
				}
				dojo.publish(Constants.ASSIGNED_RESOURCES_FIELD_CHANGE_EVENT, [publishedObj]);
            }
        },
        
		/**
		 * The method will close the pop up dialog after pressing
		 * the Assign and Remove button
		 */
        _closePopup: function(){
            this.destroy();
			this.parent.destroyAndCloseDialog();
        },
        
        _createWidgets: function(){
            if (this._chargecodesTree === null) {
                this._chargecodesTree = new com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesTreeWidget();
                this._treeContent.appendChild(this._chargecodesTree.domNode);
            }
            this._chargecodesTree._buildProjectChargecodesTree(this.parent._gridController._projectID);
            
            if (this._chargecodesGrid === null) {
                this._chargecodesGrid = new com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesGridView({
                    _treeID: "ChargecodesTree"
                });
                this._gridContent.appendChild(this._chargecodesGrid.domNode);
            }
            this._chargecodesGrid.buildChargecodesGrid();
        },
        
        /**
		 * The method will be called when the grid is loaded
		 * completely
		 * @param {Object} publishedData
		 */
		_onGridLoaded:function(publishedData){
			if (publishedData.controllerID == "ChargecodesController") {
				var saveButton = dojo.byId("savebutton");
				saveButton.disabled = false;
				if(this.enableRemoveButton){
					var removebutton = dojo.byId("removebutton");
					removebutton.disabled = false;
				}
			}
		},
        
        _selectChargecode: function(chargeCodeUri){
            var self = this;
            if (chargeCodeUri == "null") {
                return;
            }
            self._getChargecode(chargeCodeUri);
            var count = 0;
            var intervalID = setInterval(function(){
                if (count == 25) {
                    console.log("Closing on count  " + count);
                    clearInterval(intervalID);
                }
                else {
                    if (self.cnt == 0) {
                        clearInterval(intervalID);
                        self._setfocus(chargeCodeUri);
                    }
                    count = count + 1;
                }
            }, 50);
            
            
        },
        
        _getChargecode: function(chargeCodeUri){
            this.cnt = this.cnt + 1;
            var self = this;
            var serviceObj = {
                success: function(data){
                    if (data) {
                        self.chargecodeLinks.push(chargeCodeUri);
                        var codeLinks = getLink(data, "ParentChargeCode");
                        if (codeLinks) {
                            var projectFound = false;
                            var projectLinks = getLink(data, "Project");
                            if (projectLinks) {
                                if (dojo.isArray(projectLinks)) {
                                    for (var j = 0; j < projectLinks.length; j++) {
                                        if (self.projectID == projectLinks[j].relativeHref) {
                                            projectFound = true;
                                        }
                                    }
                                }
                                else {
                                    if (self.projectID == projectLinks.relativeHref) {
                                        projectFound = true;
                                    }
                                }
                            }
                            if (projectFound == false) {
                                if (dojo.isArray(codeLinks)) {
                                    self._getChargecode(codeLinks[0].relativeHref);
                                }
                                else {
                                    self._getChargecode(codeLinks.relativeHref);
                                }
                            }
                        }
                        self.cnt = self.cnt - 1;
                    }
                },
                
                failure: function(errorObj){
                    //Show the error
                    self._displayErrorMessage("Cannot Retrieve Information");
                    
                }
            };
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            EPMClient.getAllResources(srh, chargeCodeUri);
        },
        
        _setfocus: function(chargeCodeUriTofound){
            var selfTree = this._chargecodesTree._chargecodesTree;
            if (this.chargecodeLinks.length == 2) {
                var chargeCodeUri = this.chargecodeLinks[1];
                var foundNode = selfTree._itemNodeMap[chargeCodeUri];
                if (foundNode) {
                    this._highlightrow(foundNode.item.identifier);
                    return true;
                }
            }
            
            var ccIndex = this.chargecodeLinks.length - 1;
            var codeUri = this.chargecodeLinks[ccIndex];
            var ccNode = selfTree._itemNodeMap[codeUri];
            this._recursiveExpand(ccNode, ccIndex, chargeCodeUriTofound);
            return false;
        },
        
        _highlightrow: function(nodeId){
            var selfTree = this._chargecodesTree._chargecodesTree;
            selfTree._highlightSpecifiedNode(nodeId, true);
        },
        
        _recursiveExpand: function(ccNode, ccIndex, chargeCodeUriTofound){
            var self = this;
            var selfTree = this._chargecodesTree._chargecodesTree;
            if ((ccNode.isExpandable == true) && (ccNode.isExpanded == false) && (ccIndex > 0)) {
                selfTree._expandNode(ccNode);
            }
            var intervalID = setInterval(function(){
                var children = ccNode.getChildren();
                dojo.forEach(children, function(child){
                    if (child.label == "Loading ...") {
                    }
                    else {
                        if ((child.item.identifier[0] == chargeCodeUriTofound)) {
                            clearInterval(intervalID);
                            self._highlightrow(child.item.identifier[0]);
                            return;
                        }
                        else 
                            if (ccIndex == 2) {
                                //No data found at the end of all iteration.
                                clearInterval(intervalID);
                            }
                            else {
                                if (child.item.identifier[0] == self.chargecodeLinks[ccIndex - 1]) {
                                    clearInterval(intervalID);
                                    self._recursiveExpand(child, ccIndex - 1, chargeCodeUriTofound);
                                }
                            }
                    }
                    
                });
            }, 50);
        }
    });
})();
