/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.RateAssignmentAssociation");
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.RateAssignmentGridView");
    dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMToolbar");
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    var IconClassConstants = com.ibm.epm.web.core.ui.internal.IconClassConstants;
    var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.RateAssignmentAssociation", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.assignment.web", "ui/internal2/templates/RateAssignmentAssociation.html"),
        
        postCreate: function()
        {
        },
        
        /**
         * Loads the widget and initializes the grid
         */
        load: function(row, rateEditor)
        {
            this._row = row;
            this._rateEditor = rateEditor;
            this._createToolbar();
          	this._createRatesGrid();
        },
        
        /**
         * Creates the grid
         */
        _createRatesGrid: function(){
            this._grid = new com.ibm.epm.resource.assignment.web.ui.internal2.RateAssignmentGridView({
                _treeID: "RateAssignment"
            });
            this._content.appendChild(this._grid.domNode);
            this._grid.buildRatesGrid(this._row.rates);
        },
        
        /**
         * Adds a row to the grid
         */
        _addRate: function()
        {
            if (this._grid)
            {
                this._grid._addRate();
            }
        },
        
        /**
         * Deletes one or more rows from the grid
         */
        _deleteRate: function()
        {
            if (this._grid)
            {
                this._grid._deleteRate();
            }
        },
        
        /**
         * Saves the changes in rates back to the assignment grid 
         */
        _saveRates: function()
        {
            if (this._grid)
            {
				if(this._grid.edit) {
					this._grid.edit.apply();
				}
                this._row.rates = this._grid._saveRates();
                this._rateEditor.setRowData();
                this._rateEditor._closedialog();
            }
        },
        
        /**
         * Creates the toolbar on top
         */
        _createToolbar: function()
        {
        	
        	this.addButton = new dijit.form.Button({
                title: ResourceAssignmentViewletMessages.ADD_RATE,
				label : ResourceAssignmentViewletMessages.ADD_BUTTON,
				showLabel : false,
                iconClass: IconClassConstants.EPM_ADD_ICON_CLASS,
                onClick: dojo.hitch(this, this._addRate)
            });
            
            this.deleteButton = new dijit.form.Button({
                title: ResourceAssignmentViewletMessages.DELETE_RATE,
				label : ResourceAssignmentViewletMessages.DELETE_BUTTON,
				showLabel : false,
                iconClass: IconClassConstants.EPM_DELETE_ICON_CLASS,
                onClick: dojo.hitch(this, this._deleteRate)
            });
            
            var rightContentList = [this.addButton, this.deleteButton];
            
            this._toolBar = new EPMToolbar({
                title: ResourceAssignmentViewletMessages.RATE_TOOLBAR_LABEL,
                rightContentList: rightContentList
            });
            
            this._toolbar.appendChild(this._toolBar.domNode);
        },
        
        /**
         * Destroys the widget
         */
        destroy: function()
        {
            if (this._grid && this._grid.destroy)
            {
                this._grid.destroy();
                delete this._grid;
            }
        }
    });
})();