/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.RateAssignmentGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
   	var dateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.RateAssignmentGridModel", abstractGridModel, {
        constructor: function(){
        },
        
        /**
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID){
        	var today = DateUtil.formatDateForSave(new Date());
            var row = {
                    "id": rowID,
                    "href": rowID,
                    "name": "",
                    "fromDate": today,
                    "toDate": today,
                    "costRate": "0",
                    "sellingRate": "0",
                    "loadedelement": null
                };
            return row;
        },
        
        /**
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName == null) {
                row.fromDate = dateUtil.parseDate(loadedElement.fromDate);
                row.toDate = dateUtil.parseDate(loadedElement.toDate);
                row.costRate = loadedElement.costRate;
                row.sellingRate = loadedElement.sellingRate;
                row.loadedelement = [loadedElement];
            }
        },
        
        /**
         * This is an overridden method which is not directly used
         */
        prepareSaveParams: function(row){
            var saveParams = {};
            return saveParams;
        },
        
        /**
         * This is an overridden method which is not directly used
         */
        _getNewElementURI: function(row){
            return "";
        }
    });
})();
