/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentTabManager");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    
    dojo.require("dijit.form.Button");
    
    dojo.require("com.ibm.epm.web.core.client.QueryUtil");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceQueryGrid");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridView");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridView");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    dojo.require("com.ibm.epm.web.core.util.internal.Constants");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AvailabilitySearchDialog");
    
    // Client
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
    
    dojo.require("com.ibm.epm.web.core.client.internal.QueryClient");
    
    // Error handler
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMToolbar");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants");
    
    dojo.require("com.ibm.epm.web.core.util.internal.Constants");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");
    
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil");
    
    dojo.require("com.ibm.epm.work.web.ui.internal.util.WBSUtil");
    
    dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
    dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    
    var WBSConstants = com.ibm.epm.web.core.util.internal.Constants;
    
    var QueryClient = com.ibm.epm.web.core.client.internal.QueryClient;
    
    var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
    
    var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
    
    var RESOURCE_QUERY_TYPE = "com.ibm.epm.resource.epmUserType";
    
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    
    var ProjectAssignmentGridView = com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridView;
    
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var AvailabilitySearchDialog = com.ibm.epm.resource.assignment.web.ui.internal2.AvailabilitySearchDialog;
    
    var AddProfileDialog = com.ibm.epm.resource.assignment.web.ui.internal2.AddProfileDialog;
    
    var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
    
    var EPMDomNodeConstants = com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants;
    var EPMConstants = com.ibm.epm.web.core.util.internal.Constants;
    var IconClassConstants = com.ibm.epm.web.core.ui.internal.IconClassConstants;
    
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var AssignmentUtil = com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil;
    var SelectContributorDialog = com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;
    
    var WBSUtil = com.ibm.epm.work.web.ui.internal.util.WBSUtil;
    var AdminConstants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var RMDashboardUtil = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
    var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentTabManager", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.assignment.web", "ui/internal2/templates/ResourceAssignmentTabManager.html"),
        
        identifier: Constants.GRID_TEMP_ID,
        
        wbsNodeType: "",
        
        wbsNodeName: "",
        categoryId: "",
        //Containing Project URL for WBS Child node
        containingProjectURL: "",
        //Project URL
        projectURL: "",
        
        //Containing project Id
        containingProjectId: "",
        
        queryId: "",
        
        queryName: "",
        
        queryType: "",
        
        //Current Grid being Displayed in Query Tab
        currentGrid: Constants.PROJECT_ASSIGNMENT_GRID,
        
        //Current Query ID
        currentQueryId: "",
        
        defaultStartDate: null,
        defaultFinishDate: null,
        defaultDuration: null,
        defaultEffort: null,
        replaceProfileRowId: "",
        itemOfTypeEffort: false,
        
        //for roles
        pendingMemberChanges: {},
        roleString: Constants.DEFAULT_ROLE,
        /*
         * Constructor
         * Incoming : None
         * Outgoing : None
         */
        constructor: function(){
            this._labelClose = ResourceAssignmentViewletMessages.CLOSE;
            this._showLabel = ResourceAssignmentViewletMessages.SHOW_LABEL;
            this._pconnects = [];
            this._eventSubscriptionHandler = [];
        },
        
        subscribeToTreeEvents: function(){
			//We need to unsubscribe the events before attempting to subscribe again
			this.unSubscribeFromTreeEvents();
            this._eventSubscriptionHandler = [dojo.subscribe(EPMTreePubSub.ON_SELECT, this, "_updateWBSNodeIdentifier"), 
											dojo.subscribe(EPMTreePubSub.ON_CREATE_NODE, this, "_updateWBSNodeIdentifier"), 
											dojo.subscribe(Constants.REPLACE_PROFILE_WITH_USER_EVENT, this, "replaceProfile"), 
											dojo.subscribe(GridEvents.LOADING_COMPLETED, this, "_onResourceViewGridLoaded"), 
											dojo.subscribe(Constants.AFTER_ASSIGNEDGRID_ROW_SAVE_INPROGRESS, this, "_onAssignmentGridSaveInProgress")];
        },
        
        unSubscribeFromTreeEvents: function(){
            if (this._eventSubscriptionHandler != null) {
                for (var i in this._eventSubscriptionHandler) {
                    var handler = this._eventSubscriptionHandler[i];
                    if (handler) {
                        dojo.unsubscribe(handler);
                    }
                }
            }
            this._eventSubscriptionHandler = [];
			if (this._assignmentGrid) {
				this._assignmentGrid.viewIsBusy = false;
			}
			if (this._projectAssignmentGrid) {
				this._projectAssignmentGrid.viewIsBusy = false;
			}
        },
        
        
        /*
         * Refresh Function : Load the grid based on wbs tree node
         * Incoming: None
         * Outgoing: None
         */
        refresh: function(){
            this.identifier = Constants.GRID_TEMP_ID;
            this.initViewBasedonTree();
        },
        
        /*
         * Post Create Funtion
         * Incoming: None
         * Outgoing: None
         */
        postCreate: function(){
            this._createAssignmentToolbar();
            this.ContainingViewlet._displayInformationLabel(ResourceAssignmentViewletMessages.NO_TREE_NODE_IS_SELECTED);
            this._createResourceOrQueryFilter();
            this._fieldChangeEvent = null;
            this._onUserOrProfileAdded = null;
            this._onAssignedGridFieldChange = null;
        },
        
        /*
         * Creation of Toolbar for Assignment purpose
         * Incoming : None
         * Outgoing : None
         */
        _createAssignmentToolbar: function(){
        
            this.addProfileButton = new dijit.form.Button({
                title: ResourceAssignmentViewletMessages.ADD_PROFILE_TOOLTIP,
                label: ResourceAssignmentViewletMessages.ADD_PROFILE_TOOLTIP,
                showLabel: false,
                iconClass: IconClassConstants.EPM_ADD_PROFILE_CLASS,
                onClick: dojo.hitch(this, this._addProfileButtonClick)
            });
            
            this.addResourceButton = new dijit.form.Button({
                title: ResourceAssignmentViewletMessages.ADD_RESOURCES_TOOLTIP,
                label: ResourceAssignmentViewletMessages.ADD_RESOURCES_TOOLTIP,
                showLabel: false,
                iconClass: IconClassConstants.EPM_ADD_RESOURCES_CLASS,
                onClick: dojo.hitch(this, this._addResourcesButtonClick)
            });
            
            
            this.searchAssignResourceButton = new dijit.form.Button({
                title: ResourceAssignmentViewletMessages.SEARCH_ASSIGN_RESOURCE_TOOLTIP,
                label: ResourceAssignmentViewletMessages.SEARCH_ASSIGN_RESOURCE_TOOLTIP,
                showLabel: false,
                iconClass: IconClassConstants.EPM_QUERY_RESOURCE_CLASS,
                onClick: dojo.hitch(this, this._searchAssignResourceButtonClick)
            });
            
            this.refreshButton = new dijit.form.Button({
                title: ResourceAssignmentViewletMessages.REFRESH_BUTTON,
                label: ResourceAssignmentViewletMessages.REFRESH_BUTTON,
                showLabel: false,
                iconClass: IconClassConstants.EPM_REFRESH_ICON_CLASS,
                onClick: dojo.hitch(this, this.refresh)
            });
            
            this.saveButton = document.createElement(EPMDomNodeConstants.BUTTON);
            this.saveButton.innerHTML = ResourceAssignmentViewletMessages.SAVE_BUTTON;
            this.saveButton.title = ResourceAssignmentViewletMessages.SAVE_TOOLTIP;
            dojo.connect(this.saveButton, EPMDomNodeConstants.ON_CLICK, this, this._saveAssignment);
            
            var rightContentList = [this.addProfileButton, this.addResourceButton, this.searchAssignResourceButton, this.refreshButton, this.saveButton];
            
            this._assignmentToolBar = new EPMToolbar({
                title: this.wbsNodeName,
                rightContentList: rightContentList
            });
            
            this.ContainingViewlet.setCSHelpIdInToolbar(this.ContainingViewlet.contextHelpId, this._assignmentToolBar);
            
            this._assignmentGridToolbar.appendChild(this._assignmentToolBar.domNode);
            this.toggleDisplayOfAllToolbars(false);
            this.toggleSaveButton(true);
            
        },
        
        /*
         * Action on clicking add Profile. If assignment grid is not present then Add profile dialog is not shown.
         * Incoming : None
         * Outgoing : None
         */
        _addProfileButtonClick: function(){
            // Handle button click for unsaved WBS elements
            if (this.identifier && this.identifier.indexOf(Constants.UNSAVED) != -1) {
                this._displayErrorMessage(ResourceAssignmentViewletMessages.SAVE_UNSAVED_WBS_ELEMENT_BEFORE_ASSIGNMENT);
                return;
            }
            if (this.wbsNodeType == EPMConstants.WORKITEM || this.wbsNodeType == EPMConstants.EPM_PROJECT || this.wbsNodeType == EPMConstants.EPM_RISK) {
                var multipleAssignment = true;
                if (this.wbsNodeType == EPMConstants.WORKITEM) {
                    multipleAssignment = false;
                }
                else {
                    multipleAssignment = true;
                }
                if (this._assignmentGrid) {
                    if (this.validateMultipleAssignment(this.wbsNodeType)) {
                        this.addProfileDialog = new AddProfileDialog({
                            context: this,
                            multipleAssignment: multipleAssignment
                        });
                    }
                }
            }
            else {
                this._displayErrorMessage(ResourceAssignmentViewletMessages.ASSIGNMENT_NOT_ALLOWED + WBSUtil.getWBSElementName(this.wbsNodeType));
            }
        },
        
        /*
         * Action on clicking add Profile. If assignment grid is not present then Add profile dialog is not shown.
         * Incoming : None
         * Outgoing : None
         */
        _addResourcesButtonClick: function(){
            // Handle button click for unsaved WBS elements
            if (this.identifier && this.identifier.indexOf(Constants.UNSAVED) != -1) {
                this._displayErrorMessage(ResourceAssignmentViewletMessages.SAVE_UNSAVED_WBS_ELEMENT_BEFORE_ASSIGNMENT);
                return;
            }
            if (this.wbsNodeType == EPMConstants.WORKITEM || this.wbsNodeType == EPMConstants.EPM_PROJECT || this.wbsNodeType == EPMConstants.EPM_RISK) {
                if (this.validateMultipleAssignment(this.wbsNodeType)) {
                    var useOkCancelFlag = false;
                    if (this.wbsNodeType == EPMConstants.WORKITEM) {
                        useOkCancelFlag = true;
                    }
                    else {
                        useOkCancelFlag = false;
                    }
                    var disableAlreadyAssignedUsers = this._assignmentGrid.getAllAssignedUsers();
                    this.ownerListWidget = new SelectContributorDialog({
                        hideAdminGuest: true,
                        allowMultiple: false,
                        allowArchivedUsers: false,
                        disableUsersOnAdd: false,
                        useOkCancel: useOkCancelFlag
                    });
                    this.connect(this.ownerListWidget, "onOK", dojo.hitch(this, function(selectedUserList){
                        //						dojo.style(this.ownerListWidget.dialog.domNode, "zIndex", 100);
                        var selectedRows = [];
                        for (var i = 0; i < selectedUserList.length; i++) {
                            var rowInfo = {
                                id: Constants.USER_URI + Constants.SLASH + selectedUserList[i].userId
                            };
                            selectedRows.push(rowInfo);
                        }
                        if (selectedRows.length > 0) {
                            this._getResourceInfoAndAssign(selectedRows);
                        }
                    }));
                    this.ownerListWidget.searchText.focus();
                }
            }
            else {
                this._displayErrorMessage(ResourceAssignmentViewletMessages.ASSIGNMENT_NOT_ALLOWED + WBSUtil.getWBSElementName(this.wbsNodeType));
            }
        },
        
        /*
         * Public Function
         * assignProfile: To be used by the Add profile dialog when user clicks the OK button
         * Incoming : None
         * Outgoing : None
         */
        assignProfile: function(profiles){
            this.roleString = Constants.DEFAULT_ROLE;
            this.assignResourceWithDetails(profiles, true);
        },
        
        /*
         * Action on clicking search and Assign resource
         * Incoming : None
         * Outgoing : None
         */
        _searchAssignResourceButtonClick: function(){
        
            if (this.identifier && this.identifier.indexOf(Constants.UNSAVED) != -1) {
                this._displayErrorMessage(ResourceAssignmentViewletMessages.SAVE_UNSAVED_WBS_ELEMENT_BEFORE_ASSIGNMENT);
                return;
            }
            
            if (this._assignmentGrid) {
                if (this.wbsNodeType == EPMConstants.WORKITEM || this.wbsNodeType == EPMConstants.EPM_PROJECT || this.wbsNodeType == EPMConstants.EPM_RISK) {
                    //1. Display the search/assign container
                    //2. Populate the select filter
                    var currentDisplayStatus = dojo.style(this._sectionGridContainer, "display");
                    if (currentDisplayStatus == "none") {
                        dojo.style(this._sectionGridContainer, "display", "");
                        //dojo.style(this._flexibleBox, "display", "");
                        
                        this._populateStaticItemsToResourceOrQueryFilter();
                        this._reloadSearchOrQueryGrid();
                    }
                }
                else {
                    this._displayErrorMessage(ResourceAssignmentViewletMessages.ASSIGNMENT_NOT_ALLOWED + WBSUtil.getWBSElementName(this.wbsNodeType));
                }
            }
            
        },
        
        /*
         * Close the availability search dialog
         * Incoming : None
         * Outgoing : None
         */
        _closeAvailabilitySearchDlg: function(){
            if (this.SelectIntervalDialog) {
                this.SelectIntervalDialog.destroy();
                delete this.SelectIntervalDialog;
            }
        },
        
        /**
         * Formats the date for query parameter
         * @param {Object} date
         */
        _formatDateForQuery: function(date){
        
            return DateUtil.formatDateForSave(date, {
                datePattern: 'yyyy-MM-dd',
                selector: 'date'
            });
        },
        /*
         * Private Method
         * 		Calls the server to the URI /query/<queryID>?execute=true.
         * @param String queryId: The Item ID of the stored query.
         * @return void
         */
        _executeQuery_n_BuildGrid: function(jsonParam){
            this.containingProjectURL = "";
            var queryParameterForAvailablitySearch = {};
            
            if (this._availabilitySearchDialog) {
            
                var startDate = this._formatDateForQuery(this._availabilitySearchDialog.getFromDate());
                
                var endDate = this._formatDateForQuery(this._availabilitySearchDialog.getEndDate());
                var availablitySearchFlag = this._availabilitySearchDialog.isAvailabilitySearch();
                var effort = this._availabilitySearchDialog.getEffort();
                
                var availabilitySearchType = this._availabilitySearchDialog.effortOrDurationType();
                if (availablitySearchFlag && !availabilitySearchType) {
                    if (!startDate || !endDate) {
                        return;
                    }
                }
                if (availablitySearchFlag && availabilitySearchType) {
                    if (!startDate || (!effort || isNaN(effort) || effort < 0)) {
                        return;
                    }
                }

				var contour = this._availabilitySearchDialog.getContour();				
				if ( contour == null || contour == "undefined" || (!isNaN(contour) && contour <=0 )) {
					
					return;
				}
                
                var availabilitySearchScope = this._availabilitySearchDialog.searchWithinProject();
                
                this._availabilitySearchDialog.destroy();
                delete this._availabilitySearchDialog;
                
                if (availabilitySearchScope) {
                    queryParameterForAvailablitySearch.searchScope = Constants.SEARCH_SCOPE_PROJECT;
                }
                else {
                    queryParameterForAvailablitySearch.searchScope = Constants.SEARCH_SCOPE_GLOBAL;
                }
                
                if (availabilitySearchType) {
                    queryParameterForAvailablitySearch.searchType = Constants.EFFORT_TYPE_ELEMENT;
                    if (effort != null && effort != "undefined" && effort != "") {
                    	queryParameterForAvailablitySearch.effort = effort;
                	}
                }
                else {
                    queryParameterForAvailablitySearch.searchType = Constants.DURATION_TYPE_ELEMENT;
                    queryParameterForAvailablitySearch.endDate = endDate;
                }
				
				if(this.wbsNodeType == EPMConstants.WORKITEM || this.wbsNodeType == EPMConstants.EPM_RISK){
					
					queryParameterForAvailablitySearch.searchLevel = Constants.SEARCH_LEVEL_TASK;
				}else{
					
					queryParameterForAvailablitySearch.searchLevel = Constants.SEARCH_LEVEL_PROJECT;
				}
                
                queryParameterForAvailablitySearch.startDate = startDate;
                
                
               
				if (!isNaN(contour)) {
					queryParameterForAvailablitySearch.contour = contour;
				}
				
                queryParameterForAvailablitySearch.availablitySearchFlag = availablitySearchFlag;
                queryParameterForAvailablitySearch.projectId = this.projectURL.substring(this.projectURL.lastIndexOf(Constants.SLASH) + 1);
				
                
            }
            else 
                if (jsonParam) {
                    queryParameterForAvailablitySearch.availablitySearchFlag = false;
                    queryParameterForAvailablitySearch.startDate = jsonParam.startDate;
                    queryParameterForAvailablitySearch.endDate = jsonParam.finishDate;
                    queryParameterForAvailablitySearch.skill = jsonParam.skills;
                    queryParameterForAvailablitySearch.competency = jsonParam.competencies;
                    queryParameterForAvailablitySearch.profileReplcementSearch = true;
                    queryParameterForAvailablitySearch.projectId = this.projectURL.substring(this.projectURL.lastIndexOf(Constants.SLASH) + 1);
                    queryParameterForAvailablitySearch.searchScope = Constants.SEARCH_SCOPE_GLOBAL;
                    queryParameterForAvailablitySearch.effort = jsonParam.effort;
                    if (this.itemOfTypeEffort) {
                        queryParameterForAvailablitySearch.searchType = Constants.EFFORT_TYPE_ELEMENT;
                    }
                    else {
                        queryParameterForAvailablitySearch.searchType = Constants.DURATION_TYPE_ELEMENT;
                    }
					if(this.wbsNodeType == EPMConstants.WORKITEM || this.wbsNodeType == EPMConstants.EPM_RISK){
						queryParameterForAvailablitySearch.searchLevel = Constants.SEARCH_LEVEL_TASK;
					}else{
						queryParameterForAvailablitySearch.searchLevel = Constants.SEARCH_LEVEL_PROJECT;
					}
                }
            this.currentQueryId = this.queryId;
            
            // Remove the Project Assignment Grid if present
            if (this.currentGrid == Constants.PROJECT_ASSIGNMENT_GRID) {
                this._destroyWidget(this._projectAssignmentGrid, this.resourceQueryGridAttachPoint);
            }
            else 
                if (this.currentGrid == Constants.RESOURCE_QUERY_GRID) {
                
                    this._destroyWidget(this._resourceQueryGrid, this.resourceQueryGridAttachPoint);
                }
            
            // Create ResourceQuery Grid and call excute query function
            this.currentGrid = Constants.RESOURCE_QUERY_GRID;
            
            this._createResourceQueryGrid(this.queryId, this.queryType, queryParameterForAvailablitySearch);
            
        },
        
        /*
         * Displays the Error Message
         * Incoming : Error message
         * Outgoing : None
         */
        _displayErrorMessage: function(errorMessage){
            this._displayAndClearErrorMessage(errorMessage);
        },
        
        _clearErrorMessage: function(){
            EPMErrorHandler.clearError();
        },
        /*
         * Display and clear the error message
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage){
            var self = this;
            EPMErrorHandler.setError(errorMessage);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._clearErrorMessage();
                clearInterval(intervalID);
            }, 10000);
        },
        
        /*
         * Checks whether the event has to be handled or not
         * Incoming : Tree Id
         * Outgoing : Boolean value
         */
        needToHandleEvent: function(publishedData){
        
            var boolNeedToHandleEvent = false;
            if (publishedData &&
            (publishedData.treeID == Constants.WBS_TREE_ID ||
            (publishedData.uniqueIdentifier && publishedData.uniqueIdentifier.treeID == Constants.WBS_TREE_ID))) {
            
                boolNeedToHandleEvent = true;
                
            }
            return boolNeedToHandleEvent;
        },
        
        /*
         * This view has 2 grids derived from abstractGrid -> _assignmentGrid and _projectAssignmentGrid
         * These may be busy loading the grid or deleted all rows. While doing so, any changes in tree selection needs to be ignored.
         * Return true if one of the view is busy else false
         */
        _isViewBusy: function(){
            if ((this._assignmentGrid && this._assignmentGrid.viewIsBusy) ||
            (this._projectAssignmentGrid && this._projectAssignmentGrid.viewIsBusy)) {
                return true;
            }
            else {
                return false;
            }
        },
        
        /*
         * Called when Tree Node Select Event is published
         * Incoming : WBS Tree Node
         * Outgoing : None
         */
        _updateWBSNodeIdentifier: function(wbsNodeDetail){
            try {
                // Process only if the Tree even has come from WBSTree
                
                if (this.needToHandleEvent(wbsNodeDetail) == false) {
                    //Event ignored due to ID mismatch
                    return;
                }
                
                //Early exit if the node clicked is the same
                var newIdentifier = this._getDataFromArray(wbsNodeDetail.identifier);
                if (this.identifier == newIdentifier) {
                    return;
                }
                
                if (this._isViewBusy()) {
                    console.log("The current request cannot be accepted now since one of the grids is busy");
                    return;
                }
                
                RMDashboardUtil.showMessage(ResourceAssignmentViewletMessages.LOADING);
                this.toggleSaveButton(true);
                
                this.identifier = this._getDataFromArray(wbsNodeDetail.identifier);
                this.wbsNodeName = this._getDataFromArray(wbsNodeDetail.name);
                this.wbsNodeType = this._getDataFromArray(wbsNodeDetail.resourcetype);
                var newGridFlag = false;
                
                //Handle Unsaved WBS Element select event
                if (this.identifier.indexOf(Constants.UNSAVED) != -1) {
                
                    this.onQueryResultSectionClose();
                    newGridFlag = false;
                    if (this._assignmentGrid) {
                        newGridFlag = this.removeAllRows(this._assignmentGrid);
                        //newGridFlag = true;
                    }
                    this._createAssignmentGrid(newGridFlag);
                    return;
                }
                //If the section container is visible then update the grid
                var currentDisplayStatus = dojo.style(this._sectionGridContainer, "display");
                if (currentDisplayStatus != "none") {
                
                    if (this.wbsNodeType == EPMConstants.WORKITEM || this.wbsNodeType == EPMConstants.EPM_PROJECT || this.wbsNodeType == EPMConstants.EPM_RISK) {
                        if (this.currentGrid == Constants.PROJECT_ASSIGNMENT_GRID) {
                            if (this.wbsNodeType == EPMConstants.EPM_RISK || this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                                this._getContainingProjectInformation(newGridFlag, false);
                            }
                            else {
                                if (this._projectAssignmentGrid) {
                                    newGridFlag = this.removeAllRows(this._projectAssignmentGrid);
                                    //newGridFlag = true;
                                }
                                this._buildProjectAssignmentGrid(newGridFlag);
                            }
                        }
                        this._populateStaticItemsToResourceOrQueryFilter();
                    }
                    else {
                        this.onQueryResultSectionClose();
                    }
                }
                var scheduleInfoFlag = true;
                if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                    this._getProjectInformation(this.identifier, newGridFlag, scheduleInfoFlag);
                }
                else 
                    if (this.wbsNodeType == EPMConstants.EPM_RISK || this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                        this._getContainingProjectInformation(newGridFlag, scheduleInfoFlag);
                    }
                    else {
                        newGridFlag = false;
                        if (this._assignmentGrid) {
                            newGridFlag = this.removeAllRows(this._assignmentGrid);
                        //newGridFlag = true;
                        }
                        this._createAssignmentGrid(newGridFlag);
                    }
            } 
            catch (error) {
                console.log(error.message);//I will not remove this since this will help us in debugging in future 
                this._displayErrorMessage(ResourceAssignmentViewletMessages.ERROR_LOADING_ASSIGNED_GRID);
                RMDashboardUtil.hideMessageArea();
            }
            finally {
                //do any final cleanup here.
            }
            
        },
        
        /*
         * Reload the top grid to show project assignments for wbs element
         * Incoming : None
         * Outgoing : None
         */
        _reloadSearchOrQueryGrid: function(){
            var newGridFlag = false;
            if (this.currentGrid == Constants.RESOURCE_QUERY_GRID) {
            
                this._destroyWidget(this._resourceQueryGrid, this.resourceQueryGridAttachPoint);
                this._buildProjectAssignmentGrid(false);
                
            }
            else 
                if (this.currentGrid == Constants.PROJECT_ASSIGNMENT_GRID) {
                
                    if (this.wbsNodeType == EPMConstants.EPM_RISK || this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                        this._getContainingProjectInformation(newGridFlag, false);
                    }
                    else {
                        if (this._projectAssignmentGrid) {
                            newGridFlag = this.removeAllRows(this._projectAssignmentGrid);
                        //newGridFlag = true;
                        }
                        this._buildProjectAssignmentGrid(newGridFlag);
                    }
                }
            
            this.currentGrid = Constants.PROJECT_ASSIGNMENT_GRID;
            
        },
        
        /*
         * Returns the Data frm the Array
         */
        _getDataFromArray: function(data){
        
            if (dojo.isArray(data)) {
                return data[0];
            }
            return data;
            
        },
        
        /*
         * Called when the Assing Button is Pressed
         * Passes the Selected Rows from Top Grid to Assignment Grid
         * Incoming : None
         * Outgoing : None
         */
        _assignResource: function(){
        
            // Get the Selected Rows from Query Grid
            
            //TODO : Imp - For task decide how to assign the resources
            
            if (this.identifier === Constants.GRID_TEMP_ID) {
            
                this._displayErrorMessage(ResourceAssignmentViewletMessages.WBS_NODE_NOT_SELECTED);
                return;
            }
            
            var selectedRows = null;
            
            if (this.currentGrid == Constants.PROJECT_ASSIGNMENT_GRID) {
            
                this._assignmentGrid.setSourceGrid(Constants.PROJECT_ASSIGNMENT_GRID);
                
                if (this.wbsNodeType == EPMConstants.EPM_RISK || this.wbsNodeType === EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                
                    selectedRows = this._projectAssignmentGrid.getSelectedRows();
                    if (this._isAssignmentAllowed(selectedRows)) {
                        this.assignResourceWithDetails(selectedRows, false);
                    }
                    
                }
//                else 
//                    if (this.wbsNodeType === EPMConstants.EPM_PROJECT) {
//                        this._displayErrorMessage(ResourceAssignmentViewletMessages.CANNOT_ALLOCATE_ALREADY_ALLOCATED_RESOURCE);
//                    }
            }
            else 
                if (this.currentGrid == Constants.RESOURCE_QUERY_GRID) {
                
                    this._assignmentGrid.setSourceGrid(Constants.QUERY_GRID);
                    
                    selectedRows = this._resourceQueryGrid.getSelectedRows();
                    if (this._isAssignmentAllowed(selectedRows)) {
                        // Get the data for all the selected rows
                        this._getResourceInfoAndAssign(selectedRows);
                    }
                }
            
            
        },
        
        /*
         * Called to check if assignment is allowed for a task/project
         * Passes the Selected Row
         * Incoming : selected row object
         * Outgoing : Boolean
         */
        _isAssignmentAllowed: function(selectedRow){
            var assignmentCount = this._assignmentGrid._generalGrid.model.getRowCount();
            if (this.wbsNodeType == EPMConstants.EPM_RISK || this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                for (var j = 0; j < assignmentCount; j++) {
                    var row1 = this._assignmentGrid.assignmentResourceController.getRowByIndex(j);
                    if (row1.active) {
                        this._displayErrorMessage(ResourceAssignmentViewletMessages.ONLY_ONE_ASSIGNMENT_ALLOWED_FOR_WORKITEM);
                        return false;
                    }
                }
            }
			
//            for (var j = 0; j < assignmentCount; j++) {
//                var row1 = this._assignmentGrid.assignmentResourceController.getRowByIndex(j);
//                if (row1.active && (selectedRow[0].id == row1.resourceRelativeHref || selectedRow[0].id == row1.replaceWith)) {
//                    this._displayErrorMessage(ResourceAssignmentViewletMessages.ALREADY_ASSIGNED + row1.name);
//                    return false;
//                }
//            }
            return true;
        },
        
        _getResourceInfoAndAssign: function(selectedRows){
        
            var self = this;
            
            var serviceObj;
            var srh;
            var uri;
            
            
            for (var i = 0; i < selectedRows.length; i++) {
            
                serviceObj = {
                
                    success: function(resourceData){
                    
                        if (!resourceData) {
                        
                            self._displayErrorMessage(ResourceAssignmentViewletMessages.GET_RESOURCE_DETAILS_FAILED);
                        }
                        else {
                        
                            var index = this.getSelectedRowIndex(resourceData.relativeHref);
                            
                            selectedRows[index].name = resourceData.name;
                            
                            if (resourceData.relativeHref && resourceData.relativeHref.indexOf(Constants.PROFILE_URI) == -1) {
                                var Calendar = self.getAssignedLink(resourceData, ["Calendar"]);
                                if (!Calendar) {
                                    self._displayErrorMessage(ResourceAssignmentViewletMessages.USER_DONT_HAVE_CALENDAR_ASSOCIATED);
                                    return;
                                }
                            }
                            
                            
                            var rate = self.getAssignedLink(resourceData, ["Rate"]);
                            
                            //                            if (!rate) {
                            //                                //TODO : Use EPMConfirmDialog instead
                            //                                var response = confirm(ResourceAssignmentViewletMessages.NO_RATES_ASSIGNED_TO_USER);
                            //                                if (!response) {
                            //                                    return;
                            //                                }
                            //                            }
                            
                            if (rate) {
                                var serviceObj2 = {
                                    success: function(rateData){
                                        if (!rateData) {
                                            self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                                        }
                                        else {
                                            selectedRows[index].costRate = rateData.costRate;
                                            selectedRows[index].sellingRate = rateData.sellingRate;
                                            self.afterRates(selectedRows[index], resourceData);
                                        }
                                    },
                                    failure: function(errorObj){
                                        self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                                    }
                                };
                                var srh2 = new ServiceResponseHandler(serviceObj2, "success", "failure");
                                ResourceAssignmentClient.getURI(srh2, rate[0].relativeHref);
                            }
                            else {
                                //Set default rate
                                var serviceObj = {
                                    success: function(rateData){
                                        if (!rateData) {
                                            self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                                        }
                                        else {
                                            selectedRows[index].costRate = rateData.costRate;
                                            selectedRows[index].sellingRate = rateData.sellingRate;
                                            self.afterRates(selectedRows[index], resourceData);
                                        }
                                    },
                                    failure: function(errorObj){
                                        self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                                    }
                                };
                                var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                                ResourceAssignmentClient.getURI(srh, AdminConstants.DEFAULT_RATE_URI);
                            }
                        }
                    },
                    
                    getSelectedRowIndex: function(relativeHref){
                    
                        for (var k = 0; k < selectedRows.length; k++) {
                        
                            if (selectedRows[k].id == relativeHref) {
                                return k;
                            }
                        }
                        
                    },
                    
                    failure: function(errorObj){
                    
                        self._displayErrorMessage(ResourceAssignmentViewletMessages.GET_RESOURCE_DETAILS_FAILED);
                    }
                    
                };
                
                srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                
                uri = selectedRows[i].id;
                
                ResourceAssignmentClient.getURI(srh, uri);
            }
            
        },
        
        
        getAssignedLink: function(loadedElement, linkIDs){
            for (var i in linkIDs) {
                var link = loadedElement[linkIDs[i]];
                if (link) {
                    if (!dojo.isArray(link)) {
                        link = [link];
                    }
                    return link;
                }
            }
        },
        
        afterRates: function(selectedRow, resourceData){
            //If the selected resource is a user or if the WBS node type is not 
            // project (this condition is required when we are assigning from project 
            // project allocated profiles - project profiles tab)  then add that to the assignment grid
            // with rates and name information
            // else create a new profile instance and then assign that to the grid
            var self = this;
            if (!(resourceData.relativeHref.indexOf(Constants.PROFILE_URI) != -1 && this._resourceQueryGrid)) {
                if (resourceData.relativeHref.indexOf(Constants.USER_URI) != -1 ||
                (self.wbsNodeType !== EPMConstants.EPM_PROJECT)) {
                
                    selectedRow.resourceRelativeHref = resourceData.relativeHref;
                    
                    //fecth corresponding team area and process roles data
                    if (resourceData.relativeHref.indexOf(Constants.USER_URI) != -1 && this.wbsNodeType == EPMConstants.EPM_PROJECT) {
						if(!this.isResourceAlreadyAssigned(resourceData)){
							AssignmentUtil.fetchTeamAreaAndRolesForProject(resourceData.name, selectedRow, this.identifier, this);
						}
						else{
							this.assignResourceWithDetails([selectedRow], false);
						}                    }
                    else {
                    
                        //Add this row to the assignment grid
                        this.assignResourceWithDetails([selectedRow], false);
                        
                    }
                }
                
            }
            //else create a new profile instance and assign that to the wbs node
            else {
            
                var profileTemplateId = resourceData.relativeHref;
                
                var saveParams = {
                
                    name: resourceData.name,
                    
                    description: resourceData.description,
                    
                    experienceInYears: resourceData.experienceInYears,
                    
                    costRate: selectedRow.costRate,
                    
                    sellingRate: selectedRow.sellingRate,
                    
                    profileTemplateId: profileTemplateId,
                    
                    skills: selectedRow.skills,
                    
                    competencies: selectedRow.competencies
                
                };
                
                self.assignResourceWithDetails([saveParams], true);
            }
            
        },
        
        isResourceAlreadyAssigned: function(resource){
			var assignmentCount = this._assignmentGrid._generalGrid.model.getRowCount();
            for (var j = 0; j < assignmentCount; j++) {
                var row1 = this._assignmentGrid.assignmentResourceController.getRowByIndex(j);
                if (resource.relativeHref == row1.resourceRelativeHref) {
					this.roleString = row1.role;
                    return true;
                }
            }
            return false;
		},
		
        /*
         * Get the contour information and add a new row to the assignemnt grid
         */
        assignResourceWithDetails: function(selectedRows, createProfileFlag){
        
            //Access the common contour type and vlaue for all assignment
            
            //Assuming the default contour value as 8
            var contourValue = 8;
            var roleValue = Constants.DEFAULT_ROLE;
            var contourType = ResourceAssignmentViewletMessages.HOURS_PER_DAY;
            
            if (!createProfileFlag) {
                if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                    //TODO: Andal need to do the neccessary Implementation here
                    if (this.roleString) {
                        roleValue = this.roleString;
                    }
                }
                else {
                    if (this.wbsNodeType == EPMConstants.EPM_RISK || this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                        roleValue = Constants.DEFAULT_ROLE;
                    }
                }
            }
            if (selectedRows) {
                this._assignmentGrid.validateAndAssignResources(selectedRows, contourType, contourValue, roleValue, createProfileFlag, this.defaultStartDate, this.defaultFinishDate, this.defaultDuration, this.defaultEffort);
            }
            
        },
        
        /*
         * Called when the unassign button ispressed
         * The dialog contains a message asking the user whether to continue
         * or not.
         * Incoming	: None
         * Outgoint	: None
         */
        _unassignResources: function(){
            this._assignmentGrid.unassignResources();
        },
        
        /*
         * Called when the save button is pressed
         * Saves the assignment in the Assignment Grid
         * Incoming : None
         * Outgoing : None
         */
        _saveAssignment: function(){
            if (this.identifier && this.identifier.indexOf(Constants.UNSAVED) != -1) {
                this._displayErrorMessage(ResourceAssignmentViewletMessages.SAVE_UNSAVED_WBS_ELEMENT_BEFORE_ASSIGNMENT);
                return;
            }
            this.toggleSaveButton(true);
            if (this._assignmentGrid) {
                this._assignmentGrid._saveAssignment();
            }
        },
        
        
        /*
         * Function : display any save error to UI
         * Incoming : err -error message
         * Outgoing : None
         */
        handleSaveError: function(err){
            this._displayErrorMessage(err);
        },
        
        
        
        /*
         * Function : If any error encountered while team area save , set it to
         */
        handleTeamAreaFetchError: function(err){
            this._displayErrorMessage(err);
        },
        
        
        
        
        
        /*
         * Creates Resource Query Grid
         * Incoming : None
         * Outgoing : None
         */
        _createResourceQueryGrid: function(queryId, queryType, queryParameterForAvailablitySearch){
        
            // Create the Query Grid
            this._resourceQueryGrid = new com.ibm.epm.resource.assignment.web.ui.internal2.ResourceQueryGrid({
                context: this
            });
            
            this.resourceQueryGridAttachPoint.appendChild(this._resourceQueryGrid.domNode);
            
            // Execute the Query
            this._resourceQueryGrid.executeQuery_n_BuildGrid(queryId, queryType, queryParameterForAvailablitySearch);
            
        },
        
        /*
         * Instantiates the Resource Assignment Grid
         * Incoming: None
         * Outgoing: None
         */
        _createAssignmentGrid: function(newGridFlag){
        
            var assignmentHref = this.identifier;
            
            //Donot create the grid if the tree has no valid nodes selected
            if (assignmentHref == Constants.GRID_TEMP_ID) {
                return;
            }
            
            this.hideNoTreeNodeSelectionLabel();
            
            //Handle select event for unsaved WBS elements
            if (this.identifier.indexOf(Constants.UNSAVED) == -1) {
                if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                    assignmentHref = this.identifier + Constants.SLASH + Constants.PROJECT_ASSIGNMENT;
                }
                else 
                    if (this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1 || this.wbsNodeType == EPMConstants.EPM_RISK) {
                    
                        assignmentHref = this.identifier;
                        
                    }
                    else { // If the node is a program show blank Grid
                        assignmentHref = assignmentHref + "_" + Constants.GRID_TEMP_ID;
                    }
            }
            else {
            
                assignmentHref = assignmentHref + "_" + Constants.GRID_TEMP_ID;
            }
            // If the flag is true, then instance a new grid view else change the URI of the view and build the grid again
            if (newGridFlag && this._assignmentGrid) {
            
                this._assignmentGrid.setTreeId(assignmentHref);
                
            }
            else {
            
                this._assignmentGrid = new com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridView({
                    _treeID: assignmentHref
                });
                
                this.assignmentGridAttachPoint.appendChild(this._assignmentGrid.domNode);
            }
            
            this._assignmentGrid.buildAssignedResourcesGrid(this.identifier, this.wbsNodeType, this.wbsNodeName, this.itemOfTypeEffort, this.categoryId, this.containingProjectId);
            
        },
        
        /*
         * Builds Project Assignment URL and then creats the grid
         */
        _buildProjectAssignmentGrid: function(newGridFlag){
        
        
            if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                this._createProjectAssignmentGrid(Constants.GRID_TEMP_ID, newGridFlag);
                //                this._getProjectInformation(this.identifier, newGridFlag, false);
            }
            else 
                if (this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                    this._getContainingProjectInformation(newGridFlag, false);
                }
                else {
                    //Creating a blank grid
                    this._createProjectAssignmentGrid(Constants.GRID_TEMP_ID, newGridFlag);
                    
                }
        },
        
        /*
         * Instantiates the Project Assignment Grid
         * Incoming: Project Assignment href
         * Outgoing: None
         */
        _createProjectAssignmentGrid: function(projectAssignmentHref, newGridFlag, itemOfTypeEffort){
        
            if (newGridFlag && this._projectAssignmentGrid) {
            
                this._projectAssignmentGrid.setTreeId(projectAssignmentHref);
                
            }
            else {
                this._projectAssignmentGrid = new ProjectAssignmentGridView({
                    _treeID: projectAssignmentHref,
                    context: this
                });
                
                this.resourceQueryGridAttachPoint.appendChild(this._projectAssignmentGrid.domNode);
            }
            
            this._projectAssignmentGrid.buildProjectAssignmentGrid(itemOfTypeEffort);
            
        },
        
        /*
         * Gets the containing project information for the project children
         * Incoming : None
         * Outgoing : None
         */
        _getContainingProjectInformation: function(newGridFlag, scheduleInfoFlag){
        
            var self = this;
            
            var serviceObject = {
            
                success: function(childData){
                
                    if (!childData) {
                    
                        return;
                        
                    }
                    self.itemOfTypeEffort = (childData.constraint.assignmentType == Constants.EFFORT) ? true : false;
                    // If the work item doesnt contain containing project information show a blank grid
                    if (childData["proposedSchedule"]) {
                    
                        var proposedSchedule = childData["proposedSchedule"];
                        self.defaultStartDate = proposedSchedule.startDate;
                        self.defaultFinishDate = proposedSchedule.finishDate;
                        self.defaultDuration = proposedSchedule.duration;
                        self.defaultEffort = proposedSchedule.effort;
                        
                        
                    }
                    //Populate the containing project Id
                    if (childData.containingProject) {
                        self.containingProjectId = childData.containingProject.substring(childData.containingProject.lastIndexOf("/") + 1);
                    }
                    var itemUnderSameProject = false;
                    if (childData.containingProject && !scheduleInfoFlag) {
                        //The 2 urls must be checked fully
                        if (self.containingProjectURL == (childData.containingProject)) {
                            itemUnderSameProject = true;
                        }
                        else {
                            self.containingProjectURL = childData.containingProject;
                            self.projectURL = childData.containingProject;
                        }
                    }
                    //                    if (childData.containingProject) {
                    //                    
                    //                        self.projectURL = childData.containingProject;
                    //                    }
                    if (scheduleInfoFlag) {
                        newGridFlag = false;
                        if (self._assignmentGrid) {
                            newGridFlag = self.removeAllRows(self._assignmentGrid);
                            //newGridFlag = true;
                        }
                        self._createAssignmentGrid(newGridFlag);
                        return;
                    }
                    if (!itemUnderSameProject) {
                        if (self._projectAssignmentGrid && !self._projectAssignmentGrid.deleted) {
                            newGridFlag = self.removeAllRows(self._projectAssignmentGrid);
                            //newGridFlag = true;
                        }
                        if (childData.containingProject) {
                        
                            var projectAssignmentHref = childData.containingProject + Constants.SLASH + Constants.PROJECT_ASSIGNMENT;
                            
                            //call the grid create method
                            
                            self._createProjectAssignmentGrid(projectAssignmentHref, newGridFlag, self.itemOfTypeEffort);
                        }
                        else {
                            self._createProjectAssignmentGrid(Constants.GRID_TEMP_ID, newGridFlag, self.itemOfTypeEffort);
                        }
                    }
                    
                },
                failure: function(errorObj){
                    //Create Blank grid
                    self._createProjectAssignmentGrid(Constants.GRID_TEMP_ID, newGridFlag);
                }
            };
            
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            
            var childURL = this.identifier;
            
            if (childURL.indexOf(Constants.UNSAVED) != -1) {
                //Create Blank grid
                self._createProjectAssignmentGrid(Constants.GRID_TEMP_ID, newGridFlag);
            }
            else {
                ResourceAssignmentClient.getResourceData_Href(srh, childURL);
            }
            
        },
        
        /*
         * Destroys tha grid and removed the dom node from the attach point
         * Incoming : Grid Object and Attachpoint
         * Outgoing : None
         */
        _destroyWidget: function(resourceWidget, attachPoint){
        
            if (resourceWidget && attachPoint) {
                attachPoint.removeChild(resourceWidget.domNode);
            }
            
            //If the funtion Exists
            if (resourceWidget && resourceWidget.destroy) {
            
                resourceWidget.destroy();
                resourceWidget.deleted = true;
                // delete the refrence
                delete resourceWidget;
                resourceWidget = null;
                
            }
            
            
        },
        
        /*
         * Destroys the widget
         */
        destroy: function(){
            //Unsubscribe from all tree events
            this.unSubscribeFromTreeEvents();
            this.unsubscribeToEventsForSaveButton();
            
            //Disconnect from other events
            dojo.forEach(this._pconnects, dojo.disconnect);
            this._pconnects = [];
            
            // Destroy the Assignment Grid, Project Assignment Grid , Project Profiles Tab
            if (this._projectAssignmentGrid) {
                this._projectAssignmentGrid.destroy();
                delete this._projectAssignmentGrid;
            }
            
            if (this._resourceQueryGrid) {
                this._resourceQueryGrid.destroy();
                delete this._resourceQueryGrid;
            }
            
            if (this._assignmentGrid) {
                this._assignmentGrid.destroy();
                delete this._assignmentGrid;
            }
            
            this.inherited("destroy", arguments);
        },
        
        /*
         * Removes all the rows of the Grid
         */
        removeAllRows: function(grid){
            var retVal = true;
            if (grid) {
                grid.viewIsBusy = true;
            }
            if (grid._generalGrid) {
                grid._generalGrid.selection.unselectAll();
            }
            var _gridData = null;
            if (grid._controller) {
                _gridData = grid._controller.getDataModel();
            }
            
            if (_gridData) {
                var count = _gridData.getRowCount();
                var allRows = [];
                for (var i = 0; i < count; i++) {
                    allRows.push(i);
                }
                try {
                    if (allRows.length > 0) {
                        grid._generalGrid.model.remove(allRows);
                        _gridData.store.save();
                    }
                } 
                catch (error) {
                    //console.log("the grid has crashed due to " + error.message + " Auto recovery will start now");
                    this._resetGrid(grid);
                    retVal = false;
                }
                finally {
                    return retVal;
                }
            }
        },
        
        /*
         * Destroys the grid view based on the grid type
         * Incoming : grid view
         * Outgoing : None
         */
        _resetGrid: function(targetGrid){
            if (targetGrid) {
                var gridClass = targetGrid.declaredClass;
                if (gridClass == "com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridView") {
                    this._destroyWidget(targetGrid, this.assignmentGridAttachPoint);
                    delete this._assignmentGrid;
                }
                else {
                    this._destroyWidget(targetGrid, this.resourceQueryGridAttachPoint);
                    if (gridClass == "com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridView") {
                        delete this._projectAssignmentGrid;
                    }
                    if (gridClass == "com.ibm.epm.resource.assignment.web.ui.internal2.ResourceQueryGrid") {
                        delete this._resourceQueryGrid;
                    }
                }
            }
        },
        
        /*
         * Close the query/results grid container
         * Incoming : None
         * Outgoing : None
         */
        onQueryResultSectionClose: function(){
            //Hide the container
            dojo.style(this._sectionGridContainer, "display", "none");
        },
        
        /*
         * Get the current tree node to load the resource assignment page
         * Incoming : None
         * Outgoing : None
         */
        initViewBasedonTree: function(){
            var tree = dijit.byId(Constants.WBS_TREE_ID);
            if (tree && tree._selectedNode) {
                var item = tree._selectedNode.item;
                if (item && item.identifier != this.identifier) {
                    var obj = {
                        treeID: item.treeID,
                        identifier: item.identifier,
                        name: item.name,
                        resourcetype: item.resourcetype
                    };
                    this._updateWBSNodeIdentifier(obj);
                }
            }
        },
        
        /*
         * Hide the no tree selection information
         * Incoming : None
         * Outgoing : None
         */
        hideNoTreeNodeSelectionLabel: function(){
            this.ContainingViewlet._hideInformationLabel();
            this.toggleDisplayOfAllToolbars(true);
        },
        
        /*
         * Create the select filter
         * Incoming : None
         * Outgoing : None
         */
        _createResourceOrQueryFilter: function(){
            this.selectFilter = document.createElement(EPMDomNodeConstants.SELECT);
            dojo.addClass(this.selectFilter, "rm-header-select");
            this._headerMenu.appendChild(this.selectFilter);
            this.allowEventsForFilterBox(true);
        },
        
        /*
         * Action on select filter change
         * Incoming : event
         * Outgoing : None
         */
        _onSelectFilterChange: function(e){
            this.selectFilter.size = 0;
            var value = this.selectFilter.value;
            if (value == Constants.LIST_OF_QUERIES) {
                this.selectFilter.selectedIndex = 0;
                return;
            }
            var queryText = this.selectFilter[this.selectFilter.selectedIndex].text;
            var queryType = this.selectFilter[this.selectFilter.selectedIndex].qType;
            this._queryClicked(value, queryText, queryType);
        },
        
        /*
         * Add one option to select filter
         * Incoming : text(display text), value(internal value), qType(query type)
         * Outgoing : OPTION
         */
        _addItemToSelectFilter: function(text, value, queryType){
            var option = document.createElement(EPMDomNodeConstants.OPTION);
            dojo.addClass(option, "com-ibm-epm-resource-query-section-query-option");
            option.appendChild(document.createTextNode(text));
            option.value = value;
            option.qType = queryType;
            this.selectFilter.appendChild(option);
            return option;
        },
        
        /*
         * Add a query header at the end of select filter
         * Incoming : none
         * Outgoing : none
         */
        _addQueryHeaderToSelectFilter: function(){
            var newOption = this._addItemToSelectFilter(ResourceAssignmentViewletMessages.LIST_OF_QUERIES, Constants.LIST_OF_QUERIES, "");
            dojo.addClass(newOption, "com-ibm-epm-resource-query-section-query-header-option");
        },
        
        /**
         * Add No saved query at the end of select filter
         * Incoming : none
         * Outgoing : none
         */
        _addNoSavedQueryToSelectFilter: function(){
            var newOption = this._addItemToSelectFilter(ResourceAssignmentViewletMessages.NO_SAVED_QUERIES, Constants.NO_SAVED_QUERIES, "");
            newOption.disabled = true;
        },
        /*
         * Remove item from filter based on its value
         * Incoming : value(internal value)
         * Outgoing : none
         */
        removeItemFromSelectFilter: function(itemValue){
            var len = this.selectFilter.options.length;
            for (var i = 0; i < len; i++) {
                if (itemValue == this.selectFilter.options[i].value) {
                    this.selectFilter.remove(i);
                    break;
                }
            }
        },
        
        _reduceQueryFilterSize: function(){
            this.selectFilter.size = 0;
        },
        
        /*
         * Add query items to the select filter dynamically
         * Incoming : None
         * Outgoing : None
         */
        _addQueryItemsToFilter: function(){
            //First clear the old dynamic items
            this._removeQueryItemsFromFilter();
            
            //Add the separator and Loading...
            
            this._addItemToSelectFilter(ResourceAssignmentViewletMessages.WAITING_TO_LOAD, Constants.LOADING, "");
            
            var self = this;
            //Get saved My Queries		
            var serviceObj = {
                _loadSavedQueries: function(queries){
                    // if we have no queries, no action needed
                    if (!queries || queries.length === 0) {
                        //Remove the loading menu item and Add no saved query menu item
                        self.removeItemFromSelectFilter(Constants.LOADING);
                        self._addNoSavedQueryToSelectFilter();
                        self.selectFilter.selectedIndex = -1;
                        return;
                    }
                    if (queries.length > 8) {
                        self.selectFilter.size = 10;
                    }
                    //Remove the loading menu item
                    self.removeItemFromSelectFilter(Constants.LOADING);
                    //Now load all the queries
                    for (var i = 0; i < queries.length; i++) {
                        self._addItemToSelectFilter(queries[i].name, queries[i].id, queries[i].queryType);
                    }
                    self.selectFilter.selectedIndex = -1;
                },
                
                failure: function(errorObj){
                    //Remove the loading menu item
                    self.removeItemFromSelectFilter(Constants.SEPARATOR);
                    self.removeItemFromSelectFilter(Constants.LOADING);
                    self._displayErrorMessage(ResourceAssignmentViewletMessages.GET_QUERY_FAILED + errorObj.message);
                }
            };
            var responseHandler = new ServiceResponseHandler(serviceObj, "_loadSavedQueries", "failure");
            var args = {
                ownerId: getAuthenticatedContributor().itemId
            };
            QueryClient.getQueriesForOwner(RESOURCE_QUERY_TYPE, args, responseHandler);
        },
        
        /*
         * Internal method to clear the filter from dynamic queries
         * Incoming : None
         * Outgoing : None
         */
        _removeQueryItemsFromFilter: function(){
            var len = this.selectFilter.options.length;
            if (this.wbsNodeType !== WBSConstants.EPM_PROGRAM && this.wbsNodeType !== WBSConstants.EPM_PROJECT) {
                //We always have 2 static entries in the filter
                for (var i = 2; i < len; i++) {
                    this.selectFilter.remove(2);
                }
            }
            else {
                //We always have 1 static entries in the filter
                for (var i = 1; i < len; i++) {
                    this.selectFilter.remove(1);
                }
            }
        },
        
        /*
         * Add static elements to the select filter based on the wbs node type
         * Incoming : None
         * Outgoing : None
         */
        _populateStaticItemsToResourceOrQueryFilter: function(){
            //Stop events for filter box so that it doesnot listen to any events
            this.allowEventsForFilterBox(false);
            //First reset the filter
            var length = this.selectFilter.options.length;
            for (var i = 0; i < length; i++) {
                this.selectFilter.remove(0);
            }
            if (this.wbsNodeType != "") {
                if (this.wbsNodeType == WBSConstants.EPM_PROGRAM) {
                    //donot add any static entries
                }
                else 
                    if (this.wbsNodeType == WBSConstants.EPM_PROJECT) {
                    //add 2 entries: all program resources and all program profiles
                    //                        this._addItemToSelectFilter(ResourceAssignmentViewletMessages.ALL_PROGRAM_RESOURCES, Constants.ALL_PROGRAM_RESOURCES, Constants.ALL_PROGRAM_RESOURCES);
                    //                        this._addItemToSelectFilter(ResourceAssignmentViewletMessages.ALL_PROGRAM_PROFILES, Constants.ALL_PROGRAM_PROFILES, Constants.ALL_PROGRAM_PROFILES);
                    }
                    else {
                        //add 2 entries: all project resources and all project profiles					
                        //                        this._addItemToSelectFilter(ResourceAssignmentViewletMessages.ALL_PROJECT_RESOURCES, Constants.ALL_PROJECT_RESOURCES, Constants.ALL_PROJECT_RESOURCES);
                        //                        this._addItemToSelectFilter(ResourceAssignmentViewletMessages.ALL_PROJECT_PROFILES, Constants.ALL_PROJECT_PROFILES, Constants.ALL_PROJECT_PROFILES);
                        this._addItemToSelectFilter(ResourceAssignmentViewletMessages.ALL_PROJECT_ASSIGNMENT, Constants.ALL_PROJECT_ASSIGNMENT, Constants.ALL_PROJECT_ASSIGNMENT);
                    }
            }
            else {
                //do nothing now.
            }
            this._addQueryHeaderToSelectFilter();
            this.allowEventsForFilterBox(true);
        },
        
        /*
         * Execute a user or profile query
         * Incoming : QueryId, query name and querytype ( user or profile )
         * Outgoing : None
         */
        _queryClicked: function(queryId, queryName, queryType){
        
            if (queryType == Constants.QUERY_TYPE_USER) {
            
                this._availabilitySearchDialog = new AvailabilitySearchDialog({
                    _context: this,
                    startDate: DateUtil.parseDate(this.defaultStartDate),
                    finishDate: DateUtil.parseDate(this.defaultFinishDate),
                    effort: this.defaultEffort,
                    projectId : this.projectURL.substring(this.projectURL.lastIndexOf(Constants.SLASH) + 1)
                });
                this.queryId = queryId;
                this.queryName = queryName;
                this.queryType = queryType;
                this._availabilitySearchDialog.show();
                
            }
            else 
                if (queryType == Constants.QUERY_TYPE_PROFILE) {
                
                    this.queryId = queryId;
                    this.queryName = queryName;
                    this.queryType = queryType;
                    
                    this._prepareProjectURLandExecuteQuery(null);
                }
                else {
                    //load project assignments of the selected node
                    //check node type, clear the top grid for program and project
                    if ((this.wbsNodeType == WBSConstants.EPM_PROGRAM) || (this.wbsNodeType == WBSConstants.EPM_PROJECT)) {
                        if (this.currentGrid == Constants.PROJECT_ASSIGNMENT_GRID) {
                            if (this._projectAssignmentGrid) {
                                this.removeAllRows(this._projectAssignmentGrid);
                            }
                        }
                    }
                    else {
                        this._reloadSearchOrQueryGrid();
                    }
                }
        },
        
        /*
         * Allow/disallow events from the filter box.
         * Incoming : Boolean, true to connect, false to disconnect
         * Outgoing : None
         */
        allowEventsForFilterBox: function(enable){
            if (enable) {
                this._pconnects.push(dojo.connect(this.selectFilter, EPMDomNodeConstants.ON_CHANGE, this, this._onSelectFilterChange));
                this._pconnects.push(dojo.connect(this.selectFilter, EPMDomNodeConstants.ON_FOCUS, this, this._addQueryItemsToFilter));
                this._pconnects.push(dojo.connect(this.selectFilter, EPMDomNodeConstants.ON_BLUR, this, this._reduceQueryFilterSize));
            }
            else {
                dojo.forEach(this._pconnects, dojo.disconnect);
                this._pconnects = [];
            }
        },
        
        /*
         * Gets the containing project information for the project children
         * Incoming : None
         * Outgoing : None
         */
        _getProjectInformation: function(uri, newGridFlag, scheduleInfoFlag){
        
            var self = this;
            
            var serviceObject = {
            
                success: function(childData){
                
                    if (!childData) {
                    
                        return;
                        
                    }
                    self.containingProjectURL = "";
                    self.itemOfTypeEffort = (childData.constraint.assignmentType == Constants.EFFORT) ? true : false;
                    var titleObj = dojo.fromJson(childData.constraint.workElement.title);
                    self.categoryId = titleObj.category;
                    // If the work item doesnt contain containing project information show a blank grid
                    if (childData["proposedSchedule"]) {
                        var proposedSchedule = childData["proposedSchedule"];
                        self.defaultStartDate = proposedSchedule.startDate;
                        self.defaultFinishDate = proposedSchedule.finishDate;
                        self.defaultDuration = proposedSchedule.duration;
                        self.defaultEffort = proposedSchedule.effort;
                        
                    }
                    self.projectURL = childData.relativeHref;
                    if (scheduleInfoFlag) {
                        newGridFlag = false;
                        if (self._assignmentGrid) {
                            newGridFlag = self.removeAllRows(self._assignmentGrid);
                            //newGridFlag = true;
                        }
                        self._createAssignmentGrid(newGridFlag);
                        return;
                    }
                    
                    
                    var assignmentHref = uri + Constants.SLASH + Constants.PROJECT_ASSIGNMENT;
                    self._createProjectAssignmentGrid(assignmentHref, newGridFlag, self.itemOfTypeEffort);
                    
                },
                failure: function(errorObj){
                
                    self.defaultStartDate = null;
                    self.defaultFinishDate = null;
                    self.defaultDuration = null;
                    self.defaultEffort = null;
                    
                }
            };
            
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            
            ResourceAssignmentClient.getResourceData_Href(srh, uri);
            
        },
        
        
        /*
         *
         */
        replaceProfile: function(jsonParam){
            var currentDisplayStatus = dojo.style(this._sectionGridContainer, "display");
            if (currentDisplayStatus == "none") {
                dojo.style(this._sectionGridContainer, "display", "");
                this._populateStaticItemsToResourceOrQueryFilter();
            }
            this.replaceProfileRowId = jsonParam.rowId;
            this._prepareProjectURLandExecuteQuery(jsonParam);
        },
        
        /*
         *
         */
        replaceProfileWithUser: function(selectedRows){
            //check if there are any rows in the assignment grid - bug 13195
            if (this._assignmentGrid &&
            this._assignmentGrid._generalGrid &&
            this._assignmentGrid._generalGrid.model &&
            (this._assignmentGrid._generalGrid.model.getRowCount() == 0) ) {
                return;
            }
            
            var replaceRow = this._assignmentGrid.getSelectedRows();
            //if no rows selected return - bug 11155 fix
            if (replaceRow && replaceRow.length == 0 || !replaceRow[0]) {
                return;
            }
            if (replaceRow[0].resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
                var item = this._assignmentGrid._generalGrid.model.store._getItemByIdentity(replaceRow[0].id);
                var name;
                if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                    if (!this._isAssignmentAllowed(selectedRows)) {
                        return;
                    }
                }
                //when results fetched from availability search field is "Name" otherwise its "name"
                //bug fix - 11148
                if (!selectedRows[0].name) {
                    name = selectedRows[0].Name;
                }
                else {
                    name = selectedRows[0].name;
                }
                this._assignmentGrid._generalGrid.model.store._setValueOrValues(item, "name", name, true);
                this._assignmentGrid._generalGrid.model.store._setValueOrValues(item, "replaceWith", selectedRows[0].id, true);
            }
        },
        
        /*
         *
         */
        replaceProfileWithAllocatedUser: function(selectedRows){
            var assignmentCount = this._assignmentGrid._generalGrid.model.getRowCount();
            for (var j = 0; j < assignmentCount; j++) {
                var row = this._assignmentGrid.assignmentResourceController.getRowByIndex(j);
                if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
                    var item = this._assignmentGrid._generalGrid.model.store._getItemByIdentity(row.id);
                    this._assignmentGrid._generalGrid.model.store._setValueOrValues(item, "name", selectedRows[0].name, true);
                    this._assignmentGrid._generalGrid.model.store._setValueOrValues(item, "replaceWith", selectedRows[0].resourceRelativeHref, true);
                }
            }
        },
        
        /*
         * Toggles the display of the toolbars in the assigned resource grid
         * Incoming : boolean flag, true -> visible, false -> invisible
         * Outgoing : None
         */
        toggleDisplayOfAllToolbars: function(state){
            var vizState = state ? "" : "none";
            dojo.style(this._assignmentGridToolbar, "display", vizState);
        },
        
        validateMultipleAssignment: function(nodeType){
            if (nodeType == EPMConstants.EPM_TASK || nodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                var assignmentCount = this._assignmentGrid._generalGrid.model.getRowCount();
                for (var j = 0; j < assignmentCount; j++) {
                    var row1 = this._assignmentGrid.assignmentResourceController.getRowByIndex(j);
                    if (row1.active) {
                        this._displayErrorMessage(ResourceAssignmentViewletMessages.ONLY_ONE_ASSIGNMENT_ALLOWED_FOR_WORKITEM);
                        return false;
                    }
                }
            }
            return true;
        },
        
        /*
         * Wrapper funcion on _executeQuery_n_BuildGrid(jsonParam). It validates the projectURL. If it is not present, it fetches it
         * Incoming : json expression for the query
         * Outgoing : None
         */
        _prepareProjectURLandExecuteQuery: function(jsonExpr){
            if (this.projectURL) {
                this._executeQuery_n_BuildGrid(jsonExpr);
            }
            else {
                var tree = dijit.byId(Constants.WBS_TREE_ID);
                if (tree && tree._selectedNode) {
                    var item = tree._selectedNode.item;
                    if (item) {
                        this.identifier = this._getDataFromArray(item.identifier);
                        this.wbsNodeName = this._getDataFromArray(item.name);
                        this.wbsNodeType = this._getDataFromArray(item.resourcetype);
                        
                        if (this.wbsNodeType == EPMConstants.WORKITEM) {
                            var self = this;
                            var serviceObject = {
                                success: function(childData){
                                    if (!childData) {
                                        self._displayErrorMessage(ResourceAssignmentViewletMessages.ERROR_LOADING_WORKITEM);
                                        return;
                                    }
                                    if (childData.containingProject) {
                                        self.projectURL = childData.containingProject;
                                        self._executeQuery_n_BuildGrid(jsonExpr);
                                    }
                                    else {
                                        self._displayErrorMessage(ResourceAssignmentViewletMessages.PROJECT_INFO_NOT_PRESENT_IN_WORKITEM);
                                    }
                                },
                                failure: function(errorObj){
                                    self._displayErrorMessage(ResourceAssignmentViewletMessages.ERROR_LOADING_WORKITEM);
                                }
                            };
                            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
                            var childURL = this.identifier;
                            ResourceAssignmentClient.getResourceData_Href(srh, childURL);
                        }
                        else 
                            if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
                                this.projectURL = this.identifier;
                                this._executeQuery_n_BuildGrid(jsonExpr);
                            }
                    }
                }
            }
        },
        
        _onResourceViewGridLoaded: function(publishedData){
            if (publishedData.controllerID == Constants.ASSIGNED_RESOURCES_GRID_ID) {
                RMDashboardUtil.hideMessageArea();
                this._assignmentGrid.viewIsBusy = false;
            }
            if (publishedData.controllerID == Constants.PROJECT_ASSIGNMENT_GRID_CONTROLLER) {
                RMDashboardUtil.hideMessageArea();
                this._projectAssignmentGrid.viewIsBusy = false;
            }
            
        },
        
        /**
         *  toggleSaveButton : Save button is enabled once there is any updation in the grid
         *  Incoming : state
         *  Outgoing : none
         *
         */
        toggleSaveButton: function(state){
            if (this.saveButton.disabled != state) {
                this.saveButton.disabled = state;
                
                if (state == true) {
                    this.subscribeToEventsForSaveButton();
                    this.ContainingViewlet.resetDirtyFlag();
                }
                else {
                    this.unsubscribeToEventsForSaveButton();
                    this.ContainingViewlet.setDirtyFlag();
                }
            }
        },
        
        subscribeToEventsForSaveButton: function(){
            if (this._fieldChangeEvent == null) {
                this._fieldChangeEvent = dojo.subscribe(GridEvents.FIELD_CHANGED, this, this._enableSaveButton);
            }
            
            if (this._onUserOrProfileAdded == null) {
                this._onUserOrProfileAdded = dojo.subscribe(Constants.USER_PROFILE_ROW_ADDED_EVENT, this, this._enableSaveButton);
            }
            
            if (this._onAssignedGridFieldChange == null) {
                this._onAssignedGridFieldChange = dojo.subscribe(Constants.ASSIGNED_RESOURCES_FIELD_CHANGE_EVENT, this, this._enableSaveButton);
            }
        },
        
        unsubscribeToEventsForSaveButton: function(){
            if (this._fieldChangeEvent != null) {
                dojo.unsubscribe(this._fieldChangeEvent);
                this._fieldChangeEvent = null;
            }
            if (this._onUserOrProfileAdded != null) {
                dojo.unsubscribe(this._onUserOrProfileAdded);
                this._onUserOrProfileAdded = null;
            }
            if (this._onAssignedGridFieldChange != null) {
                dojo.unsubscribe(this._onAssignedGridFieldChange);
                this._onAssignedGridFieldChange = null;
            }
        },
        
        /**
         *  _enableSaveButton : Event handler when there is any updation in Grid
         *  Incoming : publishedObj
         *  Outgoing : none
         *
         */
        _enableSaveButton: function(publishedObj){
            if (!publishedObj) {
                return;
            }
            if (publishedObj.controllerID == Constants.ASSIGNED_RESOURCES_GRID_ID) {
                //find out if the current publishedObj.fieldName is present in the ignore list of assignment grid
                if (this._assignmentGrid) {
                    if (this._assignmentGrid.ignoreFieldChange(publishedObj.fieldName)) {
                        return;
                    }
                }
                this.toggleSaveButton(false);
            }
        },
        
        availabilitySearchDialog_onOK: function(){
			
			//Update the label to show the query info
			if (this._availabilitySearchDialog) {
            
                var startDate = this._formatDateForQuery(this._availabilitySearchDialog.getFromDate());
                var endDate = this._formatDateForQuery(this._availabilitySearchDialog.getEndDate());
                var effort = this._availabilitySearchDialog.getEffort();
				var contour = this._availabilitySearchDialog.getContour();
				if(isNaN(contour)){
					
					contour = ResourceAssignmentViewletMessages.WORKING_HOURS
				}
				var availabilitySearchType = this._availabilitySearchDialog.effortOrDurationType(); // 0 - Duration, 1 - Effort
				
				this.queryInfoLabel = document.createElement(EPMDomNodeConstants.LABEL);
	
				var isAvailabilitySearch = this._availabilitySearchDialog.isAvailabilitySearch();
				
				if(isAvailabilitySearch){
					if(availabilitySearchType){
						this.queryInfoLabel.innerHTML = ResourceAssignmentViewletMessages.START_DATE + ": " + this._formatDate(startDate) +
						"&nbsp | &nbsp;" + 
						ResourceAssignmentViewletMessages.EFFORT +  ": " + effort +
						"&nbsp | &nbsp;" +
						ResourceAssignmentViewletMessages.AVL_CONTOUR_LABEL + " " + contour +
						"&nbsp; " + ResourceAssignmentViewletMessages.HOURS_PER_DAY;
						
					}else{
						
						this.queryInfoLabel.innerHTML = ResourceAssignmentViewletMessages.START_DATE + ": " + this._formatDate(startDate) +
						"&nbsp | &nbsp;" +
						ResourceAssignmentViewletMessages.END_DATE +  ": " + this._formatDate(endDate) +
						"&nbsp | &nbsp;" +
						ResourceAssignmentViewletMessages.AVL_CONTOUR_LABEL + " " + contour +
						"&nbsp; " + ResourceAssignmentViewletMessages.HOURS_PER_DAY;
					}
				}
				
				if (this._headerQueryInfo.hasChildNodes()) {
	                while (this._headerQueryInfo.childNodes.length >= 1) {
	                    this._headerQueryInfo.removeChild(this._headerQueryInfo.firstChild);
	                }
           		 }
				this._headerQueryInfo.appendChild(this.queryInfoLabel);
			}
			
            this._prepareProjectURLandExecuteQuery();
        },
		
		/**
		 * Formats dates
		 * @param {Object} inDatum
		 */
	 	 _formatDate : function(inDatum){
				if (inDatum && (inDatum !== "") && (inDatum !== "?") && (inDatum !== "-")) {
					var leastDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate(Constants.LEAST_DATE);
					var inDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate(inDatum);
					if (0 >= dojo.date.compare(leastDate, inDate, 'date')) {
						return dojo.date.locale.format(new Date(inDate), {selector: 'date', formatLength: 'medium'});
					}
				}
				return " - ";
	   	 },
        
        availabilitySearchDialog_onCancel: function(){
            if (this._availabilitySearchDialog) {
                this._availabilitySearchDialog.destroy();
                delete this._availabilitySearchDialog;
            }
        },
        
        _onAssignmentGridSaveInProgress: function(publishedObj){
            this.toggleSaveButton(publishedObj.disableSaveButton);
        },
		
		renderAssignmentGrid: function() {
			if(this._assignmentGrid && this._assignmentGrid._generalGrid) {
				this._assignmentGrid._generalGrid.render();
			}
		}
        
    });
    
})();