/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

//TODO : Change the date funtions to use dojo.date utilities rather doing the calculation all by ourself

(function(){
    dojo.provide("com.ibm.epm.web.core.util.internal.DateUtil");
    
    
    /*
     * Date related  purpose utility methods.
     */
    com.ibm.epm.web.core.util.internal.DateUtil = {
        formatDate: function(inDatum){
            if (isNaN(inDatum)) {
                return ("   -   ");
            }
            if (inDatum != "") {
				
                var leastDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate("1980-12-31");
                if (dojo.date.compare(leastDate, inDatum, 'date') === 1) {
                    return "";
                }
				
                return dojo.date.locale.format(new Date(inDatum), {
                    selector: 'date',
					formatLength: 'medium'
                });
            }
            else {
                return ("   -   ");
            }
        },
        
        formatDate_Short: function(inDatum){
            if (isNaN(inDatum)) {
                return ("   -   ");
            }
            if (inDatum != "") {
				
				var leastDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate("1980-12-31");
                if (dojo.date.compare(leastDate, inDatum, 'date') === 1) {
                    return "";
                }
				
                return dojo.date.locale.format(new Date(inDatum), {
                    selector: 'date',
                    formatLength: 'short'
                });
            }
            else {
                return ("   -   ");
            }
        },
        
        
        formatDateForSave: function(inDate){
            if (inDate) {
                return dojo.date.locale.format(new Date(inDate), {
                    selector: 'date',
                    datePattern: "yyyy-MM-dd"
                });
            }
            else {
                return null;
            }
        },
        
        parseDate: function(serverDateString){
            if (serverDateString && serverDateString != null && serverDateString != "" && serverDateString != "null") {
                if (dojo.date.locale) {
                    return dojo.date.locale.parse(serverDateString.substring(0, 10), {
                        selector: 'date',
                        datePattern: "yyyy-MM-dd"
                    });
                }
            }
            return null;
        },
        
        /**
         *  compareDates : Compares two dates
         *  Accepts: 2 Dates
         *  date1, date2 
         *
         *  Returns: +ve integer if date1 > date2
         *           -ve integer if date1 < date2
         *           zero if date1 == date2  
         *
         */
        compareDates: function(date1, date2){
           return dojo.date.compare(date1, date2, "date");
        },
        
        /**
         *  updateDaysInDate : Updates the days in the date with the specified days
         *  Incoming :
         *      date - Date to be updated
         *      days - Days to update the date with [+ve adds days, -ve subtracts days]
         *  Outgoing : none
         */
        updateDaysInDate: function(date, days){
            var oldDate = new Date(date);
            oldDate.setDate(oldDate.getDate() + days);
            return oldDate;
        },
		 /**
         *  diffDates : Finds the differnce between two dates
         *  Accepts: 2 Dates
         *  date1, date2 
         *  and the interval in which the difference is required like day,year etc
         *
         *  Returns: date difference
         *
         */
        diffDates: function(startDate, finishDate, interval){
			return dojo.date.difference(startDate,finishDate,interval);
        }
    };
    
})();
