<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:msp="http://schemas.microsoft.com/project"
xmlns:epm="http://schema.ibm.com/epm/resources/1.0/Project">

<xsl:param name="PARENT_ID"/>
<xsl:param name="Name"/>
<xsl:param name="CALENDAR_ID"/>
<xsl:variable name="empty_string"/>
<xsl:param name="INTERNAL"/>

<xsl:template match="msp:Project">
  <msp>
  	<epm:project>
		<!--xsl:choose>
			<xsl:when test="contains(msp:Tasks/msp:Task[position()=1]/msp:ExtendedAttribute/msp:Value, 'projects')">
				<xsl:attribute name="rel">edit</xsl:attribute>
				<xsl:attribute name="relativeHref"><xsl:value-of select="msp:Tasks/msp:Task[position()=1]/msp:ExtendedAttribute[msp:FieldID='188743731']/msp:Value"/></xsl:attribute>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose-->
		<ID>0</ID>
  		<workItemType>project</workItemType>
		<summary><xsl:value-of select="$Name"/></summary>
		<xsl:call-template name="ProposedSchedule"/>
		<!--Program><link rel="add" relativeHref="program/10"/></Program-->
		<Program><link>
			<xsl:attribute name="rel">add</xsl:attribute>
			<xsl:attribute name="relativeHref"><xsl:value-of select="$PARENT_ID"/></xsl:attribute>
		</link></Program>
		<Calendar><link>
			<xsl:attribute name="rel">add</xsl:attribute>
			<xsl:attribute name="relativeHref">
				<xsl:choose>
					<xsl:when test="$CALENDAR_ID">
						<xsl:value-of select="$CALENDAR_ID"/>
					</xsl:when>
					<xsl:otherwise>calendars/default</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
		</link></Calendar>
		<xsl:call-template name="IntegrationAttributes">
 			<xsl:with-param name="node" select="msp:Tasks/msp:Task[position()=1]"/>
		</xsl:call-template> 
		<xsl:if test="msp:Manager and msp:Manager != $empty_string">
			<owner><xsl:value-of select="msp:Manager"/></owner>
		</xsl:if>
		<rpcSequenceValue>O00000</rpcSequenceValue>
  	</epm:project>
  	<xsl:apply-templates select="msp:Tasks"/>
  	<xsl:apply-templates select="msp:Assignments"/>
	<xsl:apply-templates select="msp:Resources"/>
  </msp>
</xsl:template>

<xsl:template match="msp:Tasks">
	<xsl:for-each select="msp:Task[position()>1]">
		<xsl:if test="msp:OutlineNumber">
			<epm:workitem>
				<!--xsl:choose>
					<xsl:when test="contains(msp:ExtendedAttribute/msp:Value, 'workitems')">
						<xsl:attribute name="rel">edit</xsl:attribute>
						<xsl:attribute name="relativeHref"><xsl:value-of select="msp:ExtendedAttribute[msp:FieldID='188743731']/msp:Value"/></xsl:attribute>
					</xsl:when>
					<xsl:otherwise></xsl:otherwise>
				</xsl:choose-->
				<Parent><link>
					<xsl:attribute name="rel">add</xsl:attribute>
					<xsl:attribute name="relativeHref">
						<xsl:choose>
							<xsl:when test="contains(msp:OutlineNumber, '.')">
								<xsl:call-template name="FindParent">
						             <xsl:with-param name="theString" select="msp:OutlineNumber"/>
						        </xsl:call-template>
							</xsl:when>
							<xsl:otherwise>0</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
				</link></Parent>
				<ID><xsl:value-of select="msp:UID"/></ID>
				<summary>				
				<xsl:choose>
					<xsl:when test="msp:Name"><xsl:value-of select="msp:Name"/></xsl:when>
					<xsl:otherwise>...</xsl:otherwise>
				</xsl:choose>
				</summary>
				<rpcSequenceValue><xsl:value-of select="msp:OutlineLevel"/></rpcSequenceValue>
				<state>New</state>
				<xsl:choose>
					<!--xsl:when test="msp:Milestone=1">
						<workItemType>milestone</workItemType>
					</xsl:when-->
					<xsl:when test="msp:Summary=1 or count(../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:UID])>1">
						<workItemType>summarytask</workItemType>
					</xsl:when>
					<xsl:otherwise>
						<workItemType>task</workItemType>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="IntegrationAttributes">
 					<xsl:with-param name="node" select="."/>
				</xsl:call-template>
				<xsl:choose>
					<xsl:when test="$INTERNAL = 'FALSE'">
						<xsl:call-template name="IntegrationProposedSchedule"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="ProposedSchedule"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="Constraint">
					<xsl:with-param name="ConstraintType" select="msp:ConstraintType"/>
					<xsl:with-param name="ConstraintDate" select="msp:ConstraintDate"/>
				</xsl:call-template>
			</epm:workitem>
			<xsl:choose>
				<xsl:when test="count(../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:UID])>1">
					<xsl:if test="msp:Summary=0"> 
						<Message>Multiple assignments found for task <xsl:value-of select="msp:Name"/>. Converting to Summary Task.</Message>
					</xsl:if>
					<xsl:if test="msp:Summary=1"> 
						<Message>Multiple assignments found for Summary Task <xsl:value-of select="msp:Name"/>. Splitting into tasks.</Message>
					</xsl:if>
					<xsl:variable name="constraintType" select="msp:ConstraintType" />
					<xsl:variable name="constraintDate" select="msp:ConstraintDate" />
					<xsl:for-each select="../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:UID]">
						<xsl:variable name="cur" select='position()' />
						<epm:workitem>
							<Parent><link>
								<xsl:attribute name="rel">add</xsl:attribute>
								<xsl:attribute name="relativeHref"><xsl:value-of select="msp:TaskUID"/></xsl:attribute>
							</link></Parent>
							<ID><xsl:value-of select="concat(concat(msp:TaskUID, '.'), msp:UID)"/></ID>
							<summary>				
							<xsl:choose>
								<xsl:when test="../../msp:Tasks/msp:Task[msp:UID = current()/msp:TaskUID]/msp:Name">
									<xsl:value-of select="concat(concat(../../msp:Tasks/msp:Task[msp:UID = current()/msp:TaskUID]/msp:Name, '_'), $cur)"/>
								</xsl:when>
								<xsl:otherwise><xsl:value-of select="concat(concat('...', '_'), $cur)"/></xsl:otherwise>
							</xsl:choose>
							</summary>
							<state>New</state>
							<workItemType>task</workItemType>
							<xsl:call-template name="ProposedSchedule"/>
							<xsl:call-template name="Constraint">
								<xsl:with-param name="ConstraintType" select="$constraintType"/>
								<xsl:with-param name="ConstraintDate" select="$constraintDate"/>
							</xsl:call-template>
						</epm:workitem>							
					</xsl:for-each>					
				</xsl:when>
				<xsl:otherwise></xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:for-each>
	<xsl:for-each select="msp:Task[position()>1]">
		<xsl:choose>
			<xsl:when test="count(../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:UID])>1">
				<xsl:for-each select="../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:UID]">
					<xsl:variable name="IDValue" select="concat(concat(msp:TaskUID, '.'), msp:UID)" />
					<xsl:for-each select="../../msp:Tasks/msp:Task[msp:UID = current()/msp:TaskUID]/msp:PredecessorLink">
						<xsl:if test="msp:Type=1 and count(../../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:PredecessorUID]) > 1 and ../../../msp:Tasks/msp:Task[msp:UID = current()/msp:PredecessorUID]/msp:Summary=0">
							<xsl:for-each select="../../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:PredecessorUID]">
								<epm:workitem>
									<xsl:attribute name="rel">edit</xsl:attribute>
									<xsl:attribute name="relativeHref">
										<xsl:value-of select="$IDValue"/>
									</xsl:attribute>								
										<xsl:variable name="PredecessorID" select="concat(concat(msp:TaskUID, '.'), msp:UID)" />
										<DependsOn><link>
											<xsl:attribute name="rel">add</xsl:attribute>
											<xsl:attribute name="relativeHref">
												<xsl:value-of select="$PredecessorID"/>
											</xsl:attribute>
										</link></DependsOn>								
								</epm:workitem>
							</xsl:for-each>
						</xsl:if>
						<xsl:if test="msp:Type=1 and count(../../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:PredecessorUID]) &lt;= 1 and ../../../msp:Tasks/msp:Task[msp:UID = current()/msp:PredecessorUID]/msp:Summary=0">
							<epm:workitem>
								<xsl:attribute name="rel">edit</xsl:attribute>
								<xsl:attribute name="relativeHref">
									<xsl:value-of select="$IDValue"/>
								</xsl:attribute>
								<DependsOn><link>
									<xsl:attribute name="rel">add</xsl:attribute>
									<xsl:attribute name="relativeHref">
										<xsl:value-of select="msp:PredecessorUID"/>
									</xsl:attribute>
								</link></DependsOn>
							</epm:workitem>
			        	</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>
		<xsl:if test="msp:Summary=0 and count(../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:UID]) &lt;= 1">
			<xsl:for-each select="msp:PredecessorLink">
				<xsl:if test="msp:Type=1 and count(../../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:PredecessorUID]) &lt;= 1 and ../../../msp:Tasks/msp:Task[msp:UID = current()/msp:PredecessorUID]/msp:Summary=0">
					<epm:workitem>
						<xsl:attribute name="rel">edit</xsl:attribute>
						<xsl:attribute name="relativeHref">
							<xsl:value-of select="../msp:UID"/>
						</xsl:attribute>
						<DependsOn><link>
							<xsl:attribute name="rel">add</xsl:attribute>
							<xsl:attribute name="relativeHref">
								<xsl:value-of select="msp:PredecessorUID"/>
							</xsl:attribute>
						</link></DependsOn>
					</epm:workitem>
	        	</xsl:if>	
				<xsl:if test="msp:Type=1 and count(../../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:PredecessorUID]) > 1 and ../../../msp:Tasks/msp:Task[msp:UID = current()/msp:PredecessorUID]/msp:Summary=0">
					<xsl:variable name="SuccessorID" select="../msp:UID" />
					<xsl:for-each select="../../../msp:Assignments/msp:Assignment[msp:TaskUID = current()/msp:PredecessorUID]">
						<epm:workitem>
							<xsl:attribute name="rel">edit</xsl:attribute>
							<xsl:attribute name="relativeHref">
								<xsl:value-of select="$SuccessorID"/>
							</xsl:attribute>
							<DependsOn><link>
								<xsl:attribute name="rel">add</xsl:attribute>
								<xsl:attribute name="relativeHref">
									<xsl:value-of select="concat(concat(msp:TaskUID, '.'), msp:UID)"/>
								</xsl:attribute>
							</link></DependsOn>
						</epm:workitem>
					</xsl:for-each>
	        	</xsl:if>
			</xsl:for-each>			
        </xsl:if>
		<!--xsl:for-each select="msp:PredecessorLink">
			<epm:dependency>
				<predecessor><xsl:value-of select="msp:PredecessorUID"/></predecessor>
				<successor><xsl:value-of select="../msp:UID"/></successor>
			</epm:dependency>
		</xsl:for-each-->
	</xsl:for-each>
</xsl:template>

<xsl:template match="msp:Assignments">
	<xsl:for-each select="msp:Assignment">
		<xsl:choose>
			<xsl:when test="msp:ResourceUID>0">
				<epm:taskAssignment>
					<User><link>
						<xsl:attribute name="rel">add</xsl:attribute>
						<!--xsl:attribute name="relativeHref"><xsl:value-of select="../../msp:Resources/msp:Resource[msp:UID = current()/msp:ResourceUID]/msp:Name"/></xsl:attribute-->
						<xsl:attribute name="relativeHref"><xsl:value-of select="msp:ResourceUID"/></xsl:attribute>
					</link></User>
					<Task><link>
						<xsl:attribute name="rel">add</xsl:attribute>
						<xsl:attribute name="relativeHref">
							<xsl:choose>
								<xsl:when test="count(../msp:Assignment[msp:TaskUID = current()/msp:TaskUID])>1">
									<xsl:value-of select="concat(concat(msp:TaskUID, '.'), msp:UID)"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="msp:TaskUID"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>
					</link></Task>
					<xsl:if test="msp:WorkContour=8 or msp:WorkContour=0">
						<contourType>Hours / Day</contourType>
						<contourValue><xsl:apply-templates select="msp:Units"/></contourValue>						
					</xsl:if>
					<xsl:if test="msp:WorkContour!=8">
						<contourType>As Soon as Possible</contourType>												
					</xsl:if>					
					<plannedSchedule>
						<startDate><xsl:apply-templates select="msp:Start"/></startDate>						
						<effort><xsl:value-of select="substring-after(substring-before(msp:Work, 'H'), 'T')"/></effort>
					</plannedSchedule>
					<profile>
						<name><xsl:value-of select="../../msp:Resources/msp:Resource[msp:UID = current()/msp:ResourceUID]/msp:Name"/></name>
					</profile>
				</epm:taskAssignment>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template match="msp:Resources">
	<xsl:for-each select="msp:Resource">
		<xsl:if test="../../msp:Assignments/msp:Assignment[msp:ResourceUID = current()/msp:UID]">
			<epm:projectAssignment>
				<xsl:attribute name="rel">edit</xsl:attribute>
				<xsl:attribute name="relativeHref"><xsl:value-of select="msp:UID"/></xsl:attribute>
				<xsl:for-each select="msp:Rates/msp:Rate">
					<xsl:if test="msp:RateTable=0">
						<rate>
						<xsl:if test="contains(msp:RatesFrom, '1984')">
							<xsl:attribute name="id">default</xsl:attribute>
						</xsl:if>
						<toDate><xsl:value-of select="concat(substring-before(msp:RatesTo, 'T'), ' 00:00:00')"/></toDate>
						<fromDate><xsl:value-of select="concat(substring-before(msp:RatesFrom, 'T'), ' 00:00:00')"/></fromDate>
						<sellingRate><xsl:value-of select="msp:StandardRate"/></sellingRate>
						<costRate><xsl:value-of select="msp:StandardRate"/></costRate>
						</rate>
					</xsl:if>
				</xsl:for-each>
			</epm:projectAssignment>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template match="msp:Start|msp:StartDate|msp:Finish|msp:FinishDate">
    <xsl:call-template name="Date"/>
</xsl:template>

<xsl:template name="Date">
    <xsl:value-of select="concat(substring-before(., 'T'), ' 00:00:00')"/>
</xsl:template>

<xsl:template name="ProposedSchedule">
		<proposedSchedule>
    		<startDate><xsl:apply-templates select="msp:Start|msp:StartDate"/></startDate>
  			<finishDate><xsl:apply-templates select="msp:Finish|msp:FinishDate"/></finishDate>
  		</proposedSchedule>
</xsl:template>

<xsl:template name="IntegrationProposedSchedule">
	<proposedSchedule>
		<!--For the integration send in the project's start date-->
		<startDate><xsl:apply-templates select="../../msp:Start|../../msp:StartDate"/></startDate>
		<xsl:call-template name="Effort"/>
	</proposedSchedule>
</xsl:template>

<!--template for processing attributes common to all tasks including the project's task 0 -->
<xsl:template name="IntegrationAttributes">
	<xsl:param name="node"/>
		<description><xsl:value-of select="$node/msp:Notes"/></description>
		<xsl:if test="$node/msp:HyperlinkAddress and $node/msp:HyperlinkAddress != $empty_string">
			<integrationLink><xsl:value-of select="$node/msp:HyperlinkAddress"/></integrationLink>
		</xsl:if>
</xsl:template>

<!--Processes the effort extended attribute definition.  
Eventually this template will process all extended attribute definitions
-->
<xsl:template name="Effort">
	<!--Only store effort for tasks-->
	<xsl:if test="name(.)='Task'">
		<xsl:variable name="Effort">
			<xsl:for-each select="../../msp:ExtendedAttributes/msp:ExtendedAttribute">
				<xsl:if test="contains(msp:Alias, 'Effort')">
					<xsl:value-of select="msp:FieldID"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
    	<xsl:if test="string($Effort)">
			<xsl:call-template name="StoreEffort">
				<xsl:with-param name="Node" select="."/>
		        <xsl:with-param name="Effort" select="$Effort"/>
			</xsl:call-template>
	    </xsl:if>
	</xsl:if>
</xsl:template>

<!--Parse the task looking for the effort for the current task-->
<xsl:template name="StoreEffort">
	<xsl:param name="Node"/>
	<xsl:param name="Effort"/>
	<xsl:for-each select="msp:ExtendedAttribute">
		<xsl:if test="contains(msp:FieldID, $Effort)">
 			<effort><xsl:value-of select="msp:Value"/></effort>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="Constraint">
	<xsl:param name="ConstraintType"/>
	<xsl:param name="ConstraintDate"/>
	<constraint>
		<constraintType>
			<xsl:choose>
				<xsl:when test="$ConstraintType=0">AsSoonAsPossible</xsl:when>
				<!--xsl:when test="msp:ConstraintType=6">FinishNoEarlierThan</xsl:when-->
				<xsl:when test="$ConstraintType=6">AsSoonAsPossible</xsl:when>
				<!--xsl:when test="msp:ConstraintType=1">AsLateAsPossible</xsl:when-->
				<xsl:when test="$ConstraintType=1">AsSoonAsPossible</xsl:when>
				<!--xsl:when test="msp:ConstraintType=2">MustStartOn</xsl:when-->
				<xsl:when test="$ConstraintType=2">AsSoonAsPossible</xsl:when>
				<!--xsl:when test="msp:ConstraintType=3">MustFinishOn</xsl:when-->
				<xsl:when test="$ConstraintType=3">AsSoonAsPossible</xsl:when>
				<!--xsl:when test="msp:ConstraintType=4">StartNoEarlierThan</xsl:when-->
				<xsl:when test="$ConstraintType=4">AsSoonAsPossible</xsl:when>
				<!--xsl:when test="msp:ConstraintType=5">StartNoLaterThan</xsl:when-->
				<xsl:when test="$ConstraintType=5">AsSoonAsPossible</xsl:when>
				<xsl:when test="$ConstraintType=7">FinishNoLaterThan</xsl:when>
				<xsl:otherwise>AsSoonAsPossible</xsl:otherwise>
			</xsl:choose>
	    </constraintType>
		<xsl:choose>
			<xsl:when test="$ConstraintType=7">
				<constraintDate><xsl:value-of select="substring-before($ConstraintDate, 'T')"/></constraintDate>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>	
	</constraint>
</xsl:template>

<xsl:template name="FindParent">
    <xsl:param name="theString" />
    <xsl:param name="reversedString" />
    <xsl:choose>
       <xsl:when test="$theString">
          <xsl:call-template name="FindParent">
             <xsl:with-param name="theString"
                             select="substring($theString, 2)" />
             <xsl:with-param name="reversedString" select="concat(substring($theString, 1, 1),$reversedString)" />
          </xsl:call-template>
       </xsl:when>
       <xsl:otherwise>
       		<xsl:value-of select="../msp:Task[msp:OutlineNumber=substring(current()/msp:OutlineNumber, 1, string-length(substring-after($reversedString, '.')))]/msp:UID"/>
       </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="profile">
	<profile>
		<description><xsl:value-of select="name"/></description>
		<name><xsl:value-of select="name"/></name>
		<experienceInYears><xsl:value-of select="experienceInYears"/></experienceInYears>
		<Competencies>
			<xsl:for-each select="Competencies/link">
				<link>
					<xsl:attribute name="rel">add</xsl:attribute>
					<xsl:attribute name="relativeHref">
						<xsl:value-of select="@relativeHref"/>
					</xsl:attribute>
				</link>
			</xsl:for-each>
		</Competencies>
		<Profile>
			<link>
				<xsl:attribute name="rel">add</xsl:attribute>
				<xsl:attribute name="relativeHref">
					<xsl:value-of select="@relativeHref"/>
				</xsl:attribute>
			</link>
		</Profile>
		<Skills>
			<xsl:for-each select="Skills/link">
				<link>
					<xsl:attribute name="rel">add</xsl:attribute>
					<xsl:attribute name="relativeHref">
						<xsl:value-of select="@relativeHref"/>
					</xsl:attribute>
				</link>
			</xsl:for-each>
		</Skills>
	</profile>
</xsl:template>

</xsl:stylesheet>